using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using Habanero.Faces.Base;

namespace Replace_it.UI
{
    public abstract class ControlManager : IControlManager
    {
        protected readonly IControlHabanero _control;
        protected readonly IControlFactory _controlFactory;

        protected ControlManager(IControlFactory controlFactory)
        {
            _controlFactory = controlFactory;
            _control = _controlFactory.CreatePanel();
// ReSharper disable DoNotCallOverridableMethodsInConstructor
            InitialiseControl();
// ReSharper restore DoNotCallOverridableMethodsInConstructor
        }

        protected abstract void InitialiseControl();

        public IControlHabanero Control
        {
            get { return _control; }
        }
    }
}
