using System;
using System.Collections.Generic;
using System.Text;
using Habanero.Faces.Base;
using Replace_it.BO;

namespace Replace_it.UI
{
    public abstract class UIManager
    {
        public IMainMenuHabanero SetupMainMenu(IFormHabanero programForm, IControlFactory controlFactory, IMenuBuilder menuBuilder)
        {
            HabaneroMenu menu = new HabaneroMenu("Main", programForm, GlobalUIRegistry.ControlFactory);

            HabaneroMenu dataMenu = menu.AddSubmenu("Data");
            HabaneroMenu.Item productsMenuItem = dataMenu.AddMenuItem("Computer Parts");
            productsMenuItem.ControlManagerCreator += delegate(IControlFactory factory) { return new ComputerPartsGridManager(factory); };
            HabaneroMenu.Item customerOrdersMenuItem = dataMenu.AddMenuItem("Customer Orders");
            customerOrdersMenuItem.ControlManagerCreator += delegate(IControlFactory factory) { return new OrdersGridManager<CustomerOrder>(factory); };
            HabaneroMenu.Item supplierOrdersMenuItem = dataMenu.AddMenuItem("Supplier Orders");
            supplierOrdersMenuItem.ControlManagerCreator += delegate(IControlFactory factory) { return new OrdersGridManager<SupplierOrder>(factory); };

            HabaneroMenu toolsMenu = menu.AddSubmenu("Tools");
            HabaneroMenu.Item looklupEditorMenuItem = toolsMenu.AddMenuItem("Lookup Editor");
            looklupEditorMenuItem.ControlManagerCreator += delegate(IControlFactory factory) { return new LookupEditorManager(factory); };

            return menuBuilder.BuildMainMenu(menu);
        }

        public abstract void SetupMainForm(IFormHabanero programForm);
    }
}
