using System;
using Habanero.Base;
using Habanero.BO;

namespace FireStarterModeller.BO
{
    public class BoPropAuthorisation : IBOPropAuthorisation
    {
        private readonly IBOProp _generatedProp;

        public BoPropAuthorisation(BOProp boProp, IBOProp generatedProp)
        {
            if (boProp == null) throw new ArgumentNullException("boProp");
            _generatedProp = generatedProp;
        }

        #region IBOPropAuthorisation Members

        public void AddAuthorisedRole(string authorisedRole, BOPropActions actionToPerform)
        {
        }

        public bool IsAuthorised(IBOProp boProp, BOPropActions actionToPerform)
        {
            if (actionToPerform == BOPropActions.CanRead)
            {
                return true;
            }

            object generated = _generatedProp.Value;
            bool isGenerated;
            if (generated == null) return true;
            if (bool.TryParse(Convert.ToString(generated), out isGenerated))
            {
                return !isGenerated;
            }
            return false;
        }

        #endregion
    }
}