// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class DMAssembly : IModelAssembly, IMergableBo
    {
        public DMAssembly()
        {
        }

        public DMAssembly(string assemblyName)
        {
            this.Name = assemblyName;
        }

        protected DMAssembly(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        protected internal DMAssembly(ClassDef def) : base(def)
        {
        }


        public override string ToString()
        {
            if (string.IsNullOrEmpty(this.Name))
            {
                return this.AssemblyID == null ? "-unnamed DMAssembly-" : Convert.ToString(this.AssemblyID);
            }
            return this.Name;
        }

        public override bool IsDeletable(out string message)
        {
            message = "";
            int classCount = this.Classes.Count;
            if (classCount > 0)
            {
                message = "The assembly '" + this.ToString() + "' cannot be deleted as there are " + classCount
                          + " objects related through the 'Classes' relationship that need to be deleted first.";
                return false;
            }
            return true;
        }

        public override bool IsEditable(out string message)
        {
            if(!base.IsEditable(out message)) return false;
            if (string.IsNullOrEmpty(this.AssemblyName)) return true;
            message = "The Assembly '" + this.ToString() + "' cannot be edited.";
            return !this.AssemblyName.StartsWith("System");
        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new DMAssemblyDuplicateClassNameRule());

        }

        public static DMAssembly Find(string name)
        {
            return Broker.GetBusinessObject<DMAssembly>(string.Format("Name = '{0}'", name));
        }

        public DMClass CreateClass(string className)
        {
            DMClass dmClass = this.Classes.CreateBusinessObject();
            dmClass.ClassNameBO = className;
            return dmClass;
        }

        public IModelElement Parent
        {
            get { return this.Solution; }
            set { this.Solution = (DMSolution) value; }
        }

        public string AssemblyName
        {
            get { return this.Name; }
            set { this.Name = value; }
        }

        /// <summary>
        /// Gets all the model classes assigned to this assembly
        /// </summary>
        public IList<IModelClass> ModelClasses
        {
            get
            {
                List<IModelClass> modelClasses = new List<IModelClass>();
                foreach (DMClass dmClass in this.Classes)
                {
                    modelClasses.Add(dmClass);
                }
                return modelClasses;
            }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set {  }
        }

        #endregion
    
    }
}