// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Runtime.Serialization;
using FireStarter.Base;
using Firestarter.DB.Schema.BO;
using FireStarterModeller.BO.BusinessObjectRules;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using Habanero.Util;

namespace FireStarterModeller.BO
{
    public interface IDMClass : IBusinessObject, IClassDef
    {
        string ClassNameBO { get; set; }
        bool IsObjectIDValid { get; }
        DMAssembly Assembly { get; }
        BusinessObjectCollection<DMUniqueConstraint> AllUniqueConstraints { get; }
        IDMSolution Solution { get; }
        BusinessObjectCollection<DMProperty> Properties { get; }
        bool IsSinglePropObjectID { get; }
        DMInheritanceRelationship InheritanceSuperClassRelationship { get; set; }
        BusinessObjectCollection<DMUniqueConstraint> UniqueConstraints { get; }
        DMObjectIdentity ObjectIdentity { get; }
        //string AssemblyName { get;}
        BusinessObjectCollection<DMRelationship> RelationshipsDM { get; }
        bool PrimaryKeyIsID { get; }
        BusinessObjectCollection<DMProperty> AllProperties { get; }
        BusinessObjectCollection<DMRelationship> RelatedRelationships { get; }
        BusinessObjectCollection<DMRelationship> OwnerRelationships { get; }
        DBTable MappedTable { get; }
        string MappedTableName { get; }
        Boolean? Generated { get; set; }
        BusinessObjectCollection<DMLookupListBusinessObject> DMLookupListBusinessObjects { get; }

        /// <summary>
        /// Returns the Object Identity of this object if it is set else its superclasses objectID
        /// </summary>
        /// <returns></returns>
        DMObjectIdentity GetObjectID();

        DMObjectIdentity CreateObjectIdentity(DMProperty property);
        DMProperty FindPropByName(string propertyName);
        DMUniqueConstraint CreateUnsavedUniqueConstraint(IList<DMProperty> dmProperties);
        IDMProperty GetDMProperty(string propertyName);
    }

    [Serializable]
    public partial class DMClass : IDMClass, IModelClass, IMergableBo
    {
        private DMClass ClonedClass { get; set; }
        public static bool Loading { private get; set; }

        public DMClass() : this(null)
        {
        }

        // ReSharper disable DoNotCallOverridableMethodsInConstructor
        protected internal DMClass(ClassDef def) : base(def)
        {
            SetupDMClass();
        }

        protected DMClass(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            SetupDMClass();
        }

        protected DMClass(ConstructForFakes constructForFakes)
            : base(constructForFakes)
        {
        }

        // ReSharper restore DoNotCallOverridableMethodsInConstructor

        protected virtual void SetupDMClass()
        {
            new PropertyLink<string, string>(this, "ClassNameBO", "MappedTableName", BusinessObjectNameToTableTransform);
            new PropertyLink<string, string>(this, "ClassNameBO", "DisplayName", GetDisplayNameFromClassName);
            MultipleRelationship<DMProperty> propRelationship =
                (MultipleRelationship<DMProperty>) this.Relationships["Properties"];
            propRelationship.CurrentBusinessObjectCollection.BusinessObjectAdded += HandleDMPropAddedEvent;
            propRelationship.CurrentBusinessObjectCollection.BusinessObjectRemoved +=
                (sender, args) => MarkDMClassAsDirty();
            propRelationship.CurrentBusinessObjectCollection.BusinessObjectPropertyUpdated += HandlePropertyUpdatedEvent;
            MultipleRelationship<DMRelationship> ownerRelRelationship =
                (MultipleRelationship<DMRelationship>) this.Relationships["RelationshipsDM"];
            ownerRelRelationship.CurrentBusinessObjectCollection.BusinessObjectAdded +=
                (sender, args) => MarkDMClassAsDirty();
            ownerRelRelationship.CurrentBusinessObjectCollection.BusinessObjectRemoved +=
                (sender, args) => MarkDMClassAsDirty();
            ownerRelRelationship.CurrentBusinessObjectCollection.BusinessObjectPropertyUpdated +=
                HandleRelationshipUpdatedEvent;

            BOProp prop = (BOProp) this.Props["ClassNameBO"];
            BoPropAuthorisation boPropAuthorisation = new BoPropAuthorisation(prop, this.Props["Generated"]);
            prop.SetAuthorisationRules(boPropAuthorisation);
        }

        public static string GetDisplayNameFromClassName(string value)
        {
            return StringUtilities.DelimitPascalCase(Convert.ToString(value), " ");
        }

        private void MarkDMClassAsDirty()
        {
            if (Loading) return;
            this.NeedsRegeneration = true;
        }


        private void HandlePropertyUpdatedEvent(object sender, BOPropUpdatedEventArgs<DMProperty> e)
        {
            DMProperty dmProperty = e.BusinessObject;
            if (!dmProperty.Status.IsDirty) return;
            if (dmProperty.Props
                .Any(boProp => boProp.IsDirty
                               || ((dmProperty.GenerateCode)
                                   && (!Convert.ToBoolean(dmProperty.Props["GenerateCode"].ValueBeforeLastEdit)))))
            {
                MarkDMClassAsDirty();
            }
        }

        private void HandleRelationshipUpdatedEvent(object sender, BOPropUpdatedEventArgs<DMRelationship> e)
        {
            DMRelationship relationship = e.BusinessObject;
            if (relationship.Status.IsDirty)
            {
                foreach (IBOProp boProp in relationship.Props)
                {
                    if (((boProp.PropertyName != "DMSortOrderID") && (boProp.IsDirty)) ||
                        ((relationship.GenerateCode) &&
                         (!Convert.ToBoolean(relationship.Props["GenerateCode"].ValueBeforeLastEdit))))
                    {
                        MarkDMClassAsDirty();
                        break;
                    }
                }
            }
        }


        private void HandleDMPropAddedEvent(object sender, BOEventArgs<DMProperty> e)
        {
            DMProperty dmProperty = e.BusinessObject;
            if (dmProperty.Status.IsNew)
            {
                MarkDMClassAsDirty();
                BusinessObjectCollection<DMProperty> properties = this.Properties;
                if (dmProperty.Order <= 0)
                {
                    int maxUIOrder = FirestarterUtils.GetNextUIOrder(properties);
                    dmProperty.OrdinalPosition = maxUIOrder;
                }

                // int maxFieldNumber = FirestarterUtils.GetMaxFieldNumber(properties);
                // dmProperty.MappedDBColumnName = "field" + (maxFieldNumber + 1);
                properties.Sort("OrdinalPosition", true, true);
            }
        }

        /// <summary>
        /// Creates a DMProperty for this DMClass.
        /// </summary>
        /// <returns></returns>
        public DMProperty CreateDMProp()
        {
            DMProperty dmProperty = this.Properties.CreateBusinessObject();
            dmProperty.PropertyTypeString = "System.String";
            return dmProperty;
        }

        public void MovePropertyUp(DMProperty dmProperty)
        {
            MoveProperty(dmProperty, true);
        }

        private void MoveProperty(DMProperty dmProperty, bool moveUp)
        {
            if (dmProperty == null) return;
            bool ascending = moveUp;
            BusinessObjectCollection<DMProperty> properties = this.Properties;
            List<DMProperty> sortedDefs = properties.GetSortedList("OrdinalPosition", ascending);
            FirestarterUtils.SwapObjectWithPrevious(sortedDefs, dmProperty);
            properties.Sort("OrdinalPosition", true, true);
        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new DMClassMustHaveOneProp());
            boRules.Add(new DMClassMustHaveObjectID());
            boRules.Add(new DMClassNameNoSpecialCharsRule());
            boRules.Add(new DMClassNameDoesNotStartWithNumberRule());
            boRules.Add(new DMClassDuplicateRelationshipNameRule());
            boRules.Add(new DMClassAllSubClassesDiscriminatorsAreEqual());
            boRules.Add(new DMClassSubClassPropertyNameNotSameAsSuperClassPropertyName());
            boRules.Add(new DMClassDuplicateUIViewNameRule());
        }

        public void MovePropertyDown(DMProperty dmProperty)
        {
            MoveProperty(dmProperty, false);
        }

        private string BusinessObjectNameToTableTransform(string boName)
        {
            return this.MappedTableID == null ? boName : this.MappedTableName;
        }

        public override string ToString()
        {
            if (string.IsNullOrEmpty(this.ClassNameBO))
            {
                return this.ClassID == null ? "-unnamed DMClass-" : Convert.ToString(this.ClassID);
            }
            return this.ClassNameBO;
        }

        public override bool IsDeletable(out string message)
        {
            base.IsDeletable(out message);
            if (this.Generated.GetValueOrDefault())
            {
                message += "The entity '" + this.ToString() + "' cannot be deleted as it has already been exported.";
            }
            return message.Length == 0;
        }

        public DMProperty FindBOPropertyByColumnId(Guid? columnInfoID)
        {
            return this.Properties.FirstOrDefault(propertyInfo => propertyInfo.MappedDBColumnID == columnInfoID);
        }


        public IDMSolution Solution
        {
            get { return this.Assembly == null ? null : this.Assembly.Solution; }
        }


        public void SetObjectIdentity(IEnumerable<DMProperty> selectedBOProps)
        {
            DMObjectIdentity dmObjectIdentity = ClearCurrentPrimaryKey();

            if (selectedBOProps == null) return;

            CreateNewPrimaryKey(selectedBOProps, dmObjectIdentity);
            this.ObjectIdentity = dmObjectIdentity;
        }

        private static void CreateNewPrimaryKey(IEnumerable<DMProperty> selectedBusinessObjects,
                                                DMObjectIdentity dmObjectIdentity)
        {
            foreach (DMProperty propertyInfo in selectedBusinessObjects)
            {
                dmObjectIdentity.Properties.Add(propertyInfo);
            }
        }

        private DMObjectIdentity ClearCurrentPrimaryKey()
        {
            DMObjectIdentity dmObjectIdentity = this.ObjectIdentity;
            if (this.ObjectIdentity != null)
            {
                BusinessObjectCollection<DMProperty> properties = dmObjectIdentity.Properties;
                properties.RemoveAll(property => true);
                //Hack_Brett: This is a hack to fix the failing Bug_ #369 - Seems to be a fundamental bug_ in Habanero but I cannot duplicate it in tests
                properties.Refresh();
                properties.RemoveAll(property => true);
            }
            else
            {
                dmObjectIdentity = CreateObjectIdentity();
            }
            return dmObjectIdentity;
        }

        public DMObjectIdentity CreateObjectIdentity(DMProperty propertyInfo)
        {
            DMObjectIdentity dmObjectIdentity = CreateObjectIdentity();
            dmObjectIdentity.Properties.Add(propertyInfo);
            return dmObjectIdentity;
        }

        public DMObjectIdentity CreateObjectIdentity()
        {
            DMObjectIdentity dmObjectIdentity = new DMObjectIdentity {Class = this};
            return dmObjectIdentity;
        }


        public virtual Boolean GenerateCode
        {
            get { return ((Boolean) (GetPropertyValue("GenerateCode"))); }
            set { SetPropertyValue("GenerateCode", value); }
        }

        public virtual Boolean NeedsRegeneration
        {
            get { return ((Boolean) (base.GetPropertyValue("NeedsRegeneration"))); }
            set { base.SetPropertyValue("NeedsRegeneration", value); }
        }

        //protected override bool AreCustomRulesValid(out string customRuleErrors)
        //{
        //    base.AreCustomRulesValid(out customRuleErrors);
        //    if (this.ObjectIdentity == null)
        //    {
        //        customRuleErrors += "The Entity '" + this.ToString() + "' cannot be saved as there is no primary key set for this entity.";
        //    }
        //    return customRuleErrors.Length == 0;
        //}


        //protected override void AfterLoad()
        //{
        //    base.AfterLoad();
        //    this.NeedsRegeneration = false;
        //}

        /// <summary>
        /// Executes any custom code required by the business object before it is persisted to the database.
        ///              This has the additionl capability of creating or updating other business objects and adding these
        ///              to the transaction committer.
        /// <remarks>
        /// Recursive call to UpdateObjectBeforePersisting will not be done i.e. it is the bo developers responsibility to implement
        /// </remarks>
        /// </summary>
        /// <param name="transactionCommitter">the transaction committer that is executing the transaction</param>
        protected override void UpdateObjectBeforePersisting(ITransactionCommitter transactionCommitter)
        {
            DMObjectIdentity dmObjectIdentity = this.ObjectIdentity;
            if (this.Status.IsDeleted && dmObjectIdentity != null)
            {
                dmObjectIdentity.MarkForDelete();
                transactionCommitter.AddBusinessObject(dmObjectIdentity);
            }
            DMInheritanceRelationship superClassRelationship = this.InheritanceSuperClassRelationship;
            if (superClassRelationship != null && superClassRelationship.Status.IsDeleted)
            {
                transactionCommitter.AddBusinessObject(superClassRelationship);
            }
            base.UpdateObjectBeforePersisting(transactionCommitter);
        }

        #region Implementation of IModelElement

        IModelElement IModelElement.Parent
        {
            get { return this.Assembly; }
            set
            {
                // The logic of whether to allow setting a parent is not clear to us
                // right now.  Change this approach if you need to and modify the tests.
                throw new HabaneroDeveloperException
                    ("Set the parent of the class by setting the related Assembly object", "");
            }
        }

        #endregion

        #region Implementation of IModelClass

        string IModelClass.ClassName
        {
            get { return this.ClassNameBO; }
            set { this.ClassNameBO = value; }
        }

        IList<IModelProperty> IModelClass.Properties
        {
            get { return this.Properties.Cast<IModelProperty>().ToList(); }
        }

        /// <summary>
        /// Gets all the properties in this class and inherited from parents
        /// </summary>
        IList<IModelProperty> IModelClass.AllProperties
        {
            get
            {
                // Eric: This uses cloning because of inheritance in templates.
                //   If you use an inherited property and call the ClassName, you
                //   get the parent class name, whereas you want to get the child's ClassName.
                //   Rework this if you can find a better solution to the inheritance issue.
                if (ClonedClass == null)
                {
                    ClonedClass = new DMClass();
                    CloneBusinessObjectContents(this, ClonedClass, "AssemblyID");
                    AddClonedProperties(this, ClonedClass);
                    AddClonedObjectIdentity(this, ClonedClass);
                }
                return ((IModelClass) ClonedClass).Properties;
            }
        }

        private static void AddClonedProperties(IDMClass originalClass, DMClass cloneClass)
        {
            foreach (DMProperty property in originalClass.Properties)
            {
                DMProperty cloneProperty = new DMProperty();
                CloneBusinessObjectContents(property, cloneProperty, "ClassID", "DefaultPropRuleID", "LookupListID");
                cloneClass.Properties.Add(cloneProperty);
            }
            DMInheritanceRelationship superClass = originalClass.InheritanceSuperClassRelationship;
            if (superClass == null) return;
            AddClonedProperties(superClass.SuperClass, cloneClass);
        }

//
//        private static void CloneBusinessObjectContents(IBusinessObject originalClass, IBusinessObject cloneClass)
//        {
//            CloneBusinessObjectContents(originalClass, cloneClass, "");
//        }

        private static void CloneBusinessObjectContents
            (IBusinessObject originalClass, IBusinessObject cloneClass, params string[] propNamesToIgnore)
        {
            List<string> ignoredPropNames = new List<string>(propNamesToIgnore);
            foreach (IBOProp boProp in originalClass.Props)
            {
                string propertyName = boProp.PropertyName;
                if (!originalClass.ID.Contains(propertyName) && !ignoredPropNames.Contains(propertyName))
                {
                    cloneClass.Props[propertyName].Value = boProp.Value;
                }
            }
        }

        private static void AddClonedObjectIdentity(IDMClass originalClass, DMClass cloneClass)
        {
            if (originalClass.ObjectIdentity == null) return;

            DMObjectIdentity clonedObjectIdentity = new DMObjectIdentity();
            clonedObjectIdentity.Class = cloneClass;
            clonedObjectIdentity.IsObjectID = originalClass.ObjectIdentity.IsObjectID.GetValueOrDefault();

            foreach (DMProperty dmProperty in cloneClass.Properties)
            {
                if (dmProperty.ObjectIdentityID.HasValue)
                {
                    dmProperty.ObjectIdentity = clonedObjectIdentity;
                }
            }
        }

        /// <summary>
        /// Gets the relationships owned by this class only, excluding inherited ones
        /// </summary>
        IList<IModelRelationship> IModelClass.Relationships
        {
            get { return this.OwnerRelationships.Cast<IModelRelationship>().ToList(); }
        }

        /// <summary>
        /// Gets the relationships owned by this class and inherited from parents
        /// </summary>
        IList<IModelRelationship> IModelClass.AllRelationships
        {
            get
            {
                if (ClonedClass == null)
                {
                    ClonedClass = new DMClass();
                    CloneBusinessObjectContents(this, ClonedClass, "AssemblyID");
                    AddClonedProperties(this, ClonedClass);
                    AddClonedObjectIdentity(this, ClonedClass);
                    AddClonedRelationships(this, ClonedClass);
                }
                return ((IModelClass) ClonedClass).Relationships;
            }
        }

        private static void AddClonedRelationships(DMClass originalClass, DMClass cloneClass)
        {
            //Debug.Print("Original Owner Class - " + DMRelationshipProperty.Prn(originalClass.ClassID));
            //Debug.Print("Clone Owner Class - " + DMRelationshipProperty.Prn(cloneClass.ClassID));
            foreach (DMRelationship dmRelationship in originalClass.OwnerRelationships.ToArray())
            {
                DMRelationship cloneRelationship = new DMRelationship();
                CloneBusinessObjectContents(dmRelationship, cloneRelationship, "ClassID", "ReverseRelationshipID");
                cloneClass.OwnerRelationships.Add(cloneRelationship);

                DMClass clonedRelatedClass = new DMClass();
                CloneBusinessObjectContents(dmRelationship.RelatedClass, clonedRelatedClass, "AssemblyID");
                AddClonedProperties(dmRelationship.RelatedClass, clonedRelatedClass);
                AddClonedObjectIdentity(dmRelationship.RelatedClass, clonedRelatedClass);
                cloneRelationship.RelatedClass = clonedRelatedClass;

                //Debug.Print("Original Related Class - " + DMRelationshipProperty.Prn(
                //    dmRelationship.ReverseRelationship != null ? dmRelationship.ReverseRelationship.ClassID : null));
                //Debug.Print("Original Relationship - " + DMRelationshipProperty.Prn(dmRelationship.RelationshipID));
                //Debug.Print("Original Rev Relationship - " + DMRelationshipProperty.Prn(dmRelationship.ReverseRelationshipID));
                //Debug.Print("Clone Related Class - " + DMRelationshipProperty.Prn(clonedRelatedClass.ClassID));
                //Debug.Print("Clone Relationship - " + DMRelationshipProperty.Prn(cloneRelationship.RelationshipID));
                //Debug.Print("Clone Rev Relationship - " + DMRelationshipProperty.Prn(cloneRelationship.ReverseRelationshipID));
                //Debug.Print("Clone Rev Rev Relationship - " + DMRelationshipProperty.Prn(cloneRelationship.ReverseRelationship.ReverseRelationshipID));

                foreach (DMRelationshipProperty relationshipProperty in dmRelationship.RelationshipProperties.ToArray())
                {
                    DMRelationshipProperty clonedRelationshipProperty =
                        cloneRelationship.RelationshipProperties.CreateBusinessObject();
                    //CloneBusinessObjectContents(relationshipProperty, clonedRelationshipProperty, "PropertyID");
                    clonedRelationshipProperty.OwnerProperty =
                        cloneClass.FindPropByName(relationshipProperty.OwnerPropertyName);
                    clonedRelationshipProperty.RelatedProperty =
                        clonedRelatedClass.FindPropByName(relationshipProperty.RelatedPropertyName);
                    //cloneRelationship.RelationshipProperties.Add(clonedRelationshipProperty);
                }
            }
            DMInheritanceRelationship superClass = originalClass.InheritanceSuperClassRelationship;
            if (superClass == null) return;
            if (superClass.SuperClass == null) return;
            AddClonedRelationships(superClass.SuperClass, cloneClass);
        }

        public virtual string AssemblyName
        {
            get { return this.Assembly == null ? "" : this.Assembly.AssemblyName; }
            set
            {
                throw new HabaneroDeveloperException(
                    "Cannot set the AssemblyName property of a DMClass, set this through the Assembly relationship instead.",
                    "");
            }
        }

        string IModelClass.AssemblyName
        {
            get
            {
                if (this.Assembly == null)
                {
                    return "";
                }
                return this.Assembly.AssemblyName;
            }
        }

        string IModelClass.SuperClassName
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) return "";
                if (this.InheritanceSuperClassRelationship.SuperClass == null)
                {
                    throw new HabaneroDeveloperException
                        (string.Format("DMInheritanceRelationship for '{0}' has not had its SuperClassClass set",
                                       this.ClassNameBO),
                         "");
                }
                return this.InheritanceSuperClassRelationship.SuperClass.ClassNameBO;
            }
        }

        string IModelClass.SuperClassAssemblyName
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) return "";
                if (this.InheritanceSuperClassRelationship.SuperClass == null)
                {
                    throw new HabaneroDeveloperException
                        (string.Format("DMInheritanceRelationship for '{0}' has not had its SuperClassClass set",
                                       this.ClassNameBO),
                         "");
                }
                if (this.InheritanceSuperClassRelationship.SuperClass.Assembly == null)
                {
                    throw new HabaneroDeveloperException
                        (string.Format("DMInheritanceRelationship for '{0}' has no Assembly", this.ClassNameBO), "");
                }
                return this.InheritanceSuperClassRelationship.SuperClass.Assembly.AssemblyName;
            }
        }

        string IModelClass.SuperClassChildID
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) return "";
                return this.InheritanceSuperClassRelationship.Identity;
            }
        }

        string IModelClass.SuperClassDiscriminator
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) return "";
                return this.InheritanceSuperClassRelationship.Discriminator;
            }
        }

        string IModelClass.InheritanceType
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) return "";
                if (!this.InheritanceSuperClassRelationship.InheritanceType.HasValue)
                {
                    throw new HabaneroDeveloperException
                        (string.Format("Inheritance type for DMInheritanceRelationship of '{0}' cannot be null",
                                       this.ClassNameBO),
                         "");
                }
                return this.InheritanceSuperClassRelationship.InheritanceType.Value.ToString();
            }
        }

        /// <summary>
        /// Searches the relationship definition collection and returns 
        ///             the relationship definition found under the
        ///             relationship with the name specified.
        /// </summary>
        /// <param name="relationshipName">The relationship name in question</param>
        /// <returns>
        /// Returns the relationship definition if found, 
        ///             or null if not found
        /// </returns>
        public IRelationshipDef GetRelationship(string relationshipName)
        {
            return this.OwnerRelationships.Find(relationship => relationship.RelationshipName == relationshipName);
        }


        string IModelClass.TableName
        {
            get { return this.MappedTableName; }
        }

        IList<IModelProperty> IModelClass.PrimaryKeyProperties
        {
            get
            {
                if (this.GetObjectID() == null)
                {
                    throw new HabaneroDeveloperException
                        (string.Format("ObjectIdentity for class '{0}' has nor been set.", this.ClassNameBO), "");
                }
                DMObjectIdentity objectIdentity = this.GetObjectID();
                return objectIdentity.Properties.Cast<IModelProperty>().ToList();
            }
        }

        bool IModelClass.PrimaryKeyIsID
        {
            get { return PrimaryKeyIsID; }
        }

        IList<IModelKey> IModelClass.AlternateKeys
        {
            get
            {
                BusinessObjectCollection<DMUniqueConstraint> uniqueConstraints = this.UniqueConstraints;
                return uniqueConstraints.Cast<IModelKey>().ToList();
            }
        }

        public bool HasSuperClass
        {
            get
            {
                return this.InheritanceSuperClassRelationship != null &&
                       this.InheritanceSuperClassRelationship.SuperClass != null;
            }
        }

        // ReSharper disable PossibleNullReferenceException
        bool IModelClass.SuperClassDefIDIsEmpty
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) ThrowSuperClassError("SuperClassDefIDIsEmpty");
                return this.InheritanceSuperClassRelationship.Identity == "";
            }
        }

        bool IModelClass.SuperClassDefIDIsNotNullOrEmpty
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null)
                    ThrowSuperClassError("SuperClassDefIDIsNotNullOrEmpty");
                return !String.IsNullOrEmpty(this.InheritanceSuperClassRelationship.Identity);
            }
        }

        bool IModelClass.SuperClassDefIDIsNull
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) ThrowSuperClassError("SuperClassDefIDIsNull");
                return this.InheritanceSuperClassRelationship.Identity == null;
            }
        }

        bool IModelClass.HasPrimaryKeyWithProps
        {
            get { return (this.ObjectIdentity != null && this.ObjectIdentity.HasProperties); }
        }

        IModelClass IModelClass.SuperClass
        {
            get
            {
                if (this.InheritanceSuperClassRelationship == null) ThrowSuperClassError("SuperClass");

                return this.InheritanceSuperClassRelationship.SuperClass;
            }
        }

        public DMClass SuperClass
        {
            get
            {
                return this.InheritanceSuperClassRelationship == null
                           ? null
                           : this.InheritanceSuperClassRelationship.SuperClass;
            }
            set
            {
                this.InheritanceSuperClassRelationship = new DMInheritanceRelationship
                                                             {
                                                                 SuperClass = value,
                                                                 InheritanceType = ORMapping.SingleTableInheritance
                                                             };
            }
        }


        private void ThrowSuperClassError(string errorProperty)
        {
            throw new HabaneroDeveloperException
                (string.Format
                     (errorProperty + " is being called on class '{0}' when the class has no SuperClass. "
                      + "First check for a SuperClass using HasSuperClass.", this.ClassNameBO), "");
        }

        // ReSharper restore PossibleNullReferenceException

        #endregion

        #region Implementation of IClassDef 

        string IClassDef.ClassNameFull
        {
            get { return ClassNameBO; }
            set { ClassNameBO = value; }
        }

        string IClassDef.ClassName
        {
            get { return ClassNameBO; }
            set { ClassNameBO = value; }
        }

        string IClassDef.ClassNameExcludingTypeParameter
        {
            get { return this.ClassNameBO; }
        }

        string IClassDef.TypeParameter
        {
            get { return TypeParameter; }
            set { TypeParameter = value; }
        }

        IRelationshipDefCol IClassDef.RelationshipDefCol
        {
            get
            {
                DMRelationshipCollection relCol = new DMRelationshipCollection();
                this.OwnerRelationships.ForEach(relCol.Add);
                return relCol;
            }
            set { SetRelationships(value); }
        }

        private void SetRelationships(IEnumerable<IRelationshipDef> relationshipDefCol)
        {
            if (relationshipDefCol == null) return;
            foreach (IRelationshipDef relationshipDef in relationshipDefCol)
            {
                this.RelationshipsDM.Add((DMRelationship) relationshipDef);
            }
        }

        IPropDefCol IClassDef.PropDefColIncludingInheritance
        {
            get { throw new System.NotImplementedException(); }
        }


        IPropDef IClassDef.GetPropDef(string propertyName)
        {
            return this.FindPropByName(propertyName);
        }

        IPropDef IClassDef.GetPropDef(string propertyName, bool throwError)
        {
            throw new System.NotImplementedException();
        }

        IPropDef IClassDef.GetPropDef(Source source, string propertyName, bool throwError)
        {
            throw new System.NotImplementedException();
        }

        ILookupList IClassDef.GetLookupList(string propertyName)
        {
            throw new System.NotImplementedException();
        }

        IBusinessObject IClassDef.CreateNewBusinessObject()
        {
            throw new System.NotImplementedException();
        }

        string IClassDef.GetTableName(IPropDef propDef)
        {
            throw new System.NotImplementedException();
        }

        Type IClassDef.GetPropertyType(string propertyName)
        {
            throw new System.NotImplementedException();
        }

        IPropertyComparer<T> IClassDef.CreatePropertyComparer<T>(string propertyName)
        {
            throw new System.NotImplementedException();
        }

        string IClassDef.GetTableName()
        {
            throw new System.NotImplementedException();
        }

        bool IClassDef.IsUsingClassTableInheritance()
        {
            throw new System.NotImplementedException();
        }

        string IClassDef.TableName
        {
            get { return MappedTableName; }
            set { MappedTableName = value; }
        }

        Type IClassDef.ClassType
        {
            get { throw new System.NotImplementedException(); }
            set { throw new System.NotImplementedException(); }
        }

        IPropDefCol IClassDef.PropDefcol
        {
            get
            {
                DMPropertyCollection propCol = new DMPropertyCollection();
                this.Properties.ForEach(propCol.Add);
                return propCol;
            }
            set { throw new System.NotImplementedException(); }
        }

        ISuperClassDef IClassDef.SuperClassDef
        {
            get { return InheritanceSuperClassRelationship; }
            set { this.InheritanceSuperClassRelationship = (DMInheritanceRelationship) value; }
        }

        string IClassDef.Module
        {
            get { throw new System.NotImplementedException(); }
            set { throw new System.NotImplementedException(); }
        }

        IPrimaryKeyDef IClassDef.PrimaryKeyDef
        {
            get
            {
                //if (this.ObjectIdentity == null)
                //{
                //    if (this.InheritanceSuperClassRelationship != null && InheritanceSuperClassRelationship.SuperClass != null)
                //        return ((IClassDef) InheritanceSuperClassRelationship.SuperClass).PrimaryKeyDef;
                //}

                return this.ObjectIdentity;
            }
            set { this.ObjectIdentity = (DMObjectIdentity) value; }
        }

        KeyDefCol IClassDef.KeysCol
        {
            get
            {
                KeyDefCol keyDefCol = new KeyDefCol();
                this.UniqueConstraints.ForEach(keyDefCol.Add);
                return keyDefCol;
            }
            set { throw new NotImplementedException(); }
        }

        UIDefCol IClassDef.UIDefCol
        {
            get
            {
                UIDefCol uiDefCol = new UIDefCol();
                this.UIViews.ForEach(uiDefCol.Add);
                return uiDefCol;
            }
            set { SetUIDefs(value); }
        }

        private void SetUIDefs(UIDefCol uiDefCol)
        {
            if (uiDefCol == null) return;
            foreach (IUIDef uiDef in uiDefCol)
            {
                this.UIViews.Add((UIView) uiDef);
            }
        }

        ClassDefCol IClassDef.AllChildren
        {
            get
            {
                ClassDefCol col = new ClassDefCol();
                this.SubClassRelationships.ForEach(relationship => col.Add(relationship.SubClass));
                return col;
            }
        }

        public IClassDef SuperClassClassDef
        {
            get
            {
                return this.InheritanceSuperClassRelationship == null
                           ? null
                           : this.InheritanceSuperClassRelationship.SuperClass;
            }
        }

        #endregion

        public bool PrimaryKeyIsID
        {
            get
            {
                if (this.GetObjectID() == null)
                {
                    throw new HabaneroDeveloperException
                        (string.Format
                             ("Cannot call PrimaryKeyIsID when ObjectIdentity has not been set, in class: {0}",
                              this.ClassNameBO), "");
                }
                return this.GetObjectID().IsObjectID.GetValueOrDefault();
            }
        }

        public DMUniqueConstraint CreateUnsavedUniqueConstraint(IList<DMProperty> selectedProperties)
        {
            if (selectedProperties == null) return null;
            if (selectedProperties.Count == 0) return null;
            if (this.UniqueConstraints.Count > 0)
            {
                foreach (DMUniqueConstraint constraint in this.UniqueConstraints)
                {
                    if (constraint.AreAllPropertiesEqual(selectedProperties)) return constraint;
                }
            }
            DMUniqueConstraint uniqueConstraint = this.UniqueConstraints.CreateBusinessObject();
            string constraintName = "";
            foreach (DMProperty dmProperty in selectedProperties)
            {
                DMUniqueConstraintProperty uniqueConstraintProperty =
                    uniqueConstraint.UniqueConstraintProperties.CreateBusinessObject();
                uniqueConstraintProperty.Property = dmProperty;
                constraintName = string.Format("{0}{1}_", constraintName, dmProperty.PropertyName);
            }
            constraintName = constraintName.Remove(constraintName.Length - 1);
            uniqueConstraint.UniqueConstraintName = constraintName;
            return uniqueConstraint;
        }

        public DMProperty FindBOPropertyByColumnName(string columnName)
        {
            BusinessObjectCollection<DMProperty> properties = Properties;
            properties = properties.Clone();
            properties.Sort("OrdinalPosition", true, true);
            return properties.Find(property => property.MappedDBColumnName == columnName);
        }


        public string FullName
        {
            get
            {
                if (this.Assembly == null)
                {
                    return this.ClassNameBO;
                }
                return this.Assembly.Name + "." + this.ClassNameBO;
            }
        }

        public BusinessObjectCollection<DMRelationship> OwnerRelationships
        {
            //TODO Mark 06 Aug 2009: Test this readonly property
            get { return this.RelationshipsDM; }
        }

        public BusinessObjectCollection<DMRelationship> RelatedRelationships
        {
            //TODO Mark 06 Aug 2009: Test this readonly property
            get { return this.RelationshipsDM; }
        }

        public BusinessObjectCollection<DMProperty> AllProperties
        {
            get
            {
                BusinessObjectCollection<DMProperty> allProperties = new BusinessObjectCollection<DMProperty>();
                AddProperties(this, allProperties);
                return allProperties;
            }
        }

        private static void AddProperties(IDMClass originalClass, ICollection<DMProperty> allProperties)
        {
            if (originalClass == null) return;
            if (allProperties == null) return;
            foreach (DMProperty property in originalClass.Properties)
            {
                allProperties.Add(property);
            }
            DMInheritanceRelationship superClass = originalClass.InheritanceSuperClassRelationship;
            if (superClass == null) return;
            AddProperties(superClass.SuperClass, allProperties);
        }

/*        /// <summary>
        /// Returns a BusinessObjectCollection of all Related Classes to the number of levels deep specified by number of levels
        /// If you want to traverse the tree through all levels then specify number of levels to be Int.MaxValue;
        /// </summary>
        /// <param name="numLevels"></param>
        /// <returns></returns>
        private BusinessObjectCollection<DMClass> GetAllSingleRelatedClasses(int numLevels)
        {
            BusinessObjectCollection<DMClass> classes = new BusinessObjectCollection<DMClass>();
            if (numLevels <= 0) return classes;
            BusinessObjectCollection<DMRelationship> relationships = this.OwnerRelationships.Clone();
            foreach (DMRelationship relationship in relationships)
            {
                if (relationship.Cardinality == Cardinality.Single)
                {
                    DMClass relatedClass = relationship.RelatedClass;
                    if (!classes.Contains(relatedClass))
                    {
                        classes.Add(relatedClass);

                        BusinessObjectCollection<DMClass> innerList =
                            relatedClass.GetAllSingleRelatedClasses(numLevels - 1);
                        classes.Add(innerList);
                    }
                }
            }
            return classes;
        }*/

/*        /// <summary>
        /// Returns a  BusinessObjectCollection of all Single Related Classes where the entire tree is traversed.
        /// </summary>
        /// <returns></returns>
        public BusinessObjectCollection<DMClass> GetAllSingleRelatedClasses()
        {
            return GetAllSingleRelatedClasses(int.MaxValue);
        }*/


        /// <summary>
        /// Returns only the props that are not part of a single relationship.
        /// </summary>
        /// <returns></returns>
        public BusinessObjectCollection<DMProperty> GetNonSingleRelationshipProperties()
        {
            BusinessObjectCollection<DMProperty> properties = this.Properties.Clone();
            for (int counter = properties.Count - 1; counter >= 0; counter--)
            {
                DMProperty dmProperty = properties[counter];
                if (dmProperty.IsPartOfSingleRelationship())
                {
                    properties.Remove(dmProperty);
                }
            }
            return properties;
        }

        /// <summary>
        /// Creates a Property Id using Default Naming and System Type Rules.
        /// </summary>
        public void CreateObjectIdWithDefaultProp()
        {
            if (this.ObjectIdentity != null) return;
            DMProperty property = this.Properties.CreateBusinessObject();
            property.PropertyName = GetStandardPKPropName();
            property.PropertyTypeString = "System.Guid";
            this.ObjectIdentity = new DMObjectIdentity {IsObjectID = true};
            this.ObjectIdentity.Properties.Add(property);
//            this.Save();
        }

        private string GetStandardPKPropName()
        {
            return this.ClassNameBO + "ID";
        }

        /// <summary>
        /// Returns the DMProperty identified by 
        /// <paramref name="propertyName"/> for this class or for any of its 
        /// Inheritance Super Classes <see cref="InheritanceSuperClassRelationship"/>.
        /// </summary>
        /// <param name="propertyName"></param>
        /// <returns></returns>
        public IDMProperty GetDMProperty(string propertyName)
        {
            return this.AllProperties.Find(property => property.PropertyName == propertyName);
        }

        /// <summary>
        /// Return true if this class or any of its parent classes has the Property identified by 
        /// <paramref name="propertyName"/>
        /// </summary>
        /// <param name="propertyName"></param>
        /// <returns></returns>
        public bool HasProperty(string propertyName)
        {
            return this.GetDMProperty(propertyName) != null;
        }

        /// <summary>
        /// Returns True if this Class owns the Property i.e.
        /// It is not Inherited from any superclass.
        /// If you want to check for SuperClasses as well
        /// then please use <see cref="HasProperty"/>
        /// </summary>
        /// <param name="propertyName"></param>
        /// <returns></returns>
        public bool OwnsProperty(string propertyName)
        {
            return FindPropByName(propertyName) != null;
        }

        /// <summary>
        /// Returns the Property that this object owns.
        /// If the Property is inherited from a SuperClass then null will be returned
        /// rather use <see cref="GetDMProperty"/>
        /// </summary>
        /// <param name="propertyName"></param>
        /// <returns></returns>
        public DMProperty FindPropByName(string propertyName)
        {
            return this.Properties.Find(property => property.PropertyName == propertyName);
        }

        /// <summary>
        /// Returns the ObjectID for this DMClass. If the DMClass has its own ObjectID defined then this is returned.
        /// Else the ObjectID of its SuperClass is returned. If no ObjectID is defined then returns null.
        /// This is the ObjectID that will be used by this class when it is generating Code and ClassDefs.
        /// </summary>
        /// <returns>The found </returns>
        public DMObjectIdentity GetObjectID()
        {
            if (this.ObjectIdentity != null && this.ObjectIdentity.HasProperties)
                return this.ObjectIdentity;
            return HasSuperClass ? this.SuperClass.GetObjectID() : null;
        }


        public bool IsObjectIDValid
        {
            get
            {
                DMObjectIdentity objectID = this.GetObjectID();
                return (objectID != null && objectID.HasProperties);
            }
        }

        public List<DMProperty> NonOIDProperties
        {
            get { return Properties.FindAll(property => property.ObjectIdentity == null); }
        }

        public bool IsSinglePropObjectID
        {
            get { return this.ObjectIdentity != null && this.ObjectIdentity.Properties.Count == 1; }
        }

        /// <summary>
        /// Returns All Unique Constraints including those Inherited from SuperClasses.
        /// </summary>
        public BusinessObjectCollection<DMUniqueConstraint> AllUniqueConstraints
        {
            get
            {
                BusinessObjectCollection<DMUniqueConstraint> dmUniqueConstraints = this.UniqueConstraints;
                if (this.InheritanceSuperClassRelationship != null &&
                    this.InheritanceSuperClassRelationship.SuperClass != null)
                {
                    dmUniqueConstraints =
                        dmUniqueConstraints.Union(this.InheritanceSuperClassRelationship.SuperClass.AllUniqueConstraints);
                }
                return dmUniqueConstraints;
            }
        }

        /// <summary>
        /// Returns True if any propery other than those making up the Object ID are 
        ///  Compulsory.
        /// </summary>
        public bool HasCompulsoryProperties
        {
            get { return Properties.Any(property => !property.IsPartOfObjectIdentity && property.IsCompulsory); }
        }

        /// <summary>
        /// Returns true if any of this BO's Relationships have the Foreign Key on the BO.
        /// </summary>
        public virtual bool HasRelationshipsWithRelatedFK
        {
            get { return this.RelationshipsDM.Any(relationship => relationship.RelatedBOHasForeignKey); }
        }


        public BusinessObjectCollection<DMProperty> GetSortOrderProperties()
        {
            BusinessObjectCollection<DMProperty> sortOrderProperties = AllProperties;
            AllProperties.ForEach(
                delegate(DMProperty property) { property.SortOrderPropertyName = property.PropertyName; }
                );
            BusinessObjectCollection<DMClass> classes = new BusinessObjectCollection<DMClass>();
            BusinessObjectCollection<DMRelationship> relationships = this.OwnerRelationships.Clone();
            var singleRelationships = relationships.Where(relationship => relationship.IsSingle);
            foreach (DMRelationship relationship in singleRelationships)
            {
//                if (relationship.Cardinality != Cardinality.Single) continue;
                DMClass relatedClass = (DMClass) relationship.RelatedClass;
                if (classes.Contains(relatedClass)) continue;
                BusinessObjectCollection<DMProperty> dmProperties = relatedClass.AllProperties;
                DMRelationship relationship1 = relationship;
                dmProperties.ForEach(
                    delegate(DMProperty property) { property.SortOrderPropertyName = relationship1.RelationshipName + "." + property.PropertyName; }
                    );
                sortOrderProperties.Add(dmProperties);
            }
            return sortOrderProperties;
        }

        public virtual void RenameClass()
        {
            this.MappedTableName = BusinessObjectNameToTableTransform(this.ClassNameBO);
            this.DisplayName = GetDisplayNameFromClassName(this.ClassNameBO);
            if (this.GetObjectID() != null)
            {
                if (this.ObjectIdentity != null)
                {
                    var pkProp = this.ObjectIdentity.Properties.First();
                    pkProp.PropertyName = GetStandardPKPropName();
                    pkProp.RenameProperty();
                }
            }
            else if (this.InheritanceSuperClassRelationship == null)
            {
                this.CreateObjectIdWithDefaultProp();
            }
        }

        public void ClearClonedClass()
        {
            ClonedClass = null;
        }

        // ReSharper disable EmptyGeneralCatchClause
        public string GetUniqueViewNameWithSuffix(string viewName)
        {
            string name = "";
            Int32 val = 0;
            List<UIView> uiViews = this.UIViews.FindAll(uiview => uiview.ViewName.StartsWith(viewName));
            if (uiViews.Count < 2) return viewName;
            uiViews.Sort((x, y) => string.Compare(x.ViewName, y.ViewName));
            if (uiViews.Count == 0) return viewName;
            int startIndex = viewName.Length;
            foreach (UIView uiView in uiViews)
            {
                if (uiView.ViewName == viewName) continue;
                name = uiView.ViewName.Substring(startIndex, uiView.ViewName.Length - startIndex);
                try
                {
                    Int32 nextVal = System.Convert.ToInt32(name);
                    if (nextVal > val) val = nextVal;
                }
                catch
                {
                    //Do Nothing
                }
            }
            val++;
            return viewName + val;
        }

        // ReSharper restore EmptyGeneralCatchClause

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType { get; set; }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}