// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;

namespace FireStarterModeller.BO
{
    public partial class DMInheritanceRelationship : ISuperClassDef, IMergableBo
    {
        private string _superClassAssemblyName;
        private string _superClassName;
        private string _superClassTypeParameter;

        public virtual DMClass SuperClass
        {
            get
            {
                var superClass = Relationships.GetRelatedObject<DMClass>("SuperClass");
                if (superClass == null && SubClass != null && !string.IsNullOrEmpty(_superClassName) &&
                    !string.IsNullOrEmpty(_superClassAssemblyName))
                {
                    DMSolution solution = SubClass.Solution as DMSolution;
                    if (solution != null)
                    {
                        superClass = solution.AllClasses.Find(
                            @class =>
                            @class.ClassNameBO == _superClassName &&
                            @class.Assembly.AssemblyName == _superClassAssemblyName);

                        SuperClass = superClass;
                    }
                }

                if (superClass == null && !string.IsNullOrEmpty(_superClassName) &&
                    !string.IsNullOrEmpty(_superClassAssemblyName))
                {
                    if (!ClassDefCol.GetColClassDef().Contains(_superClassAssemblyName, _superClassName)) return null;
                    superClass = ClassDefCol.GetColClassDef()[_superClassAssemblyName, _superClassName] as DMClass;
                    SuperClass = superClass;
                }
                return superClass;
            }
            set { Relationships.SetRelatedObject("SuperClass", value); }
        }

        #region Implementation of ISuperClassDef

        public string TypeParameter
        {
            get { throw new NotImplementedException(); }
            set { throw new NotImplementedException(); }
        }

        ORMapping ISuperClassDef.ORMapping
        {
            get { return InheritanceType.Value; }
            set { InheritanceType = value; }
        }

        string ISuperClassDef.AssemblyName
        {
            get
            {
                if (SuperClass != null) return SuperClass.Assembly.AssemblyName;
                return _superClassAssemblyName;
            }
            set { _superClassAssemblyName = value; }
        }

        string ISuperClassDef.ClassName
        {
            get
            {
                if (SuperClass != null) return SuperClass.ClassNameBO;
                return _superClassName;
            }
            set { _superClassName = value; }
        }

        IClassDef ISuperClassDef.SuperClassClassDef
        {
            get
            {
                if (SuperClass != null) return SuperClass;
                return null;
            }
            set { SuperClass = (DMClass) value; }
        }

        string ISuperClassDef.ID
        {
            get { return Identity; }
            set { Identity = value; }
        }

        string ISuperClassDef.TypeParameter
        {
            get
            {
                if (SuperClass != null) return SuperClass.TypeParameter;
                return _superClassTypeParameter;
            }
            set { _superClassTypeParameter = value; }
        }

        #endregion

        public override string ToString()
        {
            if (SubClass == null && SuperClass == null) return base.ToString();
            return SubClass + "-" + SuperClass;
        }

        /// <summary>
        ///             Override this method in subclasses of DMClass to check custom rules for that
        ///             class.  The default implementation returns true and sets customRuleErrors to the empty string.
        /// </summary>
        /// <param name="customRuleErrors">The error string to display</param>
        /// <returns>
        /// true if no custom rule errors are encountered.
        /// </returns>
        protected override bool AreCustomRulesValid(out string customRuleErrors)
        {
            base.AreCustomRulesValid(out customRuleErrors);
            //if (this.InheritanceType == ORMapping.ClassTableInheritance && this.ID == null)
            //{
            //    customRuleErrors += "The ID is compulsory for Class Table Inheritance";
            //}
            if (InheritanceType == ORMapping.SingleTableInheritance && Discriminator == null)
            {
                customRuleErrors += "The Discriminator is compulsory for Single Table Inheritance";
            }
            return (customRuleErrors.Length == 0);
        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new DMInheritanceRelationshipDiscriminatorMustBeStringProp());
            boRules.Add(new DMInheritanceHierachDiscriminatorsAreEqual());
            boRules.Add(new DMInheritanceRelationshipDiscriminatorMustBeCompulsoryAndWriteOnceOrWriteNew());
        }

        public void CreateDiscriminator()
        {
            if (this.SuperClass == null)
            {
                throw new UserException("The Super Class has not been set for the Inheritance Relationship for '" +
                                        ToString());
            }
            if (this.SubClass == null)
            {
                throw new UserException("The Sub Class has not been set for the Inheritance Relationship for '" +
                                        ToString());
            }
            if (this.InheritanceType == ORMapping.ConcreteTableInheritance)
            {
                throw new UserException("The Inheritance Type cannot be Concrete Table Inheritance");
            }

            DMProperty prop = this.SuperClass.CreateDMProp();
            string discriminatorName = SuperClass.ClassNameBO + "Type";
            prop.PropertyName = discriminatorName;
            this.Discriminator = prop.PropertyName;
//            prop.ReadWriteRule = PropReadWriteRule.WriteOnce;
        }

        public Dictionary<string, string> GetIDLookupList()
        {
                   
            var subClass = this.SubClass;
            if (subClass == null) return null;
            var superClass = this.SuperClass;
            if (superClass == null) return null;
           
            Dictionary<string, string> idLookupList = new Dictionary<string, string>();
            
            DMObjectIdentity superClassObjectID = superClass.GetObjectID();
            DMObjectIdentity subClassObjectID = subClass.ObjectIdentity;
            
            if (IsCompositeKey(superClassObjectID) || IsCompositeKey(subClassObjectID))
            {
                throw new UserException(
                    "You cannot use a DMClass that has a Composite Primary Key in an Inheritance Relationship");

            }
            if (superClassObjectID != null && superClassObjectID.HasProperties)
            {

                DMProperty superClassIdentityProp = superClassObjectID.Properties[0];
                idLookupList.Add(superClassIdentityProp.PropertyName, superClassIdentityProp.ID.ToString());
            }
            foreach (DMProperty prop in subClass.Properties.ToArray())
            {
                idLookupList.Add(prop.PropertyName, prop.ID.ToString());
            }
           
            return idLookupList;
        }

        private bool IsCompositeKey(DMObjectIdentity objectID)
        {
            return (objectID != null && objectID.IsCompositeKey);
        }

        public IDMProperty GetDiscriminatorProp()
        {
            var discriminatorName = this.Discriminator;
            return this.SubClass.GetDMProperty(discriminatorName);
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}