// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    public interface IHasOwnerClass
    {
        string OwnerClassName { get; }
    }

    [Serializable]
    public partial class DMLookupListBusinessObject : IBusinessObjectLookupList, IModelElement, IHasOwnerClass, IMergableBo
    {
        public DMLookupListBusinessObject()
        {
            this.Relationships.GetSingle("DMClass").RelatedBusinessObjectChanged += (sender, args) =>
            {
                if (this.DMSortOrder != null)
                {
                    this.DMSortOrder.MarkForDelete();
                    this.DMSortOrder.Save();
                    this.DMSortOrder = new DMSortOrder();
                }
            };
        }
    

        protected internal DMLookupListBusinessObject(ClassDef def) : base(def)
        {
        }

        protected DMLookupListBusinessObject(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            if (this.DMClass==null)
            {
                return this.BusinessObjectLookupListID == null
                           ? "-unnamed BOLookupList-"
                           : Convert.ToString(this.BusinessObjectLookupListID);
            }
            return this.DMClass.ClassNameBO;
        }
        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            //boRules.Add(new DMLookupListSortOrderPropsMustExist(this));
            boRules.Add(new DMSortOrderPropMustBeOnRelatedClassRule((SingleRelationship<DMSortOrder>)this.Relationships["DMSortOrder"], (SingleRelationship<DMClass>)this.Relationships["DMClass"]));

            
        }
        #region Implementation of ILookupList
        //TODO brett 28 Sep 2009: why are these not implemented
        public Dictionary<string, string> GetLookupList()
        {
            throw new System.NotImplementedException();
        }

        public Dictionary<string, string> GetLookupList(IDatabaseConnection connection)
        {
            throw new System.NotImplementedException();
        }

        public Dictionary<string, string> GetIDValueLookupList()
        {
            throw new System.NotImplementedException();
        }

        public IPropDef PropDef
        {
            get { return this.DMProperty; }
            set { this.DMProperty = (DMProperty)value; }
        }

        //TODO brett 28 Sep 2009: why are these not implemented
        public bool LimitToList
        {
            get { throw new System.NotImplementedException(); }
        }

        int ILookupList.TimeOut
        {
            get { return Timeout.GetValueOrDefault(); }
            set { Timeout = value; }
        }

        #endregion

        #region Implementation of ILookupListWithClassDef

        protected override void UpdateObjectBeforePersisting(ITransactionCommitter transactionCommitter)
        {
            DMSortOrder dmSortOrder = this.DMSortOrder;
            if (this.Status.IsDeleted || (dmSortOrder != null && dmSortOrder.DMSortProperties.Count == 0))
            {
                if (dmSortOrder != null)
                {
                    dmSortOrder.MarkForDelete();
                    transactionCommitter.AddBusinessObject(dmSortOrder);
                    this.DMSortOrder = null;
                }
            }
            base.UpdateObjectBeforePersisting(transactionCommitter);
        }

        IClassDef ILookupListWithClassDef.ClassDef
        {
            get { throw new NotImplementedException(); } }

        #endregion

        #region Implementation of IBusinessObjectLookupList

        string IBusinessObjectLookupList.AssemblyName
        {
            get
            {
                if (this.DMClass != null) return DMClass.Assembly.AssemblyName;
                return this.AssemblyName;
            }
            set { this.AssemblyName = value; }
        }

        string IBusinessObjectLookupList.ClassName
        {
            get
            {
                if (this.DMClass != null) return DMClass.ClassNameBO;
                return this.ClassName;
            }
            set { this.ClassName = value; }
        }

        IOrderCriteria IBusinessObjectLookupList.OrderCriteria
        {
            get { throw new NotImplementedException(); } }

        Criteria IBusinessObjectLookupList.Criteria
        {
             get { throw new NotImplementedException(); } }

        public string SortString
        {
            get { return Convert.ToString(this.DMSortOrder); }
        }

        string IBusinessObjectLookupList.CriteriaString
        {
            get { return Criteria; }
        }

        #endregion

        
        public IModelElement Parent
        {
            get { return DMProperty; }
            set { throw new NotImplementedException("Parent"); }
        }

        public string OwnerClassName
        {
            get { return this.DMClass == null?"":this.DMClass.ClassNameBO; }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}