// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class DMPropRule : IModelElement, IPropRule, IMergableBo
    {
        public DMPropRule()
        {
        }

        protected internal DMPropRule(ClassDef def) : base(def)
        {
        }

        protected DMPropRule(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            if (string.IsNullOrEmpty(PropRuleName))
            {
                return this.PropRuleID == null ? "-unnamed PropRule-" : Convert.ToString(this.PropRuleID);
            }
            return this.PropRuleName;
        }

        public IModelElement Parent
        {
            get { return this.DMProperty; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the Property rule by setting the related Property object", "");
            }
        }

        #region Implementation of IPropRule

        bool IPropRule.IsPropValueValid(string displayName, object propValue, ref string errorMessage)
        {
            throw new System.NotImplementedException();
        }

        string IPropRule.Name
        {
            get { return this.PropRuleName; }
            set { this.PropRuleName = value; }
        }

        String IPropRule.Message
        {
            get
            {
                return Message;
            }
            set
            {
                Message = value;
            }
        }

        Dictionary<string, object> IPropRule.Parameters
        {
            get
            {
                Dictionary<string, object> parameters =  new Dictionary<string, object>();
                this.PropRuleParameters.ForEach(parameter => parameters.Add(parameter.KeyName, parameter.Value));
                return parameters;
            }
            set {
                foreach (KeyValuePair<string, object> parameter in value)
                {
                    ((IPropRule)this).SetParameter(parameter.Key, parameter.Value);
                }
            }
        }

        List<string> IPropRule.AvailableParameters
        {
            get
            {
                return this.PropRuleParameters.Select(ruleParameter => ruleParameter.KeyName).ToList();
            }
        }

        void IPropRule.SetParameter(string parameterName, object value)
        {
            DMPropRuleParameter propRule =
                this.PropRuleParameters.Find(ruleParameter => ruleParameter.KeyName == parameterName);
            if (propRule == null) this.PropRuleParameters.Add(new DMPropRuleParameter() { KeyName = parameterName, Value = Convert.ToString(value) });
            else
            {
                propRule.Value = Convert.ToString(value);
            }
            
        }

        #endregion

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}