// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.Util;
using Microsoft.Practices.Unity;

namespace FireStarterModeller.BO
{


    public interface IDMRelationship : IBusinessObject, IHasOwnerClass
    {
        IDMRelationship ReverseRelationship { get; set; }
        bool IsAssociation { get; }
        RelationshipType? RelationshipType { get; set; }
        string RelationshipName { get; set; }
        IDMClass ClassDM { get; set; }
        bool IsMultiple { get; }
        bool IsCompositionOrAggregation { get; }
        Cardinality? Cardinality { get; set; }
        IDMClass OwnerClass { get; set; }
        IDMClass RelatedClass { get; set; }
        DeleteParentAction? DeleteAction { get; set; }
        BusinessObjectCollection<DMRelationshipProperty> RelationshipProperties{ get;}
        bool IsOneToMany { get; }
        bool IsSingle { get; }
        bool IsOneToOne { get; }
        bool IsManyToOne { get; }
        string RelatedClassName { get; set; }
        string ReverseRelationshipName { get; set; }
        string RelatedAssemblyName { get; set; }
        bool GenerateCode { get; set; }
        string OwnerClassAssemblyName { get; }
        bool HasAllAkProps();
        bool HasAllPkProps();
    }

    [Serializable]
    public partial class DMRelationship : IModelRelationship, IRelationshipDef, IDMRelationship, IMergableBo
    {
        private string _relatedClassName;
        private string _relatedAssemblyName;
        private string _reverseRelationshipName;

        public virtual IDMRelationship ReverseRelationship
        {
            get
            {
                return Relationships.GetRelatedObject<DMRelationship>("ReverseRelationship");
            }
            set
            {
                if(this.ReverseRelationship != null && this.ReverseRelationship != value && value != null)
                {
                    string message = string.Format("The Reverse Relationship of Relationship '{0}' on Class '{1}'  cannot be changed once it is set"
                            , this.RelationshipName, this.OwnerClassName);
                    throw new HabaneroDeveloperException(message);
                }
                Relationships.SetRelatedObject("ReverseRelationship", value);
            }
        }
        public static bool Loading { get; set; }
        // ReSharper disable DoNotCallOverridableMethodsInConstructor
        [InjectionConstructor]
        public DMRelationship()
            : this((IClassDef)null)
        {
            if (Loading) return;
            CreateReverseRelationship();
        }

        public DMRelationship(IDMRelationship reverseRelationship)
            : this((IClassDef)null)
        {
            SetupReverseRelationships(reverseRelationship);
        }

        protected internal DMRelationship(IClassDef def)
            : base(def)
        {
            SetPropAuthorisationRules();
        }

        protected DMRelationship(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
            SetPropAuthorisationRules();
        }

// ReSharper disable UnusedMember.Global
        protected DMRelationship(ConstructForFakes constructForFakes)
            : base(constructForFakes)
        {
        }
        // ReSharper restore UnusedMember.Global

        protected virtual void SetupReverseRelationships(IDMRelationship reverseRelationship)
        {
            this.ReverseRelationship = reverseRelationship;

            if (reverseRelationship != null)
            {
                reverseRelationship.Relationships.SetRelatedObject("ReverseRelationship", this);
            }
        }

        protected virtual void CreateReverseRelationship()
        {
            new DMRelationship(this);
            this.DMSortOrder = new DMSortOrder();
        }

        // ReSharper disable MemberCanBePrivate.Global

        // ReSharper restore DoNotCallOverridableMethodsInConstructor
        // ReSharper restore MemberCanBePrivate.Global

        protected virtual void SetPropAuthorisationRules()
        {
            IBOProp generatedProp = this.Props["Generated"];
            SetPropAuthorisation((BOProp)this.Props["ClassID"], generatedProp);
            SetPropAuthorisation((BOProp)this.Props["RelationshipName"], generatedProp);
            SetPropAuthorisation((BOProp)this.Props["Cardinality"], generatedProp);
            SetPropAuthorisation((BOProp)this.Props["RelationshipType"], generatedProp);
        }

        private static void SetPropAuthorisation(BOProp prop, IBOProp generatedProp)
        {
            BoPropAuthorisation boPropAuthorisation = new BoPropAuthorisation(prop, generatedProp);
            prop.SetAuthorisationRules(boPropAuthorisation);
        }


        public override string ToString()
        {
            if (string.IsNullOrEmpty(RelationshipName))
            {
                return this.RelationshipID == null ? "-unnamed Relationship-" : Convert.ToString(this.RelationshipID);
            }

            return this.RelationshipName;
        }

        public override bool IsDeletable(out string message)
        {
            base.IsDeletable(out message);
            if (this.Generated.GetValueOrDefault())
            {
                message += "The relationship '" + this.ToString() +
                           "' cannot be deleted as it has already been exported.";
                return false;
            }
            return message.Length == 0;
        }

        public bool HasOwnerProperty(DMProperty property)
        {
            return this.RelationshipProperties.Any(relationshipProperty => relationshipProperty.OwnerProperty == property);
            }

        public bool HasRelatedProperty(DMProperty property)
        {
            return this.RelationshipProperties.Any(relationshipProperty => relationshipProperty.RelatedProperty == property||
                (relationshipProperty.RelatedProperty  == null && relationshipProperty.RelatedPropertyName == property.PropertyName));
            }

        protected override void UpdateObjectBeforePersisting(ITransactionCommitter transactionCommitter)
        {
            DMSortOrder dmSortOrder = this.DMSortOrder;
            if (this.Status.IsDeleted || (dmSortOrder != null && dmSortOrder.DMSortProperties.Count == 0))
            {
                if (dmSortOrder != null)
                {
                    dmSortOrder.MarkForDelete();
                    transactionCommitter.AddBusinessObject(dmSortOrder);
                    this.DMSortOrder = null;
                }
            }
            // this.RelationshipProperties.CreateBusinessObject();

            base.UpdateObjectBeforePersisting(transactionCommitter);

        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new DMRelationshipMustHaveProperty());
            boRules.Add(new PropertyCompulsoryRule("RelationshipName", ErrorLevel.Warning));
            boRules.Add(new PropertyCompulsoryRule("ClassID", ErrorLevel.Warning));
            boRules.Add(new DMRelationshipDeleteActionRule());
            boRules.Add(new DMRelationshipOneDirectionMustBeDoNothing());
            boRules.Add(new DMRelationshipOneSideMustBeSingle());
            boRules.Add(new DMRelationshipOnetoOneAndManytoOnePropKeyRule());
            boRules.Add(new DMRelationshipSingleToSingleAKRule());
            boRules.Add(new DMRelationshipSingleToMultipleCannotBePKorUC());
            boRules.Add(new DMRelationshipOneToOneOneSideMustBeAssociation());
            boRules.Add(new DMRelationshipManyToOneMustBeAssociation());
            if (this.ReverseRelationship != null)
            {
                boRules.Add(new DMSortOrderPropMustBeOnRelatedClassRule((SingleRelationship<DMSortOrder>) this.Relationships["DMSortOrder"],
                     (SingleRelationship<DMClass>) this.ReverseRelationship.Relationships["ClassDM"]));
            }

        }

        public virtual bool HasAllPkProps()
        {
            return OwnerPropertiesConstitutePK;
            //DMClass dmClass = this.ClassDM;
            ////if (dmClass == null) return true; //throw new NullReferenceException("The relationship '" +  this.ToString() + "' does not have a Class" );
            //DMObjectIdentity dmObjectIdentity = dmClass.GetObjectID();
            //if (dmObjectIdentity == null) return false;
            //BusinessObjectCollection<DMRelationshipProperty> relationshipProperties = this.RelationshipProperties;
            //bool allPKProps = true;
            //if (relationshipProperties.Count != dmObjectIdentity.Properties.Count) return false;
            //foreach (DMRelationshipProperty relationshipProperty in relationshipProperties)
            //{
            //    DMRelationshipProperty dmRelationshipProperty = relationshipProperty;
            //    DMObjectIdentity objectIdentity = dmRelationshipProperty.Property.ObjectIdentity;
            //    if (objectIdentity == null)
            //    {
            //        allPKProps = false;
            //        break;
            //    }
            //    DMProperty dmproperty = dmObjectIdentity.Properties.Find(property => property.Equals(dmRelationshipProperty.OwnerProperty));
            //    if (dmproperty == null)
            //    {
            //        allPKProps = false;
            //        break;
            //    }
            //}
            //return allPKProps;
        }



        public virtual bool HasAllAkProps()
        {
            return OwnerPropertiesConstituteUC;
        }

        private static bool AllRelPropsBelongToUniqueConstraint(DMUniqueConstraint dmUniqueConstraint, BusinessObjectCollection<DMRelationshipProperty> relationshipProperties)
        {
            ReadOnlyCollection<DMProperty> uniqueConstraintProperties = dmUniqueConstraint.Properties;
            if (uniqueConstraintProperties.Count != relationshipProperties.Count) return false;
            return relationshipProperties.All(dmRelationshipProperty => uniqueConstraintProperties.Contains((DMProperty) dmRelationshipProperty.OwnerProperty));
        }

        public virtual Cardinality? Cardinality
        {
            get { return ((Cardinality?)(base.GetPropertyValue("Cardinality"))); }
            set { base.SetPropertyValue("Cardinality", value); }
        }

        #region Implementation of IModelElement

        IModelElement IModelElement.Parent
        {
            get { return this.OwnerClass as DMClass; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the Relationship by setting the related OwnerClass object", "");
            }
        }

        #endregion

        #region Implementation of IModelRelationship

        string IModelRelationship.RelatedAssembly
        {
            get
            {
                if (RelatedClass == null)
                {
                    throw new HabaneroDeveloperException("Related class was null when accessing RelatedAssembly", "");
                }
                if (RelatedClass.Assembly == null)
                {
                    throw new HabaneroDeveloperException("Related assembly was null when accessing RelatedAssembly", "");
                }
                return this.RelatedClass.Assembly.AssemblyName;
            }
        }

        bool IModelRelationship.IsMultiple
        {
            get { return this.Cardinality == FireStarterModeller.BO.Cardinality.Multiple; }
        }

        IModelProperty IModelRelationship.Property
        {
            get
            {
                //TODO 2009-03-09 Eric - the templates were designed for single prop relationships,
                //  so this is a cheat that needs to be fixed when the templates are changed
                CheckHasRelationshipProperties("OwnerProperty");
                return (DMProperty)this.RelationshipProperties[0].OwnerProperty;
            }
        }

        private void CheckHasRelationshipProperties(string errorContext)
        {
            if (this.RelationshipProperties.Count == 0)
            {
                throw new HabaneroDeveloperException
                    (string.Format("There are no properties for the relationship when accessing the {0}",
                    errorContext) + GetErrorContextDescription(), "");
            }
        }

        private string GetErrorContextDescription()
        {
            return string.Format(" for the '{0}' relationship on '{1}'.", RelationshipName, ClassDM != null ? ClassDM.ClassNameBO : string.Empty);
        }

        IModelProperty IModelRelationship.RelatedProperty
        {
            get
            {
                //TODO 2009-03-09 Eric - the templates were designed for single prop relationships,
                //  so this is a cheat that needs to be fixed when the templates are changed
                CheckHasRelationshipProperties("RelatedProperty");
                return (DMProperty)this.RelationshipProperties[0].RelatedProperty;
            }
        }

        string IModelRelationship.RelatedPropertyName
        {
            get
            {
                //TODO 2009-03-09 Eric - the templates were designed for single prop relationships,
                //  so this is a cheat that needs to be fixed when the templates are changed
                CheckHasRelationshipProperties("RelatedPropertyName");
                if (this.RelationshipProperties[0].RelatedProperty == null)
                {
                    throw new HabaneroDeveloperException
                        ("The related property not set when accessing the RelatedPropertyName" + GetErrorContextDescription(), "");
                }
                return this.RelationshipProperties[0].RelatedProperty.PropertyName;
            }
        }

        string IModelRelationship.PropertyName
        {
            get
            {
                //TODO 2009-03-09 Eric - the templates were designed for single prop relationships,
                //  so this is a cheat that needs to be fixed when the templates are changed
                CheckHasRelationshipProperties("PropertyName");
                if (this.RelationshipProperties[0].OwnerProperty == null)
                {
                    throw new HabaneroDeveloperException
                        ("The owner property for the relationship not set when accessing the PropertyName" + GetErrorContextDescription(), "");
                }
                return this.RelationshipProperties[0].OwnerProperty.PropertyName;
            }
        }

        //DeleteParentAction IModelRelationship.DeleteParentAction
        string IModelRelationship.DeleteParentAction
        {
            // get { return this.DeleteAction.Value; }
            get
            {
                if (!this.DeleteAction.HasValue)
                {
                    throw new HabaneroDeveloperException
                        (string.Format("DeleteAction has a null value for the relationship '{0}'", this.RelationshipName), "");
        }
                return this.DeleteAction.ToString();
            }
        }

        public bool GenerateCode
        {
            get { return ((bool)(base.GetPropertyValue("GenerateCode"))); }
            set { base.SetPropertyValue("GenerateCode", value); }
        }

        string IModelRelationship.RelatedClass
        {
            get
            {
                if (this.RelatedClass == null)
                {
                    throw new HabaneroDeveloperException("Related class not set when accessing the RelatedClass" + GetErrorContextDescription(), "");
                }

                return this.RelatedClass.ClassNameBO;
            }
        }

        #endregion

        #region Implementation of IRelationshipDef

        IRelationship IRelationshipDef.CreateRelationship(IBusinessObject owningBo, IBOPropCol lBOPropCol)
        {
            throw new System.NotImplementedException();
        }

        void IRelationshipDef.CheckCanAddChild(IBusinessObject bo)
        {
            throw new System.NotImplementedException();
        }

        void IRelationshipDef.CheckCanRemoveChild(IBusinessObject bo)
        {
            throw new System.NotImplementedException();
        }

        string IRelationshipDef.RelatedObjectAssemblyName
        {
            get { return this.RelatedAssemblyName; }
        }

        string IRelationshipDef.RelatedObjectClassName
        {
            get { return RelatedClassName; }
        }

        IRelKeyDef IRelationshipDef.RelKeyDef
        {
            get
            {
                IRelKeyDef relKeyDef = new DMRelationshipPropertyCollection();
                this.RelationshipProperties.ForEach(relKeyDef.Add);
                return relKeyDef;
            }
        }

        bool IRelationshipDef.KeepReferenceToRelatedObject
        {
            get { return true; }
        }

        DeleteParentAction IRelationshipDef.DeleteParentAction
        {
            get { return this.DeleteAction.GetValueOrDefault(); }
        }

        IOrderCriteria IRelationshipDef.OrderCriteria
        {
            get { return this.DMSortOrder; }
        }

        public virtual string ReverseRelationshipName
        {
            get
            {
                if (ReverseRelationship != null && !String.IsNullOrEmpty(ReverseRelationship.RelationshipName))
                {
                    return ReverseRelationship.RelationshipName;
                }
                return _reverseRelationshipName;
            }
            set { _reverseRelationshipName = value; }
        }

        public virtual bool OwningBOHasForeignKey
        {
            get
            {
                //try
                //{
                    if (Cardinality == FireStarterModeller.BO.Cardinality.Multiple) return false;
                    if (ReverseRelationship == null) return false;
                    if (ReverseRelationship.Cardinality == FireStarterModeller.BO.Cardinality.Multiple) return true;
                    bool isFirstRelationshipName = RelationshipName.CompareTo(ReverseRelationship.RelationshipName) < 0;
                    bool ownerPropertiesConstitutePK = OwnerPropertiesConstitutePK;
                    bool relatedPropertiesConstitutePK = ((DMRelationship)ReverseRelationship).OwnerPropertiesConstitutePK;
                    if (!ownerPropertiesConstitutePK && relatedPropertiesConstitutePK) return true;
                    if (ownerPropertiesConstitutePK) return relatedPropertiesConstitutePK && isFirstRelationshipName;
                    bool ownerPropertiesConstituteUC = OwnerPropertiesConstituteUC;
                    bool relatedPropertiesConstituteUC =  ((DMRelationship)ReverseRelationship).OwnerPropertiesConstituteUC;
                    if (!ownerPropertiesConstituteUC && relatedPropertiesConstituteUC) return true;
                    if (ownerPropertiesConstituteUC) return relatedPropertiesConstituteUC && isFirstRelationshipName;

                    return isFirstRelationshipName;
                //}
                //catch (Exception )
                //{

                //    return false;
                //}
               
            }
            set { } //Do Nothing this is a needed since the ClassDefLoaders(Load from ClassDef.xml needs this setter.
        }
        /// <summary>
        /// If the Foreign Key is owned by the Related Class then this is true.
        /// <see cref="OwningBOHasForeignKey"/>
        /// </summary>
        public virtual bool RelatedBOHasForeignKey
        {
            get { return !this.OwningBOHasForeignKey; }
        }
        public bool OwnerPropertiesConstituteUC
        {
            get
            {
                IDMClass dmClass = this.ClassDM;
                if (dmClass == null) return false;
                BusinessObjectCollection<DMUniqueConstraint> allUniqueConstraints = dmClass.AllUniqueConstraints;
                if (allUniqueConstraints.Count == 0) return false;
                BusinessObjectCollection<DMRelationshipProperty> relationshipProperties = this.RelationshipProperties;
                if (relationshipProperties.Count == 0) return false;

                return allUniqueConstraints.Any(dmUniqueConstraint => AllRelPropsBelongToUniqueConstraint(dmUniqueConstraint, relationshipProperties));
            }
        }

        public bool OwnerPropertiesConstitutePK
        {
            get
            {
                IDMClass dmClass = this.ClassDM;
                if (dmClass == null) return false;
                DMObjectIdentity dmObjectIdentity = dmClass.GetObjectID();
                if (dmObjectIdentity == null) return false;
                BusinessObjectCollection<DMProperty> oidProperties = dmObjectIdentity.Properties;
                if (oidProperties.Count == 0) return false;
                return RelationshipProperties.Count == oidProperties.Count
                       && RelationshipProperties.FindAll(property => oidProperties.Contains( (DMProperty) property.Property)).Count == oidProperties.Count;
            }
        }

        IClassDef IRelationshipDef.RelatedObjectClassDef
        {
            get
            {
                if (this.RelatedClass != null) return this.RelatedClass;
                return this.ClassDM.Solution.AllClasses.Find(
                    @class =>
                    @class.ClassNameBO == _relatedClassName && @class.Assembly.AssemblyName == _relatedAssemblyName);
            }
        }

        string IRelationshipDef.RelatedObjectTypeParameter
        {
            get { return ""; }
            set { }
        }

        RelationshipType IRelationshipDef.RelationshipType
        {
            get { return RelationshipType.GetValueOrDefault(); }
            set { RelationshipType = value; }
        }

        public string OwnerClassAssemblyName
        {
            get
            {
                return this.OwnerClass == null ? "" : this.OwnerClass.AssemblyName;
            }
        }

        public virtual string OwnerClassName
        {
            get
            {
                return this.OwnerClass == null ? "" : this.OwnerClass.ClassNameBO;
            }
        }

        InsertParentAction IRelationshipDef.InsertParentAction
        {
            get { return InsertParentAction.GetValueOrDefault(); }
        }

        int IRelationshipDef.TimeOut
        {
            get { return this.Timeout ?? 0; }
            set { this.Timeout = value; }
        }

        string IRelationshipDef.OrderCriteriaString
        {
            get { return Convert.ToString(this.DMSortOrder); }
        }

        string IRelationshipDef.RelatedObjectClassNameWithTypeParameter
        {
            get { return this.RelatedClassName; }
        }

        public bool IsCompulsory
        {
            get
            {
                return this.AllOwnerPropertiesAreCompulsory && this.OwningBOHasForeignKey;
            }
        }

        public IClassDef OwningClassDef
        {
            get { return (IClassDef) this.OwnerClass; }
            set { this.OwnerClass = (IDMClass) value; }
        }

        #endregion

        public virtual IDMClass ClassDM
        {
            get
            {
                return Relationships.GetRelatedObject<DMClass>("ClassDM");
            }
            set
            {
                Relationships.SetRelatedObject("ClassDM", value);
            }
        }

        public virtual string RelatedClassName
        {
            get
            {
                return this.RelatedClass != null ? this.RelatedClass.ClassNameBO : _relatedClassName;
            }
            set { _relatedClassName = value; }
        }

        public virtual string RelatedAssemblyName
        {
            get
            {
                return this.RelatedClass != null ? this.RelatedClass.AssemblyName : _relatedAssemblyName;
            }
            set { _relatedAssemblyName = value; }
        }

        public virtual IDMClass OwnerClass
        {
            get { return this.ClassDM; }
            set { this.ClassDM = value; }
        }

        public virtual IDMClass RelatedClass
        {
            get { return this.ReverseRelationship != null ? this.ReverseRelationship.OwnerClass : null; }
            set
            {
                if(this.ReverseRelationship == null && value == null) return;
                if (this.ReverseRelationship == null)
                {
                    this._relatedAssemblyName = value.AssemblyName;
                    this._relatedClassName = value.ClassNameBO;
                    return;
                }
                this.ReverseRelationship.ClassDM = value;
            }
        }


        public bool AreObjectIDsValid
        {
            get
            {
                if (this.OwnerClass == null || this.RelatedClass == null) return false;

                return (this.OwnerClass.IsObjectIDValid && this.RelatedClass.IsObjectIDValid);
                }
        }

        public bool BothClassesHaveSinglePropIDs
                {
            get
            {
                if (this.RelatedClass == null) return false;
                return this.ClassDM.IsSinglePropObjectID && this.RelatedClass.IsSinglePropObjectID;
                }
            }

        public bool IsAssociation
        {
            get
            {
                RelationshipType? relationshipType = this.RelationshipType;
                return relationshipType == Habanero.Base.RelationshipType.Association;
            }
        }
        /// <summary>
        /// Returns true if this Relationship is either Composition or Aggregation
        /// </summary>
        public bool IsCompositionOrAggregation
        {
            get
            {
                RelationshipType? relationshipType = this.RelationshipType;
                return relationshipType == Habanero.Base.RelationshipType.Composition ||
                       relationshipType == Habanero.Base.RelationshipType.Aggregation;
            }
        }

        public bool IsSingle
        {
            get { return this.Cardinality == BO.Cardinality.Single; }
        }

        public bool IsMultiple
        {
            get { return this.Cardinality == BO.Cardinality.Multiple; }
        }

        public virtual bool IsOneToMany
        {
            get
            {
                return this.IsMultiple && (!this.HasReverseRelationship || this.ReverseRelationship.IsSingle);
            }
        }

        public virtual bool IsManyToOne
        {
            get
            {
                return this.IsSingle && (!this.HasReverseRelationship || this.ReverseRelationship.IsMultiple);
            }
        }

        public virtual bool IsOneToOne
        {
            get
            {
                return this.IsSingle && (this.HasReverseRelationship && this.ReverseRelationship.IsSingle);
            }
        }
        /// <summary>
        /// If Reverse Relationship is null returns false, otherwise true.
        /// </summary>
        public virtual bool HasReverseRelationship
        {
            get { return this.ReverseRelationship != null; }
        }
/*

        public virtual bool AreBothSidesPrevent
        {
            get
            {
                if (!this.HasReverseRelationship) return false;
                return this.DeleteAction == DeleteParentAction.Prevent && this.ReverseRelationship.DeleteAction == DeleteParentAction.Prevent;
            }
        }
*/

        public virtual bool IsOneDeleteActionDoNothing
        {
            get
            {
                if (!this.HasReverseRelationship) return true;
                DMRelationship reverseRelationship = (DMRelationship)this.ReverseRelationship;
                return this.DeleteAction == DeleteParentAction.DoNothing || reverseRelationship.DeleteAction == DeleteParentAction.DoNothing;
            }

        }
        public void ResetCardinality()
        {
            if(this.ReverseRelationship == null) return;
            if(this.IsSingle) return;
            if (!(this.ReverseRelationship.HasAllAkProps() || this.ReverseRelationship.HasAllPkProps())) return;

            this.Cardinality = BO.Cardinality.Single;
            this.DeleteAction = DeleteParentAction.DoNothing;
            if (this.RelationshipName == null || this.RelationshipName == StringUtilities.Pluralize(this.RelatedClassName))
            {
                this.RelationshipName = RenameRelationship();
            }
        }

        private string RenameRelationship()
        {
            return new RelationshipNameGenerator().RenameRelationship(this);
        }
        /// <summary>
        /// Should return true if all <see cref="DMRelationshipProperty.OwnerProperty"/>s
        /// for this Relationship are Compulsory False Otherwise.
        /// </summary>
        public virtual bool AllOwnerPropertiesAreCompulsory
        {
            get {
                return this.RelationshipProperties.All(relProp => relProp.IsOwnerPropCompulsory);
            }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }

    
    public class DMRelationshipCollection : BusinessObjectCollection<DMRelationship>, IRelationshipDefCol
    {
        #region Implementation of IRelationshipDefCol

        void IRelationshipDefCol.Add(IRelationshipDef relationshipDef)
        {
            this.Add((DMRelationship)relationshipDef);
        }

        bool IRelationshipDefCol.Contains(string keyName)
        {
            return this.Find(relationship => relationship.RelationshipName == keyName) != null;

        }

        IRelationshipDef IRelationshipDefCol.this[string relationshipName]
        {
            get { return this.Find(relationship => relationship.RelationshipName == relationshipName); }
        }

        #endregion

        IEnumerator<IRelationshipDef> IEnumerable<IRelationshipDef>.GetEnumerator()
        {
            List<IRelationshipDef> col = new List<IRelationshipDef>();
            for (int i = 0; i < base.Count; i++)
            {
                col.Add(base[i]);
    }
            return col.GetEnumerator();
        }
    }


    public class DMRelationshipPropertyCollection : BusinessObjectCollection<DMRelationshipProperty>, IRelKeyDef
    {
        #region Implementation of IRelKeyDef

        public void Add(IRelPropDef relPropDef)
        {
            base.Add((DMRelationshipProperty)relPropDef);
        }

        public IRelKey CreateRelKey(IBOPropCol lBoPropCol)
        {
            throw new System.NotImplementedException();
        }

        public bool Contains(string propName)
        {
            throw new NotImplementedException();
        }

        public IRelPropDef this[string propName]
        {
            get { return this.Find(property => property.OwnerPropertyName == propName); }
        }

        #endregion

        IEnumerator<IRelPropDef> IEnumerable<IRelPropDef>.GetEnumerator()
        {
            List<IRelPropDef> col = new List<IRelPropDef>();
            for (int i = 0; i < base.Count; i++)
            {
                col.Add(base[i]);
    }
            return col.GetEnumerator();
        }
    }
}