
// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;

namespace FireStarterModeller.BO
{
    using System;
    using Habanero.BO;
    
    
    public partial class DMSortOrder: IOrderCriteria, IMergableBo
    {
        public DMSortOrder() : this(null)
        {
        }

        protected internal DMSortOrder(IClassDef def) : base(def)
        {
            MultipleRelationship<DMSortProperty> propRelationship =
                    (MultipleRelationship<DMSortProperty>)this.Relationships["DMSortProperties"];
            propRelationship.CurrentBusinessObjectCollection.BusinessObjectAdded += HandleDMSortPropAddedEvent;
        }

        protected DMSortOrder(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            MultipleRelationship<DMSortProperty> propRelationship =
                    (MultipleRelationship<DMSortProperty>)this.Relationships["DMSortProperties"];
            propRelationship.CurrentBusinessObjectCollection.BusinessObjectAdded += HandleDMSortPropAddedEvent;
        }

        private void HandleDMSortPropAddedEvent(object sender, BOEventArgs<DMSortProperty> e)
        {
            DMSortProperty dmSortProperty = e.BusinessObject;
            if (dmSortProperty.Status.IsNew)
            {
                BusinessObjectCollection<DMSortProperty> dmSortProperties = this.DMSortProperties;
                if (dmSortProperty.SortPosition <= 0)
                {
                    int maxUIOrder = FirestarterUtils.GetNextSortPositionOrder(dmSortProperties);
                    dmSortProperty.SortPosition = maxUIOrder;
                }

                // int maxFieldNumber = FirestarterUtils.GetMaxFieldNumber(properties);
                // dmProperty.MappedDBColumnName = "field" + (maxFieldNumber + 1);
                dmSortProperties.Sort("SortPosition", true, true);
            }
        }

        public override string ToString()
        {
            List<string> sortPropDetails = new List<string>();
            BusinessObjectCollection<DMSortProperty> dmSortProperties = DMSortProperties;
            dmSortProperties.Sort();
            foreach (DMSortProperty sortProperty in dmSortProperties)
            {
                sortPropDetails.Add(sortProperty.ToString());
            }
            return String.Join(", ", sortPropDetails.ToArray());
        }

        public static DMSortOrder FromString(string sortString)
        {
            DMSortOrder sortOrder = new DMSortOrder();
            if (string.IsNullOrEmpty(sortString)) return sortOrder;
            string[] sortParts = sortString.Split(',');
            foreach (string sortPart in sortParts)
            {
                DMSortProperty sortProp = sortOrder.DMSortProperties.CreateBusinessObject();
                string trimmedSortPart = sortPart.Trim();
                if (trimmedSortPart.ToUpper().EndsWith(" DESC"))
                {
                    sortProp.SortDirection = "DESC";
                    trimmedSortPart = trimmedSortPart.Substring(0, trimmedSortPart.ToUpper().IndexOf(" DESC")).Trim();
                }else if (trimmedSortPart.ToUpper().EndsWith(" ASC"))
                {
                    sortProp.SortDirection = "ASC";
                    trimmedSortPart = trimmedSortPart.Substring(0, trimmedSortPart.ToUpper().IndexOf(" ASC")).Trim();
                }
                sortProp.PropertyName = trimmedSortPart;
            }
   
            return sortOrder;
        }

        #region Implementation of IOrderCriteria

        /// <summary>
        /// Add a field to the fields to be sorted on. This is a convenience method that will created a Field and add it
        ///             to the Fields list with the Ascending option.
        /// </summary>
        /// <param name="field">The name of the field to be sorted on</param>
        /// <returns>
        /// This OrderCriteria, to allow chaining of adds (eg:  myOrderCriteria.Add("Name").Add("Age"))
        /// </returns>
        public IOrderCriteria Add(string field)
        {
            DMSortProperty dmSortProperty = new DMSortProperty();
            dmSortProperty.PropertyName = field;
            dmSortProperty.SortDirection = "ASC";
            this.DMSortProperties.Add(dmSortProperty);
            return this;
        }

        /// <summary>
        /// Add a field to the fields to be sorted on. This is a convenience method that will created a Field and add it
        ///             to the Fields list. 
        /// </summary>
        /// <param name="field">The name of the field to be sorted on</param><param name="sortDirection">The sort direction of this field</param>
        /// <returns>
        /// This OrderCriteria, to allow chaining of adds
        /// </returns>
        public IOrderCriteria Add(string field, SortDirection sortDirection) { throw new NotImplementedException(); }

        /// <summary>
        /// Adds a field to the fields to be sorted on.
        /// </summary>
        /// <param name="orderCriteriaField">The <see cref="T:Habanero.Base.OrderCriteriaField"/> to add to the OrderCriteria's field collection</param>
        /// <returns>
        /// This OrderCriteria, to allow chaining of adds
        /// </returns>
        public IOrderCriteria Add(IOrderCriteriaField orderCriteriaField) { throw new NotImplementedException(); }

        /// <summary>
        /// Compares two BusinessObjects using the criteria set up in this OrderCriteria object.
        /// </summary>
        /// <typeparam name="T">The Type to be compared</typeparam><param name="bo1">The first object to be used in the comparison</param><param name="bo2">The second object to be used in the comparison</param>
        /// <returns>
        /// a value less than 0 if bo1 is less than bo2, 0 if bo1 = bo2 and greater than 0 if b01 is greater than bo2
        ///             The value returned is negated if the SortDirection is Descending
        /// </returns>
        public int Compare<T>(T bo1, T bo2) where T : IBusinessObject { throw new NotImplementedException(); }

        /// <summary>
        /// The fields that will be ordered on. See <see cref="IOrderCriteriaField"/>
        /// </summary>
        public List<IOrderCriteriaField> Fields
        {
            get { throw new NotImplementedException(); } }

        /// <summary>
        /// Creates an OrderCriteria object by parsing a string in the correct format.
        ///             The format is:
        /// <para>
        /// &lt;orderCriteria&gt; =&gt; &lt;emptystring&gt; | &lt;field&gt; [, &lt;field&gt;, ... ] <br/>
        ///             &lt;field&gt; =&gt; &lt;fieldName&gt; [ ASC | DESC ] 
        /// </para>
        ///             For example: 
        /// <code>
        /// Surname, Age DESC
        /// </code>
        ///  or 
        /// <code>
        /// Age ASC, Surname DESC
        /// </code>
        /// </summary>
        /// <param name="orderCriteriaString">The string in the correct format (see above)</param>
        /// <returns>
        /// An OrderCriteria created from the string
        /// </returns>
        IOrderCriteria IOrderCriteria.FromString(string orderCriteriaString) { return FromString(orderCriteriaString); }
        
        #endregion
        
        #region Implementation of IComparer

        /// <summary>
        /// Compares two objects and returns a value indicating whether one is less than, equal to, or greater than the other.
        /// </summary>
        /// <returns>
        /// Value Condition Less than zero <paramref name="x"/> is less than <paramref name="y"/>. Zero <paramref name="x"/> equals <paramref name="y"/>. Greater than zero <paramref name="x"/> is greater than <paramref name="y"/>. 
        /// </returns>
        /// <param name="x">The first object to compare. </param><param name="y">The second object to compare. </param><exception cref="T:System.ArgumentException">Neither <paramref name="x"/> nor <paramref name="y"/> implements the <see cref="T:System.IComparable"/> interface.-or- <paramref name="x"/> and <paramref name="y"/> are of different types and neither one can handle comparisons with the other. </exception><filterpriority>2</filterpriority>
        public int Compare(object x, object y) { throw new NotImplementedException(); }

        #endregion

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}
