// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIColumnLayout : IModelElement, IUIFormColumn, IOrderableObject, IMergableBo
    {
        private OrderedCollectionController<UIField> _orderedCollectionController;

        public UIColumnLayout()
        {
            SetupUIColumnLayout();
        }

        protected internal UIColumnLayout(ClassDef def) : base(def)
        {
            SetupUIColumnLayout();
        }

        protected UIColumnLayout(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            SetupUIColumnLayout();
        }

        private void SetupUIColumnLayout()
        {
            _orderedCollectionController = new OrderedCollectionController<UIField>(UIFields);
        }

        public IModelElement Parent
        {
            get { return this.UITab; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIColumnLayout by setting the related UITab object", "");
            }
        }

        public override string ToString() { return this.UITab == null ? "" : this.UITab.ToString(); }

        /// <summary>
        /// Returns an enumerator that iterates through a collection.
        /// </summary>
        /// <returns>
        /// An <see cref="T:System.Collections.IEnumerator"/> object that can be used to iterate through the collection.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.UIFields.Clone().GetEnumerator();
        }

        /// <summary>
        /// Copies the elements of the <see cref="T:System.Collections.ICollection"/> to an <see cref="T:System.Array"/>, starting at a particular <see cref="T:System.Array"/> index.
        /// </summary>
        /// <param name="array">The one-dimensional <see cref="T:System.Array"/> that is the destination of the elements copied from <see cref="T:System.Collections.ICollection"/>. The <see cref="T:System.Array"/> must have zero-based indexing. 
        ///                 </param><param name="index">The zero-based index in <paramref name="array"/> at which copying begins. 
        ///                 </param><exception cref="T:System.ArgumentNullException"><paramref name="array"/> is null. 
        ///                 </exception><exception cref="T:System.ArgumentOutOfRangeException"><paramref name="index"/> is less than zero. 
        ///                 </exception><exception cref="T:System.ArgumentException"><paramref name="array"/> is multidimensional.
        ///                     -or- 
        ///                 <paramref name="index"/> is equal to or greater than the length of <paramref name="array"/>.
        ///                     -or- 
        ///                     The number of elements in the source <see cref="T:System.Collections.ICollection"/> is greater than the available space from <paramref name="index"/> to the end of the destination <paramref name="array"/>. 
        ///                 </exception><exception cref="T:System.ArgumentException">The type of the source <see cref="T:System.Collections.ICollection"/> cannot be cast automatically to the type of the destination <paramref name="array"/>. 
        ///                 </exception><filterpriority>2</filterpriority>
        void ICollection.CopyTo(Array array, int index)
        {
            //this.UIFields.CopyTo((UIField[]) array, index);
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// The number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        int ICollection.Count
        {
            get { return this.UIFields.Count; }
        }

        /// <summary>
        /// Gets an object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// An object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        object ICollection.SyncRoot
        {
            
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Gets a value indicating whether access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe).
        /// </summary>
        /// <returns>
        /// true if access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe); otherwise, false.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        bool ICollection.IsSynchronized
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Adds a form field to the definition
        /// </summary>
        /// <param name="field">A form field definition</param>
        void IUIFormColumn.Add(IUIFormField field)
        {
            this.UIFields.Add((UIField) field);
        }

        /// <summary>
        /// Removes a form field from the definition
        /// </summary>
        /// <param name="field">A form field definition</param>
        void IUIFormColumn.Remove(IUIFormField field)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Checks if a form field is in the definition
        /// </summary>
        /// <param name="field">A form field definition</param>
        bool IUIFormColumn.Contains(IUIFormField field)
        {
            return this.UIFields.Contains((UIField) field);
        }

        /// <summary>
        /// Inserts a formField. at the specified index.
        ///              If Index Less than or equal to zero then the form field wil be inserted at the first postion
        ///              If the index is greater than the Count of the list then it will be inserted at the last position.
        /// </summary>
        /// <param name="index">The position at which the formField should be inserted</param><param name="formField">The FormField to be iserted.</param>
        void IUIFormColumn.Insert(int index, IUIFormField formField)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Provides an indexing facility so that the contents of the definition
        ///             collection can be accessed with square brackets like an array
        /// </summary>
        /// <param name="index">The index position to access</param>
        /// <returns>
        /// Returns the property definition at the index position
        ///             specified
        /// </returns>
        IUIFormField IUIFormColumn.this[int index]
        {
            get
            {
                return this.UIFields[index];
            }
        }

        /// <summary>
        /// Gets and sets the column width
        /// </summary>
        int IUIFormColumn.Width
        {
            get { return this.Width.Value; }
            set { this.Width = value; }
        }

        /// <summary>
        /// Returns the Form tab that this UIFormColumn is on.
        /// </summary>
        IUIFormTab IUIFormColumn.UIFormTab
        {
            get { return this.UITab; }
            set { throw new NotImplementedException("Please set this via the UITab relationship."); }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}