// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIFormInfo : IModelElement, IUIForm, IMergableBo
    {
        private OrderedCollectionController<UITab> _orderedCollectionController;

        public UIFormInfo()
        {
            SetupUIFormInfo();
        }

        protected internal UIFormInfo(ClassDef def) : base(def)
        {
            SetupUIFormInfo();
        }

        protected UIFormInfo(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            SetupUIFormInfo();
        }

        private void SetupUIFormInfo()
        {
            _orderedCollectionController = new OrderedCollectionController<UITab>(UITabs);
        }

        public ReadOnlyCollection<UIField> UIFields
        {
            get
            {
                IList<UIField> formFields = new List<UIField>();
                foreach (UITab tab in this.UITabs)
                {
                    foreach (UIColumnLayout columnLayout in tab.UIColumnLayouts)
                    {
                        columnLayout.UIFields.Sort("OrdinalPosition", true, true);
                        foreach (UIField field in columnLayout.UIFields)
                        {
                            formFields.Add(field);
                        }
                    }
                }
                return new ReadOnlyCollection<UIField>(formFields);
            }
        }

        public IModelElement Parent
        {
            get { return this.UIView; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIFormInfo by setting the related UIView object", "");
            }
        }

        /// <summary>
        /// Returns an enumerator that iterates through a collection.
        /// </summary>
        /// <returns>
        /// An <see cref="T:System.Collections.IEnumerator"/> object that can be used to iterate through the collection.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return  this.UITabs.Clone().GetEnumerator();
        }

        /// <summary>
        /// Copies the elements of the <see cref="T:System.Collections.ICollection"/> to an <see cref="T:System.Array"/>, starting at a particular <see cref="T:System.Array"/> index.
        /// </summary>
        /// <param name="array">The one-dimensional <see cref="T:System.Array"/> that is the destination of the elements copied from <see cref="T:System.Collections.ICollection"/>. The <see cref="T:System.Array"/> must have zero-based indexing. 
        ///                 </param><param name="index">The zero-based index in <paramref name="array"/> at which copying begins. 
        ///                 </param><exception cref="T:System.ArgumentNullException"><paramref name="array"/> is null. 
        ///                 </exception><exception cref="T:System.ArgumentOutOfRangeException"><paramref name="index"/> is less than zero. 
        ///                 </exception><exception cref="T:System.ArgumentException"><paramref name="array"/> is multidimensional.
        ///                     -or- 
        ///                 <paramref name="index"/> is equal to or greater than the length of <paramref name="array"/>.
        ///                     -or- 
        ///                     The number of elements in the source <see cref="T:System.Collections.ICollection"/> is greater than the available space from <paramref name="index"/> to the end of the destination <paramref name="array"/>. 
        ///                 </exception><exception cref="T:System.ArgumentException">The type of the source <see cref="T:System.Collections.ICollection"/> cannot be cast automatically to the type of the destination <paramref name="array"/>. 
        ///                 </exception><filterpriority>2</filterpriority>
        void ICollection.CopyTo(Array array, int index)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// The number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        int ICollection.Count
        {
            get {return this.UITabs.Count;}
        }

        /// <summary>
        /// Gets an object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// An object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        object ICollection.SyncRoot
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Gets a value indicating whether access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe).
        /// </summary>
        /// <returns>
        /// true if access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe); otherwise, false.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        bool ICollection.IsSynchronized
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Adds a tab to the form
        /// </summary>
        /// <param name="tab">A UIFormTab object</param>
        void IUIForm.Add(IUIFormTab tab)
        {
            if (tab == null) return;
            this.UITabs.Add((UITab) tab);
        }

        /// <summary>
        /// Removes a tab from the form
        /// </summary>
        /// <param name="tab">A UIFormTab object</param>
        void IUIForm.Remove(IUIFormTab tab)
        {
            if (tab == null) return;
            throw new NotImplementedException();
        }

        /// <summary>
        /// Checks if the form contains the specified tab
        /// </summary>
        /// <param name="tab">A UIFormTab object</param>
        bool IUIForm.Contains(IUIFormTab tab)
        {
            if (tab == null) return false;
            return this.UITabs.Contains((UITab) tab);
        }

        /// <summary>
        /// Provides an indexing facility so that the contents of the definition
        ///             collection can be accessed with square brackets like an array
        /// </summary>
        /// <param name="index">The index position to access</param>
        /// <returns>
        /// Returns the property definition at the index position
        ///             specified
        /// </returns>
        IUIFormTab IUIForm.this[int index]
        {
            get { return this.UITabs[index]; }
        }

        /// <summary>
        /// Gets and sets the width
        /// </summary>
        int IUIForm.Width
        {
            get { return this.Width.Value; }
            set { this.Width = value; }
        }

        /// <summary>
        /// Gets and sets the height
        /// </summary>
        int IUIForm.Height
        {
            get { return this.Height.Value; }
            set { this.Height = value; }
        }

        /// <summary>
        /// Gets and sets the heading
        /// </summary>
        string IUIForm.Title
        {
            get { return this.Title; }
            set { this.Title = value; }
        }

        /// <summary>
        /// The UI Def that this UIForm is related to.
        /// </summary>
        IUIDef IUIForm.UIDef
        {
            get {throw new NotImplementedException();}
            set { throw new NotImplementedException(); }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}