// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;
using Habanero.Util;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIGridColumnInfo : IModelElement, IUIGridColumn, IOrderableObject, IMergableBo
    {
        public UIGridColumnInfo()
        {
            //new PropertyLink<string, string>(this, "PropertyName", "Heading", value => StringUtilities.DelimitPascalCase(Convert.ToString(value), " "));
        }

        protected internal UIGridColumnInfo(ClassDef def) : base(def)
        {
        }

        protected UIGridColumnInfo(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }


        public override string ToString()
        {
            if (this.UIGrid == null && this.PropertyName == null)
            {
                return this.UIGridColumnID == null
                           ? "-unnamed UIGridColumnInfo-"
                           : Convert.ToString(this.UIGridColumnID);
            }
            return (this.UIGrid == null ? "" : this.UIGrid.ToString()) + " - " + (this.PropertyName ?? "");
        }

        public IModelElement Parent
        {
            get { return this.UIGrid; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIGridColumnInfo by setting the related UIGrid object", "");
            }
        }


        /// <summary>
        /// Gets the heading for this grid column.
        /// </summary>
        /// <returns>
        /// The heading for this grid column 
        /// </returns>
        string IUIGridColumn.GetHeading()
        {
            return this.Heading;
        }

        /// <summary>
        /// Gets the heading for this grid column given a classDef.
        /// </summary>
        /// <param name="classDef">The class definition that corresponds to this grid column. </param>
        /// <returns>
        /// The heading for this grid column 
        /// </returns>
        string IUIGridColumn.GetHeading(IClassDef classDef)
        {
            return this.Heading;
        }

        /// <summary>
        /// Returns the parameter value for the name provided
        /// </summary>
        /// <param name="parameterName">The parameter name</param>
        /// <returns>
        /// Returns the parameter value or null if not found
        /// </returns>
        object IUIGridColumn.GetParameterValue(string parameterName)
        {
            if (parameterName == null) throw new ArgumentNullException("parameterName");
            foreach (UIParameter uiParameter in UIParameters)
            {
                if (uiParameter.Name == parameterName)
                {
                    return uiParameter.Value;
                }
            }
            throw new ArgumentException("There is no parameter with the name '" + parameterName + "' for the UIGridColumn", "parameterName");
        }


        /// <summary>
        /// Returns the heading text that will be used for this column.
        /// </summary>
        string IUIGridColumn.Heading
        {
            get { return this.Heading; }
            set { this.Heading = value; }
        }

        /// <summary>
        /// Returns the property name
        /// </summary>
        string IUIGridColumn.PropertyName
        {
            get
            {
                return PropertyName;
            }
            set { PropertyName = value; }
        }

        ///// <summary>
        ///// Returns the grid control type
        ///// </summary>
        //Type IUIGridColumn.GridControlType
        //{
        //    get
        //    {
        //        UIGridColumnControlType gridColumnControlType = this.UIGridColumnControlType;
        //        if (gridColumnControlType != null)
        //        {
        //            Type type = TypeLoader.LoadType(gridColumnControlType.AssemblyName, gridColumnControlType.TypeName);
        //            return type;
        //        }
        //        return null;
        //    }
        //    set
        //    {
        //        throw new NotImplementedException("Please set this via the UIGridColumnControlType relationship.");
        //    }
        //}

        /// <summary>
        /// Indicates whether the column is editable
        /// </summary>
        bool IUIGridColumn.Editable
        {
            get { return this.Editable.Value; }
            set { this.Editable = value; }
        }

        /// <summary>
        /// Returns the width
        /// </summary>
        int IUIGridColumn.Width
        {
            get { return this.Width.Value; }
            set { this.Width = value; }
        }

        /// <summary>
        /// Returns the horizontal alignment
        /// </summary>
        PropAlignment IUIGridColumn.Alignment
        {
            get { return (PropAlignment)Enum.Parse(typeof(PropAlignment), this.Alignment); }
            set 
            {
                this.Alignment = value.ToString();
            }
        }

        /// <summary>
        /// Returns the Hashtable containing the property parameters
        /// </summary>
        Hashtable IUIGridColumn.Parameters
        {
            get
            {
                Hashtable hashtable = new Hashtable();
                foreach (UIParameter parameter in UIParameters)
                {
                    hashtable.Add(parameter.Name, parameter.Value);
                }
                return hashtable;
            }
        }

        /// <summary>
        /// Gets and sets the name of the grid control type
        /// </summary>
        string IUIGridColumn.GridControlTypeName
        {
            get
            {
                UIGridColumnControlType gridColumnControlType = this.UIGridColumnControlType;
                return gridColumnControlType == null ? "" : gridColumnControlType.TypeName;
            }
            set { throw new NotImplementedException("This should be set when the UIGridColumnControlType is set for the UIGridColumnInfo."); }
        }

        /// <summary>
        /// Gets and sets the assembly name of the grid control type
        /// </summary>
        string IUIGridColumn.GridControlAssemblyName
        {
            get
            {
                UIGridColumnControlType gridColumnControlType = this.UIGridColumnControlType;
                return gridColumnControlType == null ? "" : gridColumnControlType.AssemblyName;
            }
            set { throw new NotImplementedException("This should be set when the UIGridColumnControlType is set for the UIGridColumnInfo."); }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}