// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIGridFilter : IModelElement, IFilterDef, IMergableBo
    {
        public UIGridFilter()
        {
        }

        protected internal UIGridFilter(ClassDef def) : base(def)
        {
        }

        protected UIGridFilter(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public IModelElement Parent
        {
            get { return this.UIGridInfo; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIGridFilter by setting the related UIGridInfo object", "");
            }
        }

        /// <summary>
        /// The list of <see cref="T:Habanero.BO.ClassDefinition.FilterPropertyDef"/>s which define each filter.
        /// </summary>
        IList<IFilterPropertyDef> IFilterDef.FilterPropertyDefs
        {
            get
            {
                BusinessObjectCollection<UIGridFilterProp> gridFilterProps = this.UIGridFilterProps;
                IList<IFilterPropertyDef> filterPropertyDefs = new List<IFilterPropertyDef>();
                foreach (UIGridFilterProp gridFilterProp in gridFilterProps)
                {
                    filterPropertyDefs.Add(gridFilterProp);
                }
                return filterPropertyDefs;
            }
            set { throw new NotImplementedException("This should be set via the UIGridFilterProps relationship."); }
        }

        /// <summary>
        /// The mode of filtering, where <see cref="F:Habanero.Base.FilterModes.Filter"/> means to filter already loaded data, and 
        ///             <see cref="F:Habanero.Base.FilterModes.Search"/> means to search via a query to the data store in the process of loading.
        /// </summary>
        FilterModes IFilterDef.FilterMode
        {
            get { return this.FilterMode.Value; }
            set { this.FilterMode = value;}
        }

        /// <summary>
        /// The number of columns to layout the filters in.  By default this is 0, and the layout used is that of a flow layout
        ///             which simply adds controls until the right side of the container is reached and then moves to the next line.
        ///             If this is set to a number greater than zero it will lay out the filter controls in that number of columns.
        /// </summary>
        int IFilterDef.Columns
        {
            get { return Columns ?? 0; }
            set { Columns = value;}
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}