// ------------------------------------------------------------------------------
// This class was auto-generated for use with the Habanero Enterprise Framework.
// ------------------------------------------------------------------------------

using System;
using System.Collections;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIGridInfo : IModelElement, IUIGrid, IMergableBo
    {
        private OrderedCollectionController<UIGridColumnInfo> _orderedCollectionController;

        public UIGridInfo()
        {
            SetupUIGridInfo();
        }

        protected internal UIGridInfo(ClassDef def) : base(def)
        {
            SetupUIGridInfo();
        }

        protected UIGridInfo(SerializationInfo info, StreamingContext context) : base(info, context)
        {
            SetupUIGridInfo();
        }

        private void SetupUIGridInfo()
        {
            _orderedCollectionController = new OrderedCollectionController<UIGridColumnInfo>(UIColumns);
        }

        public IModelElement Parent
        {
            get { return this.UIView; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIGridInfo by setting the related UIView object", "");
            }
        }

        /// <summary>
        /// Returns an enumerator that iterates through a collection.
        /// </summary>
        /// <returns>
        /// An <see cref="T:System.Collections.IEnumerator"/> object that can be used to iterate through the collection.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        IEnumerator IEnumerable.GetEnumerator()
        {
            return this.UIColumns.Clone().GetEnumerator();
        }

        /// <summary>
        /// Copies the elements of the <see cref="T:System.Collections.ICollection"/> to an <see cref="T:System.Array"/>, starting at a particular <see cref="T:System.Array"/> index.
        /// </summary>
        /// <param name="array">The one-dimensional <see cref="T:System.Array"/> that is the destination of the elements copied from <see cref="T:System.Collections.ICollection"/>. The <see cref="T:System.Array"/> must have zero-based indexing. 
        ///                 </param><param name="index">The zero-based index in <paramref name="array"/> at which copying begins. 
        ///                 </param><exception cref="T:System.ArgumentNullException"><paramref name="array"/> is null. 
        ///                 </exception><exception cref="T:System.ArgumentOutOfRangeException"><paramref name="index"/> is less than zero. 
        ///                 </exception><exception cref="T:System.ArgumentException"><paramref name="array"/> is multidimensional.
        ///                     -or- 
        ///                 <paramref name="index"/> is equal to or greater than the length of <paramref name="array"/>.
        ///                     -or- 
        ///                     The number of elements in the source <see cref="T:System.Collections.ICollection"/> is greater than the available space from <paramref name="index"/> to the end of the destination <paramref name="array"/>. 
        ///                 </exception><exception cref="T:System.ArgumentException">The type of the source <see cref="T:System.Collections.ICollection"/> cannot be cast automatically to the type of the destination <paramref name="array"/>. 
        ///                 </exception><filterpriority>2</filterpriority>
        void ICollection.CopyTo(Array array, int index)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Gets the number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// The number of elements contained in the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        int ICollection.Count
        {
            get { return this.UIColumns.Count; }
        }

        /// <summary>
        /// Gets an object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </summary>
        /// <returns>
        /// An object that can be used to synchronize access to the <see cref="T:System.Collections.ICollection"/>.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        object ICollection.SyncRoot
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Gets a value indicating whether access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe).
        /// </summary>
        /// <returns>
        /// true if access to the <see cref="T:System.Collections.ICollection"/> is synchronized (thread safe); otherwise, false.
        /// </returns>
        /// <filterpriority>2</filterpriority>
        bool ICollection.IsSynchronized
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// Adds a grid property definition
        /// </summary>
        /// <param name="prop">The grid property definition</param>
        void IUIGrid.Add(IUIGridColumn prop)
        {
            this.UIColumns.Add((UIGridColumnInfo) prop);
        }

        /// <summary>
        /// Removes a grid property definition
        /// </summary>
        /// <param name="prop">The grid property definition</param>
        void IUIGrid.Remove(IUIGridColumn prop)
        {
            throw new NotImplementedException();
        }

        /// <summary>
        /// Checks if a grid property definition is in the Grid definition
        /// </summary>
        /// <param name="prop">The grid property definition</param>
        bool IUIGrid.Contains(IUIGridColumn prop)
        {
            return this.UIColumns.Contains((UIGridColumnInfo) prop);
        }

        /// <summary>
        /// Provides an indexing facility so that the contents of the definition
        ///             collection can be accessed with square brackets like an array
        /// </summary>
        /// <param name="index">The index position to access</param>
        /// <returns>
        /// Returns the property definition at the index position
        ///             specified
        /// </returns>
        IUIGridColumn IUIGrid.this[int index]
        {
            get { return this.UIColumns[index]; }
        }

        /// <summary>
        /// Provides an indexing facility so that the contents of the definition
        ///             collection can be accessed with square brackets like an array
        /// </summary>
        /// <param name="propName">The index position to access</param>
        /// <returns>
        /// Returns the property definition at the index position
        ///             specified
        /// </returns>
        IUIGridColumn IUIGrid.this[string propName]
        {
            get { throw new NotImplementedException(); }
        }

        /// <summary>
        /// The column on which rows are ordered initially.
        ///             Indicate the direction by adding " asc" or " desc"
        ///             after the column name (" asc" is assumed if left out).  If this
        ///             property is not specified, rows will be listed in the order
        ///             they were added to the database.
        /// </summary>
        string IUIGrid.SortColumn
        {
            get { return this.SortColumn; }
            set { this.SortColumn = value; }
        }

        /// <summary>
        /// The definition of the filter that will be used for this grid.
        /// </summary>
        IFilterDef IUIGrid.FilterDef
        {
            get { return this.UIGridFilter;}
            set { UIGridFilter = (UIGridFilter) value; }
        }

        IUIDef IUIGrid.UIDef
        {
            get { return this.UIView; }
            set { UIView = (UIView)value; }
        }

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}