// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO.ClassDefinition;

namespace FireStarterModeller.BO
{
    [Serializable]
    public partial class UIView : IModelElement, IUIDef, IMergableBo
    {
        public UIView()
        {
        }

        protected internal UIView(ClassDef def) : base(def)
        {
        }

        protected UIView(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            return this.ViewName;
        }

        public IModelElement Parent
        {
            get { return this.Class; }
            set
            {
                throw new HabaneroDeveloperException
                    ("Set the parent of the UIView by setting the related Class object", "");
            }
        }

        protected override void LoadBusinessObjectRules(IList<IBusinessObjectRule> boRules)
        {
            base.LoadBusinessObjectRules(boRules);
            boRules.Add(new UIViewMustHaveUIGridOrUIForm());
        }

        #region Implementation of IUIDef

        /// <summary>
        /// Returns the form property definitions
        /// </summary>
        /// <returns>
        /// Returns a UIForm object
        /// </returns>
        IUIForm IUIDef.GetUIFormProperties()
        {
            return this.UIFormInfo;
        }

        /// <summary>
        /// Returns the grid property definitions
        /// </summary>
        /// <returns>
        /// Returns a UIGridDef object
        /// </returns>
        IUIGrid IUIDef.GetUIGridProperties()
        {
            return this.UIGridInfo;
        }

        /// <summary>
        /// Returns the form field for this UIDefinition for the property specified.
        ///              If the form field for the property is not defined in the uidef then null is returned.
        /// </summary>
        /// <param name="propertyName">The property name that you want the form field for</param>
        /// <returns>
        /// the form field or null
        /// </returns>
        IUIFormField IUIDef.GetFormField(string propertyName)
        {
            throw new NotImplementedException();
        }

        IUIDef IUIDef.Clone()
        {
            throw new System.NotImplementedException();
        }

        /// <summary>
        /// Returns the form definition
        /// </summary>
        IUIForm IUIDef.UIForm
        {
            get { return this.UIFormInfo; }
            set { this.UIFormInfo = (UIFormInfo) value; }
        }

        /// <summary>
        /// Returns the name
        /// </summary>
        string IUIDef.Name
        {
            get { return this.ViewName; }
            set { this.ViewName = value; }
        }

        /// <summary>
        /// Returns the grid definition
        /// </summary>
        IUIGrid IUIDef.UIGrid
        {
            get { return this.UIGridInfo; }
            set { this.UIGridInfo = (UIGridInfo) value; }
        }

        /// <summary>
        /// Gets a Collection of UIDefs
        /// </summary>
        UIDefCol IUIDef.UIDefCol
        {
            get { throw new NotImplementedException(); }
            set {  }
        }

        /// <summary>
        /// The Class Definition that this UIDef belongs to.
        /// </summary>
        IClassDef IUIDef.ClassDef
        {
            get { return this.Class; }
            set { }//Do Nothing this is only implemented to support the IUIDef interface
        }

        public string ClassName
        {
            get { return this.Class == null ? "" : this.Class.ClassNameBO; }
        }

        #endregion

        #region Implementation of IMergableBo

        ChangeType IMergableBo.PendingChangeType
        {
            get;
            set;
        }

        bool IMergableBo.PendingChangeApproved
        {
            get { return true; }
            set { }
        }

        #endregion
    }
}
