// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DBColumn objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DBColumn with a random value assigned to every property
        /// </summary>
        public static DBColumn CreateSavedDBColumn()
		{
		    DBColumn dBColumn = CreateUnsavedValidDBColumn();
			dBColumn.Save();
			return dBColumn;
		}

        /// <summary>
        /// Creates a new unsaved DBColumn with a random value assigned to every property
        /// </summary>
		public static DBColumn CreateUnsavedValidDBColumn()
		{
			DBColumn dBColumn = new DBColumn();
			dBColumn.ColumnName = TestUtils.GetRandomString();
			dBColumn.DataType = TestUtils.GetRandomString();
			dBColumn.DataLength = TestUtils.GetRandomInt();
			dBColumn.Nullable = TestUtils.GetRandomBoolean();
			dBColumn.DefaultValue = TestUtils.GetRandomString();
			dBColumn.TableID = TestUtils.CreateSavedDBTable().TableID;
			dBColumn.IsAutoIncrementing = TestUtils.GetRandomBoolean();
			dBColumn.Comment = TestUtils.GetRandomString();
			dBColumn.OrdinalPosition = TestUtils.GetRandomInt();
			dBColumn.PendingChangeType = null;
			dBColumn.Approved = TestUtils.GetRandomBoolean();
			return dBColumn;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DBColumn where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DBColumn CreateUnsavedDefaultDBColumn()
		{
			DBColumn dBColumn = new DBColumn();
			return dBColumn;
		}
    }
    
    // Provides the part of the test class that tests DBColumn objects
    [TestFixture]
    public partial class TestDBColumn : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBColumnWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBColumn dBColumn = new DBColumn();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dBColumn.ColumnID);
            Assert.IsInstanceOfType(dBColumn.Props["ColumnID"].PropertyType, dBColumn.ColumnID);
                        Assert.IsNull(dBColumn.ColumnName);
                        Assert.IsNull(dBColumn.DataType);
                        Assert.IsNull(dBColumn.DataLength);
                        Assert.IsNotNull(dBColumn.Nullable);
            Assert.IsInstanceOfType(dBColumn.Props["Nullable"].PropertyType, dBColumn.Nullable);
                        Assert.IsNull(dBColumn.DefaultValue);
                        Assert.IsNull(dBColumn.TableID);
                        Assert.IsNotNull(dBColumn.IsAutoIncrementing);
            Assert.IsInstanceOfType(dBColumn.Props["IsAutoIncrementing"].PropertyType, dBColumn.IsAutoIncrementing);
                        Assert.IsNull(dBColumn.Comment);
                        Assert.IsNull(dBColumn.OrdinalPosition);
                        Assert.IsNotNull(dBColumn.PendingChangeType);
            Assert.IsInstanceOfType(dBColumn.Props["PendingChangeType"].PropertyType, dBColumn.PendingChangeType);
                        Assert.IsNull(dBColumn.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateUnsavedValidDBColumn();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBColumn.Status.IsNew);
            BusinessObjectCollection<DBColumn> col = new BusinessObjectCollection<DBColumn>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBColumn.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBColumn.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            //---------------Execute Test ----------------------
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dBColumn.ColumnID, loadedDBColumn.ColumnID);
                        Assert.AreEqual(dBColumn.ColumnName, loadedDBColumn.ColumnName);
                        Assert.AreEqual(dBColumn.DataType, loadedDBColumn.DataType);
                        Assert.AreEqual(dBColumn.DataLength, loadedDBColumn.DataLength);
                        Assert.AreEqual(dBColumn.Nullable, loadedDBColumn.Nullable);
                        Assert.AreEqual(dBColumn.DefaultValue, loadedDBColumn.DefaultValue);
                        Assert.AreEqual(dBColumn.TableID, loadedDBColumn.TableID);
                        Assert.AreEqual(dBColumn.IsAutoIncrementing, loadedDBColumn.IsAutoIncrementing);
                        Assert.AreEqual(dBColumn.Comment, loadedDBColumn.Comment);
                        Assert.AreEqual(dBColumn.OrdinalPosition, loadedDBColumn.OrdinalPosition);
                        Assert.AreEqual(dBColumn.PendingChangeType, loadedDBColumn.PendingChangeType);
                        Assert.AreEqual(dBColumn.Approved, loadedDBColumn.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBColumn.Delete();
            dBColumn.Save();
            //---------------Test Result -----------------------
            try
            {
                DBColumn retrievedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBColumn", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnName = TestUtils.GetRandomString();
            dBColumn.ColumnName = (System.String) valueForColumnName;
            object valueForDataType = TestUtils.GetRandomString();
            dBColumn.DataType = (System.String) valueForDataType;
            object valueForDataLength = TestUtils.GetRandomInt();
            dBColumn.DataLength = (System.Int32) valueForDataLength;
            object valueForNullable = TestUtils.GetRandomBoolean();
            dBColumn.Nullable = (System.Boolean) valueForNullable;
            object valueForDefaultValue = TestUtils.GetRandomString();
            dBColumn.DefaultValue = (System.String) valueForDefaultValue;
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBColumn.TableID = (System.Guid) valueForTableID;
            object valueForIsAutoIncrementing = TestUtils.GetRandomBoolean();
            dBColumn.IsAutoIncrementing = (System.Boolean) valueForIsAutoIncrementing;
            object valueForComment = TestUtils.GetRandomString();
            dBColumn.Comment = (System.String) valueForComment;
            object valueForOrdinalPosition = TestUtils.GetRandomInt();
            dBColumn.OrdinalPosition = (System.Int32) valueForOrdinalPosition;
            object valueForPendingChangeType = null;
            dBColumn.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBColumn.Approved = (System.Boolean) valueForApproved;
            dBColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBColumn retrievedDBColumn =
                    Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            
            Assert.AreEqual(valueForColumnName, retrievedDBColumn.ColumnName);
            Assert.AreEqual(valueForDataType, retrievedDBColumn.DataType);
            Assert.AreEqual(valueForDataLength, retrievedDBColumn.DataLength);
            Assert.AreEqual(valueForNullable, retrievedDBColumn.Nullable);
            Assert.AreEqual(valueForDefaultValue, retrievedDBColumn.DefaultValue);
            Assert.AreEqual(valueForTableID, retrievedDBColumn.TableID);
            Assert.AreEqual(valueForIsAutoIncrementing, retrievedDBColumn.IsAutoIncrementing);
            Assert.AreEqual(valueForComment, retrievedDBColumn.Comment);
            Assert.AreEqual(valueForOrdinalPosition, retrievedDBColumn.OrdinalPosition);
            Assert.AreEqual(valueForPendingChangeType, retrievedDBColumn.PendingChangeType);
            Assert.AreEqual(valueForApproved, retrievedDBColumn.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = new DBColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnName = TestUtils.GetRandomString();
            dBColumn.ColumnName = (System.String) valueForColumnName;
            object valueForDataType = TestUtils.GetRandomString();
            dBColumn.DataType = (System.String) valueForDataType;
            object valueForDataLength = TestUtils.GetRandomInt();
            dBColumn.DataLength = (System.Int32) valueForDataLength;
            object valueForNullable = TestUtils.GetRandomBoolean();
            dBColumn.Nullable = (System.Boolean) valueForNullable;
            object valueForDefaultValue = TestUtils.GetRandomString();
            dBColumn.DefaultValue = (System.String) valueForDefaultValue;
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBColumn.TableID = (System.Guid) valueForTableID;
            object valueForIsAutoIncrementing = TestUtils.GetRandomBoolean();
            dBColumn.IsAutoIncrementing = (System.Boolean) valueForIsAutoIncrementing;
            object valueForComment = TestUtils.GetRandomString();
            dBColumn.Comment = (System.String) valueForComment;
            object valueForOrdinalPosition = TestUtils.GetRandomInt();
            dBColumn.OrdinalPosition = (System.Int32) valueForOrdinalPosition;
            object valueForPendingChangeType = null;
            dBColumn.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForColumnName, dBColumn.ColumnName);
            Assert.AreEqual(valueForDataType, dBColumn.DataType);
            Assert.AreEqual(valueForDataLength, dBColumn.DataLength);
            Assert.AreEqual(valueForNullable, dBColumn.Nullable);
            Assert.AreEqual(valueForDefaultValue, dBColumn.DefaultValue);
            Assert.AreEqual(valueForTableID, dBColumn.TableID);
            Assert.AreEqual(valueForIsAutoIncrementing, dBColumn.IsAutoIncrementing);
            Assert.AreEqual(valueForComment, dBColumn.Comment);
            Assert.AreEqual(valueForOrdinalPosition, dBColumn.OrdinalPosition);
            Assert.AreEqual(valueForPendingChangeType, dBColumn.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBColumn.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = new DBColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnName = TestUtils.GetRandomString();
            dBColumn.ColumnName = (System.String) valueForColumnName;
            object valueForDataType = TestUtils.GetRandomString();
            dBColumn.DataType = (System.String) valueForDataType;
            object valueForDataLength = TestUtils.GetRandomInt();
            dBColumn.DataLength = (System.Int32) valueForDataLength;
            object valueForNullable = TestUtils.GetRandomBoolean();
            dBColumn.Nullable = (System.Boolean) valueForNullable;
            object valueForDefaultValue = TestUtils.GetRandomString();
            dBColumn.DefaultValue = (System.String) valueForDefaultValue;
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBColumn.TableID = (System.Guid) valueForTableID;
            object valueForIsAutoIncrementing = TestUtils.GetRandomBoolean();
            dBColumn.IsAutoIncrementing = (System.Boolean) valueForIsAutoIncrementing;
            object valueForComment = TestUtils.GetRandomString();
            dBColumn.Comment = (System.String) valueForComment;
            object valueForOrdinalPosition = TestUtils.GetRandomInt();
            dBColumn.OrdinalPosition = (System.Int32) valueForOrdinalPosition;
            object valueForPendingChangeType = null;
            dBColumn.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBColumn.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForColumnName, dBColumn.GetPropertyValue("ColumnName"));
            Assert.AreEqual(valueForDataType, dBColumn.GetPropertyValue("DataType"));
            Assert.AreEqual(valueForDataLength, dBColumn.GetPropertyValue("DataLength"));
            Assert.AreEqual(valueForNullable, dBColumn.GetPropertyValue("Nullable"));
            Assert.AreEqual(valueForDefaultValue, dBColumn.GetPropertyValue("DefaultValue"));
            Assert.AreEqual(valueForTableID, dBColumn.GetPropertyValue("TableID"));
            Assert.AreEqual(valueForIsAutoIncrementing, dBColumn.GetPropertyValue("IsAutoIncrementing"));
            Assert.AreEqual(valueForComment, dBColumn.GetPropertyValue("Comment"));
            Assert.AreEqual(valueForOrdinalPosition, dBColumn.GetPropertyValue("OrdinalPosition"));
            Assert.AreEqual(valueForPendingChangeType, dBColumn.GetPropertyValue("PendingChangeType"));
            Assert.AreEqual(valueForApproved, dBColumn.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = new DBColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForColumnName = TestUtils.GetRandomString();            
            dBColumn.SetPropertyValue("ColumnName", valueForColumnName);
            object valueForDataType = TestUtils.GetRandomString();            
            dBColumn.SetPropertyValue("DataType", valueForDataType);
            object valueForDataLength = TestUtils.GetRandomInt();            
            dBColumn.SetPropertyValue("DataLength", valueForDataLength);
            object valueForNullable = TestUtils.GetRandomBoolean();            
            dBColumn.SetPropertyValue("Nullable", valueForNullable);
            object valueForDefaultValue = TestUtils.GetRandomString();            
            dBColumn.SetPropertyValue("DefaultValue", valueForDefaultValue);
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;            
            dBColumn.SetPropertyValue("TableID", valueForTableID);
            object valueForIsAutoIncrementing = TestUtils.GetRandomBoolean();            
            dBColumn.SetPropertyValue("IsAutoIncrementing", valueForIsAutoIncrementing);
            object valueForComment = TestUtils.GetRandomString();            
            dBColumn.SetPropertyValue("Comment", valueForComment);
            object valueForOrdinalPosition = TestUtils.GetRandomInt();            
            dBColumn.SetPropertyValue("OrdinalPosition", valueForOrdinalPosition);
            object valueForPendingChangeType = null;            
            dBColumn.SetPropertyValue("PendingChangeType", valueForPendingChangeType);
            object valueForApproved = TestUtils.GetRandomBoolean();            
            dBColumn.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForColumnName, dBColumn.ColumnName);
            Assert.AreEqual(valueForDataType, dBColumn.DataType);
            Assert.AreEqual(valueForDataLength, dBColumn.DataLength);
            Assert.AreEqual(valueForNullable, dBColumn.Nullable);
            Assert.AreEqual(valueForDefaultValue, dBColumn.DefaultValue);
            Assert.AreEqual(valueForTableID, dBColumn.TableID);
            Assert.AreEqual(valueForIsAutoIncrementing, dBColumn.IsAutoIncrementing);
            Assert.AreEqual(valueForComment, dBColumn.Comment);
            Assert.AreEqual(valueForOrdinalPosition, dBColumn.OrdinalPosition);
            Assert.AreEqual(valueForPendingChangeType, dBColumn.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBColumn.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBColumn.DataLength = null;
            dBColumn.DefaultValue = null;
            dBColumn.IsAutoIncrementing = null;
            dBColumn.Comment = null;
            dBColumn.OrdinalPosition = null;
            dBColumn.PendingChangeType = null;
            dBColumn.Approved = null;
            dBColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBColumn retrievedDBColumn =
                    Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            
            Assert.IsNull(retrievedDBColumn.DataLength);
            Assert.IsNull(retrievedDBColumn.DefaultValue);
            Assert.IsNull(retrievedDBColumn.IsAutoIncrementing);
            Assert.IsNull(retrievedDBColumn.Comment);
            Assert.IsNull(retrievedDBColumn.OrdinalPosition);
            Assert.IsNull(retrievedDBColumn.PendingChangeType);
            Assert.IsNull(retrievedDBColumn.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateUnsavedValidDBColumn();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBColumn.ColumnID = null;
            dBColumn.ColumnName = null;
            dBColumn.DataType = null;
            dBColumn.Nullable = null;
            dBColumn.TableID = null;
            
            try
            {
                dBColumn.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Column ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Column Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Data Type' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Nullable' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Table I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBColumn>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["ColumnID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ColumnName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DataType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DataLength"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Nullable"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DefaultValue"].ReadWriteRule.ToString());
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["TableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["IsAutoIncrementing"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Comment"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["OrdinalPosition"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_MappedDMProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DMProperty boForRelationshipMappedDMProperty = TestUtils.CreateSavedDMProperty();
            dBColumn.MappedDMProperty = boForRelationshipMappedDMProperty;
            dBColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMProperty loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipMappedDMProperty.ID);
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipMappedDMProperty, loadedDBColumn.MappedDMProperty);
            Assert.AreEqual(loadedRelatedBO, loadedDBColumn.MappedDMProperty);
            Assert.AreEqual(loadedRelatedBO, dBColumn.MappedDMProperty);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Table()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBTable boForRelationshipTable = TestUtils.CreateSavedDBTable();
            dBColumn.Table = boForRelationshipTable;
            dBColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBTable loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBTable>(boForRelationshipTable.ID);
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipTable, loadedDBColumn.Table);
            Assert.AreEqual(loadedRelatedBO, loadedDBColumn.Table);
            Assert.AreEqual(loadedRelatedBO, dBColumn.Table);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ForeignKeyColumnsAsParentColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBForeignKeyColumn boForRelationshipForeignKeyColumnsAsParentColumn = TestUtils.CreateUnsavedValidDBForeignKeyColumn();
            boForRelationshipForeignKeyColumnsAsParentColumn.ParentColumnID = dBColumn.ColumnID;
            boForRelationshipForeignKeyColumnsAsParentColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.ForeignKeyColumnsAsParentColumn.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBForeignKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBForeignKeyColumn>(boForRelationshipForeignKeyColumnsAsParentColumn.ID);
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBColumn.ForeignKeyColumnsAsParentColumn.Count);
            Assert.AreEqual(boForRelationshipForeignKeyColumnsAsParentColumn, loadedDBColumn.ForeignKeyColumnsAsParentColumn[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBColumn.ForeignKeyColumnsAsParentColumn[0]);
            Assert.AreEqual(loadedRelatedBO, dBColumn.ForeignKeyColumnsAsParentColumn[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ForeignKeyColumnsAsRelatedColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBForeignKeyColumn boForRelationshipForeignKeyColumnsAsRelatedColumn = TestUtils.CreateUnsavedValidDBForeignKeyColumn();
            boForRelationshipForeignKeyColumnsAsRelatedColumn.RelatedColumnID = dBColumn.ColumnID;
            boForRelationshipForeignKeyColumnsAsRelatedColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.ForeignKeyColumnsAsRelatedColumn.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBForeignKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBForeignKeyColumn>(boForRelationshipForeignKeyColumnsAsRelatedColumn.ID);
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBColumn.ForeignKeyColumnsAsRelatedColumn.Count);
            Assert.AreEqual(boForRelationshipForeignKeyColumnsAsRelatedColumn, loadedDBColumn.ForeignKeyColumnsAsRelatedColumn[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBColumn.ForeignKeyColumnsAsRelatedColumn[0]);
            Assert.AreEqual(loadedRelatedBO, dBColumn.ForeignKeyColumnsAsRelatedColumn[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_KeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBKeyColumn boForRelationshipKeyColumns = TestUtils.CreateUnsavedValidDBKeyColumn();
            boForRelationshipKeyColumns.ColumnID = dBColumn.ColumnID;
            boForRelationshipKeyColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.KeyColumns.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBKeyColumn>(boForRelationshipKeyColumns.ID);
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBColumn.KeyColumns.Count);
            Assert.AreEqual(boForRelationshipKeyColumns, loadedDBColumn.KeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBColumn.KeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, dBColumn.KeyColumns[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_PrimaryKeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBPrimaryKeyColumn boForRelationshipPrimaryKeyColumns = TestUtils.CreateUnsavedValidDBPrimaryKeyColumn();
            boForRelationshipPrimaryKeyColumns.ColumnID = dBColumn.ColumnID;
            boForRelationshipPrimaryKeyColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.PrimaryKeyColumns.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBPrimaryKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBPrimaryKeyColumn>(boForRelationshipPrimaryKeyColumns.ID);
            DBColumn loadedDBColumn = Broker.GetBusinessObject<DBColumn>(dBColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBColumn.PrimaryKeyColumns.Count);
            Assert.AreEqual(boForRelationshipPrimaryKeyColumns, loadedDBColumn.PrimaryKeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBColumn.PrimaryKeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, dBColumn.PrimaryKeyColumns[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ForeignKeyColumnsAsParentColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBForeignKeyColumn boForRelationshipForeignKeyColumnsAsParentColumn = TestUtils.CreateUnsavedValidDBForeignKeyColumn();
            boForRelationshipForeignKeyColumnsAsParentColumn.ParentColumnID = dBColumn.ColumnID;
            boForRelationshipForeignKeyColumnsAsParentColumn.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.ForeignKeyColumnsAsParentColumn.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBColumn>().RelationshipDefCol["ForeignKeyColumnsAsParentColumn"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBColumn.Delete();
                dBColumn.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'ForeignKeyColumnsAsParentColumn' relationship that need to be deleted first"));
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ForeignKeyColumnsAsRelatedColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBForeignKeyColumn boForRelationshipForeignKeyColumnsAsRelatedColumn = TestUtils.CreateUnsavedValidDBForeignKeyColumn();
            boForRelationshipForeignKeyColumnsAsRelatedColumn.RelatedColumnID = dBColumn.ColumnID;
            boForRelationshipForeignKeyColumnsAsRelatedColumn.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.ForeignKeyColumnsAsRelatedColumn.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBColumn>().RelationshipDefCol["ForeignKeyColumnsAsRelatedColumn"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBColumn.Delete();
                dBColumn.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'ForeignKeyColumnsAsRelatedColumn' relationship that need to be deleted first"));
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_KeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBKeyColumn boForRelationshipKeyColumns = TestUtils.CreateUnsavedValidDBKeyColumn();
            boForRelationshipKeyColumns.ColumnID = dBColumn.ColumnID;
            boForRelationshipKeyColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.KeyColumns.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBColumn>().RelationshipDefCol["KeyColumns"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBColumn.Delete();
                dBColumn.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'KeyColumns' relationship that need to be deleted first"));
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_PrimaryKeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBColumn dBColumn = TestUtils.CreateSavedDBColumn();

            FireStarterModeller.BO.DBPrimaryKeyColumn boForRelationshipPrimaryKeyColumns = TestUtils.CreateUnsavedValidDBPrimaryKeyColumn();
            boForRelationshipPrimaryKeyColumns.ColumnID = dBColumn.ColumnID;
            boForRelationshipPrimaryKeyColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBColumn.PrimaryKeyColumns.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBColumn>().RelationshipDefCol["PrimaryKeyColumns"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBColumn.Delete();
                dBColumn.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'PrimaryKeyColumns' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
