// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DBKey objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DBKey with a random value assigned to every property
        /// </summary>
        public static DBKey CreateSavedDBKey()
		{
		    DBKey dBKey = CreateUnsavedValidDBKey();
			dBKey.Save();
			return dBKey;
		}

        /// <summary>
        /// Creates a new unsaved DBKey with a random value assigned to every property
        /// </summary>
		public static DBKey CreateUnsavedValidDBKey()
		{
			DBKey dBKey = new DBKey();
			dBKey.KeyName = TestUtils.GetRandomString();
			dBKey.TableID = TestUtils.CreateSavedDBTable().TableID;
			dBKey.PendingChangeType = null;
			dBKey.Approved = TestUtils.GetRandomBoolean();
			return dBKey;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DBKey where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DBKey CreateUnsavedDefaultDBKey()
		{
			DBKey dBKey = new DBKey();
			return dBKey;
		}
    }
    
    // Provides the part of the test class that tests DBKey objects
    [TestFixture]
    public partial class TestDBKey : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBKeyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBKey dBKey = new DBKey();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dBKey.KeyID);
            Assert.IsInstanceOfType(dBKey.Props["KeyID"].PropertyType, dBKey.KeyID);
                        Assert.IsNull(dBKey.KeyName);
                        Assert.IsNull(dBKey.TableID);
                        Assert.IsNotNull(dBKey.PendingChangeType);
            Assert.IsInstanceOfType(dBKey.Props["PendingChangeType"].PropertyType, dBKey.PendingChangeType);
                        Assert.IsNull(dBKey.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = TestUtils.CreateUnsavedValidDBKey();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBKey.Status.IsNew);
            BusinessObjectCollection<DBKey> col = new BusinessObjectCollection<DBKey>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBKey.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBKey.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = TestUtils.CreateSavedDBKey();

            //---------------Execute Test ----------------------
            DBKey loadedDBKey = Broker.GetBusinessObject<DBKey>(dBKey.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dBKey.KeyID, loadedDBKey.KeyID);
                        Assert.AreEqual(dBKey.KeyName, loadedDBKey.KeyName);
                        Assert.AreEqual(dBKey.TableID, loadedDBKey.TableID);
                        Assert.AreEqual(dBKey.PendingChangeType, loadedDBKey.PendingChangeType);
                        Assert.AreEqual(dBKey.Approved, loadedDBKey.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = TestUtils.CreateSavedDBKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBKey.Delete();
            dBKey.Save();
            //---------------Test Result -----------------------
            try
            {
                DBKey retrievedDBKey = Broker.GetBusinessObject<DBKey>(dBKey.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBKey", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBKey()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = TestUtils.CreateSavedDBKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForKeyName = TestUtils.GetRandomString();
            dBKey.KeyName = (System.String) valueForKeyName;
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBKey.TableID = (System.Guid) valueForTableID;
            object valueForPendingChangeType = null;
            dBKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBKey.Approved = (System.Boolean) valueForApproved;
            dBKey.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBKey retrievedDBKey =
                    Broker.GetBusinessObject<DBKey>(dBKey.ID);
            
            Assert.AreEqual(valueForKeyName, retrievedDBKey.KeyName);
            Assert.AreEqual(valueForTableID, retrievedDBKey.TableID);
            Assert.AreEqual(valueForPendingChangeType, retrievedDBKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, retrievedDBKey.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = new DBKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForKeyName = TestUtils.GetRandomString();
            dBKey.KeyName = (System.String) valueForKeyName;
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBKey.TableID = (System.Guid) valueForTableID;
            object valueForPendingChangeType = null;
            dBKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBKey.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForKeyName, dBKey.KeyName);
            Assert.AreEqual(valueForTableID, dBKey.TableID);
            Assert.AreEqual(valueForPendingChangeType, dBKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBKey.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = new DBKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForKeyName = TestUtils.GetRandomString();
            dBKey.KeyName = (System.String) valueForKeyName;
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;
            dBKey.TableID = (System.Guid) valueForTableID;
            object valueForPendingChangeType = null;
            dBKey.PendingChangeType = (FireStarterModeller.BO.FireStarterModeller.BO.ChangeType) valueForPendingChangeType;
            object valueForApproved = TestUtils.GetRandomBoolean();
            dBKey.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForKeyName, dBKey.GetPropertyValue("KeyName"));
            Assert.AreEqual(valueForTableID, dBKey.GetPropertyValue("TableID"));
            Assert.AreEqual(valueForPendingChangeType, dBKey.GetPropertyValue("PendingChangeType"));
            Assert.AreEqual(valueForApproved, dBKey.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = new DBKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForKeyName = TestUtils.GetRandomString();            
            dBKey.SetPropertyValue("KeyName", valueForKeyName);
            object valueForTableID = TestUtils.CreateSavedDBTable().TableID;            
            dBKey.SetPropertyValue("TableID", valueForTableID);
            object valueForPendingChangeType = null;            
            dBKey.SetPropertyValue("PendingChangeType", valueForPendingChangeType);
            object valueForApproved = TestUtils.GetRandomBoolean();            
            dBKey.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForKeyName, dBKey.KeyName);
            Assert.AreEqual(valueForTableID, dBKey.TableID);
            Assert.AreEqual(valueForPendingChangeType, dBKey.PendingChangeType);
            Assert.AreEqual(valueForApproved, dBKey.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = TestUtils.CreateSavedDBKey();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBKey.KeyName = null;
            dBKey.TableID = null;
            dBKey.PendingChangeType = null;
            dBKey.Approved = null;
            dBKey.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DBKey retrievedDBKey =
                    Broker.GetBusinessObject<DBKey>(dBKey.ID);
            
            Assert.IsNull(retrievedDBKey.KeyName);
            Assert.IsNull(retrievedDBKey.TableID);
            Assert.IsNull(retrievedDBKey.PendingChangeType);
            Assert.IsNull(retrievedDBKey.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            // There are no compulsory properties
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBKey>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["KeyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["KeyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Table()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBKey dBKey = TestUtils.CreateSavedDBKey();

            FireStarterModeller.BO.DBTable boForRelationshipTable = TestUtils.CreateSavedDBTable();
            dBKey.Table = boForRelationshipTable;
            dBKey.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBTable loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBTable>(boForRelationshipTable.ID);
            DBKey loadedDBKey = Broker.GetBusinessObject<DBKey>(dBKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipTable, loadedDBKey.Table);
            Assert.AreEqual(loadedRelatedBO, loadedDBKey.Table);
            Assert.AreEqual(loadedRelatedBO, dBKey.Table);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_KeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBKey dBKey = TestUtils.CreateSavedDBKey();

            FireStarterModeller.BO.DBKeyColumn boForRelationshipKeyColumns = TestUtils.CreateUnsavedValidDBKeyColumn();
            boForRelationshipKeyColumns.KeyID = dBKey.KeyID;
            boForRelationshipKeyColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBKey.KeyColumns.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBKeyColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBKeyColumn>(boForRelationshipKeyColumns.ID);
            DBKey loadedDBKey = Broker.GetBusinessObject<DBKey>(dBKey.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBKey.KeyColumns.Count);
            Assert.AreEqual(boForRelationshipKeyColumns, loadedDBKey.KeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBKey.KeyColumns[0]);
            Assert.AreEqual(loadedRelatedBO, dBKey.KeyColumns[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_KeyColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBKey dBKey = TestUtils.CreateSavedDBKey();

            FireStarterModeller.BO.DBKeyColumn boForRelationshipKeyColumns = TestUtils.CreateUnsavedValidDBKeyColumn();
            boForRelationshipKeyColumns.KeyID = dBKey.KeyID;
            boForRelationshipKeyColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBKey.KeyColumns.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DBKey>().RelationshipDefCol["KeyColumns"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBKey.Delete();
                dBKey.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'KeyColumns' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
