// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMAssembly objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMAssembly with a random value assigned to every property
        /// </summary>
        public static DMAssembly CreateSavedDMAssembly()
		{
		    DMAssembly dMAssembly = CreateUnsavedValidDMAssembly();
			dMAssembly.Save();
			return dMAssembly;
		}

        /// <summary>
        /// Creates a new unsaved DMAssembly with a random value assigned to every property
        /// </summary>
		public static DMAssembly CreateUnsavedValidDMAssembly()
		{
			DMAssembly dMAssembly = new DMAssembly();
			dMAssembly.Name = TestUtils.GetRandomString();
			dMAssembly.SolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
			return dMAssembly;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMAssembly where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMAssembly CreateUnsavedDefaultDMAssembly()
		{
			DMAssembly dMAssembly = new DMAssembly();
			return dMAssembly;
		}
    }
    
    // Provides the part of the test class that tests DMAssembly objects
    [TestFixture]
    public partial class TestDMAssembly : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMAssemblyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMAssembly dMAssembly = new DMAssembly();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMAssembly.AssemblyID);
            Assert.IsInstanceOfType(dMAssembly.Props["AssemblyID"].PropertyType, dMAssembly.AssemblyID);
                        Assert.IsNull(dMAssembly.Name);
                        Assert.IsNull(dMAssembly.SolutionID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateUnsavedValidDMAssembly();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMAssembly.Status.IsNew);
            BusinessObjectCollection<DMAssembly> col = new BusinessObjectCollection<DMAssembly>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMAssembly.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMAssembly.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();

            //---------------Execute Test ----------------------
            DMAssembly loadedDMAssembly = Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMAssembly.AssemblyID, loadedDMAssembly.AssemblyID);
                        Assert.AreEqual(dMAssembly.Name, loadedDMAssembly.Name);
                        Assert.AreEqual(dMAssembly.SolutionID, loadedDMAssembly.SolutionID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMAssembly.Delete();
            dMAssembly.Save();
            //---------------Test Result -----------------------
            try
            {
                DMAssembly retrievedDMAssembly = Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMAssembly", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMAssembly.Name = (System.String) valueForName;
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
            dMAssembly.SolutionID = (System.Guid) valueForSolutionID;
            dMAssembly.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMAssembly retrievedDMAssembly =
                    Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
            
            Assert.AreEqual(valueForName, retrievedDMAssembly.Name);
            Assert.AreEqual(valueForSolutionID, retrievedDMAssembly.SolutionID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = new DMAssembly();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMAssembly.Name = (System.String) valueForName;
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
            dMAssembly.SolutionID = (System.Guid) valueForSolutionID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMAssembly.Name);
            Assert.AreEqual(valueForSolutionID, dMAssembly.SolutionID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = new DMAssembly();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMAssembly.Name = (System.String) valueForName;
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
            dMAssembly.SolutionID = (System.Guid) valueForSolutionID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMAssembly.GetPropertyValue("Name"));
            Assert.AreEqual(valueForSolutionID, dMAssembly.GetPropertyValue("SolutionID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = new DMAssembly();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();            
            dMAssembly.SetPropertyValue("Name", valueForName);
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;            
            dMAssembly.SetPropertyValue("SolutionID", valueForSolutionID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMAssembly.Name);
            Assert.AreEqual(valueForSolutionID, dMAssembly.SolutionID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMAssembly.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMAssembly retrievedDMAssembly =
                    Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMAssembly dMAssembly = TestUtils.CreateUnsavedValidDMAssembly();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMAssembly.AssemblyID = null;
            dMAssembly.Name = null;
            dMAssembly.SolutionID = null;
            
            try
            {
                dMAssembly.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Assembly I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Solution ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMAssembly>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();

            FireStarterModeller.BO.DMSolution boForRelationshipSolution = TestUtils.CreateSavedDMSolution();
            dMAssembly.Solution = boForRelationshipSolution;
            dMAssembly.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSolution loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSolution>(boForRelationshipSolution.ID);
            DMAssembly loadedDMAssembly = Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedDMAssembly.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedDMAssembly.Solution);
            Assert.AreEqual(loadedRelatedBO, dMAssembly.Solution);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution_DefaultAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();

            FireStarterModeller.BO.DMSolution boForRelationshipSolution_DefaultAssembly = TestUtils.CreateSavedDMSolution();
            dMAssembly.Solution_DefaultAssembly = boForRelationshipSolution_DefaultAssembly;
            dMAssembly.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSolution loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSolution>(boForRelationshipSolution_DefaultAssembly.ID);
            DMAssembly loadedDMAssembly = Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution_DefaultAssembly, loadedDMAssembly.Solution_DefaultAssembly);
            Assert.AreEqual(loadedRelatedBO, loadedDMAssembly.Solution_DefaultAssembly);
            Assert.AreEqual(loadedRelatedBO, dMAssembly.Solution_DefaultAssembly);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Classes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();

            FireStarterModeller.BO.DMClass boForRelationshipClasses = TestUtils.CreateUnsavedValidDMClass();
            boForRelationshipClasses.AssemblyID = dMAssembly.AssemblyID;
            boForRelationshipClasses.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMAssembly.Classes.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipClasses.ID);
            DMAssembly loadedDMAssembly = Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMAssembly.Classes.Count);
            Assert.AreEqual(boForRelationshipClasses, loadedDMAssembly.Classes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMAssembly.Classes[0]);
            Assert.AreEqual(loadedRelatedBO, dMAssembly.Classes[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_Classes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();

            FireStarterModeller.BO.DMClass boForRelationshipClasses = TestUtils.CreateUnsavedValidDMClass();
            boForRelationshipClasses.AssemblyID = dMAssembly.AssemblyID;
            boForRelationshipClasses.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMAssembly.Classes.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMAssembly>().RelationshipDefCol["Classes"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMAssembly.Delete();
                dMAssembly.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'Classes' relationship that need to be deleted first"));
        }
        
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_Solution_DefaultAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMAssembly dMAssembly = TestUtils.CreateSavedDMAssembly();

            FireStarterModeller.BO.DMSolution boForRelationshipSolution_DefaultAssembly = TestUtils.CreateSavedDMSolution();
            dMAssembly.Solution_DefaultAssembly = boForRelationshipSolution_DefaultAssembly;
            dMAssembly.Save();

            //---------------Assert Preconditions---------------
            RelationshipDef relationshipDef = ClassDef.Get<DMAssembly>().RelationshipDefCol["Solution_DefaultAssembly"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMAssembly.Delete();
            dMAssembly.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMAssembly>(dMAssembly.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMAssembly"));
            }            
            
            FireStarterModeller.BO.DMSolution relatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSolution>(boForRelationshipSolution_DefaultAssembly.ID);
            Assert.AreEqual(relatedBO,boForRelationshipSolution_DefaultAssembly);
            
        }
       
    }
}
