// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMClass objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMClass with a random value assigned to every property
        /// </summary>
        public static DMClass CreateSavedDMClass()
		{
		    DMClass dMClass = CreateUnsavedValidDMClass();
			dMClass.Save();
			return dMClass;
		}

        /// <summary>
        /// Creates a new unsaved DMClass with a random value assigned to every property
        /// </summary>
		public static DMClass CreateUnsavedValidDMClass()
		{
			DMClass dMClass = new DMClass();
			dMClass.ClassNameBO = TestUtils.GetRandomString(1,100);
			dMClass.MappedTableName = TestUtils.GetRandomString();
			dMClass.AssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
			dMClass.DisplayName = TestUtils.GetRandomString();
			dMClass.Generated = TestUtils.GetRandomBoolean();
			dMClass.SuperClassID = TestUtils.CreateSavedDMSuperClass().SuperClassID;
			dMClass.MappedTableID = TestUtils.CreateSavedDBTable().TableID;
			dMClass.BusinessObjectDescription = TestUtils.GetRandomString();
			return dMClass;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMClass where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMClass CreateUnsavedDefaultDMClass()
		{
			DMClass dMClass = new DMClass();
			return dMClass;
		}
    }
    
    // Provides the part of the test class that tests DMClass objects
    [TestFixture]
    public partial class TestDMClass : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMClassWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMClass dMClass = new DMClass();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMClass.ClassID);
            Assert.IsInstanceOfType(dMClass.Props["ClassID"].PropertyType, dMClass.ClassID);
                        Assert.IsNull(dMClass.ClassNameBO);
                        Assert.IsNull(dMClass.MappedTableName);
                        Assert.IsNull(dMClass.AssemblyID);
                        Assert.IsNull(dMClass.DisplayName);
                        Assert.IsNotNull(dMClass.Generated);
            Assert.IsInstanceOfType(dMClass.Props["Generated"].PropertyType, dMClass.Generated);
                        Assert.IsNull(dMClass.SuperClassID);
                        Assert.IsNull(dMClass.MappedTableID);
                        Assert.IsNull(dMClass.BusinessObjectDescription);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateUnsavedValidDMClass();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMClass.Status.IsNew);
            BusinessObjectCollection<DMClass> col = new BusinessObjectCollection<DMClass>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMClass.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMClass.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            //---------------Execute Test ----------------------
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMClass.ClassID, loadedDMClass.ClassID);
                        Assert.AreEqual(dMClass.ClassNameBO, loadedDMClass.ClassNameBO);
                        Assert.AreEqual(dMClass.MappedTableName, loadedDMClass.MappedTableName);
                        Assert.AreEqual(dMClass.AssemblyID, loadedDMClass.AssemblyID);
                        Assert.AreEqual(dMClass.DisplayName, loadedDMClass.DisplayName);
                        Assert.AreEqual(dMClass.Generated, loadedDMClass.Generated);
                        Assert.AreEqual(dMClass.SuperClassID, loadedDMClass.SuperClassID);
                        Assert.AreEqual(dMClass.MappedTableID, loadedDMClass.MappedTableID);
                        Assert.AreEqual(dMClass.BusinessObjectDescription, loadedDMClass.BusinessObjectDescription);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMClass.Delete();
            dMClass.Save();
            //---------------Test Result -----------------------
            try
            {
                DMClass retrievedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMClass", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtils.GetRandomString(1,100);
            dMClass.ClassNameBO = (System.String) valueForClassNameBO;
            object valueForMappedTableName = TestUtils.GetRandomString();
            dMClass.MappedTableName = (System.String) valueForMappedTableName;
            object valueForAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
            dMClass.AssemblyID = (System.Guid) valueForAssemblyID;
            object valueForDisplayName = TestUtils.GetRandomString();
            dMClass.DisplayName = (System.String) valueForDisplayName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMClass.Generated = (System.Boolean) valueForGenerated;
            object valueForSuperClassID = TestUtils.CreateSavedDMSuperClass().SuperClassID;
            dMClass.SuperClassID = (System.Guid) valueForSuperClassID;
            object valueForMappedTableID = TestUtils.CreateSavedDBTable().TableID;
            dMClass.MappedTableID = (System.Guid) valueForMappedTableID;
            object valueForBusinessObjectDescription = TestUtils.GetRandomString();
            dMClass.BusinessObjectDescription = (System.String) valueForBusinessObjectDescription;
            dMClass.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMClass retrievedDMClass =
                    Broker.GetBusinessObject<DMClass>(dMClass.ID);
            
            Assert.AreEqual(valueForClassNameBO, retrievedDMClass.ClassNameBO);
            Assert.AreEqual(valueForMappedTableName, retrievedDMClass.MappedTableName);
            Assert.AreEqual(valueForAssemblyID, retrievedDMClass.AssemblyID);
            Assert.AreEqual(valueForDisplayName, retrievedDMClass.DisplayName);
            Assert.AreEqual(valueForGenerated, retrievedDMClass.Generated);
            Assert.AreEqual(valueForSuperClassID, retrievedDMClass.SuperClassID);
            Assert.AreEqual(valueForMappedTableID, retrievedDMClass.MappedTableID);
            Assert.AreEqual(valueForBusinessObjectDescription, retrievedDMClass.BusinessObjectDescription);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = new DMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtils.GetRandomString(1,100);
            dMClass.ClassNameBO = (System.String) valueForClassNameBO;
            object valueForMappedTableName = TestUtils.GetRandomString();
            dMClass.MappedTableName = (System.String) valueForMappedTableName;
            object valueForAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
            dMClass.AssemblyID = (System.Guid) valueForAssemblyID;
            object valueForDisplayName = TestUtils.GetRandomString();
            dMClass.DisplayName = (System.String) valueForDisplayName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMClass.Generated = (System.Boolean) valueForGenerated;
            object valueForSuperClassID = TestUtils.CreateSavedDMSuperClass().SuperClassID;
            dMClass.SuperClassID = (System.Guid) valueForSuperClassID;
            object valueForMappedTableID = TestUtils.CreateSavedDBTable().TableID;
            dMClass.MappedTableID = (System.Guid) valueForMappedTableID;
            object valueForBusinessObjectDescription = TestUtils.GetRandomString();
            dMClass.BusinessObjectDescription = (System.String) valueForBusinessObjectDescription;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassNameBO, dMClass.ClassNameBO);
            Assert.AreEqual(valueForMappedTableName, dMClass.MappedTableName);
            Assert.AreEqual(valueForAssemblyID, dMClass.AssemblyID);
            Assert.AreEqual(valueForDisplayName, dMClass.DisplayName);
            Assert.AreEqual(valueForGenerated, dMClass.Generated);
            Assert.AreEqual(valueForSuperClassID, dMClass.SuperClassID);
            Assert.AreEqual(valueForMappedTableID, dMClass.MappedTableID);
            Assert.AreEqual(valueForBusinessObjectDescription, dMClass.BusinessObjectDescription);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = new DMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtils.GetRandomString(1,100);
            dMClass.ClassNameBO = (System.String) valueForClassNameBO;
            object valueForMappedTableName = TestUtils.GetRandomString();
            dMClass.MappedTableName = (System.String) valueForMappedTableName;
            object valueForAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
            dMClass.AssemblyID = (System.Guid) valueForAssemblyID;
            object valueForDisplayName = TestUtils.GetRandomString();
            dMClass.DisplayName = (System.String) valueForDisplayName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMClass.Generated = (System.Boolean) valueForGenerated;
            object valueForSuperClassID = TestUtils.CreateSavedDMSuperClass().SuperClassID;
            dMClass.SuperClassID = (System.Guid) valueForSuperClassID;
            object valueForMappedTableID = TestUtils.CreateSavedDBTable().TableID;
            dMClass.MappedTableID = (System.Guid) valueForMappedTableID;
            object valueForBusinessObjectDescription = TestUtils.GetRandomString();
            dMClass.BusinessObjectDescription = (System.String) valueForBusinessObjectDescription;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassNameBO, dMClass.GetPropertyValue("ClassNameBO"));
            Assert.AreEqual(valueForMappedTableName, dMClass.GetPropertyValue("MappedTableName"));
            Assert.AreEqual(valueForAssemblyID, dMClass.GetPropertyValue("AssemblyID"));
            Assert.AreEqual(valueForDisplayName, dMClass.GetPropertyValue("DisplayName"));
            Assert.AreEqual(valueForGenerated, dMClass.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForSuperClassID, dMClass.GetPropertyValue("SuperClassID"));
            Assert.AreEqual(valueForMappedTableID, dMClass.GetPropertyValue("MappedTableID"));
            Assert.AreEqual(valueForBusinessObjectDescription, dMClass.GetPropertyValue("BusinessObjectDescription"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = new DMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassNameBO = TestUtils.GetRandomString(1,100);            
            dMClass.SetPropertyValue("ClassNameBO", valueForClassNameBO);
            object valueForMappedTableName = TestUtils.GetRandomString();            
            dMClass.SetPropertyValue("MappedTableName", valueForMappedTableName);
            object valueForAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;            
            dMClass.SetPropertyValue("AssemblyID", valueForAssemblyID);
            object valueForDisplayName = TestUtils.GetRandomString();            
            dMClass.SetPropertyValue("DisplayName", valueForDisplayName);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMClass.SetPropertyValue("Generated", valueForGenerated);
            object valueForSuperClassID = TestUtils.CreateSavedDMSuperClass().SuperClassID;            
            dMClass.SetPropertyValue("SuperClassID", valueForSuperClassID);
            object valueForMappedTableID = TestUtils.CreateSavedDBTable().TableID;            
            dMClass.SetPropertyValue("MappedTableID", valueForMappedTableID);
            object valueForBusinessObjectDescription = TestUtils.GetRandomString();            
            dMClass.SetPropertyValue("BusinessObjectDescription", valueForBusinessObjectDescription);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassNameBO, dMClass.ClassNameBO);
            Assert.AreEqual(valueForMappedTableName, dMClass.MappedTableName);
            Assert.AreEqual(valueForAssemblyID, dMClass.AssemblyID);
            Assert.AreEqual(valueForDisplayName, dMClass.DisplayName);
            Assert.AreEqual(valueForGenerated, dMClass.Generated);
            Assert.AreEqual(valueForSuperClassID, dMClass.SuperClassID);
            Assert.AreEqual(valueForMappedTableID, dMClass.MappedTableID);
            Assert.AreEqual(valueForBusinessObjectDescription, dMClass.BusinessObjectDescription);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMClass.DisplayName = null;
            dMClass.Generated = null;
            dMClass.SuperClassID = null;
            dMClass.MappedTableID = null;
            dMClass.BusinessObjectDescription = null;
            dMClass.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMClass retrievedDMClass =
                    Broker.GetBusinessObject<DMClass>(dMClass.ID);
            
            Assert.IsNull(retrievedDMClass.DisplayName);
            Assert.IsNull(retrievedDMClass.Generated);
            Assert.IsNull(retrievedDMClass.SuperClassID);
            Assert.IsNull(retrievedDMClass.MappedTableID);
            Assert.IsNull(retrievedDMClass.BusinessObjectDescription);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateUnsavedValidDMClass();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMClass.ClassNameBO = null;
            dMClass.MappedTableName = null;
            dMClass.AssemblyID = null;
            
            try
            {
                dMClass.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Class Name BO' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Mapped Table Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Assembly' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMClass>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteOnce",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassNameBO"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedTableName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DisplayName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SuperClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedTableID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BusinessObjectDescription"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Assembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMAssembly boForRelationshipAssembly = TestUtils.CreateSavedDMAssembly();
            dMClass.Assembly = boForRelationshipAssembly;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMAssembly loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMAssembly>(boForRelationshipAssembly.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipAssembly, loadedDMClass.Assembly);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.Assembly);
            Assert.AreEqual(loadedRelatedBO, dMClass.Assembly);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_MappedTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DBTable boForRelationshipMappedTable = TestUtils.CreateSavedDBTable();
            dMClass.MappedTable = boForRelationshipMappedTable;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBTable loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBTable>(boForRelationshipMappedTable.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipMappedTable, loadedDMClass.MappedTable);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.MappedTable);
            Assert.AreEqual(loadedRelatedBO, dMClass.MappedTable);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMObjectIdentity boForRelationshipObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();
            dMClass.ObjectIdentity = boForRelationshipObjectIdentity;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMObjectIdentity loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMObjectIdentity>(boForRelationshipObjectIdentity.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipObjectIdentity, loadedDMClass.ObjectIdentity);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.ObjectIdentity);
            Assert.AreEqual(loadedRelatedBO, dMClass.ObjectIdentity);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_SuperClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMSuperClass boForRelationshipSuperClass = TestUtils.CreateSavedDMSuperClass();
            dMClass.SuperClass = boForRelationshipSuperClass;
            dMClass.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSuperClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSuperClass>(boForRelationshipSuperClass.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSuperClass, loadedDMClass.SuperClass);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.SuperClass);
            Assert.AreEqual(loadedRelatedBO, dMClass.SuperClass);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMProperty boForRelationshipProperties = TestUtils.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ClassID = dMClass.ClassID;
            boForRelationshipProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.Properties.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMProperty loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipProperties.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.Properties.Count);
            Assert.AreEqual(boForRelationshipProperties, loadedDMClass.Properties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.Properties[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.Properties[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_RelatedRelationships()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMRelationship boForRelationshipRelatedRelationships = TestUtils.CreateUnsavedValidDMRelationship();
            boForRelationshipRelatedRelationships.RelatedClassID = dMClass.ClassID;
            boForRelationshipRelatedRelationships.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.RelatedRelationships.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMRelationship loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMRelationship>(boForRelationshipRelatedRelationships.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.RelatedRelationships.Count);
            Assert.AreEqual(boForRelationshipRelatedRelationships, loadedDMClass.RelatedRelationships[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.RelatedRelationships[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.RelatedRelationships[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_RelationshipsDM()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMRelationship boForRelationshipRelationshipsDM = TestUtils.CreateUnsavedValidDMRelationship();
            boForRelationshipRelationshipsDM.OwnerClassID = dMClass.ClassID;
            boForRelationshipRelationshipsDM.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.RelationshipsDM.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMRelationship loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMRelationship>(boForRelationshipRelationshipsDM.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.RelationshipsDM.Count);
            Assert.AreEqual(boForRelationshipRelationshipsDM, loadedDMClass.RelationshipsDM[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.RelationshipsDM[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.RelationshipsDM[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_SubClasses()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMSuperClass boForRelationshipSubClasses = TestUtils.CreateUnsavedValidDMSuperClass();
            boForRelationshipSubClasses.SuperClassClassID = dMClass.ClassID;
            boForRelationshipSubClasses.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.SubClasses.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSuperClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSuperClass>(boForRelationshipSubClasses.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.SubClasses.Count);
            Assert.AreEqual(boForRelationshipSubClasses, loadedDMClass.SubClasses[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.SubClasses[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.SubClasses[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIViews()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.UIView boForRelationshipUIViews = TestUtils.CreateUnsavedValidUIView();
            boForRelationshipUIViews.ClassID = dMClass.ClassID;
            boForRelationshipUIViews.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UIViews.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIView loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIView>(boForRelationshipUIViews.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.UIViews.Count);
            Assert.AreEqual(boForRelationshipUIViews, loadedDMClass.UIViews[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.UIViews[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.UIViews[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UniqueConstraints()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMUniqueConstraint boForRelationshipUniqueConstraints = TestUtils.CreateUnsavedValidDMUniqueConstraint();
            boForRelationshipUniqueConstraints.ClassID = dMClass.ClassID;
            boForRelationshipUniqueConstraints.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UniqueConstraints.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMUniqueConstraint loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMUniqueConstraint>(boForRelationshipUniqueConstraints.ID);
            DMClass loadedDMClass = Broker.GetBusinessObject<DMClass>(dMClass.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMClass.UniqueConstraints.Count);
            Assert.AreEqual(boForRelationshipUniqueConstraints, loadedDMClass.UniqueConstraints[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMClass.UniqueConstraints[0]);
            Assert.AreEqual(loadedRelatedBO, dMClass.UniqueConstraints[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_RelatedRelationships()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMRelationship boForRelationshipRelatedRelationships = TestUtils.CreateUnsavedValidDMRelationship();
            boForRelationshipRelatedRelationships.RelatedClassID = dMClass.ClassID;
            boForRelationshipRelatedRelationships.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.RelatedRelationships.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["RelatedRelationships"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMClass.Delete();
                dMClass.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'RelatedRelationships' relationship that need to be deleted first"));
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_RelationshipsDM()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMRelationship boForRelationshipRelationshipsDM = TestUtils.CreateUnsavedValidDMRelationship();
            boForRelationshipRelationshipsDM.OwnerClassID = dMClass.ClassID;
            boForRelationshipRelationshipsDM.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.RelationshipsDM.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["RelationshipsDM"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMClass.Delete();
                dMClass.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'RelationshipsDM' relationship that need to be deleted first"));
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_SubClasses()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMSuperClass boForRelationshipSubClasses = TestUtils.CreateUnsavedValidDMSuperClass();
            boForRelationshipSubClasses.SuperClassClassID = dMClass.ClassID;
            boForRelationshipSubClasses.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.SubClasses.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["SubClasses"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMClass.Delete();
                dMClass.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'SubClasses' relationship that need to be deleted first"));
        }
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UniqueConstraints()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMUniqueConstraint boForRelationshipUniqueConstraints = TestUtils.CreateUnsavedValidDMUniqueConstraint();
            boForRelationshipUniqueConstraints.ClassID = dMClass.ClassID;
            boForRelationshipUniqueConstraints.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UniqueConstraints.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["UniqueConstraints"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMClass.Delete();
                dMClass.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'UniqueConstraints' relationship that need to be deleted first"));
        }
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.DMProperty boForRelationshipProperties = TestUtils.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ClassID = dMClass.ClassID;
            boForRelationshipProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.Properties.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["Properties"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMClass.Delete();
            dMClass.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMClass>(dMClass.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMClass"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipProperties.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMProperty"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIViews()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMClass dMClass = TestUtils.CreateSavedDMClass();

            FireStarterModeller.BO.UIView boForRelationshipUIViews = TestUtils.CreateUnsavedValidUIView();
            boForRelationshipUIViews.ClassID = dMClass.ClassID;
            boForRelationshipUIViews.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMClass.UIViews.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMClass>().RelationshipDefCol["UIViews"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMClass.Delete();
            dMClass.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMClass>(dMClass.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMClass"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIView>(boForRelationshipUIViews.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIView"));
            }
        }
        
        
        
        
       
    }
}
