// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMObjectIdentity objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMObjectIdentity with a random value assigned to every property
        /// </summary>
        public static DMObjectIdentity CreateSavedDMObjectIdentity()
		{
		    DMObjectIdentity dMObjectIdentity = CreateUnsavedValidDMObjectIdentity();
			dMObjectIdentity.Save();
			return dMObjectIdentity;
		}

        /// <summary>
        /// Creates a new unsaved DMObjectIdentity with a random value assigned to every property
        /// </summary>
		public static DMObjectIdentity CreateUnsavedValidDMObjectIdentity()
		{
			DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
			dMObjectIdentity.ClassID = TestUtils.CreateSavedDMClass().ClassID;
			dMObjectIdentity.IsObjectID = TestUtils.GetRandomBoolean();
			dMObjectIdentity.Generated = TestUtils.GetRandomBoolean();
			dMObjectIdentity.MappedPrimaryKeyID = Guid.NewGuid();
			return dMObjectIdentity;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMObjectIdentity where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMObjectIdentity CreateUnsavedDefaultDMObjectIdentity()
		{
			DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
			return dMObjectIdentity;
		}
    }
    
    // Provides the part of the test class that tests DMObjectIdentity objects
    [TestFixture]
    public partial class TestDMObjectIdentity : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMObjectIdentityWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMObjectIdentity.ObjectIdentityID);
            Assert.IsInstanceOfType(dMObjectIdentity.Props["ObjectIdentityID"].PropertyType, dMObjectIdentity.ObjectIdentityID);
                        Assert.IsNull(dMObjectIdentity.ClassID);
                        Assert.IsNotNull(dMObjectIdentity.IsObjectID);
            Assert.IsInstanceOfType(dMObjectIdentity.Props["IsObjectID"].PropertyType, dMObjectIdentity.IsObjectID);
                        Assert.IsNotNull(dMObjectIdentity.Generated);
            Assert.IsInstanceOfType(dMObjectIdentity.Props["Generated"].PropertyType, dMObjectIdentity.Generated);
                        Assert.IsNull(dMObjectIdentity.MappedPrimaryKeyID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateUnsavedValidDMObjectIdentity();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMObjectIdentity.Status.IsNew);
            BusinessObjectCollection<DMObjectIdentity> col = new BusinessObjectCollection<DMObjectIdentity>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMObjectIdentity.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMObjectIdentity.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();

            //---------------Execute Test ----------------------
            DMObjectIdentity loadedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMObjectIdentity.ObjectIdentityID, loadedDMObjectIdentity.ObjectIdentityID);
                        Assert.AreEqual(dMObjectIdentity.ClassID, loadedDMObjectIdentity.ClassID);
                        Assert.AreEqual(dMObjectIdentity.IsObjectID, loadedDMObjectIdentity.IsObjectID);
                        Assert.AreEqual(dMObjectIdentity.Generated, loadedDMObjectIdentity.Generated);
                        Assert.AreEqual(dMObjectIdentity.MappedPrimaryKeyID, loadedDMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectIdentity.Delete();
            dMObjectIdentity.Save();
            //---------------Test Result -----------------------
            try
            {
                DMObjectIdentity retrievedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMObjectIdentity", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMObjectIdentity.ClassID = (System.Guid) valueForClassID;
            object valueForIsObjectID = TestUtils.GetRandomBoolean();
            dMObjectIdentity.IsObjectID = (System.Boolean) valueForIsObjectID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMObjectIdentity.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedPrimaryKeyID = Guid.NewGuid();
            dMObjectIdentity.MappedPrimaryKeyID = (System.Guid) valueForMappedPrimaryKeyID;
            dMObjectIdentity.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMObjectIdentity retrievedDMObjectIdentity =
                    Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            
            Assert.AreEqual(valueForClassID, retrievedDMObjectIdentity.ClassID);
            Assert.AreEqual(valueForIsObjectID, retrievedDMObjectIdentity.IsObjectID);
            Assert.AreEqual(valueForGenerated, retrievedDMObjectIdentity.Generated);
            Assert.AreEqual(valueForMappedPrimaryKeyID, retrievedDMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMObjectIdentity.ClassID = (System.Guid) valueForClassID;
            object valueForIsObjectID = TestUtils.GetRandomBoolean();
            dMObjectIdentity.IsObjectID = (System.Boolean) valueForIsObjectID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMObjectIdentity.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedPrimaryKeyID = Guid.NewGuid();
            dMObjectIdentity.MappedPrimaryKeyID = (System.Guid) valueForMappedPrimaryKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMObjectIdentity.ClassID);
            Assert.AreEqual(valueForIsObjectID, dMObjectIdentity.IsObjectID);
            Assert.AreEqual(valueForGenerated, dMObjectIdentity.Generated);
            Assert.AreEqual(valueForMappedPrimaryKeyID, dMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMObjectIdentity.ClassID = (System.Guid) valueForClassID;
            object valueForIsObjectID = TestUtils.GetRandomBoolean();
            dMObjectIdentity.IsObjectID = (System.Boolean) valueForIsObjectID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMObjectIdentity.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedPrimaryKeyID = Guid.NewGuid();
            dMObjectIdentity.MappedPrimaryKeyID = (System.Guid) valueForMappedPrimaryKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMObjectIdentity.GetPropertyValue("ClassID"));
            Assert.AreEqual(valueForIsObjectID, dMObjectIdentity.GetPropertyValue("IsObjectID"));
            Assert.AreEqual(valueForGenerated, dMObjectIdentity.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForMappedPrimaryKeyID, dMObjectIdentity.GetPropertyValue("MappedPrimaryKeyID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtils.CreateSavedDMClass().ClassID;            
            dMObjectIdentity.SetPropertyValue("ClassID", valueForClassID);
            object valueForIsObjectID = TestUtils.GetRandomBoolean();            
            dMObjectIdentity.SetPropertyValue("IsObjectID", valueForIsObjectID);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMObjectIdentity.SetPropertyValue("Generated", valueForGenerated);
            object valueForMappedPrimaryKeyID = Guid.NewGuid();            
            dMObjectIdentity.SetPropertyValue("MappedPrimaryKeyID", valueForMappedPrimaryKeyID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMObjectIdentity.ClassID);
            Assert.AreEqual(valueForIsObjectID, dMObjectIdentity.IsObjectID);
            Assert.AreEqual(valueForGenerated, dMObjectIdentity.Generated);
            Assert.AreEqual(valueForMappedPrimaryKeyID, dMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectIdentity.MappedPrimaryKeyID = null;
            dMObjectIdentity.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMObjectIdentity retrievedDMObjectIdentity =
                    Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            
            Assert.IsNull(retrievedDMObjectIdentity.MappedPrimaryKeyID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateUnsavedValidDMObjectIdentity();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectIdentity.ObjectIdentityID = null;
            dMObjectIdentity.ClassID = null;
            dMObjectIdentity.IsObjectID = null;
            dMObjectIdentity.Generated = null;
            
            try
            {
                dMObjectIdentity.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Object Identity I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Class I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Is Object I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMObjectIdentity>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ObjectIdentityID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["IsObjectID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedPrimaryKeyID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Class()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();

            FireStarterModeller.BO.DMClass boForRelationshipClass = TestUtils.CreateSavedDMClass();
            dMObjectIdentity.Class = boForRelationshipClass;
            dMObjectIdentity.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipClass.ID);
            DMObjectIdentity loadedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipClass, loadedDMObjectIdentity.Class);
            Assert.AreEqual(loadedRelatedBO, loadedDMObjectIdentity.Class);
            Assert.AreEqual(loadedRelatedBO, dMObjectIdentity.Class);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();

            FireStarterModeller.BO.DMProperty boForRelationshipProperties = TestUtils.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ObjectIdentityID = dMObjectIdentity.ObjectIdentityID;
            boForRelationshipProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMObjectIdentity.Properties.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMProperty loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipProperties.ID);
            DMObjectIdentity loadedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMObjectIdentity.Properties.Count);
            Assert.AreEqual(boForRelationshipProperties, loadedDMObjectIdentity.Properties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMObjectIdentity.Properties[0]);
            Assert.AreEqual(loadedRelatedBO, dMObjectIdentity.Properties[0]);
        }
        
        
        [Test, Ignore("Does not apply for single relationships.")]  // Checks that deleting a parent clears the related property on the child
        public void Test_MultipleRelationshipDeletion_DereferenceRelated_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtils.CreateSavedDMObjectIdentity();

            FireStarterModeller.BO.DMProperty boForRelationshipProperties = TestUtils.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ObjectIdentityID = dMObjectIdentity.ObjectIdentityID;
            boForRelationshipProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMObjectIdentity.Properties.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMObjectIdentity>().RelationshipDefCol["Properties"];
            Assert.AreEqual(DeleteParentAction.DereferenceRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMObjectIdentity.Delete();
            dMObjectIdentity.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMObjectIdentity"));
            }            
            
            FireStarterModeller.BO.DMProperty relatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipProperties.ID);
            Assert.IsNull(relatedBO.ObjectIdentityID);
        }
        
        
        
        
       
    }
}
