// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMPropRule objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMPropRule with a random value assigned to every property
        /// </summary>
        public static DMPropRule CreateSavedDMPropRule()
		{
		    DMPropRule dMPropRule = CreateUnsavedValidDMPropRule();
			dMPropRule.Save();
			return dMPropRule;
		}

        /// <summary>
        /// Creates a new unsaved DMPropRule with a random value assigned to every property
        /// </summary>
		public static DMPropRule CreateUnsavedValidDMPropRule()
		{
			DMPropRule dMPropRule = new DMPropRule();
			dMPropRule.Name = TestUtils.GetRandomString();
			dMPropRule.Message = TestUtils.GetRandomString();
			dMPropRule.Class = TestUtils.GetRandomString();
			dMPropRule.Assembly = TestUtils.GetRandomString();
			dMPropRule.Generated = TestUtils.GetRandomBoolean();
			dMPropRule.PropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
			return dMPropRule;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMPropRule where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMPropRule CreateUnsavedDefaultDMPropRule()
		{
			DMPropRule dMPropRule = new DMPropRule();
			return dMPropRule;
		}
    }
    
    // Provides the part of the test class that tests DMPropRule objects
    [TestFixture]
    public partial class TestDMPropRule : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMPropRuleWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMPropRule dMPropRule = new DMPropRule();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMPropRule.PropRuleID);
            Assert.IsInstanceOfType(dMPropRule.Props["PropRuleID"].PropertyType, dMPropRule.PropRuleID);
                        Assert.IsNull(dMPropRule.Name);
                        Assert.IsNull(dMPropRule.Message);
                        Assert.IsNull(dMPropRule.Class);
                        Assert.IsNull(dMPropRule.Assembly);
                        Assert.IsNotNull(dMPropRule.Generated);
            Assert.IsInstanceOfType(dMPropRule.Props["Generated"].PropertyType, dMPropRule.Generated);
                        Assert.IsNull(dMPropRule.PropertyID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMPropRule()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = TestUtils.CreateUnsavedValidDMPropRule();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMPropRule.Status.IsNew);
            BusinessObjectCollection<DMPropRule> col = new BusinessObjectCollection<DMPropRule>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMPropRule.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMPropRule.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMPropRule()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();

            //---------------Execute Test ----------------------
            DMPropRule loadedDMPropRule = Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMPropRule.PropRuleID, loadedDMPropRule.PropRuleID);
                        Assert.AreEqual(dMPropRule.Name, loadedDMPropRule.Name);
                        Assert.AreEqual(dMPropRule.Message, loadedDMPropRule.Message);
                        Assert.AreEqual(dMPropRule.Class, loadedDMPropRule.Class);
                        Assert.AreEqual(dMPropRule.Assembly, loadedDMPropRule.Assembly);
                        Assert.AreEqual(dMPropRule.Generated, loadedDMPropRule.Generated);
                        Assert.AreEqual(dMPropRule.PropertyID, loadedDMPropRule.PropertyID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMPropRule()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropRule.Delete();
            dMPropRule.Save();
            //---------------Test Result -----------------------
            try
            {
                DMPropRule retrievedDMPropRule = Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMPropRule", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMPropRule()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMPropRule.Name = (System.String) valueForName;
            object valueForMessage = TestUtils.GetRandomString();
            dMPropRule.Message = (System.String) valueForMessage;
            object valueForClass = TestUtils.GetRandomString();
            dMPropRule.Class = (System.String) valueForClass;
            object valueForAssembly = TestUtils.GetRandomString();
            dMPropRule.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMPropRule.Generated = (System.Boolean) valueForGenerated;
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
            dMPropRule.PropertyID = (System.Guid) valueForPropertyID;
            dMPropRule.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMPropRule retrievedDMPropRule =
                    Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);
            
            Assert.AreEqual(valueForName, retrievedDMPropRule.Name);
            Assert.AreEqual(valueForMessage, retrievedDMPropRule.Message);
            Assert.AreEqual(valueForClass, retrievedDMPropRule.Class);
            Assert.AreEqual(valueForAssembly, retrievedDMPropRule.Assembly);
            Assert.AreEqual(valueForGenerated, retrievedDMPropRule.Generated);
            Assert.AreEqual(valueForPropertyID, retrievedDMPropRule.PropertyID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = new DMPropRule();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMPropRule.Name = (System.String) valueForName;
            object valueForMessage = TestUtils.GetRandomString();
            dMPropRule.Message = (System.String) valueForMessage;
            object valueForClass = TestUtils.GetRandomString();
            dMPropRule.Class = (System.String) valueForClass;
            object valueForAssembly = TestUtils.GetRandomString();
            dMPropRule.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMPropRule.Generated = (System.Boolean) valueForGenerated;
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
            dMPropRule.PropertyID = (System.Guid) valueForPropertyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMPropRule.Name);
            Assert.AreEqual(valueForMessage, dMPropRule.Message);
            Assert.AreEqual(valueForClass, dMPropRule.Class);
            Assert.AreEqual(valueForAssembly, dMPropRule.Assembly);
            Assert.AreEqual(valueForGenerated, dMPropRule.Generated);
            Assert.AreEqual(valueForPropertyID, dMPropRule.PropertyID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = new DMPropRule();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            dMPropRule.Name = (System.String) valueForName;
            object valueForMessage = TestUtils.GetRandomString();
            dMPropRule.Message = (System.String) valueForMessage;
            object valueForClass = TestUtils.GetRandomString();
            dMPropRule.Class = (System.String) valueForClass;
            object valueForAssembly = TestUtils.GetRandomString();
            dMPropRule.Assembly = (System.String) valueForAssembly;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMPropRule.Generated = (System.Boolean) valueForGenerated;
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;
            dMPropRule.PropertyID = (System.Guid) valueForPropertyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMPropRule.GetPropertyValue("Name"));
            Assert.AreEqual(valueForMessage, dMPropRule.GetPropertyValue("Message"));
            Assert.AreEqual(valueForClass, dMPropRule.GetPropertyValue("Class"));
            Assert.AreEqual(valueForAssembly, dMPropRule.GetPropertyValue("Assembly"));
            Assert.AreEqual(valueForGenerated, dMPropRule.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForPropertyID, dMPropRule.GetPropertyValue("PropertyID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = new DMPropRule();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();            
            dMPropRule.SetPropertyValue("Name", valueForName);
            object valueForMessage = TestUtils.GetRandomString();            
            dMPropRule.SetPropertyValue("Message", valueForMessage);
            object valueForClass = TestUtils.GetRandomString();            
            dMPropRule.SetPropertyValue("Class", valueForClass);
            object valueForAssembly = TestUtils.GetRandomString();            
            dMPropRule.SetPropertyValue("Assembly", valueForAssembly);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMPropRule.SetPropertyValue("Generated", valueForGenerated);
            object valueForPropertyID = TestUtils.CreateSavedDMProperty().ProperyID;            
            dMPropRule.SetPropertyValue("PropertyID", valueForPropertyID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, dMPropRule.Name);
            Assert.AreEqual(valueForMessage, dMPropRule.Message);
            Assert.AreEqual(valueForClass, dMPropRule.Class);
            Assert.AreEqual(valueForAssembly, dMPropRule.Assembly);
            Assert.AreEqual(valueForGenerated, dMPropRule.Generated);
            Assert.AreEqual(valueForPropertyID, dMPropRule.PropertyID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropRule.Message = null;
            dMPropRule.Class = null;
            dMPropRule.Assembly = null;
            dMPropRule.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMPropRule retrievedDMPropRule =
                    Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);
            
            Assert.IsNull(retrievedDMPropRule.Message);
            Assert.IsNull(retrievedDMPropRule.Class);
            Assert.IsNull(retrievedDMPropRule.Assembly);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropRule dMPropRule = TestUtils.CreateUnsavedValidDMPropRule();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropRule.Name = null;
            dMPropRule.Generated = null;
            dMPropRule.PropertyID = null;
            
            try
            {
                dMPropRule.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Property I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMPropRule>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropRuleID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Message"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Class"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Assembly"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Property()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();

            FireStarterModeller.BO.DMProperty boForRelationshipProperty = TestUtils.CreateSavedDMProperty();
            dMPropRule.Property = boForRelationshipProperty;
            dMPropRule.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMProperty loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMProperty>(boForRelationshipProperty.ID);
            DMPropRule loadedDMPropRule = Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipProperty, loadedDMPropRule.Property);
            Assert.AreEqual(loadedRelatedBO, loadedDMPropRule.Property);
            Assert.AreEqual(loadedRelatedBO, dMPropRule.Property);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_PropRuleParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();

            FireStarterModeller.BO.DMPropRuleParameter boForRelationshipPropRuleParameters = TestUtils.CreateUnsavedValidDMPropRuleParameter();
            boForRelationshipPropRuleParameters.PropRuleID = dMPropRule.PropRuleID;
            boForRelationshipPropRuleParameters.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMPropRule.PropRuleParameters.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMPropRuleParameter loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMPropRuleParameter>(boForRelationshipPropRuleParameters.ID);
            DMPropRule loadedDMPropRule = Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMPropRule.PropRuleParameters.Count);
            Assert.AreEqual(boForRelationshipPropRuleParameters, loadedDMPropRule.PropRuleParameters[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMPropRule.PropRuleParameters[0]);
            Assert.AreEqual(loadedRelatedBO, dMPropRule.PropRuleParameters[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_PropRuleParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRule dMPropRule = TestUtils.CreateSavedDMPropRule();

            FireStarterModeller.BO.DMPropRuleParameter boForRelationshipPropRuleParameters = TestUtils.CreateUnsavedValidDMPropRuleParameter();
            boForRelationshipPropRuleParameters.PropRuleID = dMPropRule.PropRuleID;
            boForRelationshipPropRuleParameters.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMPropRule.PropRuleParameters.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMPropRule>().RelationshipDefCol["PropRuleParameters"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMPropRule.Delete();
            dMPropRule.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMPropRule>(dMPropRule.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMPropRule"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.DMPropRuleParameter>(boForRelationshipPropRuleParameters.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMPropRuleParameter"));
            }
        }
        
        
        
        
       
    }
}
