// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMPropRuleParameter objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMPropRuleParameter with a random value assigned to every property
        /// </summary>
        public static DMPropRuleParameter CreateSavedDMPropRuleParameter()
		{
		    DMPropRuleParameter dMPropRuleParameter = CreateUnsavedValidDMPropRuleParameter();
			dMPropRuleParameter.Save();
			return dMPropRuleParameter;
		}

        /// <summary>
        /// Creates a new unsaved DMPropRuleParameter with a random value assigned to every property
        /// </summary>
		public static DMPropRuleParameter CreateUnsavedValidDMPropRuleParameter()
		{
			DMPropRuleParameter dMPropRuleParameter = new DMPropRuleParameter();
			dMPropRuleParameter.RuleID = Guid.NewGuid();
			dMPropRuleParameter.Key = TestUtils.GetRandomString();
			dMPropRuleParameter.Value = TestUtils.GetRandomString();
			dMPropRuleParameter.PropRuleID = TestUtils.CreateSavedDMPropRule().PropRuleID;
			dMPropRuleParameter.Generated = TestUtils.GetRandomBoolean();
			return dMPropRuleParameter;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMPropRuleParameter where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMPropRuleParameter CreateUnsavedDefaultDMPropRuleParameter()
		{
			DMPropRuleParameter dMPropRuleParameter = new DMPropRuleParameter();
			return dMPropRuleParameter;
		}
    }
    
    // Provides the part of the test class that tests DMPropRuleParameter objects
    [TestFixture]
    public partial class TestDMPropRuleParameter : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMPropRuleParameterWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMPropRuleParameter dMPropRuleParameter = new DMPropRuleParameter();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMPropRuleParameter.PropRuleParameterID);
            Assert.IsInstanceOfType(dMPropRuleParameter.Props["PropRuleParameterID"].PropertyType, dMPropRuleParameter.PropRuleParameterID);
                        Assert.IsNull(dMPropRuleParameter.RuleID);
                        Assert.IsNull(dMPropRuleParameter.Key);
                        Assert.IsNull(dMPropRuleParameter.Value);
                        Assert.IsNull(dMPropRuleParameter.PropRuleID);
                        Assert.IsNotNull(dMPropRuleParameter.Generated);
            Assert.IsInstanceOfType(dMPropRuleParameter.Props["Generated"].PropertyType, dMPropRuleParameter.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMPropRuleParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateUnsavedValidDMPropRuleParameter();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMPropRuleParameter.Status.IsNew);
            BusinessObjectCollection<DMPropRuleParameter> col = new BusinessObjectCollection<DMPropRuleParameter>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMPropRuleParameter.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMPropRuleParameter.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMPropRuleParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateSavedDMPropRuleParameter();

            //---------------Execute Test ----------------------
            DMPropRuleParameter loadedDMPropRuleParameter = Broker.GetBusinessObject<DMPropRuleParameter>(dMPropRuleParameter.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMPropRuleParameter.PropRuleParameterID, loadedDMPropRuleParameter.PropRuleParameterID);
                        Assert.AreEqual(dMPropRuleParameter.RuleID, loadedDMPropRuleParameter.RuleID);
                        Assert.AreEqual(dMPropRuleParameter.Key, loadedDMPropRuleParameter.Key);
                        Assert.AreEqual(dMPropRuleParameter.Value, loadedDMPropRuleParameter.Value);
                        Assert.AreEqual(dMPropRuleParameter.PropRuleID, loadedDMPropRuleParameter.PropRuleID);
                        Assert.AreEqual(dMPropRuleParameter.Generated, loadedDMPropRuleParameter.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMPropRuleParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateSavedDMPropRuleParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropRuleParameter.Delete();
            dMPropRuleParameter.Save();
            //---------------Test Result -----------------------
            try
            {
                DMPropRuleParameter retrievedDMPropRuleParameter = Broker.GetBusinessObject<DMPropRuleParameter>(dMPropRuleParameter.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMPropRuleParameter", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMPropRuleParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateSavedDMPropRuleParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForRuleID = Guid.NewGuid();
            dMPropRuleParameter.RuleID = (System.Guid) valueForRuleID;
            object valueForKey = TestUtils.GetRandomString();
            dMPropRuleParameter.Key = (System.String) valueForKey;
            object valueForValue = TestUtils.GetRandomString();
            dMPropRuleParameter.Value = (System.String) valueForValue;
            object valueForPropRuleID = TestUtils.CreateSavedDMPropRule().PropRuleID;
            dMPropRuleParameter.PropRuleID = (System.Guid) valueForPropRuleID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMPropRuleParameter.Generated = (System.Boolean) valueForGenerated;
            dMPropRuleParameter.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMPropRuleParameter retrievedDMPropRuleParameter =
                    Broker.GetBusinessObject<DMPropRuleParameter>(dMPropRuleParameter.ID);
            
            Assert.AreEqual(valueForRuleID, retrievedDMPropRuleParameter.RuleID);
            Assert.AreEqual(valueForKey, retrievedDMPropRuleParameter.Key);
            Assert.AreEqual(valueForValue, retrievedDMPropRuleParameter.Value);
            Assert.AreEqual(valueForPropRuleID, retrievedDMPropRuleParameter.PropRuleID);
            Assert.AreEqual(valueForGenerated, retrievedDMPropRuleParameter.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = new DMPropRuleParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForRuleID = Guid.NewGuid();
            dMPropRuleParameter.RuleID = (System.Guid) valueForRuleID;
            object valueForKey = TestUtils.GetRandomString();
            dMPropRuleParameter.Key = (System.String) valueForKey;
            object valueForValue = TestUtils.GetRandomString();
            dMPropRuleParameter.Value = (System.String) valueForValue;
            object valueForPropRuleID = TestUtils.CreateSavedDMPropRule().PropRuleID;
            dMPropRuleParameter.PropRuleID = (System.Guid) valueForPropRuleID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMPropRuleParameter.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForRuleID, dMPropRuleParameter.RuleID);
            Assert.AreEqual(valueForKey, dMPropRuleParameter.Key);
            Assert.AreEqual(valueForValue, dMPropRuleParameter.Value);
            Assert.AreEqual(valueForPropRuleID, dMPropRuleParameter.PropRuleID);
            Assert.AreEqual(valueForGenerated, dMPropRuleParameter.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = new DMPropRuleParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForRuleID = Guid.NewGuid();
            dMPropRuleParameter.RuleID = (System.Guid) valueForRuleID;
            object valueForKey = TestUtils.GetRandomString();
            dMPropRuleParameter.Key = (System.String) valueForKey;
            object valueForValue = TestUtils.GetRandomString();
            dMPropRuleParameter.Value = (System.String) valueForValue;
            object valueForPropRuleID = TestUtils.CreateSavedDMPropRule().PropRuleID;
            dMPropRuleParameter.PropRuleID = (System.Guid) valueForPropRuleID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMPropRuleParameter.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForRuleID, dMPropRuleParameter.GetPropertyValue("RuleID"));
            Assert.AreEqual(valueForKey, dMPropRuleParameter.GetPropertyValue("Key"));
            Assert.AreEqual(valueForValue, dMPropRuleParameter.GetPropertyValue("Value"));
            Assert.AreEqual(valueForPropRuleID, dMPropRuleParameter.GetPropertyValue("PropRuleID"));
            Assert.AreEqual(valueForGenerated, dMPropRuleParameter.GetPropertyValue("Generated"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = new DMPropRuleParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForRuleID = Guid.NewGuid();            
            dMPropRuleParameter.SetPropertyValue("RuleID", valueForRuleID);
            object valueForKey = TestUtils.GetRandomString();            
            dMPropRuleParameter.SetPropertyValue("Key", valueForKey);
            object valueForValue = TestUtils.GetRandomString();            
            dMPropRuleParameter.SetPropertyValue("Value", valueForValue);
            object valueForPropRuleID = TestUtils.CreateSavedDMPropRule().PropRuleID;            
            dMPropRuleParameter.SetPropertyValue("PropRuleID", valueForPropRuleID);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMPropRuleParameter.SetPropertyValue("Generated", valueForGenerated);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForRuleID, dMPropRuleParameter.RuleID);
            Assert.AreEqual(valueForKey, dMPropRuleParameter.Key);
            Assert.AreEqual(valueForValue, dMPropRuleParameter.Value);
            Assert.AreEqual(valueForPropRuleID, dMPropRuleParameter.PropRuleID);
            Assert.AreEqual(valueForGenerated, dMPropRuleParameter.Generated);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateSavedDMPropRuleParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropRuleParameter.RuleID = null;
            dMPropRuleParameter.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMPropRuleParameter retrievedDMPropRuleParameter =
                    Broker.GetBusinessObject<DMPropRuleParameter>(dMPropRuleParameter.ID);
            
            Assert.IsNull(retrievedDMPropRuleParameter.RuleID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateUnsavedValidDMPropRuleParameter();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMPropRuleParameter.PropRuleParameterID = null;
            dMPropRuleParameter.Key = null;
            dMPropRuleParameter.Value = null;
            dMPropRuleParameter.PropRuleID = null;
            dMPropRuleParameter.Generated = null;
            
            try
            {
                dMPropRuleParameter.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Prop Rule Parameter I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Key' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Value' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Prop Rule I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMPropRuleParameter>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropRuleParameterID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RuleID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Key"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Value"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropRuleID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_PropRule()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMPropRuleParameter dMPropRuleParameter = TestUtils.CreateSavedDMPropRuleParameter();

            FireStarterModeller.BO.DMPropRule boForRelationshipPropRule = TestUtils.CreateSavedDMPropRule();
            dMPropRuleParameter.PropRule = boForRelationshipPropRule;
            dMPropRuleParameter.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMPropRule loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMPropRule>(boForRelationshipPropRule.ID);
            DMPropRuleParameter loadedDMPropRuleParameter = Broker.GetBusinessObject<DMPropRuleParameter>(dMPropRuleParameter.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipPropRule, loadedDMPropRuleParameter.PropRule);
            Assert.AreEqual(loadedRelatedBO, loadedDMPropRuleParameter.PropRule);
            Assert.AreEqual(loadedRelatedBO, dMPropRuleParameter.PropRule);
        }
        
        
        
        
        
        
        
       
    }
}
