// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMRelationship objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMRelationship with a random value assigned to every property
        /// </summary>
        public static DMRelationship CreateSavedDMRelationship()
		{
		    DMRelationship dMRelationship = CreateUnsavedValidDMRelationship();
			dMRelationship.Save();
			return dMRelationship;
		}

        /// <summary>
        /// Creates a new unsaved DMRelationship with a random value assigned to every property
        /// </summary>
		public static DMRelationship CreateUnsavedValidDMRelationship()
		{
			DMRelationship dMRelationship = new DMRelationship();
			dMRelationship.OwnerClassID = TestUtils.CreateSavedDMClass().ClassID;
			dMRelationship.RelationshipName = TestUtils.GetRandomString();
			dMRelationship.Cardinality = null;
			dMRelationship.RelatedClassID = TestUtils.CreateSavedDMClass().ClassID;
			dMRelationship.KeepReference = TestUtils.GetRandomBoolean();
			dMRelationship.OrderBy = TestUtils.GetRandomString();
			dMRelationship.DeleteAction = TestUtils.GetRandomString();
			dMRelationship.Generated = TestUtils.GetRandomBoolean();
			dMRelationship.RelationshipType = null;
			dMRelationship.MappedForeignKeyID = Guid.NewGuid();
			return dMRelationship;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMRelationship where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMRelationship CreateUnsavedDefaultDMRelationship()
		{
			DMRelationship dMRelationship = new DMRelationship();
			return dMRelationship;
		}
    }
    
    // Provides the part of the test class that tests DMRelationship objects
    [TestFixture]
    public partial class TestDMRelationship : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMRelationshipWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMRelationship dMRelationship = new DMRelationship();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMRelationship.RelationshipID);
            Assert.IsInstanceOfType(dMRelationship.Props["RelationshipID"].PropertyType, dMRelationship.RelationshipID);
                        Assert.IsNull(dMRelationship.OwnerClassID);
                        Assert.IsNull(dMRelationship.RelationshipName);
                        Assert.IsNotNull(dMRelationship.Cardinality);
            Assert.IsInstanceOfType(dMRelationship.Props["Cardinality"].PropertyType, dMRelationship.Cardinality);
                        Assert.IsNull(dMRelationship.RelatedClassID);
                        Assert.IsNotNull(dMRelationship.KeepReference);
            Assert.IsInstanceOfType(dMRelationship.Props["KeepReference"].PropertyType, dMRelationship.KeepReference);
                        Assert.IsNull(dMRelationship.OrderBy);
                        Assert.IsNotNull(dMRelationship.DeleteAction);
            Assert.IsInstanceOfType(dMRelationship.Props["DeleteAction"].PropertyType, dMRelationship.DeleteAction);
                        Assert.IsNotNull(dMRelationship.Generated);
            Assert.IsInstanceOfType(dMRelationship.Props["Generated"].PropertyType, dMRelationship.Generated);
                        Assert.IsNull(dMRelationship.RelationshipType);
                        Assert.IsNull(dMRelationship.MappedForeignKeyID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtils.CreateUnsavedValidDMRelationship();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMRelationship.Status.IsNew);
            BusinessObjectCollection<DMRelationship> col = new BusinessObjectCollection<DMRelationship>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMRelationship.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMRelationship.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();

            //---------------Execute Test ----------------------
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMRelationship.RelationshipID, loadedDMRelationship.RelationshipID);
                        Assert.AreEqual(dMRelationship.OwnerClassID, loadedDMRelationship.OwnerClassID);
                        Assert.AreEqual(dMRelationship.RelationshipName, loadedDMRelationship.RelationshipName);
                        Assert.AreEqual(dMRelationship.Cardinality, loadedDMRelationship.Cardinality);
                        Assert.AreEqual(dMRelationship.RelatedClassID, loadedDMRelationship.RelatedClassID);
                        Assert.AreEqual(dMRelationship.KeepReference, loadedDMRelationship.KeepReference);
                        Assert.AreEqual(dMRelationship.OrderBy, loadedDMRelationship.OrderBy);
                        Assert.AreEqual(dMRelationship.DeleteAction, loadedDMRelationship.DeleteAction);
                        Assert.AreEqual(dMRelationship.Generated, loadedDMRelationship.Generated);
                        Assert.AreEqual(dMRelationship.RelationshipType, loadedDMRelationship.RelationshipType);
                        Assert.AreEqual(dMRelationship.MappedForeignKeyID, loadedDMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationship.Delete();
            dMRelationship.Save();
            //---------------Test Result -----------------------
            try
            {
                DMRelationship retrievedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMRelationship", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMRelationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForOwnerClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMRelationship.OwnerClassID = (System.Guid) valueForOwnerClassID;
            object valueForRelationshipName = TestUtils.GetRandomString();
            dMRelationship.RelationshipName = (System.String) valueForRelationshipName;
            object valueForCardinality = null;
            dMRelationship.Cardinality = (FireStarterModeller.BO.FireStarterModeller.BO.Cardinality) valueForCardinality;
            object valueForRelatedClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMRelationship.RelatedClassID = (System.Guid) valueForRelatedClassID;
            object valueForKeepReference = TestUtils.GetRandomBoolean();
            dMRelationship.KeepReference = (System.Boolean) valueForKeepReference;
            object valueForOrderBy = TestUtils.GetRandomString();
            dMRelationship.OrderBy = (System.String) valueForOrderBy;
            object valueForDeleteAction = TestUtils.GetRandomString();
            dMRelationship.DeleteAction = (System.String) valueForDeleteAction;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMRelationship.Generated = (System.Boolean) valueForGenerated;
            object valueForRelationshipType = null;
            dMRelationship.RelationshipType = (Habanero.Base.RelationshipType) valueForRelationshipType;
            object valueForMappedForeignKeyID = Guid.NewGuid();
            dMRelationship.MappedForeignKeyID = (System.Guid) valueForMappedForeignKeyID;
            dMRelationship.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMRelationship retrievedDMRelationship =
                    Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            
            Assert.AreEqual(valueForOwnerClassID, retrievedDMRelationship.OwnerClassID);
            Assert.AreEqual(valueForRelationshipName, retrievedDMRelationship.RelationshipName);
            Assert.AreEqual(valueForCardinality, retrievedDMRelationship.Cardinality);
            Assert.AreEqual(valueForRelatedClassID, retrievedDMRelationship.RelatedClassID);
            Assert.AreEqual(valueForKeepReference, retrievedDMRelationship.KeepReference);
            Assert.AreEqual(valueForOrderBy, retrievedDMRelationship.OrderBy);
            Assert.AreEqual(valueForDeleteAction, retrievedDMRelationship.DeleteAction);
            Assert.AreEqual(valueForGenerated, retrievedDMRelationship.Generated);
            Assert.AreEqual(valueForRelationshipType, retrievedDMRelationship.RelationshipType);
            Assert.AreEqual(valueForMappedForeignKeyID, retrievedDMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = new DMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForOwnerClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMRelationship.OwnerClassID = (System.Guid) valueForOwnerClassID;
            object valueForRelationshipName = TestUtils.GetRandomString();
            dMRelationship.RelationshipName = (System.String) valueForRelationshipName;
            object valueForCardinality = null;
            dMRelationship.Cardinality = (FireStarterModeller.BO.FireStarterModeller.BO.Cardinality) valueForCardinality;
            object valueForRelatedClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMRelationship.RelatedClassID = (System.Guid) valueForRelatedClassID;
            object valueForKeepReference = TestUtils.GetRandomBoolean();
            dMRelationship.KeepReference = (System.Boolean) valueForKeepReference;
            object valueForOrderBy = TestUtils.GetRandomString();
            dMRelationship.OrderBy = (System.String) valueForOrderBy;
            object valueForDeleteAction = TestUtils.GetRandomString();
            dMRelationship.DeleteAction = (System.String) valueForDeleteAction;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMRelationship.Generated = (System.Boolean) valueForGenerated;
            object valueForRelationshipType = null;
            dMRelationship.RelationshipType = (Habanero.Base.RelationshipType) valueForRelationshipType;
            object valueForMappedForeignKeyID = Guid.NewGuid();
            dMRelationship.MappedForeignKeyID = (System.Guid) valueForMappedForeignKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForOwnerClassID, dMRelationship.OwnerClassID);
            Assert.AreEqual(valueForRelationshipName, dMRelationship.RelationshipName);
            Assert.AreEqual(valueForCardinality, dMRelationship.Cardinality);
            Assert.AreEqual(valueForRelatedClassID, dMRelationship.RelatedClassID);
            Assert.AreEqual(valueForKeepReference, dMRelationship.KeepReference);
            Assert.AreEqual(valueForOrderBy, dMRelationship.OrderBy);
            Assert.AreEqual(valueForDeleteAction, dMRelationship.DeleteAction);
            Assert.AreEqual(valueForGenerated, dMRelationship.Generated);
            Assert.AreEqual(valueForRelationshipType, dMRelationship.RelationshipType);
            Assert.AreEqual(valueForMappedForeignKeyID, dMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = new DMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForOwnerClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMRelationship.OwnerClassID = (System.Guid) valueForOwnerClassID;
            object valueForRelationshipName = TestUtils.GetRandomString();
            dMRelationship.RelationshipName = (System.String) valueForRelationshipName;
            object valueForCardinality = null;
            dMRelationship.Cardinality = (FireStarterModeller.BO.FireStarterModeller.BO.Cardinality) valueForCardinality;
            object valueForRelatedClassID = TestUtils.CreateSavedDMClass().ClassID;
            dMRelationship.RelatedClassID = (System.Guid) valueForRelatedClassID;
            object valueForKeepReference = TestUtils.GetRandomBoolean();
            dMRelationship.KeepReference = (System.Boolean) valueForKeepReference;
            object valueForOrderBy = TestUtils.GetRandomString();
            dMRelationship.OrderBy = (System.String) valueForOrderBy;
            object valueForDeleteAction = TestUtils.GetRandomString();
            dMRelationship.DeleteAction = (System.String) valueForDeleteAction;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMRelationship.Generated = (System.Boolean) valueForGenerated;
            object valueForRelationshipType = null;
            dMRelationship.RelationshipType = (Habanero.Base.RelationshipType) valueForRelationshipType;
            object valueForMappedForeignKeyID = Guid.NewGuid();
            dMRelationship.MappedForeignKeyID = (System.Guid) valueForMappedForeignKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForOwnerClassID, dMRelationship.GetPropertyValue("OwnerClassID"));
            Assert.AreEqual(valueForRelationshipName, dMRelationship.GetPropertyValue("RelationshipName"));
            Assert.AreEqual(valueForCardinality, dMRelationship.GetPropertyValue("Cardinality"));
            Assert.AreEqual(valueForRelatedClassID, dMRelationship.GetPropertyValue("RelatedClassID"));
            Assert.AreEqual(valueForKeepReference, dMRelationship.GetPropertyValue("KeepReference"));
            Assert.AreEqual(valueForOrderBy, dMRelationship.GetPropertyValue("OrderBy"));
            Assert.AreEqual(valueForDeleteAction, dMRelationship.GetPropertyValue("DeleteAction"));
            Assert.AreEqual(valueForGenerated, dMRelationship.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForRelationshipType, dMRelationship.GetPropertyValue("RelationshipType"));
            Assert.AreEqual(valueForMappedForeignKeyID, dMRelationship.GetPropertyValue("MappedForeignKeyID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = new DMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForOwnerClassID = TestUtils.CreateSavedDMClass().ClassID;            
            dMRelationship.SetPropertyValue("OwnerClassID", valueForOwnerClassID);
            object valueForRelationshipName = TestUtils.GetRandomString();            
            dMRelationship.SetPropertyValue("RelationshipName", valueForRelationshipName);
            object valueForCardinality = null;            
            dMRelationship.SetPropertyValue("Cardinality", valueForCardinality);
            object valueForRelatedClassID = TestUtils.CreateSavedDMClass().ClassID;            
            dMRelationship.SetPropertyValue("RelatedClassID", valueForRelatedClassID);
            object valueForKeepReference = TestUtils.GetRandomBoolean();            
            dMRelationship.SetPropertyValue("KeepReference", valueForKeepReference);
            object valueForOrderBy = TestUtils.GetRandomString();            
            dMRelationship.SetPropertyValue("OrderBy", valueForOrderBy);
            object valueForDeleteAction = TestUtils.GetRandomString();            
            dMRelationship.SetPropertyValue("DeleteAction", valueForDeleteAction);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMRelationship.SetPropertyValue("Generated", valueForGenerated);
            object valueForRelationshipType = null;            
            dMRelationship.SetPropertyValue("RelationshipType", valueForRelationshipType);
            object valueForMappedForeignKeyID = Guid.NewGuid();            
            dMRelationship.SetPropertyValue("MappedForeignKeyID", valueForMappedForeignKeyID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForOwnerClassID, dMRelationship.OwnerClassID);
            Assert.AreEqual(valueForRelationshipName, dMRelationship.RelationshipName);
            Assert.AreEqual(valueForCardinality, dMRelationship.Cardinality);
            Assert.AreEqual(valueForRelatedClassID, dMRelationship.RelatedClassID);
            Assert.AreEqual(valueForKeepReference, dMRelationship.KeepReference);
            Assert.AreEqual(valueForOrderBy, dMRelationship.OrderBy);
            Assert.AreEqual(valueForDeleteAction, dMRelationship.DeleteAction);
            Assert.AreEqual(valueForGenerated, dMRelationship.Generated);
            Assert.AreEqual(valueForRelationshipType, dMRelationship.RelationshipType);
            Assert.AreEqual(valueForMappedForeignKeyID, dMRelationship.MappedForeignKeyID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationship.KeepReference = null;
            dMRelationship.OrderBy = null;
            dMRelationship.DeleteAction = null;
            dMRelationship.RelationshipType = null;
            dMRelationship.MappedForeignKeyID = null;
            dMRelationship.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMRelationship retrievedDMRelationship =
                    Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            
            Assert.IsNull(retrievedDMRelationship.KeepReference);
            Assert.IsNull(retrievedDMRelationship.OrderBy);
            Assert.IsNull(retrievedDMRelationship.DeleteAction);
            Assert.IsNull(retrievedDMRelationship.RelationshipType);
            Assert.IsNull(retrievedDMRelationship.MappedForeignKeyID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtils.CreateUnsavedValidDMRelationship();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationship.OwnerClassID = null;
            dMRelationship.RelationshipName = null;
            dMRelationship.Cardinality = null;
            dMRelationship.RelatedClassID = null;
            dMRelationship.Generated = null;
            
            try
            {
                dMRelationship.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Owner Class I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Relationship Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Cardinality' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Related Business Object' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMRelationship>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelationshipID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["OwnerClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelationshipName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Cardinality"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelatedClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["KeepReference"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["OrderBy"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DeleteAction"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelationshipType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedForeignKeyID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_OwnerClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();

            FireStarterModeller.BO.DMClass boForRelationshipOwnerClass = TestUtils.CreateSavedDMClass();
            dMRelationship.OwnerClass = boForRelationshipOwnerClass;
            dMRelationship.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipOwnerClass.ID);
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipOwnerClass, loadedDMRelationship.OwnerClass);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationship.OwnerClass);
            Assert.AreEqual(loadedRelatedBO, dMRelationship.OwnerClass);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_RelatedClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();

            FireStarterModeller.BO.DMClass boForRelationshipRelatedClass = TestUtils.CreateSavedDMClass();
            dMRelationship.RelatedClass = boForRelationshipRelatedClass;
            dMRelationship.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipRelatedClass.ID);
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipRelatedClass, loadedDMRelationship.RelatedClass);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationship.RelatedClass);
            Assert.AreEqual(loadedRelatedBO, dMRelationship.RelatedClass);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_RelationshipProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();

            FireStarterModeller.BO.DMRelationshipProperty boForRelationshipRelationshipProperties = TestUtils.CreateUnsavedValidDMRelationshipProperty();
            boForRelationshipRelationshipProperties.RelationshipID = dMRelationship.RelationshipID;
            boForRelationshipRelationshipProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMRelationship.RelationshipProperties.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMRelationshipProperty loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMRelationshipProperty>(boForRelationshipRelationshipProperties.ID);
            DMRelationship loadedDMRelationship = Broker.GetBusinessObject<DMRelationship>(dMRelationship.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMRelationship.RelationshipProperties.Count);
            Assert.AreEqual(boForRelationshipRelationshipProperties, loadedDMRelationship.RelationshipProperties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationship.RelationshipProperties[0]);
            Assert.AreEqual(loadedRelatedBO, dMRelationship.RelationshipProperties[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_RelationshipProperties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationship dMRelationship = TestUtils.CreateSavedDMRelationship();

            FireStarterModeller.BO.DMRelationshipProperty boForRelationshipRelationshipProperties = TestUtils.CreateUnsavedValidDMRelationshipProperty();
            boForRelationshipRelationshipProperties.RelationshipID = dMRelationship.RelationshipID;
            boForRelationshipRelationshipProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMRelationship.RelationshipProperties.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMRelationship>().RelationshipDefCol["RelationshipProperties"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dMRelationship.Delete();
                dMRelationship.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'RelationshipProperties' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
