// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample DMSolution objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved DMSolution with a random value assigned to every property
        /// </summary>
        public static DMSolution CreateSavedDMSolution()
		{
		    DMSolution dMSolution = CreateUnsavedValidDMSolution();
			dMSolution.Save();
			return dMSolution;
		}

        /// <summary>
        /// Creates a new unsaved DMSolution with a random value assigned to every property
        /// </summary>
		public static DMSolution CreateUnsavedValidDMSolution()
		{
			DMSolution dMSolution = new DMSolution();
			dMSolution.SolutionName = TestUtils.GetRandomString(2,100);
			dMSolution.DefaultAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
			dMSolution.HabaneroDllPath = TestUtils.GetRandomString();
			dMSolution.TableNamePrefix = TestUtils.GetRandomString();
			dMSolution.TableNameSuffix = TestUtils.GetRandomString();
			dMSolution.PascalCase = TestUtils.GetRandomBoolean();
			dMSolution.SolutionDirectory = TestUtils.GetRandomString();
			dMSolution.UIProjectName = TestUtils.GetRandomString();
			dMSolution.BOProjectName = TestUtils.GetRandomString();
			dMSolution.LogicProjectName = TestUtils.GetRandomString();
			dMSolution.BaseProjectName = TestUtils.GetRandomString();
			dMSolution.Generated = TestUtils.GetRandomBoolean();
			dMSolution.BOTestProjectName = TestUtils.GetRandomString();
			dMSolution.UITestProjectName = TestUtils.GetRandomString();
			return dMSolution;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMSolution where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMSolution CreateUnsavedDefaultDMSolution()
		{
			DMSolution dMSolution = new DMSolution();
			return dMSolution;
		}
    }
    
    // Provides the part of the test class that tests DMSolution objects
    [TestFixture]
    public partial class TestDMSolution : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSolutionWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSolution dMSolution = new DMSolution();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMSolution.SolutionID);
            Assert.IsInstanceOfType(dMSolution.Props["SolutionID"].PropertyType, dMSolution.SolutionID);
                        Assert.IsNull(dMSolution.SolutionName);
                        Assert.IsNull(dMSolution.DefaultAssemblyID);
                        Assert.IsNull(dMSolution.HabaneroDllPath);
                        Assert.IsNull(dMSolution.TableNamePrefix);
                        Assert.IsNull(dMSolution.TableNameSuffix);
                        Assert.IsNotNull(dMSolution.PascalCase);
            Assert.IsInstanceOfType(dMSolution.Props["PascalCase"].PropertyType, dMSolution.PascalCase);
                        Assert.IsNull(dMSolution.SolutionDirectory);
                        Assert.IsNull(dMSolution.UIProjectName);
                        Assert.IsNull(dMSolution.BOProjectName);
                        Assert.IsNull(dMSolution.LogicProjectName);
                        Assert.IsNull(dMSolution.BaseProjectName);
                        Assert.IsNotNull(dMSolution.Generated);
            Assert.IsInstanceOfType(dMSolution.Props["Generated"].PropertyType, dMSolution.Generated);
                        Assert.IsNull(dMSolution.BOTestProjectName);
                        Assert.IsNull(dMSolution.UITestProjectName);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateUnsavedValidDMSolution();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMSolution.Status.IsNew);
            BusinessObjectCollection<DMSolution> col = new BusinessObjectCollection<DMSolution>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMSolution.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMSolution.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            //---------------Execute Test ----------------------
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMSolution.SolutionID, loadedDMSolution.SolutionID);
                        Assert.AreEqual(dMSolution.SolutionName, loadedDMSolution.SolutionName);
                        Assert.AreEqual(dMSolution.DefaultAssemblyID, loadedDMSolution.DefaultAssemblyID);
                        Assert.AreEqual(dMSolution.HabaneroDllPath, loadedDMSolution.HabaneroDllPath);
                        Assert.AreEqual(dMSolution.TableNamePrefix, loadedDMSolution.TableNamePrefix);
                        Assert.AreEqual(dMSolution.TableNameSuffix, loadedDMSolution.TableNameSuffix);
                        Assert.AreEqual(dMSolution.PascalCase, loadedDMSolution.PascalCase);
                        Assert.AreEqual(dMSolution.SolutionDirectory, loadedDMSolution.SolutionDirectory);
                        Assert.AreEqual(dMSolution.UIProjectName, loadedDMSolution.UIProjectName);
                        Assert.AreEqual(dMSolution.BOProjectName, loadedDMSolution.BOProjectName);
                        Assert.AreEqual(dMSolution.LogicProjectName, loadedDMSolution.LogicProjectName);
                        Assert.AreEqual(dMSolution.BaseProjectName, loadedDMSolution.BaseProjectName);
                        Assert.AreEqual(dMSolution.Generated, loadedDMSolution.Generated);
                        Assert.AreEqual(dMSolution.BOTestProjectName, loadedDMSolution.BOTestProjectName);
                        Assert.AreEqual(dMSolution.UITestProjectName, loadedDMSolution.UITestProjectName);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Test Result -----------------------
            try
            {
                DMSolution retrievedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMSolution", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSolution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtils.GetRandomString(2,100);
            dMSolution.SolutionName = (System.String) valueForSolutionName;
            object valueForDefaultAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
            dMSolution.DefaultAssemblyID = (System.Guid) valueForDefaultAssemblyID;
            object valueForHabaneroDllPath = TestUtils.GetRandomString();
            dMSolution.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForTableNamePrefix = TestUtils.GetRandomString();
            dMSolution.TableNamePrefix = (System.String) valueForTableNamePrefix;
            object valueForTableNameSuffix = TestUtils.GetRandomString();
            dMSolution.TableNameSuffix = (System.String) valueForTableNameSuffix;
            object valueForPascalCase = TestUtils.GetRandomBoolean();
            dMSolution.PascalCase = (System.Boolean) valueForPascalCase;
            object valueForSolutionDirectory = TestUtils.GetRandomString();
            dMSolution.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForUIProjectName = TestUtils.GetRandomString();
            dMSolution.UIProjectName = (System.String) valueForUIProjectName;
            object valueForBOProjectName = TestUtils.GetRandomString();
            dMSolution.BOProjectName = (System.String) valueForBOProjectName;
            object valueForLogicProjectName = TestUtils.GetRandomString();
            dMSolution.LogicProjectName = (System.String) valueForLogicProjectName;
            object valueForBaseProjectName = TestUtils.GetRandomString();
            dMSolution.BaseProjectName = (System.String) valueForBaseProjectName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSolution.Generated = (System.Boolean) valueForGenerated;
            object valueForBOTestProjectName = TestUtils.GetRandomString();
            dMSolution.BOTestProjectName = (System.String) valueForBOTestProjectName;
            object valueForUITestProjectName = TestUtils.GetRandomString();
            dMSolution.UITestProjectName = (System.String) valueForUITestProjectName;
            dMSolution.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMSolution retrievedDMSolution =
                    Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            
            Assert.AreEqual(valueForSolutionName, retrievedDMSolution.SolutionName);
            Assert.AreEqual(valueForDefaultAssemblyID, retrievedDMSolution.DefaultAssemblyID);
            Assert.AreEqual(valueForHabaneroDllPath, retrievedDMSolution.HabaneroDllPath);
            Assert.AreEqual(valueForTableNamePrefix, retrievedDMSolution.TableNamePrefix);
            Assert.AreEqual(valueForTableNameSuffix, retrievedDMSolution.TableNameSuffix);
            Assert.AreEqual(valueForPascalCase, retrievedDMSolution.PascalCase);
            Assert.AreEqual(valueForSolutionDirectory, retrievedDMSolution.SolutionDirectory);
            Assert.AreEqual(valueForUIProjectName, retrievedDMSolution.UIProjectName);
            Assert.AreEqual(valueForBOProjectName, retrievedDMSolution.BOProjectName);
            Assert.AreEqual(valueForLogicProjectName, retrievedDMSolution.LogicProjectName);
            Assert.AreEqual(valueForBaseProjectName, retrievedDMSolution.BaseProjectName);
            Assert.AreEqual(valueForGenerated, retrievedDMSolution.Generated);
            Assert.AreEqual(valueForBOTestProjectName, retrievedDMSolution.BOTestProjectName);
            Assert.AreEqual(valueForUITestProjectName, retrievedDMSolution.UITestProjectName);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtils.GetRandomString(2,100);
            dMSolution.SolutionName = (System.String) valueForSolutionName;
            object valueForDefaultAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
            dMSolution.DefaultAssemblyID = (System.Guid) valueForDefaultAssemblyID;
            object valueForHabaneroDllPath = TestUtils.GetRandomString();
            dMSolution.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForTableNamePrefix = TestUtils.GetRandomString();
            dMSolution.TableNamePrefix = (System.String) valueForTableNamePrefix;
            object valueForTableNameSuffix = TestUtils.GetRandomString();
            dMSolution.TableNameSuffix = (System.String) valueForTableNameSuffix;
            object valueForPascalCase = TestUtils.GetRandomBoolean();
            dMSolution.PascalCase = (System.Boolean) valueForPascalCase;
            object valueForSolutionDirectory = TestUtils.GetRandomString();
            dMSolution.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForUIProjectName = TestUtils.GetRandomString();
            dMSolution.UIProjectName = (System.String) valueForUIProjectName;
            object valueForBOProjectName = TestUtils.GetRandomString();
            dMSolution.BOProjectName = (System.String) valueForBOProjectName;
            object valueForLogicProjectName = TestUtils.GetRandomString();
            dMSolution.LogicProjectName = (System.String) valueForLogicProjectName;
            object valueForBaseProjectName = TestUtils.GetRandomString();
            dMSolution.BaseProjectName = (System.String) valueForBaseProjectName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSolution.Generated = (System.Boolean) valueForGenerated;
            object valueForBOTestProjectName = TestUtils.GetRandomString();
            dMSolution.BOTestProjectName = (System.String) valueForBOTestProjectName;
            object valueForUITestProjectName = TestUtils.GetRandomString();
            dMSolution.UITestProjectName = (System.String) valueForUITestProjectName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionName, dMSolution.SolutionName);
            Assert.AreEqual(valueForDefaultAssemblyID, dMSolution.DefaultAssemblyID);
            Assert.AreEqual(valueForHabaneroDllPath, dMSolution.HabaneroDllPath);
            Assert.AreEqual(valueForTableNamePrefix, dMSolution.TableNamePrefix);
            Assert.AreEqual(valueForTableNameSuffix, dMSolution.TableNameSuffix);
            Assert.AreEqual(valueForPascalCase, dMSolution.PascalCase);
            Assert.AreEqual(valueForSolutionDirectory, dMSolution.SolutionDirectory);
            Assert.AreEqual(valueForUIProjectName, dMSolution.UIProjectName);
            Assert.AreEqual(valueForBOProjectName, dMSolution.BOProjectName);
            Assert.AreEqual(valueForLogicProjectName, dMSolution.LogicProjectName);
            Assert.AreEqual(valueForBaseProjectName, dMSolution.BaseProjectName);
            Assert.AreEqual(valueForGenerated, dMSolution.Generated);
            Assert.AreEqual(valueForBOTestProjectName, dMSolution.BOTestProjectName);
            Assert.AreEqual(valueForUITestProjectName, dMSolution.UITestProjectName);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtils.GetRandomString(2,100);
            dMSolution.SolutionName = (System.String) valueForSolutionName;
            object valueForDefaultAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;
            dMSolution.DefaultAssemblyID = (System.Guid) valueForDefaultAssemblyID;
            object valueForHabaneroDllPath = TestUtils.GetRandomString();
            dMSolution.HabaneroDllPath = (System.String) valueForHabaneroDllPath;
            object valueForTableNamePrefix = TestUtils.GetRandomString();
            dMSolution.TableNamePrefix = (System.String) valueForTableNamePrefix;
            object valueForTableNameSuffix = TestUtils.GetRandomString();
            dMSolution.TableNameSuffix = (System.String) valueForTableNameSuffix;
            object valueForPascalCase = TestUtils.GetRandomBoolean();
            dMSolution.PascalCase = (System.Boolean) valueForPascalCase;
            object valueForSolutionDirectory = TestUtils.GetRandomString();
            dMSolution.SolutionDirectory = (System.String) valueForSolutionDirectory;
            object valueForUIProjectName = TestUtils.GetRandomString();
            dMSolution.UIProjectName = (System.String) valueForUIProjectName;
            object valueForBOProjectName = TestUtils.GetRandomString();
            dMSolution.BOProjectName = (System.String) valueForBOProjectName;
            object valueForLogicProjectName = TestUtils.GetRandomString();
            dMSolution.LogicProjectName = (System.String) valueForLogicProjectName;
            object valueForBaseProjectName = TestUtils.GetRandomString();
            dMSolution.BaseProjectName = (System.String) valueForBaseProjectName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            dMSolution.Generated = (System.Boolean) valueForGenerated;
            object valueForBOTestProjectName = TestUtils.GetRandomString();
            dMSolution.BOTestProjectName = (System.String) valueForBOTestProjectName;
            object valueForUITestProjectName = TestUtils.GetRandomString();
            dMSolution.UITestProjectName = (System.String) valueForUITestProjectName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionName, dMSolution.GetPropertyValue("SolutionName"));
            Assert.AreEqual(valueForDefaultAssemblyID, dMSolution.GetPropertyValue("DefaultAssemblyID"));
            Assert.AreEqual(valueForHabaneroDllPath, dMSolution.GetPropertyValue("HabaneroDllPath"));
            Assert.AreEqual(valueForTableNamePrefix, dMSolution.GetPropertyValue("TableNamePrefix"));
            Assert.AreEqual(valueForTableNameSuffix, dMSolution.GetPropertyValue("TableNameSuffix"));
            Assert.AreEqual(valueForPascalCase, dMSolution.GetPropertyValue("PascalCase"));
            Assert.AreEqual(valueForSolutionDirectory, dMSolution.GetPropertyValue("SolutionDirectory"));
            Assert.AreEqual(valueForUIProjectName, dMSolution.GetPropertyValue("UIProjectName"));
            Assert.AreEqual(valueForBOProjectName, dMSolution.GetPropertyValue("BOProjectName"));
            Assert.AreEqual(valueForLogicProjectName, dMSolution.GetPropertyValue("LogicProjectName"));
            Assert.AreEqual(valueForBaseProjectName, dMSolution.GetPropertyValue("BaseProjectName"));
            Assert.AreEqual(valueForGenerated, dMSolution.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForBOTestProjectName, dMSolution.GetPropertyValue("BOTestProjectName"));
            Assert.AreEqual(valueForUITestProjectName, dMSolution.GetPropertyValue("UITestProjectName"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = new DMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForSolutionName = TestUtils.GetRandomString(2,100);            
            dMSolution.SetPropertyValue("SolutionName", valueForSolutionName);
            object valueForDefaultAssemblyID = TestUtils.CreateSavedDMAssembly().AssemblyID;            
            dMSolution.SetPropertyValue("DefaultAssemblyID", valueForDefaultAssemblyID);
            object valueForHabaneroDllPath = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("HabaneroDllPath", valueForHabaneroDllPath);
            object valueForTableNamePrefix = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("TableNamePrefix", valueForTableNamePrefix);
            object valueForTableNameSuffix = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("TableNameSuffix", valueForTableNameSuffix);
            object valueForPascalCase = TestUtils.GetRandomBoolean();            
            dMSolution.SetPropertyValue("PascalCase", valueForPascalCase);
            object valueForSolutionDirectory = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("SolutionDirectory", valueForSolutionDirectory);
            object valueForUIProjectName = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("UIProjectName", valueForUIProjectName);
            object valueForBOProjectName = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("BOProjectName", valueForBOProjectName);
            object valueForLogicProjectName = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("LogicProjectName", valueForLogicProjectName);
            object valueForBaseProjectName = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("BaseProjectName", valueForBaseProjectName);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            dMSolution.SetPropertyValue("Generated", valueForGenerated);
            object valueForBOTestProjectName = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("BOTestProjectName", valueForBOTestProjectName);
            object valueForUITestProjectName = TestUtils.GetRandomString();            
            dMSolution.SetPropertyValue("UITestProjectName", valueForUITestProjectName);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForSolutionName, dMSolution.SolutionName);
            Assert.AreEqual(valueForDefaultAssemblyID, dMSolution.DefaultAssemblyID);
            Assert.AreEqual(valueForHabaneroDllPath, dMSolution.HabaneroDllPath);
            Assert.AreEqual(valueForTableNamePrefix, dMSolution.TableNamePrefix);
            Assert.AreEqual(valueForTableNameSuffix, dMSolution.TableNameSuffix);
            Assert.AreEqual(valueForPascalCase, dMSolution.PascalCase);
            Assert.AreEqual(valueForSolutionDirectory, dMSolution.SolutionDirectory);
            Assert.AreEqual(valueForUIProjectName, dMSolution.UIProjectName);
            Assert.AreEqual(valueForBOProjectName, dMSolution.BOProjectName);
            Assert.AreEqual(valueForLogicProjectName, dMSolution.LogicProjectName);
            Assert.AreEqual(valueForBaseProjectName, dMSolution.BaseProjectName);
            Assert.AreEqual(valueForGenerated, dMSolution.Generated);
            Assert.AreEqual(valueForBOTestProjectName, dMSolution.BOTestProjectName);
            Assert.AreEqual(valueForUITestProjectName, dMSolution.UITestProjectName);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSolution.HabaneroDllPath = null;
            dMSolution.TableNamePrefix = null;
            dMSolution.TableNameSuffix = null;
            dMSolution.PascalCase = null;
            dMSolution.UIProjectName = null;
            dMSolution.BOProjectName = null;
            dMSolution.LogicProjectName = null;
            dMSolution.BaseProjectName = null;
            dMSolution.Generated = null;
            dMSolution.BOTestProjectName = null;
            dMSolution.UITestProjectName = null;
            dMSolution.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            DMSolution retrievedDMSolution =
                    Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            
            Assert.IsNull(retrievedDMSolution.HabaneroDllPath);
            Assert.IsNull(retrievedDMSolution.TableNamePrefix);
            Assert.IsNull(retrievedDMSolution.TableNameSuffix);
            Assert.IsNull(retrievedDMSolution.PascalCase);
            Assert.IsNull(retrievedDMSolution.UIProjectName);
            Assert.IsNull(retrievedDMSolution.BOProjectName);
            Assert.IsNull(retrievedDMSolution.LogicProjectName);
            Assert.IsNull(retrievedDMSolution.BaseProjectName);
            Assert.IsNull(retrievedDMSolution.Generated);
            Assert.IsNull(retrievedDMSolution.BOTestProjectName);
            Assert.IsNull(retrievedDMSolution.UITestProjectName);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateUnsavedValidDMSolution();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSolution.SolutionID = null;
            dMSolution.SolutionName = null;
            dMSolution.DefaultAssemblyID = null;
            dMSolution.SolutionDirectory = null;
            
            try
            {
                dMSolution.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'ProjectID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Solution Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Default Assembly ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Solution Directory' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMSolution>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DefaultAssemblyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["HabaneroDllPath"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableNamePrefix"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableNameSuffix"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PascalCase"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionDirectory"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BOProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["LogicProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BaseProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["BOTestProjectName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UITestProjectName"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_DefaultAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.DMAssembly boForRelationshipDefaultAssembly = TestUtils.CreateSavedDMAssembly();
            dMSolution.DefaultAssembly = boForRelationshipDefaultAssembly;
            dMSolution.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMAssembly loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMAssembly>(boForRelationshipDefaultAssembly.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipDefaultAssembly, loadedDMSolution.DefaultAssembly);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.DefaultAssembly);
            Assert.AreEqual(loadedRelatedBO, dMSolution.DefaultAssembly);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Assemblies()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.DMAssembly boForRelationshipAssemblies = TestUtils.CreateUnsavedValidDMAssembly();
            boForRelationshipAssemblies.SolutionID = dMSolution.SolutionID;
            boForRelationshipAssemblies.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.Assemblies.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMAssembly loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMAssembly>(boForRelationshipAssemblies.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSolution.Assemblies.Count);
            Assert.AreEqual(boForRelationshipAssemblies, loadedDMSolution.Assemblies[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.Assemblies[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.Assemblies[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_PropertyTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.DMPropertyType boForRelationshipPropertyTypes = TestUtils.CreateUnsavedValidDMPropertyType();
            boForRelationshipPropertyTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipPropertyTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.PropertyTypes.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMPropertyType loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMPropertyType>(boForRelationshipPropertyTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSolution.PropertyTypes.Count);
            Assert.AreEqual(boForRelationshipPropertyTypes, loadedDMSolution.PropertyTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.PropertyTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.PropertyTypes[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIControlMapperTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.UIControlMapperType boForRelationshipUIControlMapperTypes = TestUtils.CreateUnsavedValidUIControlMapperType();
            boForRelationshipUIControlMapperTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipUIControlMapperTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.UIControlMapperTypes.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIControlMapperType loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIControlMapperType>(boForRelationshipUIControlMapperTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSolution.UIControlMapperTypes.Count);
            Assert.AreEqual(boForRelationshipUIControlMapperTypes, loadedDMSolution.UIControlMapperTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.UIControlMapperTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.UIControlMapperTypes[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.UIControlType boForRelationshipUIControlTypes = TestUtils.CreateUnsavedValidUIControlType();
            boForRelationshipUIControlTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipUIControlTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.UIControlTypes.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIControlType loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIControlType>(boForRelationshipUIControlTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSolution.UIControlTypes.Count);
            Assert.AreEqual(boForRelationshipUIControlTypes, loadedDMSolution.UIControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.UIControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.UIControlTypes[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIGridColumnControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.UIGridColumnControlType boForRelationshipUIGridColumnControlTypes = TestUtils.CreateUnsavedValidUIGridColumnControlType();
            boForRelationshipUIGridColumnControlTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipUIGridColumnControlTypes.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.UIGridColumnControlTypes.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIGridColumnControlType loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridColumnControlType>(boForRelationshipUIGridColumnControlTypes.ID);
            DMSolution loadedDMSolution = Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMSolution.UIGridColumnControlTypes.Count);
            Assert.AreEqual(boForRelationshipUIGridColumnControlTypes, loadedDMSolution.UIGridColumnControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMSolution.UIGridColumnControlTypes[0]);
            Assert.AreEqual(loadedRelatedBO, dMSolution.UIGridColumnControlTypes[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_Assemblies()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.DMAssembly boForRelationshipAssemblies = TestUtils.CreateUnsavedValidDMAssembly();
            boForRelationshipAssemblies.SolutionID = dMSolution.SolutionID;
            boForRelationshipAssemblies.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.Assemblies.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["Assemblies"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.DMAssembly>(boForRelationshipAssemblies.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMAssembly"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_PropertyTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.DMPropertyType boForRelationshipPropertyTypes = TestUtils.CreateUnsavedValidDMPropertyType();
            boForRelationshipPropertyTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipPropertyTypes.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.PropertyTypes.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["PropertyTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.DMPropertyType>(boForRelationshipPropertyTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMPropertyType"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIControlMapperTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.UIControlMapperType boForRelationshipUIControlMapperTypes = TestUtils.CreateUnsavedValidUIControlMapperType();
            boForRelationshipUIControlMapperTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipUIControlMapperTypes.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.UIControlMapperTypes.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["UIControlMapperTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIControlMapperType>(boForRelationshipUIControlMapperTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIControlMapperType"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.UIControlType boForRelationshipUIControlTypes = TestUtils.CreateUnsavedValidUIControlType();
            boForRelationshipUIControlTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipUIControlTypes.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.UIControlTypes.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["UIControlTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIControlType>(boForRelationshipUIControlTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIControlType"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIGridColumnControlTypes()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.UIGridColumnControlType boForRelationshipUIGridColumnControlTypes = TestUtils.CreateUnsavedValidUIGridColumnControlType();
            boForRelationshipUIGridColumnControlTypes.ProjectID = dMSolution.SolutionID;
            boForRelationshipUIGridColumnControlTypes.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dMSolution.UIGridColumnControlTypes.Count);
            RelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["UIGridColumnControlTypes"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIGridColumnControlType>(boForRelationshipUIGridColumnControlTypes.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridColumnControlType"));
            }
        }
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_DefaultAssembly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSolution dMSolution = TestUtils.CreateSavedDMSolution();

            FireStarterModeller.BO.DMAssembly boForRelationshipDefaultAssembly = TestUtils.CreateSavedDMAssembly();
            dMSolution.DefaultAssembly = boForRelationshipDefaultAssembly;
            dMSolution.Save();

            //---------------Assert Preconditions---------------
            RelationshipDef relationshipDef = ClassDef.Get<DMSolution>().RelationshipDefCol["DefaultAssembly"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSolution.Delete();
            dMSolution.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSolution>(dMSolution.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMSolution"));
            }            
            
            FireStarterModeller.BO.DMAssembly relatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMAssembly>(boForRelationshipDefaultAssembly.ID);
            Assert.AreEqual(relatedBO,boForRelationshipDefaultAssembly);
            
        }
       
    }
}
