// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample ReverseEngineering objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved ReverseEngineering with a random value assigned to every property
        /// </summary>
        public static ReverseEngineering CreateSavedReverseEngineering()
		{
		    ReverseEngineering reverseEngineering = CreateUnsavedValidReverseEngineering();
			reverseEngineering.Save();
			return reverseEngineering;
		}

        /// <summary>
        /// Creates a new unsaved ReverseEngineering with a random value assigned to every property
        /// </summary>
		public static ReverseEngineering CreateUnsavedValidReverseEngineering()
		{
			ReverseEngineering reverseEngineering = new ReverseEngineering();
			reverseEngineering.DatabaseConnectionID = TestUtils.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
			reverseEngineering.StoredDatabaseID = TestUtils.CreateSavedDBDatabase().DatabaseID;
			reverseEngineering.ReverseEngineeringSettingsID = TestUtils.CreateSavedReverseEngineeringSettings().ReverseEngineeringSettingsID;
			return reverseEngineering;
		}
	    
	    /// <summary>
        /// Creates a new unsaved ReverseEngineering where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static ReverseEngineering CreateUnsavedDefaultReverseEngineering()
		{
			ReverseEngineering reverseEngineering = new ReverseEngineering();
			return reverseEngineering;
		}
    }
    
    // Provides the part of the test class that tests ReverseEngineering objects
    [TestFixture]
    public partial class TestReverseEngineering : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateReverseEngineeringWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ReverseEngineering reverseEngineering = new ReverseEngineering();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(reverseEngineering.ReverseEngineeringID);
            Assert.IsInstanceOfType(reverseEngineering.Props["ReverseEngineeringID"].PropertyType, reverseEngineering.ReverseEngineeringID);
                        Assert.IsNull(reverseEngineering.DatabaseConnectionID);
                        Assert.IsNull(reverseEngineering.StoredDatabaseID);
                        Assert.IsNull(reverseEngineering.ReverseEngineeringSettingsID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = TestUtils.CreateUnsavedValidReverseEngineering();

            //---------------Assert Precondition----------------
            Assert.IsTrue(reverseEngineering.Status.IsNew);
            BusinessObjectCollection<ReverseEngineering> col = new BusinessObjectCollection<ReverseEngineering>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            reverseEngineering.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(reverseEngineering.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();

            //---------------Execute Test ----------------------
            ReverseEngineering loadedReverseEngineering = Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(reverseEngineering.ReverseEngineeringID, loadedReverseEngineering.ReverseEngineeringID);
                        Assert.AreEqual(reverseEngineering.DatabaseConnectionID, loadedReverseEngineering.DatabaseConnectionID);
                        Assert.AreEqual(reverseEngineering.StoredDatabaseID, loadedReverseEngineering.StoredDatabaseID);
                        Assert.AreEqual(reverseEngineering.ReverseEngineeringSettingsID, loadedReverseEngineering.ReverseEngineeringSettingsID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            reverseEngineering.Delete();
            reverseEngineering.Save();
            //---------------Test Result -----------------------
            try
            {
                ReverseEngineering retrievedReverseEngineering = Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: ReverseEngineering", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseConnectionID = TestUtils.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
            reverseEngineering.DatabaseConnectionID = (System.Guid) valueForDatabaseConnectionID;
            object valueForStoredDatabaseID = TestUtils.CreateSavedDBDatabase().DatabaseID;
            reverseEngineering.StoredDatabaseID = (System.Guid) valueForStoredDatabaseID;
            object valueForReverseEngineeringSettingsID = TestUtils.CreateSavedReverseEngineeringSettings().ReverseEngineeringSettingsID;
            reverseEngineering.ReverseEngineeringSettingsID = (System.Guid) valueForReverseEngineeringSettingsID;
            reverseEngineering.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            ReverseEngineering retrievedReverseEngineering =
                    Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
            
            Assert.AreEqual(valueForDatabaseConnectionID, retrievedReverseEngineering.DatabaseConnectionID);
            Assert.AreEqual(valueForStoredDatabaseID, retrievedReverseEngineering.StoredDatabaseID);
            Assert.AreEqual(valueForReverseEngineeringSettingsID, retrievedReverseEngineering.ReverseEngineeringSettingsID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = new ReverseEngineering();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseConnectionID = TestUtils.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
            reverseEngineering.DatabaseConnectionID = (System.Guid) valueForDatabaseConnectionID;
            object valueForStoredDatabaseID = TestUtils.CreateSavedDBDatabase().DatabaseID;
            reverseEngineering.StoredDatabaseID = (System.Guid) valueForStoredDatabaseID;
            object valueForReverseEngineeringSettingsID = TestUtils.CreateSavedReverseEngineeringSettings().ReverseEngineeringSettingsID;
            reverseEngineering.ReverseEngineeringSettingsID = (System.Guid) valueForReverseEngineeringSettingsID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDatabaseConnectionID, reverseEngineering.DatabaseConnectionID);
            Assert.AreEqual(valueForStoredDatabaseID, reverseEngineering.StoredDatabaseID);
            Assert.AreEqual(valueForReverseEngineeringSettingsID, reverseEngineering.ReverseEngineeringSettingsID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = new ReverseEngineering();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseConnectionID = TestUtils.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;
            reverseEngineering.DatabaseConnectionID = (System.Guid) valueForDatabaseConnectionID;
            object valueForStoredDatabaseID = TestUtils.CreateSavedDBDatabase().DatabaseID;
            reverseEngineering.StoredDatabaseID = (System.Guid) valueForStoredDatabaseID;
            object valueForReverseEngineeringSettingsID = TestUtils.CreateSavedReverseEngineeringSettings().ReverseEngineeringSettingsID;
            reverseEngineering.ReverseEngineeringSettingsID = (System.Guid) valueForReverseEngineeringSettingsID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDatabaseConnectionID, reverseEngineering.GetPropertyValue("DatabaseConnectionID"));
            Assert.AreEqual(valueForStoredDatabaseID, reverseEngineering.GetPropertyValue("StoredDatabaseID"));
            Assert.AreEqual(valueForReverseEngineeringSettingsID, reverseEngineering.GetPropertyValue("ReverseEngineeringSettingsID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = new ReverseEngineering();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseConnectionID = TestUtils.CreateSavedDatabaseConnectionInfo().DatabaseConnectionID;            
            reverseEngineering.SetPropertyValue("DatabaseConnectionID", valueForDatabaseConnectionID);
            object valueForStoredDatabaseID = TestUtils.CreateSavedDBDatabase().DatabaseID;            
            reverseEngineering.SetPropertyValue("StoredDatabaseID", valueForStoredDatabaseID);
            object valueForReverseEngineeringSettingsID = TestUtils.CreateSavedReverseEngineeringSettings().ReverseEngineeringSettingsID;            
            reverseEngineering.SetPropertyValue("ReverseEngineeringSettingsID", valueForReverseEngineeringSettingsID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDatabaseConnectionID, reverseEngineering.DatabaseConnectionID);
            Assert.AreEqual(valueForStoredDatabaseID, reverseEngineering.StoredDatabaseID);
            Assert.AreEqual(valueForReverseEngineeringSettingsID, reverseEngineering.ReverseEngineeringSettingsID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            reverseEngineering.DatabaseConnectionID = null;
            reverseEngineering.StoredDatabaseID = null;
            reverseEngineering.ReverseEngineeringSettingsID = null;
            reverseEngineering.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            ReverseEngineering retrievedReverseEngineering =
                    Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
            
            Assert.IsNull(retrievedReverseEngineering.DatabaseConnectionID);
            Assert.IsNull(retrievedReverseEngineering.StoredDatabaseID);
            Assert.IsNull(retrievedReverseEngineering.ReverseEngineeringSettingsID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ReverseEngineering reverseEngineering = TestUtils.CreateUnsavedValidReverseEngineering();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            reverseEngineering.ReverseEngineeringID = null;
            
            try
            {
                reverseEngineering.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Reverse Engineering I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<ReverseEngineering>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ReverseEngineeringID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DatabaseConnectionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["StoredDatabaseID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ReverseEngineeringSettingsID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_DatabaseConnectionInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();

            FireStarterModeller.BO.DatabaseConnectionInfo boForRelationshipDatabaseConnectionInfo = TestUtils.CreateSavedDatabaseConnectionInfo();
            reverseEngineering.DatabaseConnectionInfo = boForRelationshipDatabaseConnectionInfo;
            reverseEngineering.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DatabaseConnectionInfo loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DatabaseConnectionInfo>(boForRelationshipDatabaseConnectionInfo.ID);
            ReverseEngineering loadedReverseEngineering = Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipDatabaseConnectionInfo, loadedReverseEngineering.DatabaseConnectionInfo);
            Assert.AreEqual(loadedRelatedBO, loadedReverseEngineering.DatabaseConnectionInfo);
            Assert.AreEqual(loadedRelatedBO, reverseEngineering.DatabaseConnectionInfo);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ReverseEngineeringSettings()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();

            FireStarterModeller.BO.ReverseEngineeringSettings boForRelationshipReverseEngineeringSettings = TestUtils.CreateSavedReverseEngineeringSettings();
            reverseEngineering.ReverseEngineeringSettings = boForRelationshipReverseEngineeringSettings;
            reverseEngineering.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.ReverseEngineeringSettings loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.ReverseEngineeringSettings>(boForRelationshipReverseEngineeringSettings.ID);
            ReverseEngineering loadedReverseEngineering = Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipReverseEngineeringSettings, loadedReverseEngineering.ReverseEngineeringSettings);
            Assert.AreEqual(loadedRelatedBO, loadedReverseEngineering.ReverseEngineeringSettings);
            Assert.AreEqual(loadedRelatedBO, reverseEngineering.ReverseEngineeringSettings);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_StoredDatabase()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();

            FireStarterModeller.BO.DBDatabase boForRelationshipStoredDatabase = TestUtils.CreateSavedDBDatabase();
            reverseEngineering.StoredDatabase = boForRelationshipStoredDatabase;
            reverseEngineering.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DBDatabase loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DBDatabase>(boForRelationshipStoredDatabase.ID);
            ReverseEngineering loadedReverseEngineering = Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipStoredDatabase, loadedReverseEngineering.StoredDatabase);
            Assert.AreEqual(loadedRelatedBO, loadedReverseEngineering.StoredDatabase);
            Assert.AreEqual(loadedRelatedBO, reverseEngineering.StoredDatabase);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ModelModifications()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();

            FireStarterModeller.BO.ModelModification boForRelationshipModelModifications = TestUtils.CreateUnsavedValidModelModification();
            boForRelationshipModelModifications.ReverseEngineeringID = reverseEngineering.ReverseEngineeringID;
            boForRelationshipModelModifications.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, reverseEngineering.ModelModifications.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.ModelModification loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.ModelModification>(boForRelationshipModelModifications.ID);
            ReverseEngineering loadedReverseEngineering = Broker.GetBusinessObject<ReverseEngineering>(reverseEngineering.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedReverseEngineering.ModelModifications.Count);
            Assert.AreEqual(boForRelationshipModelModifications, loadedReverseEngineering.ModelModifications[0]);
            Assert.AreEqual(loadedRelatedBO, loadedReverseEngineering.ModelModifications[0]);
            Assert.AreEqual(loadedRelatedBO, reverseEngineering.ModelModifications[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_ModelModifications()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ReverseEngineering reverseEngineering = TestUtils.CreateSavedReverseEngineering();

            FireStarterModeller.BO.ModelModification boForRelationshipModelModifications = TestUtils.CreateUnsavedValidModelModification();
            boForRelationshipModelModifications.ReverseEngineeringID = reverseEngineering.ReverseEngineeringID;
            boForRelationshipModelModifications.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, reverseEngineering.ModelModifications.Count);
            RelationshipDef relationshipDef = ClassDef.Get<ReverseEngineering>().RelationshipDefCol["ModelModifications"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                reverseEngineering.Delete();
                reverseEngineering.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'ModelModifications' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
