// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample UIFormInfo objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UIFormInfo with a random value assigned to every property
        /// </summary>
        public static UIFormInfo CreateSavedUIFormInfo()
		{
		    UIFormInfo uIFormInfo = CreateUnsavedValidUIFormInfo();
			uIFormInfo.Save();
			return uIFormInfo;
		}

        /// <summary>
        /// Creates a new unsaved UIFormInfo with a random value assigned to every property
        /// </summary>
		public static UIFormInfo CreateUnsavedValidUIFormInfo()
		{
			UIFormInfo uIFormInfo = new UIFormInfo();
			uIFormInfo.Width = TestUtils.GetRandomInt();
			uIFormInfo.Height = TestUtils.GetRandomInt();
			uIFormInfo.Title = TestUtils.GetRandomString();
			uIFormInfo.Generated = TestUtils.GetRandomBoolean();
			uIFormInfo.UIViewID = TestUtils.CreateSavedUIView().UIViewID;
			return uIFormInfo;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIFormInfo where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIFormInfo CreateUnsavedDefaultUIFormInfo()
		{
			UIFormInfo uIFormInfo = new UIFormInfo();
			return uIFormInfo;
		}
    }
    
    // Provides the part of the test class that tests UIFormInfo objects
    [TestFixture]
    public partial class TestUIFormInfo : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIFormInfoWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIFormInfo uIFormInfo = new UIFormInfo();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIFormInfo.UIFormID);
            Assert.IsInstanceOfType(uIFormInfo.Props["UIFormID"].PropertyType, uIFormInfo.UIFormID);
                        Assert.IsNotNull(uIFormInfo.Width);
            Assert.IsInstanceOfType(uIFormInfo.Props["Width"].PropertyType, uIFormInfo.Width);
                        Assert.IsNotNull(uIFormInfo.Height);
            Assert.IsInstanceOfType(uIFormInfo.Props["Height"].PropertyType, uIFormInfo.Height);
                        Assert.IsNull(uIFormInfo.Title);
                        Assert.IsNotNull(uIFormInfo.Generated);
            Assert.IsInstanceOfType(uIFormInfo.Props["Generated"].PropertyType, uIFormInfo.Generated);
                        Assert.IsNull(uIFormInfo.UIViewID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateUnsavedValidUIFormInfo();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIFormInfo.Status.IsNew);
            BusinessObjectCollection<UIFormInfo> col = new BusinessObjectCollection<UIFormInfo>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIFormInfo.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIFormInfo.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();

            //---------------Execute Test ----------------------
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIFormInfo.UIFormID, loadedUIFormInfo.UIFormID);
                        Assert.AreEqual(uIFormInfo.Width, loadedUIFormInfo.Width);
                        Assert.AreEqual(uIFormInfo.Height, loadedUIFormInfo.Height);
                        Assert.AreEqual(uIFormInfo.Title, loadedUIFormInfo.Title);
                        Assert.AreEqual(uIFormInfo.Generated, loadedUIFormInfo.Generated);
                        Assert.AreEqual(uIFormInfo.UIViewID, loadedUIFormInfo.UIViewID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIFormInfo.Delete();
            uIFormInfo.Save();
            //---------------Test Result -----------------------
            try
            {
                UIFormInfo retrievedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIFormInfo", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();
            uIFormInfo.Width = (System.Int32) valueForWidth;
            object valueForHeight = TestUtils.GetRandomInt();
            uIFormInfo.Height = (System.Int32) valueForHeight;
            object valueForTitle = TestUtils.GetRandomString();
            uIFormInfo.Title = (System.String) valueForTitle;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIFormInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtils.CreateSavedUIView().UIViewID;
            uIFormInfo.UIViewID = (System.Guid) valueForUIViewID;
            uIFormInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIFormInfo retrievedUIFormInfo =
                    Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            
            Assert.AreEqual(valueForWidth, retrievedUIFormInfo.Width);
            Assert.AreEqual(valueForHeight, retrievedUIFormInfo.Height);
            Assert.AreEqual(valueForTitle, retrievedUIFormInfo.Title);
            Assert.AreEqual(valueForGenerated, retrievedUIFormInfo.Generated);
            Assert.AreEqual(valueForUIViewID, retrievedUIFormInfo.UIViewID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = new UIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();
            uIFormInfo.Width = (System.Int32) valueForWidth;
            object valueForHeight = TestUtils.GetRandomInt();
            uIFormInfo.Height = (System.Int32) valueForHeight;
            object valueForTitle = TestUtils.GetRandomString();
            uIFormInfo.Title = (System.String) valueForTitle;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIFormInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtils.CreateSavedUIView().UIViewID;
            uIFormInfo.UIViewID = (System.Guid) valueForUIViewID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIFormInfo.Width);
            Assert.AreEqual(valueForHeight, uIFormInfo.Height);
            Assert.AreEqual(valueForTitle, uIFormInfo.Title);
            Assert.AreEqual(valueForGenerated, uIFormInfo.Generated);
            Assert.AreEqual(valueForUIViewID, uIFormInfo.UIViewID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = new UIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();
            uIFormInfo.Width = (System.Int32) valueForWidth;
            object valueForHeight = TestUtils.GetRandomInt();
            uIFormInfo.Height = (System.Int32) valueForHeight;
            object valueForTitle = TestUtils.GetRandomString();
            uIFormInfo.Title = (System.String) valueForTitle;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIFormInfo.Generated = (System.Boolean) valueForGenerated;
            object valueForUIViewID = TestUtils.CreateSavedUIView().UIViewID;
            uIFormInfo.UIViewID = (System.Guid) valueForUIViewID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIFormInfo.GetPropertyValue("Width"));
            Assert.AreEqual(valueForHeight, uIFormInfo.GetPropertyValue("Height"));
            Assert.AreEqual(valueForTitle, uIFormInfo.GetPropertyValue("Title"));
            Assert.AreEqual(valueForGenerated, uIFormInfo.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIViewID, uIFormInfo.GetPropertyValue("UIViewID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = new UIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForWidth = TestUtils.GetRandomInt();            
            uIFormInfo.SetPropertyValue("Width", valueForWidth);
            object valueForHeight = TestUtils.GetRandomInt();            
            uIFormInfo.SetPropertyValue("Height", valueForHeight);
            object valueForTitle = TestUtils.GetRandomString();            
            uIFormInfo.SetPropertyValue("Title", valueForTitle);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            uIFormInfo.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIViewID = TestUtils.CreateSavedUIView().UIViewID;            
            uIFormInfo.SetPropertyValue("UIViewID", valueForUIViewID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForWidth, uIFormInfo.Width);
            Assert.AreEqual(valueForHeight, uIFormInfo.Height);
            Assert.AreEqual(valueForTitle, uIFormInfo.Title);
            Assert.AreEqual(valueForGenerated, uIFormInfo.Generated);
            Assert.AreEqual(valueForUIViewID, uIFormInfo.UIViewID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIFormInfo.Title = null;
            uIFormInfo.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIFormInfo retrievedUIFormInfo =
                    Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            
            Assert.IsNull(retrievedUIFormInfo.Title);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtils.CreateUnsavedValidUIFormInfo();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIFormInfo.UIFormID = null;
            uIFormInfo.Width = null;
            uIFormInfo.Height = null;
            uIFormInfo.Generated = null;
            uIFormInfo.UIViewID = null;
            
            try
            {
                uIFormInfo.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'U I Form I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Width' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Height' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'U I View I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIFormInfo>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIFormID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Width"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Height"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Title"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIViewID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();

            FireStarterModeller.BO.UIView boForRelationshipUIView = TestUtils.CreateSavedUIView();
            uIFormInfo.UIView = boForRelationshipUIView;
            uIFormInfo.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIView loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIView>(boForRelationshipUIView.ID);
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIView, loadedUIFormInfo.UIView);
            Assert.AreEqual(loadedRelatedBO, loadedUIFormInfo.UIView);
            Assert.AreEqual(loadedRelatedBO, uIFormInfo.UIView);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIColumnLayouts()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();

            FireStarterModeller.BO.UIColumnLayout boForRelationshipUIColumnLayouts = TestUtils.CreateUnsavedValidUIColumnLayout();
            boForRelationshipUIColumnLayouts.UIFormID = uIFormInfo.UIFormID;
            boForRelationshipUIColumnLayouts.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIFormInfo.UIColumnLayouts.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIColumnLayout loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIColumnLayout>(boForRelationshipUIColumnLayouts.ID);
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIFormInfo.UIColumnLayouts.Count);
            Assert.AreEqual(boForRelationshipUIColumnLayouts, loadedUIFormInfo.UIColumnLayouts[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIFormInfo.UIColumnLayouts[0]);
            Assert.AreEqual(loadedRelatedBO, uIFormInfo.UIColumnLayouts[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UITabs()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();

            FireStarterModeller.BO.UITab boForRelationshipUITabs = TestUtils.CreateUnsavedValidUITab();
            boForRelationshipUITabs.UIFormID = uIFormInfo.UIFormID;
            boForRelationshipUITabs.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIFormInfo.UITabs.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UITab loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UITab>(boForRelationshipUITabs.ID);
            UIFormInfo loadedUIFormInfo = Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIFormInfo.UITabs.Count);
            Assert.AreEqual(boForRelationshipUITabs, loadedUIFormInfo.UITabs[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIFormInfo.UITabs[0]);
            Assert.AreEqual(loadedRelatedBO, uIFormInfo.UITabs[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIColumnLayouts()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();

            FireStarterModeller.BO.UIColumnLayout boForRelationshipUIColumnLayouts = TestUtils.CreateUnsavedValidUIColumnLayout();
            boForRelationshipUIColumnLayouts.UIFormID = uIFormInfo.UIFormID;
            boForRelationshipUIColumnLayouts.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIFormInfo.UIColumnLayouts.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UIFormInfo>().RelationshipDefCol["UIColumnLayouts"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIFormInfo.Delete();
            uIFormInfo.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIFormInfo"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIColumnLayout>(boForRelationshipUIColumnLayouts.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIColumnLayout"));
            }
        }
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UITabs()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIFormInfo uIFormInfo = TestUtils.CreateSavedUIFormInfo();

            FireStarterModeller.BO.UITab boForRelationshipUITabs = TestUtils.CreateUnsavedValidUITab();
            boForRelationshipUITabs.UIFormID = uIFormInfo.UIFormID;
            boForRelationshipUITabs.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIFormInfo.UITabs.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UIFormInfo>().RelationshipDefCol["UITabs"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIFormInfo.Delete();
            uIFormInfo.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIFormInfo>(uIFormInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIFormInfo"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UITab>(boForRelationshipUITabs.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UITab"));
            }
        }
        
        
        
        
       
    }
}
