// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample UIGridColumnControlType objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UIGridColumnControlType with a random value assigned to every property
        /// </summary>
        public static UIGridColumnControlType CreateSavedUIGridColumnControlType()
		{
		    UIGridColumnControlType uIGridColumnControlType = CreateUnsavedValidUIGridColumnControlType();
			uIGridColumnControlType.Save();
			return uIGridColumnControlType;
		}

        /// <summary>
        /// Creates a new unsaved UIGridColumnControlType with a random value assigned to every property
        /// </summary>
		public static UIGridColumnControlType CreateUnsavedValidUIGridColumnControlType()
		{
			UIGridColumnControlType uIGridColumnControlType = new UIGridColumnControlType();
			uIGridColumnControlType.AssemblyName = TestUtils.GetRandomString();
			uIGridColumnControlType.TypeName = TestUtils.GetRandomString();
			uIGridColumnControlType.ProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
			return uIGridColumnControlType;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIGridColumnControlType where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIGridColumnControlType CreateUnsavedDefaultUIGridColumnControlType()
		{
			UIGridColumnControlType uIGridColumnControlType = new UIGridColumnControlType();
			return uIGridColumnControlType;
		}
    }
    
    // Provides the part of the test class that tests UIGridColumnControlType objects
    [TestFixture]
    public partial class TestUIGridColumnControlType : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIGridColumnControlTypeWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIGridColumnControlType uIGridColumnControlType = new UIGridColumnControlType();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIGridColumnControlType.UIGridColumnControlTypeID);
            Assert.IsInstanceOfType(uIGridColumnControlType.Props["UIGridColumnControlTypeID"].PropertyType, uIGridColumnControlType.UIGridColumnControlTypeID);
                        Assert.IsNull(uIGridColumnControlType.AssemblyName);
                        Assert.IsNull(uIGridColumnControlType.TypeName);
                        Assert.IsNull(uIGridColumnControlType.ProjectID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIGridColumnControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateUnsavedValidUIGridColumnControlType();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIGridColumnControlType.Status.IsNew);
            BusinessObjectCollection<UIGridColumnControlType> col = new BusinessObjectCollection<UIGridColumnControlType>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIGridColumnControlType.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIGridColumnControlType.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIGridColumnControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();

            //---------------Execute Test ----------------------
            UIGridColumnControlType loadedUIGridColumnControlType = Broker.GetBusinessObject<UIGridColumnControlType>(uIGridColumnControlType.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIGridColumnControlType.UIGridColumnControlTypeID, loadedUIGridColumnControlType.UIGridColumnControlTypeID);
                        Assert.AreEqual(uIGridColumnControlType.AssemblyName, loadedUIGridColumnControlType.AssemblyName);
                        Assert.AreEqual(uIGridColumnControlType.TypeName, loadedUIGridColumnControlType.TypeName);
                        Assert.AreEqual(uIGridColumnControlType.ProjectID, loadedUIGridColumnControlType.ProjectID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIGridColumnControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridColumnControlType.Delete();
            uIGridColumnControlType.Save();
            //---------------Test Result -----------------------
            try
            {
                UIGridColumnControlType retrievedUIGridColumnControlType = Broker.GetBusinessObject<UIGridColumnControlType>(uIGridColumnControlType.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIGridColumnControlType", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIGridColumnControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            uIGridColumnControlType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            uIGridColumnControlType.TypeName = (System.String) valueForTypeName;
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
            uIGridColumnControlType.ProjectID = (System.Guid) valueForProjectID;
            uIGridColumnControlType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIGridColumnControlType retrievedUIGridColumnControlType =
                    Broker.GetBusinessObject<UIGridColumnControlType>(uIGridColumnControlType.ID);
            
            Assert.AreEqual(valueForAssemblyName, retrievedUIGridColumnControlType.AssemblyName);
            Assert.AreEqual(valueForTypeName, retrievedUIGridColumnControlType.TypeName);
            Assert.AreEqual(valueForProjectID, retrievedUIGridColumnControlType.ProjectID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = new UIGridColumnControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            uIGridColumnControlType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            uIGridColumnControlType.TypeName = (System.String) valueForTypeName;
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
            uIGridColumnControlType.ProjectID = (System.Guid) valueForProjectID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIGridColumnControlType.AssemblyName);
            Assert.AreEqual(valueForTypeName, uIGridColumnControlType.TypeName);
            Assert.AreEqual(valueForProjectID, uIGridColumnControlType.ProjectID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = new UIGridColumnControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            uIGridColumnControlType.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            uIGridColumnControlType.TypeName = (System.String) valueForTypeName;
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;
            uIGridColumnControlType.ProjectID = (System.Guid) valueForProjectID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIGridColumnControlType.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForTypeName, uIGridColumnControlType.GetPropertyValue("TypeName"));
            Assert.AreEqual(valueForProjectID, uIGridColumnControlType.GetPropertyValue("ProjectID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = new UIGridColumnControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();            
            uIGridColumnControlType.SetPropertyValue("AssemblyName", valueForAssemblyName);
            object valueForTypeName = TestUtils.GetRandomString();            
            uIGridColumnControlType.SetPropertyValue("TypeName", valueForTypeName);
            object valueForProjectID = TestUtils.CreateSavedDMSolution().SolutionID;            
            uIGridColumnControlType.SetPropertyValue("ProjectID", valueForProjectID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uIGridColumnControlType.AssemblyName);
            Assert.AreEqual(valueForTypeName, uIGridColumnControlType.TypeName);
            Assert.AreEqual(valueForProjectID, uIGridColumnControlType.ProjectID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridColumnControlType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIGridColumnControlType retrievedUIGridColumnControlType =
                    Broker.GetBusinessObject<UIGridColumnControlType>(uIGridColumnControlType.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateUnsavedValidUIGridColumnControlType();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridColumnControlType.UIGridColumnControlTypeID = null;
            uIGridColumnControlType.AssemblyName = null;
            uIGridColumnControlType.TypeName = null;
            uIGridColumnControlType.ProjectID = null;
            
            try
            {
                uIGridColumnControlType.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'Control Type' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Assembly Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Type Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Project I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIGridColumnControlType>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridColumnControlTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TypeName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ProjectID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();

            FireStarterModeller.BO.DMSolution boForRelationshipSolution = TestUtils.CreateSavedDMSolution();
            uIGridColumnControlType.Solution = boForRelationshipSolution;
            uIGridColumnControlType.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSolution loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSolution>(boForRelationshipSolution.ID);
            UIGridColumnControlType loadedUIGridColumnControlType = Broker.GetBusinessObject<UIGridColumnControlType>(uIGridColumnControlType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedUIGridColumnControlType.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridColumnControlType.Solution);
            Assert.AreEqual(loadedRelatedBO, uIGridColumnControlType.Solution);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();

            FireStarterModeller.BO.UIColumn boForRelationshipUIColumns = TestUtils.CreateUnsavedValidUIColumn();
            boForRelationshipUIColumns.UIGridColumnControlTypeID = uIGridColumnControlType.UIGridColumnControlTypeID;
            boForRelationshipUIColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridColumnControlType.UIColumns.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIColumn loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIColumn>(boForRelationshipUIColumns.ID);
            UIGridColumnControlType loadedUIGridColumnControlType = Broker.GetBusinessObject<UIGridColumnControlType>(uIGridColumnControlType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIGridColumnControlType.UIColumns.Count);
            Assert.AreEqual(boForRelationshipUIColumns, loadedUIGridColumnControlType.UIColumns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridColumnControlType.UIColumns[0]);
            Assert.AreEqual(loadedRelatedBO, uIGridColumnControlType.UIColumns[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UIColumns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnControlType uIGridColumnControlType = TestUtils.CreateSavedUIGridColumnControlType();

            FireStarterModeller.BO.UIColumn boForRelationshipUIColumns = TestUtils.CreateUnsavedValidUIColumn();
            boForRelationshipUIColumns.UIGridColumnControlTypeID = uIGridColumnControlType.UIGridColumnControlTypeID;
            boForRelationshipUIColumns.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridColumnControlType.UIColumns.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UIGridColumnControlType>().RelationshipDefCol["UIColumns"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                uIGridColumnControlType.Delete();
                uIGridColumnControlType.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'UIColumns' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
