// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample UIGridFilter objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UIGridFilter with a random value assigned to every property
        /// </summary>
        public static UIGridFilter CreateSavedUIGridFilter()
		{
		    UIGridFilter uIGridFilter = CreateUnsavedValidUIGridFilter();
			uIGridFilter.Save();
			return uIGridFilter;
		}

        /// <summary>
        /// Creates a new unsaved UIGridFilter with a random value assigned to every property
        /// </summary>
		public static UIGridFilter CreateUnsavedValidUIGridFilter()
		{
			UIGridFilter uIGridFilter = new UIGridFilter();
			uIGridFilter.UIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
			uIGridFilter.Generated = TestUtils.GetRandomBoolean();
			return uIGridFilter;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIGridFilter where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIGridFilter CreateUnsavedDefaultUIGridFilter()
		{
			UIGridFilter uIGridFilter = new UIGridFilter();
			return uIGridFilter;
		}
    }
    
    // Provides the part of the test class that tests UIGridFilter objects
    [TestFixture]
    public partial class TestUIGridFilter : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIGridFilterWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIGridFilter uIGridFilter = new UIGridFilter();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIGridFilter.UIGridFilterID);
            Assert.IsInstanceOfType(uIGridFilter.Props["UIGridFilterID"].PropertyType, uIGridFilter.UIGridFilterID);
                        Assert.IsNull(uIGridFilter.UIGridID);
                        Assert.IsNotNull(uIGridFilter.Generated);
            Assert.IsInstanceOfType(uIGridFilter.Props["Generated"].PropertyType, uIGridFilter.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateUnsavedValidUIGridFilter();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIGridFilter.Status.IsNew);
            BusinessObjectCollection<UIGridFilter> col = new BusinessObjectCollection<UIGridFilter>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIGridFilter.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIGridFilter.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();

            //---------------Execute Test ----------------------
            UIGridFilter loadedUIGridFilter = Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIGridFilter.UIGridFilterID, loadedUIGridFilter.UIGridFilterID);
                        Assert.AreEqual(uIGridFilter.UIGridID, loadedUIGridFilter.UIGridID);
                        Assert.AreEqual(uIGridFilter.Generated, loadedUIGridFilter.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridFilter.Delete();
            uIGridFilter.Save();
            //---------------Test Result -----------------------
            try
            {
                UIGridFilter retrievedUIGridFilter = Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIGridFilter", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIGridFilter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
            uIGridFilter.UIGridID = (System.Guid) valueForUIGridID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIGridFilter.Generated = (System.Boolean) valueForGenerated;
            uIGridFilter.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIGridFilter retrievedUIGridFilter =
                    Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
            
            Assert.AreEqual(valueForUIGridID, retrievedUIGridFilter.UIGridID);
            Assert.AreEqual(valueForGenerated, retrievedUIGridFilter.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = new UIGridFilter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
            uIGridFilter.UIGridID = (System.Guid) valueForUIGridID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIGridFilter.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForUIGridID, uIGridFilter.UIGridID);
            Assert.AreEqual(valueForGenerated, uIGridFilter.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = new UIGridFilter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;
            uIGridFilter.UIGridID = (System.Guid) valueForUIGridID;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uIGridFilter.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForUIGridID, uIGridFilter.GetPropertyValue("UIGridID"));
            Assert.AreEqual(valueForGenerated, uIGridFilter.GetPropertyValue("Generated"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = new UIGridFilter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForUIGridID = TestUtils.CreateSavedUIGridInfo().UIGridID;            
            uIGridFilter.SetPropertyValue("UIGridID", valueForUIGridID);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            uIGridFilter.SetPropertyValue("Generated", valueForGenerated);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForUIGridID, uIGridFilter.UIGridID);
            Assert.AreEqual(valueForGenerated, uIGridFilter.Generated);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridFilter.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UIGridFilter retrievedUIGridFilter =
                    Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridFilter uIGridFilter = TestUtils.CreateUnsavedValidUIGridFilter();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridFilter.UIGridID = null;
            uIGridFilter.Generated = null;
            
            try
            {
                uIGridFilter.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'UI Grid I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIGridFilter>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridFilterID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();

            FireStarterModeller.BO.UIGridInfo boForRelationshipUIGridInfo = TestUtils.CreateSavedUIGridInfo();
            uIGridFilter.UIGridInfo = boForRelationshipUIGridInfo;
            uIGridFilter.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIGridInfo loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridInfo>(boForRelationshipUIGridInfo.ID);
            UIGridFilter loadedUIGridFilter = Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridInfo, loadedUIGridFilter.UIGridInfo);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridFilter.UIGridInfo);
            Assert.AreEqual(loadedRelatedBO, uIGridFilter.UIGridInfo);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIGridFilterProps()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();

            FireStarterModeller.BO.UIGridFilterProp boForRelationshipUIGridFilterProps = TestUtils.CreateUnsavedValidUIGridFilterProp();
            boForRelationshipUIGridFilterProps.UIGridFilterID = uIGridFilter.UIGridFilterID;
            boForRelationshipUIGridFilterProps.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridFilter.UIGridFilterProps.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIGridFilterProp loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridFilterProp>(boForRelationshipUIGridFilterProps.ID);
            UIGridFilter loadedUIGridFilter = Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIGridFilter.UIGridFilterProps.Count);
            Assert.AreEqual(boForRelationshipUIGridFilterProps, loadedUIGridFilter.UIGridFilterProps[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridFilter.UIGridFilterProps[0]);
            Assert.AreEqual(loadedRelatedBO, uIGridFilter.UIGridFilterProps[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIGridFilterProps()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();

            FireStarterModeller.BO.UIGridFilterProp boForRelationshipUIGridFilterProps = TestUtils.CreateUnsavedValidUIGridFilterProp();
            boForRelationshipUIGridFilterProps.UIGridFilterID = uIGridFilter.UIGridFilterID;
            boForRelationshipUIGridFilterProps.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridFilter.UIGridFilterProps.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UIGridFilter>().RelationshipDefCol["UIGridFilterProps"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIGridFilter.Delete();
            uIGridFilter.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridFilter"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIGridFilterProp>(boForRelationshipUIGridFilterProps.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridFilterProp"));
            }
        }
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_UIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridFilter uIGridFilter = TestUtils.CreateSavedUIGridFilter();

            FireStarterModeller.BO.UIGridInfo boForRelationshipUIGridInfo = TestUtils.CreateSavedUIGridInfo();
            uIGridFilter.UIGridInfo = boForRelationshipUIGridInfo;
            uIGridFilter.Save();

            //---------------Assert Preconditions---------------
            RelationshipDef relationshipDef = ClassDef.Get<UIGridFilter>().RelationshipDefCol["UIGridInfo"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIGridFilter.Delete();
            uIGridFilter.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIGridFilter>(uIGridFilter.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridFilter"));
            }            
            
            FireStarterModeller.BO.UIGridInfo relatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridInfo>(boForRelationshipUIGridInfo.ID);
            Assert.AreEqual(relatedBO,boForRelationshipUIGridInfo);
            
        }
       
    }
}
