// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using jjjjjjj;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.Test
{
    // Provides a part of the TestUtilsBase class that creates sample UITab objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UITab with a random value assigned to every property
        /// </summary>
        public static UITab CreateSavedUITab()
		{
		    UITab uITab = CreateUnsavedValidUITab();
			uITab.Save();
			return uITab;
		}

        /// <summary>
        /// Creates a new unsaved UITab with a random value assigned to every property
        /// </summary>
		public static UITab CreateUnsavedValidUITab()
		{
			UITab uITab = new UITab();
			uITab.Name = TestUtils.GetRandomString();
			uITab.Generated = TestUtils.GetRandomBoolean();
			uITab.UIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
			return uITab;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UITab where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UITab CreateUnsavedDefaultUITab()
		{
			UITab uITab = new UITab();
			return uITab;
		}
    }
    
    // Provides the part of the test class that tests UITab objects
    [TestFixture]
    public partial class TestUITab : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUITabWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UITab uITab = new UITab();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uITab.UITabID);
            Assert.IsInstanceOfType(uITab.Props["UITabID"].PropertyType, uITab.UITabID);
                        Assert.IsNull(uITab.Name);
                        Assert.IsNotNull(uITab.Generated);
            Assert.IsInstanceOfType(uITab.Props["Generated"].PropertyType, uITab.Generated);
                        Assert.IsNull(uITab.UIFormID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUITab()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = TestUtils.CreateUnsavedValidUITab();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uITab.Status.IsNew);
            BusinessObjectCollection<UITab> col = new BusinessObjectCollection<UITab>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uITab.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uITab.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUITab()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = TestUtils.CreateSavedUITab();

            //---------------Execute Test ----------------------
            UITab loadedUITab = Broker.GetBusinessObject<UITab>(uITab.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uITab.UITabID, loadedUITab.UITabID);
                        Assert.AreEqual(uITab.Name, loadedUITab.Name);
                        Assert.AreEqual(uITab.Generated, loadedUITab.Generated);
                        Assert.AreEqual(uITab.UIFormID, loadedUITab.UIFormID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUITab()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = TestUtils.CreateSavedUITab();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITab.Delete();
            uITab.Save();
            //---------------Test Result -----------------------
            try
            {
                UITab retrievedUITab = Broker.GetBusinessObject<UITab>(uITab.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UITab", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUITab()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = TestUtils.CreateSavedUITab();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            uITab.Name = (System.String) valueForName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uITab.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
            uITab.UIFormID = (System.Guid) valueForUIFormID;
            uITab.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UITab retrievedUITab =
                    Broker.GetBusinessObject<UITab>(uITab.ID);
            
            Assert.AreEqual(valueForName, retrievedUITab.Name);
            Assert.AreEqual(valueForGenerated, retrievedUITab.Generated);
            Assert.AreEqual(valueForUIFormID, retrievedUITab.UIFormID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = new UITab();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            uITab.Name = (System.String) valueForName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uITab.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
            uITab.UIFormID = (System.Guid) valueForUIFormID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uITab.Name);
            Assert.AreEqual(valueForGenerated, uITab.Generated);
            Assert.AreEqual(valueForUIFormID, uITab.UIFormID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = new UITab();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();
            uITab.Name = (System.String) valueForName;
            object valueForGenerated = TestUtils.GetRandomBoolean();
            uITab.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;
            uITab.UIFormID = (System.Guid) valueForUIFormID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uITab.GetPropertyValue("Name"));
            Assert.AreEqual(valueForGenerated, uITab.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIFormID, uITab.GetPropertyValue("UIFormID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = new UITab();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtils.GetRandomString();            
            uITab.SetPropertyValue("Name", valueForName);
            object valueForGenerated = TestUtils.GetRandomBoolean();            
            uITab.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIFormID = TestUtils.CreateSavedUIFormInfo().UIFormID;            
            uITab.SetPropertyValue("UIFormID", valueForUIFormID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uITab.Name);
            Assert.AreEqual(valueForGenerated, uITab.Generated);
            Assert.AreEqual(valueForUIFormID, uITab.UIFormID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = TestUtils.CreateSavedUITab();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITab.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UITab retrievedUITab =
                    Broker.GetBusinessObject<UITab>(uITab.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITab uITab = TestUtils.CreateUnsavedValidUITab();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITab.UITabID = null;
            uITab.Name = null;
            uITab.Generated = null;
            uITab.UIFormID = null;
            
            try
            {
                uITab.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'U I Tab I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'U I Form I D' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UITab>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UITabID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIFormID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITab uITab = TestUtils.CreateSavedUITab();

            FireStarterModeller.BO.UIFormInfo boForRelationshipUIFormInfo = TestUtils.CreateSavedUIFormInfo();
            uITab.UIFormInfo = boForRelationshipUIFormInfo;
            uITab.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIFormInfo loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIFormInfo>(boForRelationshipUIFormInfo.ID);
            UITab loadedUITab = Broker.GetBusinessObject<UITab>(uITab.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIFormInfo, loadedUITab.UIFormInfo);
            Assert.AreEqual(loadedRelatedBO, loadedUITab.UIFormInfo);
            Assert.AreEqual(loadedRelatedBO, uITab.UIFormInfo);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIColumnLayouts()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITab uITab = TestUtils.CreateSavedUITab();

            FireStarterModeller.BO.UIColumnLayout boForRelationshipUIColumnLayouts = TestUtils.CreateUnsavedValidUIColumnLayout();
            boForRelationshipUIColumnLayouts.UITabID = uITab.UITabID;
            boForRelationshipUIColumnLayouts.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uITab.UIColumnLayouts.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIColumnLayout loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIColumnLayout>(boForRelationshipUIColumnLayouts.ID);
            UITab loadedUITab = Broker.GetBusinessObject<UITab>(uITab.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUITab.UIColumnLayouts.Count);
            Assert.AreEqual(boForRelationshipUIColumnLayouts, loadedUITab.UIColumnLayouts[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUITab.UIColumnLayouts[0]);
            Assert.AreEqual(loadedRelatedBO, uITab.UIColumnLayouts[0]);
        }
        
        
        [Test, Ignore("DeleteRelated not yet implemented in inmemory")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIColumnLayouts()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITab uITab = TestUtils.CreateSavedUITab();

            FireStarterModeller.BO.UIColumnLayout boForRelationshipUIColumnLayouts = TestUtils.CreateUnsavedValidUIColumnLayout();
            boForRelationshipUIColumnLayouts.UITabID = uITab.UITabID;
            boForRelationshipUIColumnLayouts.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uITab.UIColumnLayouts.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UITab>().RelationshipDefCol["UIColumnLayouts"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uITab.Delete();
            uITab.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UITab>(uITab.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UITab"));
            }            
            
            try
            {
                Broker.GetBusinessObject<FireStarterModeller.BO.UIColumnLayout>(boForRelationshipUIColumnLayouts.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIColumnLayout"));
            }
        }
        
        
        
        
       
    }
}
