// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO.New
{
    // Provides a part of the TestUtilsBase class that creates sample UITypeDefinition objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
	public partial class TestUtilsBase
    {
        /// <summary>
        /// Creates a new saved UITypeDefinition with a random value assigned to every property
        /// </summary>
        public static UITypeDefinition CreateSavedUITypeDefinition()
		{
		    UITypeDefinition uITypeDefinition = CreateUnsavedValidUITypeDefinition();
			uITypeDefinition.Save();
			return uITypeDefinition;
		}

        /// <summary>
        /// Creates a new unsaved UITypeDefinition with a random value assigned to every property
        /// </summary>
		public static UITypeDefinition CreateUnsavedValidUITypeDefinition()
		{
			UITypeDefinition uITypeDefinition = new UITypeDefinition();
			uITypeDefinition.AssemblyName = TestUtils.GetRandomString();
			uITypeDefinition.TypeName = TestUtils.GetRandomString();
			uITypeDefinition.SolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
			uITypeDefinition.TypeDescriminator = TestUtils.GetRandomString();
			return uITypeDefinition;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UITypeDefinition where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UITypeDefinition CreateUnsavedDefaultUITypeDefinition()
		{
			UITypeDefinition uITypeDefinition = new UITypeDefinition();
			return uITypeDefinition;
		}
    }
    
    // Provides the part of the test class that tests UITypeDefinition objects
    [TestFixture]
    public partial class TestUITypeDefinition : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUITypeDefinitionWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uITypeDefinition.UITypeDefinitionID);
            Assert.IsInstanceOfType(uITypeDefinition.Props["UITypeDefinitionID"].PropertyType, uITypeDefinition.UITypeDefinitionID);
                        Assert.IsNull(uITypeDefinition.AssemblyName);
                        Assert.IsNull(uITypeDefinition.TypeName);
                        Assert.IsNull(uITypeDefinition.SolutionID);
                        Assert.IsNull(uITypeDefinition.TypeDescriminator);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtils.CreateUnsavedValidUITypeDefinition();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uITypeDefinition.Status.IsNew);
            BusinessObjectCollection<UITypeDefinition> col = new BusinessObjectCollection<UITypeDefinition>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uITypeDefinition.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uITypeDefinition.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();

            //---------------Execute Test ----------------------
            UITypeDefinition loadedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uITypeDefinition.UITypeDefinitionID, loadedUITypeDefinition.UITypeDefinitionID);
                        Assert.AreEqual(uITypeDefinition.AssemblyName, loadedUITypeDefinition.AssemblyName);
                        Assert.AreEqual(uITypeDefinition.TypeName, loadedUITypeDefinition.TypeName);
                        Assert.AreEqual(uITypeDefinition.SolutionID, loadedUITypeDefinition.SolutionID);
                        Assert.AreEqual(uITypeDefinition.TypeDescriminator, loadedUITypeDefinition.TypeDescriminator);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITypeDefinition.Delete();
            uITypeDefinition.Save();
            //---------------Test Result -----------------------
            try
            {
                UITypeDefinition retrievedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UITypeDefinition", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            uITypeDefinition.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            uITypeDefinition.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SolutionID = (System.Guid) valueForSolutionID;
            object valueForTypeDescriminator = TestUtils.GetRandomString();
            uITypeDefinition.TypeDescriminator = (System.String) valueForTypeDescriminator;
            uITypeDefinition.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UITypeDefinition retrievedUITypeDefinition =
                    Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
            
            Assert.AreEqual(valueForAssemblyName, retrievedUITypeDefinition.AssemblyName);
            Assert.AreEqual(valueForTypeName, retrievedUITypeDefinition.TypeName);
            Assert.AreEqual(valueForSolutionID, retrievedUITypeDefinition.SolutionID);
            Assert.AreEqual(valueForTypeDescriminator, retrievedUITypeDefinition.TypeDescriminator);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            uITypeDefinition.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            uITypeDefinition.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SolutionID = (System.Guid) valueForSolutionID;
            object valueForTypeDescriminator = TestUtils.GetRandomString();
            uITypeDefinition.TypeDescriminator = (System.String) valueForTypeDescriminator;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uITypeDefinition.AssemblyName);
            Assert.AreEqual(valueForTypeName, uITypeDefinition.TypeName);
            Assert.AreEqual(valueForSolutionID, uITypeDefinition.SolutionID);
            Assert.AreEqual(valueForTypeDescriminator, uITypeDefinition.TypeDescriminator);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();
            uITypeDefinition.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtils.GetRandomString();
            uITypeDefinition.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SolutionID = (System.Guid) valueForSolutionID;
            object valueForTypeDescriminator = TestUtils.GetRandomString();
            uITypeDefinition.TypeDescriminator = (System.String) valueForTypeDescriminator;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uITypeDefinition.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForTypeName, uITypeDefinition.GetPropertyValue("TypeName"));
            Assert.AreEqual(valueForSolutionID, uITypeDefinition.GetPropertyValue("SolutionID"));
            Assert.AreEqual(valueForTypeDescriminator, uITypeDefinition.GetPropertyValue("TypeDescriminator"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtils.GetRandomString();            
            uITypeDefinition.SetPropertyValue("AssemblyName", valueForAssemblyName);
            object valueForTypeName = TestUtils.GetRandomString();            
            uITypeDefinition.SetPropertyValue("TypeName", valueForTypeName);
            object valueForSolutionID = TestUtils.CreateSavedDMSolution().SolutionID;            
            uITypeDefinition.SetPropertyValue("SolutionID", valueForSolutionID);
            object valueForTypeDescriminator = TestUtils.GetRandomString();            
            uITypeDefinition.SetPropertyValue("TypeDescriminator", valueForTypeDescriminator);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uITypeDefinition.AssemblyName);
            Assert.AreEqual(valueForTypeName, uITypeDefinition.TypeName);
            Assert.AreEqual(valueForSolutionID, uITypeDefinition.SolutionID);
            Assert.AreEqual(valueForTypeDescriminator, uITypeDefinition.TypeDescriminator);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITypeDefinition.TypeDescriminator = null;
            uITypeDefinition.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            UITypeDefinition retrievedUITypeDefinition =
                    Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
            
            Assert.IsNull(retrievedUITypeDefinition.TypeDescriminator);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITypeDefinition uITypeDefinition = TestUtils.CreateUnsavedValidUITypeDefinition();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITypeDefinition.UITypeDefinitionID = null;
            uITypeDefinition.AssemblyName = null;
            uITypeDefinition.TypeName = null;
            uITypeDefinition.SolutionID = null;
            
            try
            {
                uITypeDefinition.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'U I Type Definition I D' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Assembly Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Type Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'Solution' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UITypeDefinition>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UITypeDefinitionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TypeName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TypeDescriminator"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();

            FireStarterModeller.BO.DMSolution boForRelationshipSolution = TestUtils.CreateSavedDMSolution();
            uITypeDefinition.Solution = boForRelationshipSolution;
            uITypeDefinition.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMSolution loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMSolution>(boForRelationshipSolution.ID);
            UITypeDefinition loadedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedUITypeDefinition.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedUITypeDefinition.Solution);
            Assert.AreEqual(loadedRelatedBO, uITypeDefinition.Solution);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIGridFilterProps()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();

            FireStarterModeller.BO.UIGridFilterProp boForRelationshipUIGridFilterProps = TestUtils.CreateUnsavedValidUIGridFilterProp();
            boForRelationshipUIGridFilterProps.FilterControlTypeID = uITypeDefinition.UITypeDefinitionID;
            boForRelationshipUIGridFilterProps.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtils.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uITypeDefinition.UIGridFilterProps.Count);
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.UIGridFilterProp loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.UIGridFilterProp>(boForRelationshipUIGridFilterProps.ID);
            UITypeDefinition loadedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUITypeDefinition.UIGridFilterProps.Count);
            Assert.AreEqual(boForRelationshipUIGridFilterProps, loadedUITypeDefinition.UIGridFilterProps[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUITypeDefinition.UIGridFilterProps[0]);
            Assert.AreEqual(loadedRelatedBO, uITypeDefinition.UIGridFilterProps[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UIGridFilterProps()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtils.CreateSavedUITypeDefinition();

            FireStarterModeller.BO.UIGridFilterProp boForRelationshipUIGridFilterProps = TestUtils.CreateUnsavedValidUIGridFilterProp();
            boForRelationshipUIGridFilterProps.FilterControlTypeID = uITypeDefinition.UITypeDefinitionID;
            boForRelationshipUIGridFilterProps.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uITypeDefinition.UIGridFilterProps.Count);
            RelationshipDef relationshipDef = ClassDef.Get<UITypeDefinition>().RelationshipDefCol["UIGridFilterProps"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                uITypeDefinition.Delete();
                uITypeDefinition.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'UIGridFilterProps' relationship that need to be deleted first"));
        }
        
        
        
        
        
       
    }
}
