using Firestarter.Test.Base;
using FireStarterModeller.Logic;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using Habanero.Test.BO.Loaders;
using NUnit.Framework;

namespace FireStarterModeller.Test.Logic.Loaders
{
    [TestFixture]
    public class TestDMXmlRelationshipLoader : TestXmlRelationshipLoader
    {
        [SetUp]
        public override void SetupTest()
        {
            //Runs every time that any testmethod is executed
            //base.SetupTest(); 
            TestUtilsDomain.SetupFixture();
            TestUtilsDomain.SetupTest();
            BORegistry.DataAccessor = new DataAccessorInMemory();

            base.Initialise();
        }

        [TestFixtureSetUp]
        public void TestFixtureSetup()
        {
            //Code that is executed before any test is run in this class. If multiple tests
            // are executed then it will still only be called once.
            TestUtilsDomain.SetupFixture();
        }

        [TearDown]
        public void TearDownTest()
        {
            //runs every time any testmethod is complete
        }

        protected override IDefClassFactory GetDefClassFactory()
        {
            return new FMDefClassFactory(TestUtilsShared.CreateUnsavedValidDMSolution());
        }

        [Test, Ignore("FireStarter doesn't support importing classdefs with type parameters.")]
        public override void Test_WithTypeParameter()
        {

        }

        [Test, Ignore("OwningBOHasForeignKey is calculated in FS, so this test will not apply")]
        public override void Test_OwningBOHasForeignKey_Default_Single()
        {
            
        }
    }
}