using System;
using System.Drawing;
using FireStarter.Base;
using FireStarterModeller.BO;
using FireStarterModeller.Logic;
using Habanero.Base;
using Habanero.Faces.Base;
using Habanero.Faces.Win;
using Habanero.Util;

namespace FireStarterModeller.UI.ViewEditor
{
    public class XmlUIViewsEditorControl : UserControlWin, IUIViewsEditor
    {
        public IControlFactory ControlFactory { get; private set; }

        public IUIViewsEditorControl UIViewsEditorControl { get; internal set; }
        public IUIViewSelectorControl UIViewSelectorControl { get; internal set;}
        public IUIXmlEditorControl UIXmlEditorControl { get; internal set; }
        public IFireStarterFormsController FormsController { get; private set; }

        public XmlUIViewsEditorControl(IControlFactory controlFactory, IFireStarterFormsController formsController)
        {
            ControlFactory = controlFactory;
            FormsController = formsController;
            //XmlTextEditor xmlTextEditor = new CrossThreadRunner().RunInSTA(() => new XmlTextEditor());
            //UIXmlEditorControl uiXMLEditorControl = new UIXmlEditorControl(ControlFactory,
            //                                                               new DMToClassDefsXmlConverter(),
            //                                                               xmlTextEditor);
            //ScintillaWinXmlEditor scintilla = new CrossThreadRunner().RunInSTA(() => new ScintillaWinXmlEditor());
            //ScintillaWinXmlEditor scintilla = new ScintillaWinXmlEditor();
            //textBox.Multiline = true;
            //textBox.ScrollBars = ScrollBars.Both;
            //((TextBoxWin) textBox).WordWrap = false;
            //textBox.Font = new Font("Courier new", 9, FontStyle.Regular);
            UIXmlEditorControl = new UIXmlEditorControl(ControlFactory,
                                                                           new DMToClassDefsXmlConverter(),
                                                                           formsController.CreateXmlEditor());
            UIPreviewControl uiPreviewControl = new UIPreviewControl(ControlFactory);
            UIViewSelectorControl = new UIViewSelectorControl(ControlFactory, new DMToClassDefsXmlConverter());
            IConverter<DMSolution, ClassDefCol> converter = new DMToEntityClassDefsConverter();
            this.UIViewsEditorControl = new UIViewsEditorControl(ControlFactory, formsController, UIXmlEditorControl,
                                                                 uiPreviewControl, UIViewSelectorControl, converter);
            BorderLayoutManager layoutManager = ControlFactory.CreateBorderLayoutManager(this);
            layoutManager.AddControl(this.UIViewsEditorControl, BorderLayoutManager.Position.Centre);
            this.Enabled = false;
        }

        public void EditUIViews(DMClass dmClass)
        {
            this.Enabled = (dmClass != null);
            if (dmClass == null) return;
            this.UIViewsEditorControl.EditUIViews(dmClass.UIViews);
        }
    }
}