using FireStarterModeller.BO;
using FireStarterModeller.Logic;
using Habanero.Faces.Base;

namespace FireStarterModeller.UI
{
    /// <summary>
    /// A Wizard Controller that creates the Filter definition for a grid.
    /// </summary>
    public class CreateGridFilterWizardController : WizardController
    {
        private readonly SelectPropertiesFilterWizardStep _selectPropertiesWizardStep;

        public CreateGridFilterWizardController()
        {
            _selectPropertiesWizardStep = new SelectPropertiesFilterWizardStep();
            AddStep(_selectPropertiesWizardStep);
            _selectPropertiesWizardStep.Label.Text = "1. Select filters for the grid definition of the selected entity.";
        }

        public UIGridFilter GridFilter { get; private set; }

        public DMClass Class
        {
            get { return _selectPropertiesWizardStep.SelectedClass; }
            set { _selectPropertiesWizardStep.SelectedClass = value; }
        }

        public DMSolution Solution
        {
            get { return _selectPropertiesWizardStep.Solution; }
            set { _selectPropertiesWizardStep.Solution = value; }
        }

        public override void Finish()
        {
            UIGridFilterCreator gridFilterCreator = new UIGridFilterCreator(Solution);
            GridFilter = gridFilterCreator.CreateUIGridFilter(_selectPropertiesWizardStep.PropertiesSelectorControl.SelectedOptions);
            base.Finish();
        }
    }
}