// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// ------------------------------------------------------------------------------


using System;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.BO.ClassDefinition;
using Habanero.Util;

namespace Firestarter.DB.Schema.BO
{


    [Serializable]
    public partial class DBTable : IMergableBo
    {
        public DBTable(string tableName) : this()
        {
            this.TableNameDB = tableName;
        }

        public DBTable()
        {
            TableType = "BASE TABLE";
        }


        protected internal DBTable(ClassDef def) : base(def)
        {
        }

        protected DBTable(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }

        public override string ToString()
        {
            if (string.IsNullOrEmpty(TableNameDB))
            {
                return this.TableID == null ? "-unnamed table-" : Convert.ToString(this.TableID);
            }
            return this.TableNameDB;
        }

        public DBKey GetKeyInfo(string indexName)
        {
            foreach (DBKey keyInfo in Keys)
            {
                if (keyInfo.KeyName == indexName) return keyInfo;
            }
            return null;
        }

        //private void AlternatePopulateFromDataBase(IDatabaseConnection databaseConnection)
        //{
        //    IDbConnection connection = databaseConnection.GetConnection();
        //    connection.Open();
        //    IDbCommand command = connection.CreateCommand();
        //    SqlStatement sqlStatement = new SqlStatement(databaseConnection, "Select * from " + TableName);
        //    sqlStatement.SetupCommand(command);
        //    IDataReader dataReader = command.ExecuteReader(CommandBehavior.SchemaOnly);
        //    DataTable dataTable = dataReader.GetSchemaTable();
        //    foreach (DataRow row in dataTable.Rows)
        //    {
        //        Column columnInfo = new Column(Convert.ToString(SchemaUtils.Fix(row["ColumnName"])));
        //        columnInfo.DataType = Convert.ToString(SchemaUtils.Fix(row["DataType"]));
        //        columnInfo.DataLength = Convert.ToInt32(SchemaUtils.Fix(row["ColumnSize"]));
        //        columnInfo.Nullable = SchemaUtils.ConvertToBoolean((SchemaUtils.Fix(row["AllowDBNull"])));
        //        //columnInfo.DefaultValue = Convert.ToString(SchemaUtils.Fix(row["COLUMN_DEFAULT"]));
        //        this.Columns.Add(columnInfo);
        //    }
        //}

        public DBColumn GetColumnInfo(string columnName)
        {
            foreach (DBColumn columnInfo in Columns)
            {
                if (columnInfo.ColumnName == columnName) return columnInfo;
            }
            return null;
        }

        public DBForeignKey GetForeignKeyInfo(string foreignKeyName)
        {
            foreach (DBForeignKey foreignKeyInfo in ForeignKeys)
            {
                if (foreignKeyInfo.ForeignKeyName == foreignKeyName) return foreignKeyInfo;
            }
            return null;
        }

        /// <summary>
        /// Whether this change is approved to be applied to the domain model
        /// </summary>
        public bool PendingChangeApproved
        {
            get { return Approved ?? false; }
            set { Approved = value; }
        }

        public string GetClassNameFromPrimaryKey(string primaryKeyColumnSuffix)
        {
            if (primaryKeyColumnSuffix == null) primaryKeyColumnSuffix = "";
            //TODO Brett 20 Jan 2009: from some setting somewhere should this be here or check before this is called
            //            if (!_project.ProjectSettings.PascalCasebusinessObjectName) return;

            //If the class name has further upper case characters, then return
            //If the primary key has more or less than one property then we can't do anything
            if (PrimaryKeyDB == null) return null;
            if (PrimaryKeyDB.Columns.Count != 1) return null;

            DBColumn keyDBColumn = this.PrimaryKeyDB.Columns[0];
            string keyColumnName = StringUtilities.PascalCaseTableName(keyDBColumn.ColumnName);
            //string newbusinessObjectName = null;
            //if (keyColumnName.Equals(businessObjectName, StringComparison.InvariantCultureIgnoreCase))
            //{
            //    newbusinessObjectName = keyColumnName;
            //}
            if (keyColumnName.EndsWith(primaryKeyColumnSuffix, StringComparison.InvariantCultureIgnoreCase))
            {
                keyColumnName = keyColumnName.Substring
                    (0, keyColumnName.Length - primaryKeyColumnSuffix.Length);
                //if (newkeyColumnName.Equals(businessObjectName, StringComparison.InvariantCultureIgnoreCase))
                //{
                //    newbusinessObjectName = newkeyColumnName;
                //}
            }
            return keyColumnName;
        }


        public string GetClassName(string tableNamePrefix, string primaryKeyColumnSuffix)
        {
            string classNameFromTableName = GetClassNameFromTableName(tableNamePrefix);
            return ImproveClassNameUsingPrimaryKeyColumns(classNameFromTableName, primaryKeyColumnSuffix);
        }

        private string ImproveClassNameUsingPrimaryKeyColumns(string className, string primaryKeyColumnSuffix)
        {
            if (StringUtilities.IsManyPascalWords(className)) return className;
            string classNameFromPrimaryKey = GetClassNameFromPrimaryKey(primaryKeyColumnSuffix);
            if (classNameFromPrimaryKey == null) return className;
            // If the class name from the primary key is an improvement of the capitalisation of the class name,
            // then use the one with the improved capitalisation.
            int index = classNameFromPrimaryKey.IndexOf(className, 0, StringComparison.InvariantCultureIgnoreCase);
            return index < 0 ? className : classNameFromPrimaryKey.Substring(index, className.Length);
        }

        private string GetClassNameFromTableName(string tableNamePrefix)
        {
            string tableNameConverted = TableNameDB.Trim();
            tableNameConverted = StringUtilities.RemovePrefix(tableNamePrefix, tableNameConverted);
            tableNameConverted = StringUtilities.Singularize(tableNameConverted);
            tableNameConverted = StringUtilities.PascalCaseTableName(tableNameConverted);
            return tableNameConverted;
        }
    }
}