
// ------------------------------------------------------------------------------

// This class was auto-generated for use with the Habanero Enterprise Framework.

// ------------------------------------------------------------------------------


using System;
using System.Data;
using System.Runtime.Serialization;
using FireStarter.Base;
using Habanero.Base;
using Habanero.BO.ClassDefinition;
using Habanero.DB;

namespace Firestarter.DB.Schema.BO
{
    [Serializable]
    public partial class DatabaseConnectionInfo : IModelDatabaseSettings
    {
        public const string SelectVendorMessage = "Please select a database vendor and fill in the connection details.";
        public const string InvalidConnectionMessage = "Please fill in valid database connection details.\r\n" +
                                                       "An error ocurred when creating a connection for the specified vendor:";
        public const string ConnectionFailedMessage = "Connection to Database Failed. The following error was given:";

        protected internal DatabaseConnectionInfo(ClassDef def) : base(def)
        {
        }

        protected DatabaseConnectionInfo(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        public DatabaseConnectionInfo()
        {
        }

        public DatabaseConfig CreateDatabaseConfig()
        {
            return new DatabaseConfig(Vendor, Server, Database,UserName, Password, Port);
        }

        public static DatabaseConnectionInfo CreateFromDatabaseConfig(DatabaseConfig databaseConfig)
        {
            return new DatabaseConnectionInfo
                       {
                           Vendor = databaseConfig.Vendor,
                           Server = databaseConfig.Server,
                           Database = databaseConfig.Database,
                           UserName = databaseConfig.UserName,
                           Password = databaseConfig.Password
                       };
        }

        public IDatabaseConnection CreateDatabaseConnection(out string errorMessage)
        {
            IDatabaseConnection databaseConnection = null;
            errorMessage = null;
            try
            {
                databaseConnection = CreateDatabaseConnection();
            }
            catch (Exception ex)
            {
                errorMessage = ex.Message;
            }
            return databaseConnection;
        }

        private IDatabaseConnection CreateDatabaseConnection()
        {
            DatabaseConfig databaseConfig = this.CreateDatabaseConfig();
            return databaseConfig.GetDatabaseConnection();
        }

        public bool IsDatabaseConnectionValid(out string message)
        {
            
            string errorMessage;
            IDatabaseConnection databaseConnection = this.CreateDatabaseConnection(out errorMessage);
            if (!String.IsNullOrEmpty(errorMessage))
            {
                message = InvalidConnectionMessage;
                message += Environment.NewLine + errorMessage;
                return false;
            }
            if (databaseConnection == null)
            {
                message = SelectVendorMessage;
                return false;
            }
            try
            {
                IDbConnection connection = databaseConnection.GetConnection();
                connection.Open();
            }
            catch (Exception ex)
            {
                message = ConnectionFailedMessage;
                message += Environment.NewLine + ex.Message;
                return false;
            }
            message = null;
            return string.IsNullOrEmpty(message);
        }

        public override string ToString()
        {
            return this.Vendor + "-" + this.Server + "-" + this.Database + "-" + this.UserName; 
        }

        public IModelElement Parent { get; set; }
    }
}


