namespace Firestarter.DB.Schema.Logic
{
    public class CreateTableSqlBuilder_MySql : CreateTableSqlBuilder
    {
        public CreateTableSqlBuilder_MySql(string tableName) : base(tableName)
        {
           
        }

        protected override string Enclose(string name)
        {
            return string.Format("`{0}`", name);
        }

        /// <summary>
        ///For MySQL: CONSTRAINT `FKNAME` FOREIGN KEY 'FKName' (foreignKeyColumnList) REFERENCES referencedTable(referencedTableColumnList)
        ///For SQL Server need to change to: CONSTRAINT [FK_Table_1_Table_2] FOREIGN KEY([fdafdsf])
        /// </summary>
        /// <param name="foreignKeyName"></param>
        /// <param name="parentColumnNameList"></param>
        /// <param name="referencedTableName"></param>
        /// <param name="referencedColumnNameList"></param>
        /// <returns></returns>
        public override void AddForeignKey
            (string foreignKeyName, string parentColumnNameList, string referencedTableName,
             string referencedColumnNameList)
        {
            string createForeignKeyString = string.Format
                ("CONSTRAINT {0} FOREIGN KEY {0} ({1}) REFERENCES {2} ({3})", Enclose(foreignKeyName), EncloseList(parentColumnNameList),
                 Enclose(referencedTableName), EncloseList(referencedColumnNameList));
            ForeignKeys.Add(createForeignKeyString);
            //return this;
        }

        public override void AddUniqueKey(string keyName, string columnNameList)
        {
            string createUniqueKey = string.Format("CONSTRAINT {0} UNIQUE ({1})", Enclose(keyName), EncloseList(columnNameList));
            UniqueKeys.Add(createUniqueKey);
            //return this;
        }

    }
}