// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
  
    
    // Provides the part of the test class that tests DBDatabase objects
    [TestFixture]
    public partial class TestDBDatabase : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBDatabaseWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBDatabase dBDatabase = new DBDatabase();

            //---------------Test Result -----------------------
            Assert.IsNotNull(dBDatabase.DatabaseID);
            Assert.IsInstanceOf(dBDatabase.Props["DatabaseID"].PropertyType, dBDatabase.DatabaseID);
            Assert.IsNull(dBDatabase.DatabaseName);
            Assert.IsNull(dBDatabase.Catalog);
            Assert.IsNull(dBDatabase.Schema);
            Assert.IsNotNull(dBDatabase.PendingChangeType);
            Assert.IsInstanceOf(dBDatabase.Props["PendingChangeType"].PropertyType, dBDatabase.PendingChangeType);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBDatabase()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateUnsavedValidDBDatabase();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBDatabase.Status.IsNew);
            BusinessObjectCollection<DBDatabase> col = new BusinessObjectCollection<DBDatabase>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBDatabase.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBDatabase.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBDatabase()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();

            //---------------Execute Test ----------------------
            DBDatabase loadedDBDatabase = Broker.GetBusinessObject<DBDatabase>(dBDatabase.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dBDatabase.DatabaseID, loadedDBDatabase.DatabaseID);
                        Assert.AreEqual(dBDatabase.DatabaseName, loadedDBDatabase.DatabaseName);
                        Assert.AreEqual(dBDatabase.Catalog, loadedDBDatabase.Catalog);
                        Assert.AreEqual(dBDatabase.Schema, loadedDBDatabase.Schema);
                        Assert.AreEqual(dBDatabase.PendingChangeType, loadedDBDatabase.PendingChangeType);
                        Assert.AreEqual(dBDatabase.Approved, loadedDBDatabase.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBDatabase()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBDatabase.MarkForDelete();
            dBDatabase.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DBDatabase>(dBDatabase.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBDatabase", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBDatabase()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseName = TestUtilsShared.GetRandomString(1,255);
            dBDatabase.DatabaseName = (String) valueForDatabaseName;
            object valueForCatalog = TestUtilsShared.GetRandomString();
            dBDatabase.Catalog = (String) valueForCatalog;
            object valueForSchema = TestUtilsShared.GetRandomString();
            dBDatabase.Schema = (String) valueForSchema;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBDatabase.Approved = (Boolean) valueForApproved;
            dBDatabase.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBDatabase retrievedDBDatabase =
                    Broker.GetBusinessObject<DBDatabase>(dBDatabase.ID);
            
            Assert.AreEqual(valueForDatabaseName, retrievedDBDatabase.DatabaseName);
            Assert.AreEqual(valueForCatalog, retrievedDBDatabase.Catalog);
            Assert.AreEqual(valueForSchema, retrievedDBDatabase.Schema);
            Assert.AreEqual(valueForApproved, retrievedDBDatabase.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = new DBDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseName = TestUtilsShared.GetRandomString(1,255);
            dBDatabase.DatabaseName = (System.String) valueForDatabaseName;
            object valueForCatalog = TestUtilsShared.GetRandomString();
            dBDatabase.Catalog = (System.String) valueForCatalog;
            object valueForSchema = TestUtilsShared.GetRandomString();
            dBDatabase.Schema = (System.String) valueForSchema;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBDatabase.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDatabaseName, dBDatabase.DatabaseName);
            Assert.AreEqual(valueForCatalog, dBDatabase.Catalog);
            Assert.AreEqual(valueForSchema, dBDatabase.Schema);
            Assert.AreEqual(valueForApproved, dBDatabase.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = new DBDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseName = TestUtilsShared.GetRandomString(1,255);
            dBDatabase.DatabaseName = (System.String) valueForDatabaseName;
            object valueForCatalog = TestUtilsShared.GetRandomString();
            dBDatabase.Catalog = (System.String) valueForCatalog;
            object valueForSchema = TestUtilsShared.GetRandomString();
            dBDatabase.Schema = (System.String) valueForSchema;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBDatabase.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDatabaseName, dBDatabase.GetPropertyValue("DatabaseName"));
            Assert.AreEqual(valueForCatalog, dBDatabase.GetPropertyValue("Catalog"));
            Assert.AreEqual(valueForSchema, dBDatabase.GetPropertyValue("Schema"));
            Assert.AreEqual(valueForApproved, dBDatabase.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = new DBDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDatabaseName = TestUtilsShared.GetRandomString(1,255);            
            dBDatabase.SetPropertyValue("DatabaseName", valueForDatabaseName);
            object valueForCatalog = TestUtilsShared.GetRandomString();            
            dBDatabase.SetPropertyValue("Catalog", valueForCatalog);
            object valueForSchema = TestUtilsShared.GetRandomString();            
            dBDatabase.SetPropertyValue("Schema", valueForSchema);
            
            object valueForApproved = TestUtilsShared.GetRandomBoolean();            
            dBDatabase.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDatabaseName, dBDatabase.DatabaseName);
            Assert.AreEqual(valueForCatalog, dBDatabase.Catalog);
            Assert.AreEqual(valueForSchema, dBDatabase.Schema);
            Assert.AreEqual(valueForApproved, dBDatabase.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBDatabase.Catalog = null;
            dBDatabase.Schema = null;
//            dBDatabase.PendingChangeType = null;
            dBDatabase.Approved = null;
            dBDatabase.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBDatabase retrievedDBDatabase =
                    Broker.GetBusinessObject<DBDatabase>(dBDatabase.ID);
            
            Assert.IsNull(retrievedDBDatabase.Catalog);
            Assert.IsNull(retrievedDBDatabase.Schema);
            Assert.IsNull(retrievedDBDatabase.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateUnsavedValidDBDatabase();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBDatabase.DatabaseID = null;
//            dBDatabase.DatabaseName = null;
            
            try
            {
                dBDatabase.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("FSDatabaseID' is a compulsory field and has no value", ex.Message);
//                StringAssert.Contains("Database Name' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBDatabase>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["DatabaseID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DatabaseName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Catalog"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Schema"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_StoredByReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();

            ReverseEngineering boForRelationshipStoredByReverseEngineering = TestUtilsReverseEngineering.CreateSavedReverseEngineering();
            dBDatabase.StoredByReverseEngineering = boForRelationshipStoredByReverseEngineering;
            dBDatabase.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            ReverseEngineering loadedRelatedBO = Broker.GetBusinessObject<ReverseEngineering>(boForRelationshipStoredByReverseEngineering.ID);
            DBDatabase loadedDBDatabase = Broker.GetBusinessObject<DBDatabase>(dBDatabase.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipStoredByReverseEngineering, loadedDBDatabase.StoredByReverseEngineering);
            Assert.AreEqual(loadedRelatedBO, loadedDBDatabase.StoredByReverseEngineering);
            Assert.AreEqual(loadedRelatedBO, dBDatabase.StoredByReverseEngineering);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Tables()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();

            DBTable boForRelationshipTables = TestUtilsDBTable.CreateUnsavedValidDBTable();
            boForRelationshipTables.DatabaseID = dBDatabase.DatabaseID;
            boForRelationshipTables.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBDatabase.Tables.Count);
            //---------------Execute Test ----------------------
            DBTable loadedRelatedBO = Broker.GetBusinessObject<DBTable>(boForRelationshipTables.ID);
            DBDatabase loadedDBDatabase = Broker.GetBusinessObject<DBDatabase>(dBDatabase.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBDatabase.Tables.Count);
            Assert.AreEqual(boForRelationshipTables, loadedDBDatabase.Tables[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBDatabase.Tables[0]);
            Assert.AreEqual(loadedRelatedBO, dBDatabase.Tables[0]);
        }
/*        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_Tables()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBDatabase dBDatabase = TestUtilsDBDatabase.CreateSavedDBDatabase();

            DBTable boForRelationshipTables = TestUtilsDBTable.CreateUnsavedValidDBTable();
            boForRelationshipTables.DatabaseID = dBDatabase.DatabaseID;
            boForRelationshipTables.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBDatabase.Tables.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DBDatabase>().RelationshipDefCol["Tables"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusinessObjectReferentialIntegrityException expectedException = null;
            try
            {
                dBDatabase.MarkForDelete();
                dBDatabase.Save();
            }
            catch (BusinessObjectReferentialIntegrityException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue(expectedException.Message.Contains("There are 1 objects related through the 'Tables' relationship that need to be deleted first"));
        }*/
        
        
        
        
        
       
    }
}
