// ------------------------------------------------------------------------------

// This partial class was auto-generated for use with the Habanero Architecture.

// NB Custom code should be placed in the provided stub class.

// Please do not modify this class directly!

//

// If tests are failing due to a unique condition in your application, use the

// ignore feature in the stub class SetupTestFixture() method.  Reimplement the

// test in the stub class.

// ------------------------------------------------------------------------------


using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.DB.Schema.BO;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using FireStarterModeller.Test;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;
namespace Firestarter.DB.Schema.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    
    
    // Provides the part of the test class that tests DBTable objects
    public partial class TestDBTable
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                              ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDBTableWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DBTable dBTable = new DBTable();

            //---------------Test Result -----------------------
            Assert.IsNull(dBTable.DateCreated);
            Assert.IsNull(dBTable.Owner);
            Assert.IsNull(dBTable.TableNameDB);
            Assert.IsNotNull(dBTable.TableID);
            Assert.IsInstanceOf(dBTable.Props["TableID"].PropertyType, dBTable.TableID);
            Assert.IsNull(dBTable.DatabaseID);
//                        Assert.IsNull(dBTable.TableType);
            Assert.AreEqual("BASE TABLE", dBTable.TableType);
            Assert.IsNull(dBTable.TableComment);
            Assert.IsNull(dBTable.CreateTime);
            Assert.IsNull(dBTable.UpdateTime);
            Assert.IsNotNull(dBTable.PendingChangeType);
            Assert.IsInstanceOf(dBTable.Props["PendingChangeType"].PropertyType, dBTable.PendingChangeType);
            Assert.IsNotNull(dBTable.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDBTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = TestUtilsDBTable.CreateUnsavedValidDBTable();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dBTable.Status.IsNew);
            BusinessObjectCollection<DBTable> col = new BusinessObjectCollection<DBTable>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dBTable.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dBTable.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDBTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            //---------------Execute Test ----------------------
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(dBTable.DateCreated, loadedDBTable.DateCreated);
            Assert.AreEqual(dBTable.Owner, loadedDBTable.Owner);
            Assert.AreEqual(dBTable.TableNameDB, loadedDBTable.TableNameDB);
            Assert.AreEqual(dBTable.TableID, loadedDBTable.TableID);
            Assert.AreEqual(dBTable.DatabaseID, loadedDBTable.DatabaseID);
            Assert.AreEqual(dBTable.TableType, loadedDBTable.TableType);
            Assert.AreEqual(dBTable.TableComment, loadedDBTable.TableComment);
            Assert.AreEqual(dBTable.CreateTime, loadedDBTable.CreateTime);
            Assert.AreEqual(dBTable.UpdateTime, loadedDBTable.UpdateTime);
            Assert.AreEqual(dBTable.PendingChangeType, loadedDBTable.PendingChangeType);
            Assert.AreEqual(dBTable.Approved, loadedDBTable.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDBTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBTable.MarkForDelete();
            dBTable.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DBTable>(dBTable.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DBTable", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDBTable()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDateCreated = TestUtilsShared.GetRandomDate();
            dBTable.DateCreated = (System.DateTime) valueForDateCreated;
            object valueForOwner = TestUtilsShared.GetRandomString();
            dBTable.Owner = (System.String) valueForOwner;
            object valueForTableNameDB = TestUtilsShared.GetRandomString(1,255);
            dBTable.TableNameDB = (System.String) valueForTableNameDB;
//            object valueForDatabaseID = TestUtilsDBDatabase.CreateSavedDBDatabase().DatabaseID;
//            dBTable.DatabaseID = (System.Guid) valueForDatabaseID;
            object valueForTableType = TestUtilsShared.GetRandomString();
            dBTable.TableType = (System.String) valueForTableType;
            object valueForTableComment = TestUtilsShared.GetRandomString();
            dBTable.TableComment = (System.String) valueForTableComment;
            object valueForCreateTime = TestUtilsShared.GetRandomDate();
            dBTable.CreateTime = (System.DateTime) valueForCreateTime;
            object valueForUpdateTime = TestUtilsShared.GetRandomDate();
            dBTable.UpdateTime = (System.DateTime) valueForUpdateTime;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBTable.Approved = (System.Boolean) valueForApproved;
            dBTable.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBTable retrievedDBTable =
                Broker.GetBusinessObject<DBTable>(dBTable.ID);
            
            Assert.AreEqual(valueForDateCreated, retrievedDBTable.DateCreated);
            Assert.AreEqual(valueForOwner, retrievedDBTable.Owner);
            Assert.AreEqual(valueForTableNameDB, retrievedDBTable.TableNameDB);
//            Assert.AreEqual(valueForDatabaseID, retrievedDBTable.DatabaseID);
            Assert.AreEqual(valueForTableType, retrievedDBTable.TableType);
            Assert.AreEqual(valueForTableComment, retrievedDBTable.TableComment);
            Assert.AreEqual(valueForCreateTime, retrievedDBTable.CreateTime);
            Assert.AreEqual(valueForUpdateTime, retrievedDBTable.UpdateTime);
            Assert.AreEqual(valueForApproved, retrievedDBTable.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = new DBTable();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDateCreated = TestUtilsShared.GetRandomDate();
            dBTable.DateCreated = (System.DateTime) valueForDateCreated;
            object valueForOwner = TestUtilsShared.GetRandomString();
            dBTable.Owner = (System.String) valueForOwner;
            object valueForTableNameDB = TestUtilsShared.GetRandomString(1,255);
            dBTable.TableNameDB = (System.String) valueForTableNameDB;
            object valueForDatabaseID = TestUtilsDBDatabase.CreateSavedDBDatabase().DatabaseID;
            dBTable.DatabaseID = (System.Guid?) valueForDatabaseID;
            object valueForTableType = TestUtilsShared.GetRandomString();
            dBTable.TableType = (System.String) valueForTableType;
            object valueForTableComment = TestUtilsShared.GetRandomString();
            dBTable.TableComment = (System.String) valueForTableComment;
            object valueForCreateTime = TestUtilsShared.GetRandomDate();
            dBTable.CreateTime = (System.DateTime) valueForCreateTime;
            object valueForUpdateTime = TestUtilsShared.GetRandomDate();
            dBTable.UpdateTime = (System.DateTime) valueForUpdateTime;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBTable.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDateCreated, dBTable.DateCreated);
            Assert.AreEqual(valueForOwner, dBTable.Owner);
            Assert.AreEqual(valueForTableNameDB, dBTable.TableNameDB);
            Assert.AreEqual(valueForDatabaseID, dBTable.DatabaseID);
            Assert.AreEqual(valueForTableType, dBTable.TableType);
            Assert.AreEqual(valueForTableComment, dBTable.TableComment);
            Assert.AreEqual(valueForCreateTime, dBTable.CreateTime);
            Assert.AreEqual(valueForUpdateTime, dBTable.UpdateTime);
            Assert.AreEqual(valueForApproved, dBTable.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = new DBTable();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDateCreated = TestUtilsShared.GetRandomDate();
            dBTable.DateCreated = (System.DateTime) valueForDateCreated;
            object valueForOwner = TestUtilsShared.GetRandomString();
            dBTable.Owner = (System.String) valueForOwner;
            object valueForTableNameDB = TestUtilsShared.GetRandomString(1,255);
            dBTable.TableNameDB = (System.String) valueForTableNameDB;
            object valueForDatabaseID = TestUtilsDBDatabase.CreateSavedDBDatabase().DatabaseID;
            dBTable.DatabaseID = (System.Guid?) valueForDatabaseID;
            object valueForTableType = TestUtilsShared.GetRandomString();
            dBTable.TableType = (System.String) valueForTableType;
            object valueForTableComment = TestUtilsShared.GetRandomString();
            dBTable.TableComment = (System.String) valueForTableComment;
            object valueForCreateTime = TestUtilsShared.GetRandomDate();
            dBTable.CreateTime = (System.DateTime) valueForCreateTime;
            object valueForUpdateTime = TestUtilsShared.GetRandomDate();
            dBTable.UpdateTime = (System.DateTime) valueForUpdateTime;

            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            dBTable.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDateCreated, dBTable.GetPropertyValue("DateCreated"));
            Assert.AreEqual(valueForOwner, dBTable.GetPropertyValue("Owner"));
            Assert.AreEqual(valueForTableNameDB, dBTable.GetPropertyValue("TableNameDB"));
            Assert.AreEqual(valueForDatabaseID, dBTable.GetPropertyValue("DatabaseID"));
            Assert.AreEqual(valueForTableType, dBTable.GetPropertyValue("TableType"));
            Assert.AreEqual(valueForTableComment, dBTable.GetPropertyValue("TableComment"));
            Assert.AreEqual(valueForCreateTime, dBTable.GetPropertyValue("CreateTime"));
            Assert.AreEqual(valueForUpdateTime, dBTable.GetPropertyValue("UpdateTime"));
            Assert.AreEqual(valueForApproved, dBTable.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = new DBTable();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDateCreated = TestUtilsShared.GetRandomDate();            
            dBTable.SetPropertyValue("DateCreated", valueForDateCreated);
            object valueForOwner = TestUtilsShared.GetRandomString();            
            dBTable.SetPropertyValue("Owner", valueForOwner);
            object valueForTableNameDB = TestUtilsShared.GetRandomString(1,255);            
            dBTable.SetPropertyValue("TableNameDB", valueForTableNameDB);
            object valueForDatabaseID = TestUtilsDBDatabase.CreateSavedDBDatabase().DatabaseID;            
            dBTable.SetPropertyValue("DatabaseID", valueForDatabaseID);
            object valueForTableType = TestUtilsShared.GetRandomString();            
            dBTable.SetPropertyValue("TableType", valueForTableType);
            object valueForTableComment = TestUtilsShared.GetRandomString();            
            dBTable.SetPropertyValue("TableComment", valueForTableComment);
            object valueForCreateTime = TestUtilsShared.GetRandomDate();            
            dBTable.SetPropertyValue("CreateTime", valueForCreateTime);
            object valueForUpdateTime = TestUtilsShared.GetRandomDate();            
            dBTable.SetPropertyValue("UpdateTime", valueForUpdateTime);
            
            object valueForApproved = TestUtilsShared.GetRandomBoolean();            
            dBTable.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDateCreated, dBTable.DateCreated);
            Assert.AreEqual(valueForOwner, dBTable.Owner);
            Assert.AreEqual(valueForTableNameDB, dBTable.TableNameDB);
            Assert.AreEqual(valueForDatabaseID, dBTable.DatabaseID);
            Assert.AreEqual(valueForTableType, dBTable.TableType);
            Assert.AreEqual(valueForTableComment, dBTable.TableComment);
            Assert.AreEqual(valueForCreateTime, dBTable.CreateTime);
            Assert.AreEqual(valueForUpdateTime, dBTable.UpdateTime);
            Assert.AreEqual(valueForApproved, dBTable.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBTable.DateCreated = null;
            dBTable.Owner = null;
            dBTable.TableType = null;
            dBTable.TableComment = null;
            dBTable.CreateTime = null;
            dBTable.UpdateTime = null;
//            dBTable.PendingChangeType = null;
            dBTable.Approved = null;
            dBTable.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DBTable retrievedDBTable =
                Broker.GetBusinessObject<DBTable>(dBTable.ID);
            
            Assert.IsNull(retrievedDBTable.DateCreated);
            Assert.IsNull(retrievedDBTable.Owner);
            Assert.IsNull(retrievedDBTable.TableType);
            Assert.IsNull(retrievedDBTable.TableComment);
            Assert.IsNull(retrievedDBTable.CreateTime);
            Assert.IsNull(retrievedDBTable.UpdateTime);
            Assert.IsNull(retrievedDBTable.Approved);
        }

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateUnsavedValidDBTable();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dBTable.TableNameDB = null;
            dBTable.TableID = null;
            dBTable.DatabaseID = null;
            
            try
            {
                dBTable.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
                //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Table Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("TableID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("DatabaseID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DBTable>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DateCreated"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Owner"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableNameDB"].ReadWriteRule.ToString());
            Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["TableID"].ReadWriteRule.ToString());
            Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["DatabaseID"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableType"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["TableComment"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["CreateTime"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UpdateTime"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PendingChangeType"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Database()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            DBDatabase boForRelationshipDatabase = dBTable.Database;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBDatabase loadedRelatedBO = Broker.GetBusinessObject<DBDatabase>(boForRelationshipDatabase.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipDatabase, loadedDBTable.Database);
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.Database);
            Assert.AreEqual(loadedRelatedBO, dBTable.Database);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_MappedDMClass()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            FireStarterModeller.BO.DMClass boForRelationshipMappedDMClass = TestUtilsShared.CreateSavedDMClass();
            dBTable.SetMappedDMClass(boForRelationshipMappedDMClass);
            dBTable.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.DMClass loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.DMClass>(boForRelationshipMappedDMClass.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipMappedDMClass, loadedDBTable.GetMappedDMClass());
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.GetMappedDMClass());
            Assert.AreEqual(loadedRelatedBO, dBTable.GetMappedDMClass());
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_PrimaryKeyDB()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            DBPrimaryKey boForRelationshipPrimaryKeyDB = TestUtilsDBPrimaryKey.CreateSavedDBPrimaryKey();
            dBTable.PrimaryKeyDB = boForRelationshipPrimaryKeyDB;
            dBTable.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DBPrimaryKey loadedRelatedBO = Broker.GetBusinessObject<DBPrimaryKey>(boForRelationshipPrimaryKeyDB.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipPrimaryKeyDB, loadedDBTable.PrimaryKeyDB);
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.PrimaryKeyDB);
            Assert.AreEqual(loadedRelatedBO, dBTable.PrimaryKeyDB);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Columns()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            DBColumn boForRelationshipColumns = TestUtilsDBColumn.CreateUnsavedValidDBColumn();
            boForRelationshipColumns.TableID = dBTable.TableID;
            boForRelationshipColumns.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBTable.Columns.Count);
            //---------------Execute Test ----------------------
            DBColumn loadedRelatedBO = Broker.GetBusinessObject<DBColumn>(boForRelationshipColumns.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBTable.Columns.Count);
            Assert.AreEqual(boForRelationshipColumns, loadedDBTable.Columns[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.Columns[0]);
            Assert.AreEqual(loadedRelatedBO, dBTable.Columns[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ForeignKeys()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            DBForeignKey boForRelationshipForeignKeys = TestUtilsDBForeignKey.CreateUnsavedValidDBForeignKey();
            boForRelationshipForeignKeys.ParentTableID = dBTable.TableID;
            boForRelationshipForeignKeys.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBTable.ForeignKeys.Count);
            //---------------Execute Test ----------------------
            DBForeignKey loadedRelatedBO = Broker.GetBusinessObject<DBForeignKey>(boForRelationshipForeignKeys.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBTable.ForeignKeys.Count);
            Assert.AreEqual(boForRelationshipForeignKeys, loadedDBTable.ForeignKeys[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.ForeignKeys[0]);
            Assert.AreEqual(loadedRelatedBO, dBTable.ForeignKeys[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Keys()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            DBKey boForRelationshipKeys = TestUtilsDBKey.CreateUnsavedValidDBKey();
            boForRelationshipKeys.TableID = dBTable.TableID;
            boForRelationshipKeys.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBTable.Keys.Count);
            //---------------Execute Test ----------------------
            DBKey loadedRelatedBO = Broker.GetBusinessObject<DBKey>(boForRelationshipKeys.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBTable.Keys.Count);
            Assert.AreEqual(boForRelationshipKeys, loadedDBTable.Keys[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.Keys[0]);
            Assert.AreEqual(loadedRelatedBO, dBTable.Keys[0]);
        }
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_RelatedForeignKeys()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DBTable dBTable = TestUtilsDBTable.CreateSavedDBTable();

            DBForeignKey boForRelationshipRelatedForeignKeys = TestUtilsDBForeignKey.CreateUnsavedValidDBForeignKey();
            boForRelationshipRelatedForeignKeys.RelatedTableID = dBTable.TableID;
            boForRelationshipRelatedForeignKeys.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, dBTable.RelatedForeignKeys.Count);
            //---------------Execute Test ----------------------
            DBForeignKey loadedRelatedBO = Broker.GetBusinessObject<DBForeignKey>(boForRelationshipRelatedForeignKeys.ID);
            DBTable loadedDBTable = Broker.GetBusinessObject<DBTable>(dBTable.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDBTable.RelatedForeignKeys.Count);
            Assert.AreEqual(boForRelationshipRelatedForeignKeys, loadedDBTable.RelatedForeignKeys[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDBTable.RelatedForeignKeys[0]);
            Assert.AreEqual(loadedRelatedBO, dBTable.RelatedForeignKeys[0]);
        }
        // ReSharper restore RedundantNameQualifier
    }
}


