﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using FireStarter.Base;
using Firestarter.DB.Schema.BO;
using Firestarter.DB.Schema.Logic;
using Firestarter.DB_DomainModel.Logic.Test;
using FireStarterModeller.BO;
using FireStarterModeller.Test;
using FireStarterModeller.Test.BO;
using NUnit.Framework;
using Rhino.Mocks;

namespace Firestarter.DB_DomainModel.Logic.Test.DBChangesImporterTests
{
    [TestFixture]
    //There are also corresponding test classes for the Change Types of Add, Update, Delete and None.
    public class TestDBChangesImporter : TestBase
    {
        //TODO Mark 30 Jul 2009: Implement the following Stories:
        //Story: Need to test the secenario where the database is empty
        //Story: Need to test that the Errors collection does not return null.

        [Test]
        public void Test_ImportDBChanges_WhenAddedDatabase_ShouldSetDatabaseToUnchanged()
        {
            //---------------Set up test pack-------------------
            IDBDatabase database = new DBDatabase().ApproveForAdd();
            DMSolution solution = TestUtilsDMSolution.CreateUnsavedValidDMSolution();
            DBChangesImporter importer = TestUtilsDBChangesImporter.CreateDBChangesImporter();
            //---------------Assert Precondition----------------
            database.AssertIsStillApprovedAndPendingChangeTypeIs(ChangeType.Add);
            //---------------Execute Test ----------------------
            importer.ImportDBChanges(database, solution);
            //---------------Test Result -----------------------
            database.AssertIsBackToApprovedAndPendingChangeTypeIsNone();
        }
    }
}