// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample DMLookupListBusinessObject objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public partial class TestUtilsDMBusinessObjectLookupList
    {
        /// <summary>
        /// Creates a new saved DMLookupListBusinessObject with a random value assigned to every property
        /// </summary>
        public static DMLookupListBusinessObject CreateSavedDMBusinessObjectLookupList()
		{
		    DMLookupListBusinessObject dMObjectLookupListBusinessObject = CreateUnsavedValidDMBusinessObjectLookupList();
			dMObjectLookupListBusinessObject.Save();
			return dMObjectLookupListBusinessObject;
		}

        /// <summary>
        /// Creates a new unsaved DMLookupListBusinessObject with a random value assigned to every property
        /// </summary>
		public static DMLookupListBusinessObject CreateUnsavedValidDMBusinessObjectLookupList()
		{
			DMLookupListBusinessObject dMObjectLookupListBusinessObject = new DMLookupListBusinessObject();
            DMClass dmClass = TestUtilsDMClass.CreateUnsavedValidDMClass();
            dMObjectLookupListBusinessObject.DMClass = dmClass;
			dMObjectLookupListBusinessObject.AssemblyName = TestUtilsShared.GetRandomString();
			dMObjectLookupListBusinessObject.Criteria = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.DMProperty = TestUtilsDMProperty.CreateUnsavedValidDMProperty();
			dMObjectLookupListBusinessObject.Generated = TestUtilsShared.GetRandomBoolean();
			return dMObjectLookupListBusinessObject;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMLookupListBusinessObject where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMLookupListBusinessObject CreateUnsavedDefaultDMBusinessObjectLookupList()
		{
			DMLookupListBusinessObject dMObjectLookupListBusinessObject = new DMLookupListBusinessObject();
			return dMObjectLookupListBusinessObject;
		}
    }
    
    // Provides the part of the test class that tests DMLookupListBusinessObject objects
    [TestFixture]
    public partial class TestDMLookupListBusinessObject : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMBusinessObjectLookupListWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = new DMLookupListBusinessObject();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMObjectLookupListBusinessObject.BusinessObjectLookupListID);
            Assert.IsInstanceOf(dMObjectLookupListBusinessObject.Props["BusinessObjectLookupListID"].PropertyType, dMObjectLookupListBusinessObject.BusinessObjectLookupListID);
                        Assert.IsNull(dMObjectLookupListBusinessObject.DMClass);
                        Assert.IsNull(dMObjectLookupListBusinessObject.AssemblyName);
                        Assert.IsNull(dMObjectLookupListBusinessObject.Criteria);
                        Assert.IsNull(dMObjectLookupListBusinessObject.DMProperty);
                        Assert.IsNotNull(dMObjectLookupListBusinessObject.LookupListID);
            Assert.IsInstanceOf(dMObjectLookupListBusinessObject.Props["LookupListID"].PropertyType, dMObjectLookupListBusinessObject.LookupListID);
                        Assert.IsNotNull(dMObjectLookupListBusinessObject.Generated);
            Assert.IsInstanceOf(dMObjectLookupListBusinessObject.Props["Generated"].PropertyType, dMObjectLookupListBusinessObject.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMBusinessObjectLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateUnsavedValidDMBusinessObjectLookupList();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMObjectLookupListBusinessObject.Status.IsNew);
            BusinessObjectCollection<DMLookupListBusinessObject> col = new BusinessObjectCollection<DMLookupListBusinessObject>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMObjectLookupListBusinessObject.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMObjectLookupListBusinessObject.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMBusinessObjectLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateSavedDMBusinessObjectLookupList();

            //---------------Execute Test ----------------------
            DMLookupListBusinessObject loadedDMObjectLookupListBusinessObject = Broker.GetBusinessObject<DMLookupListBusinessObject>(dMObjectLookupListBusinessObject.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMObjectLookupListBusinessObject.BusinessObjectLookupListID, loadedDMObjectLookupListBusinessObject.BusinessObjectLookupListID);
                        Assert.AreEqual(dMObjectLookupListBusinessObject.DMClass, loadedDMObjectLookupListBusinessObject.DMClass);
                        Assert.AreEqual(dMObjectLookupListBusinessObject.AssemblyName, loadedDMObjectLookupListBusinessObject.AssemblyName);
                        Assert.AreEqual(dMObjectLookupListBusinessObject.Criteria, loadedDMObjectLookupListBusinessObject.Criteria);
                        Assert.AreEqual(dMObjectLookupListBusinessObject.DMProperty, loadedDMObjectLookupListBusinessObject.DMProperty);
                        Assert.AreEqual(dMObjectLookupListBusinessObject.LookupListID, loadedDMObjectLookupListBusinessObject.LookupListID);
                        Assert.AreEqual(dMObjectLookupListBusinessObject.Generated, loadedDMObjectLookupListBusinessObject.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMBusinessObjectLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateSavedDMBusinessObjectLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectLookupListBusinessObject.MarkForDelete();
            dMObjectLookupListBusinessObject.Save();
            //---------------Test Result -----------------------
            try
            {
                DMLookupListBusinessObject retrievedDMObjectLookupListBusinessObject = Broker.GetBusinessObject<DMLookupListBusinessObject>(dMObjectLookupListBusinessObject.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMLookupListBusinessObject", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMBusinessObjectLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateSavedDMBusinessObjectLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLookupClassID = TestUtilsDMClass.CreateSavedDMClass().ClassID;
            dMObjectLookupListBusinessObject.ClassID = (Guid)valueForLookupClassID;
            object valueForAssembly = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.AssemblyName = (System.String) valueForAssembly;
            object valueForCriteria = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.Criteria = (System.String) valueForCriteria;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMObjectLookupListBusinessObject.Generated = (System.Boolean) valueForGenerated;
            dMObjectLookupListBusinessObject.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupListBusinessObject retrievedDMObjectLookupListBusinessObject =
                    Broker.GetBusinessObject<DMLookupListBusinessObject>(dMObjectLookupListBusinessObject.ID);
            
            Assert.AreEqual(valueForLookupClassID, retrievedDMObjectLookupListBusinessObject.DMClass.ClassID);
            Assert.AreEqual(valueForAssembly, retrievedDMObjectLookupListBusinessObject.AssemblyName);
            Assert.AreEqual(valueForCriteria, retrievedDMObjectLookupListBusinessObject.Criteria);
            Assert.AreEqual(valueForGenerated, retrievedDMObjectLookupListBusinessObject.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = new DMLookupListBusinessObject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLookupClassID = TestUtilsDMClass.CreateSavedDMClass().ClassID;
            dMObjectLookupListBusinessObject.ClassID = (Guid)valueForLookupClassID;
            object valueForAssembly = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.AssemblyName = (System.String) valueForAssembly;
            object valueForCriteria = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.Criteria = (System.String) valueForCriteria;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMObjectLookupListBusinessObject.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForLookupClassID, dMObjectLookupListBusinessObject.DMClass.ClassID);
            Assert.AreEqual(valueForAssembly, dMObjectLookupListBusinessObject.AssemblyName);
            Assert.AreEqual(valueForCriteria, dMObjectLookupListBusinessObject.Criteria);
            Assert.AreEqual(valueForGenerated, dMObjectLookupListBusinessObject.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = new DMLookupListBusinessObject();
            DMClass dmClass = TestUtilsDMClass.CreateSavedDMClass();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLookupClassID = TestUtilsDMClass.CreateSavedDMClass().ClassID;
            dMObjectLookupListBusinessObject.ClassID = (Guid) valueForLookupClassID;
            object valueForAssembly = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.AssemblyName = (System.String) valueForAssembly;
            object valueForCriteria = TestUtilsShared.GetRandomString();
            dMObjectLookupListBusinessObject.Criteria = (System.String) valueForCriteria;
            object valueForSortPropertyID = TestUtilsDMProperty.CreateUnsavedValidDMProperty().PropertyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForLookupClassID, dMObjectLookupListBusinessObject.GetPropertyValue("ClassID"));
            Assert.AreEqual(valueForAssembly, dMObjectLookupListBusinessObject.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForCriteria, dMObjectLookupListBusinessObject.GetPropertyValue("Criteria"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = new DMLookupListBusinessObject();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForLookupClassID = TestUtilsDMClass.CreateSavedDMClass().ClassID;
            dMObjectLookupListBusinessObject.SetPropertyValue("ClassID", valueForLookupClassID);
            object valueForAssembly = TestUtilsShared.GetRandomString();            
            dMObjectLookupListBusinessObject.SetPropertyValue("AssemblyName", valueForAssembly);
            object valueForCriteria = TestUtilsShared.GetRandomString();            
            dMObjectLookupListBusinessObject.SetPropertyValue("Criteria", valueForCriteria);
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForLookupClassID, dMObjectLookupListBusinessObject.DMClass.ClassID);
            Assert.AreEqual(valueForAssembly, dMObjectLookupListBusinessObject.AssemblyName);
            Assert.AreEqual(valueForCriteria, dMObjectLookupListBusinessObject.Criteria);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateSavedDMBusinessObjectLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectLookupListBusinessObject.Criteria = null;
            dMObjectLookupListBusinessObject.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupListBusinessObject retrievedDMObjectLookupListBusinessObject =
                    Broker.GetBusinessObject<DMLookupListBusinessObject>(dMObjectLookupListBusinessObject.ID);
            
            Assert.IsNull(retrievedDMObjectLookupListBusinessObject.Criteria);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateUnsavedValidDMBusinessObjectLookupList();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectLookupListBusinessObject.BusinessObjectLookupListID = null;
            dMObjectLookupListBusinessObject.DMClass = null;
            dMObjectLookupListBusinessObject.AssemblyName = null;
            dMObjectLookupListBusinessObject.LookupListID = null;
            dMObjectLookupListBusinessObject.Generated = null;
            
            try
            {
                dMObjectLookupListBusinessObject.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Business Object Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("'DMLookupListBusinessObject.Class ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMLookupListBusinessObject>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["BusinessObjectLookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Criteria"].ReadWriteRule.ToString());
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
       
        [Test]
        public void Test_Inheritance_SuperClassDef_Exists()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ISuperClassDef superClassDef = ClassDef.Get<DMLookupListBusinessObject>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.IsNotNull(superClassDef);
        }

        [Test]  
        public void Test_Inheritance_SuperClassDef_PropertiesCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = (SuperClassDef) ClassDef.Get<DMLookupListBusinessObject>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.AreEqual("DMLookupList", superClassDef.ClassName);
            Assert.AreEqual("FireStarterModeller.BO", superClassDef.AssemblyName);
            Assert.IsNull(superClassDef.ID);
        }
		
        [Test]
        public void Test_Inheritance_SuperClassDef_RelatedClassIsCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            ClassDef classDef = ClassDef.Get<DMLookupListBusinessObject>();
            ISuperClassDef superClassDef = classDef.SuperClassDef;
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            IClassDef relatedClassDef = ClassDef.ClassDefs[superClassDef.AssemblyName, superClassDef.ClassName];
            //---------------Test Result -----------------------
            Assert.IsNotNull(relatedClassDef);
            PropDef relatedPrimaryKeyDef = (PropDef) relatedClassDef.PrimaryKeyDef[0];
            Assert.IsNotNull(relatedPrimaryKeyDef);
            PropDef propDef = (PropDef) classDef.PropDefColIncludingInheritance[relatedPrimaryKeyDef.PropertyName];
            Assert.IsNotNull(propDef, "Where no child ID match has been specified, the child must have a property with the same name and type as the parent ID");
            Assert.AreEqual(propDef.PropertyType, relatedPrimaryKeyDef.PropertyType);
        }
		
        [Test]
        public void Test_Inheritance_CodeClass_InheritsCorrectly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupListBusinessObject dMObjectLookupListBusinessObject = TestUtilsDMBusinessObjectLookupList.CreateUnsavedValidDMBusinessObjectLookupList();
            //---------------Test Result -----------------------
            Assert.IsInstanceOf(typeof(DMLookupList), dMObjectLookupListBusinessObject);
        }        
    }
}
