// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;
// ReSharper disable RedundantNameQualifier
namespace FireStarterModeller.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample DMObjectIdentity objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests DMObjectIdentity objects
    [TestFixture]
    public partial class TestDMObjectIdentity : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMObjectIdentityWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMObjectIdentity.ObjectIdentityID);
            Assert.IsInstanceOf(dMObjectIdentity.Props["ObjectIdentityID"].PropertyType, dMObjectIdentity.ObjectIdentityID);
                        Assert.IsNull(dMObjectIdentity.ClassID);
                        Assert.IsNotNull(dMObjectIdentity.IsObjectID);
            Assert.IsInstanceOf(dMObjectIdentity.Props["IsObjectID"].PropertyType, dMObjectIdentity.IsObjectID);
                        Assert.IsNotNull(dMObjectIdentity.Generated);
            Assert.IsInstanceOf(dMObjectIdentity.Props["Generated"].PropertyType, dMObjectIdentity.Generated);
                        Assert.IsNull(dMObjectIdentity.MappedPrimaryKeyID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateUnsavedValidDMObjectIdentity();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMObjectIdentity.Status.IsNew);
            BusinessObjectCollection<DMObjectIdentity> col = new BusinessObjectCollection<DMObjectIdentity>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMObjectIdentity.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMObjectIdentity.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();

            //---------------Execute Test ----------------------
            DMObjectIdentity loadedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMObjectIdentity.ObjectIdentityID, loadedDMObjectIdentity.ObjectIdentityID);
                        Assert.AreEqual(dMObjectIdentity.ClassID, loadedDMObjectIdentity.ClassID);
                        Assert.AreEqual(dMObjectIdentity.IsObjectID, loadedDMObjectIdentity.IsObjectID);
                        Assert.AreEqual(dMObjectIdentity.Generated, loadedDMObjectIdentity.Generated);
                        Assert.AreEqual(dMObjectIdentity.MappedPrimaryKeyID, loadedDMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectIdentity.MarkForDelete();
            dMObjectIdentity.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMObjectIdentity", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMObjectIdentity()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMObjectIdentity.ClassID = (System.Guid) valueForClassID;
            //object valueForIsObjectID = TestUtilsShared.GetRandomBoolean();
            object valueForIsObjectID = false;
            dMObjectIdentity.IsObjectID = (System.Boolean) valueForIsObjectID;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMObjectIdentity.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedPrimaryKeyID = Guid.NewGuid();
            dMObjectIdentity.MappedPrimaryKeyID = (System.Guid) valueForMappedPrimaryKeyID;
            dMObjectIdentity.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMObjectIdentity retrievedDMObjectIdentity =
                    Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            
            Assert.AreEqual(valueForClassID, retrievedDMObjectIdentity.ClassID);
            Assert.AreEqual(valueForIsObjectID, retrievedDMObjectIdentity.IsObjectID);
            Assert.AreEqual(valueForGenerated, retrievedDMObjectIdentity.Generated);
            Assert.AreEqual(valueForMappedPrimaryKeyID, retrievedDMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMObjectIdentity.ClassID = (System.Guid) valueForClassID;
            object valueForIsObjectID = TestUtilsShared.GetRandomBoolean();
            dMObjectIdentity.IsObjectID = (System.Boolean) valueForIsObjectID;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMObjectIdentity.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedPrimaryKeyID = Guid.NewGuid();
            dMObjectIdentity.MappedPrimaryKeyID = (System.Guid) valueForMappedPrimaryKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMObjectIdentity.ClassID);
            Assert.AreEqual(valueForIsObjectID, dMObjectIdentity.IsObjectID);
            Assert.AreEqual(valueForGenerated, dMObjectIdentity.Generated);
            Assert.AreEqual(valueForMappedPrimaryKeyID, dMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            dMObjectIdentity.ClassID = (System.Guid) valueForClassID;
            object valueForIsObjectID = TestUtilsShared.GetRandomBoolean();
            dMObjectIdentity.IsObjectID = (System.Boolean) valueForIsObjectID;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMObjectIdentity.Generated = (System.Boolean) valueForGenerated;
            object valueForMappedPrimaryKeyID = Guid.NewGuid();
            dMObjectIdentity.MappedPrimaryKeyID = (System.Guid) valueForMappedPrimaryKeyID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMObjectIdentity.GetPropertyValue("ClassID"));
            Assert.AreEqual(valueForIsObjectID, dMObjectIdentity.GetPropertyValue("IsObjectID"));
            Assert.AreEqual(valueForGenerated, dMObjectIdentity.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForMappedPrimaryKeyID, dMObjectIdentity.GetPropertyValue("MappedPrimaryKeyID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = new DMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;            
            dMObjectIdentity.SetPropertyValue("ClassID", valueForClassID);
            object valueForIsObjectID = TestUtilsShared.GetRandomBoolean();            
            dMObjectIdentity.SetPropertyValue("IsObjectID", valueForIsObjectID);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMObjectIdentity.SetPropertyValue("Generated", valueForGenerated);
            object valueForMappedPrimaryKeyID = Guid.NewGuid();            
            dMObjectIdentity.SetPropertyValue("MappedPrimaryKeyID", valueForMappedPrimaryKeyID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForClassID, dMObjectIdentity.ClassID);
            Assert.AreEqual(valueForIsObjectID, dMObjectIdentity.IsObjectID);
            Assert.AreEqual(valueForGenerated, dMObjectIdentity.Generated);
            Assert.AreEqual(valueForMappedPrimaryKeyID, dMObjectIdentity.MappedPrimaryKeyID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectIdentity.MappedPrimaryKeyID = null;
            dMObjectIdentity.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMObjectIdentity retrievedDMObjectIdentity =
                    Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            
            Assert.IsNull(retrievedDMObjectIdentity.MappedPrimaryKeyID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateUnsavedValidDMObjectIdentity();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMObjectIdentity.ObjectIdentityID = null;
            dMObjectIdentity.ClassID = null;
            dMObjectIdentity.IsObjectID = null;
            dMObjectIdentity.Generated = null;
            
            try
            {
                dMObjectIdentity.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Object Identity ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Class ID' is a compulsory field and has no value", ex.Message);
                //StringAssert.Contains("Is Object ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMObjectIdentity>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["ObjectIdentityID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["IsObjectID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["MappedPrimaryKeyID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Class()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();

            DMClass boForRelationshipClass = dMObjectIdentity.Class;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMClass loadedRelatedBO = Broker.GetBusinessObject<DMClass>(boForRelationshipClass.ID);
            DMObjectIdentity loadedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipClass, loadedDMObjectIdentity.Class);
            Assert.AreEqual(loadedRelatedBO, loadedDMObjectIdentity.Class);
            Assert.AreEqual(loadedRelatedBO, dMObjectIdentity.Class);
        }

        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();
            dMObjectIdentity.Properties.Remove(dMObjectIdentity.Properties[0]);
            DMProperty boForRelationshipProperties = TestUtilsShared.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ObjectIdentityID = dMObjectIdentity.ObjectIdentityID;
            boForRelationshipProperties.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            BusinessObjectCollection<DMProperty> properties = dMObjectIdentity.Properties;
            properties.Refresh();
            Assert.AreEqual(1, properties.Count);
            //---------------Execute Test ----------------------
            DMProperty loadedRelatedBO = Broker.GetBusinessObject<DMProperty>(boForRelationshipProperties.ID);
            DMObjectIdentity loadedDMObjectIdentity = Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedDMObjectIdentity.Properties.Count);
            Assert.AreEqual(boForRelationshipProperties, loadedDMObjectIdentity.Properties[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMObjectIdentity.Properties[0]);
            Assert.AreEqual(loadedRelatedBO, dMObjectIdentity.Properties[0]);
        }

        [Test]
        public void Test_SaveDMObjectIdentityWithAddedProps()
        {
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateUnsavedValidDMObjectIdentity_NoDMClass();
            DMClass dmClass = TestUtilsShared.CreateUnsavedValidDMClass();
            TestUtilsShared.CreateUnsavedValidDMProperty(dmClass);
            dmClass.Save();
            dMObjectIdentity.Class = dmClass;
            BusinessObjectCollection<DMProperty> objectIDProps = dMObjectIdentity.Properties ;
            DMProperty property = dmClass.Properties[0];
            objectIDProps.Add(property);
            
            //---------------Assert Precondition----------------
            Assert.AreEqual(0, objectIDProps.PersistedBusinessObjects.Count);
            Assert.AreEqual(1, objectIDProps.AddedBusinessObjects.Count);
            Assert.AreEqual(1, objectIDProps.Count);
            //---------------Execute Test ----------------------
            dMObjectIdentity.Save();
            //---------------Test Result -----------------------
            IBOProp prop = property.Props["ObjectIdentityID"];
            Assert.AreEqual(dMObjectIdentity.ObjectIdentityID, property.ObjectIdentityID);
            Assert.AreEqual(dMObjectIdentity.ObjectIdentityID, prop.PersistedPropertyValue);

            dMObjectIdentity.Properties.Refresh();

            Assert.AreEqual(1, objectIDProps.PersistedBusinessObjects.Count);
            Assert.AreEqual(0, objectIDProps.AddedBusinessObjects.Count);
            Assert.AreEqual(1, objectIDProps.Count);
        }
        
        
        [Test]  // Checks that deleting a parent clears the related property on the child
        public void Test_MultipleRelationshipDeletion_DereferenceRelated_Properties()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMObjectIdentity dMObjectIdentity = TestUtilsDMObjectIdentity.CreateSavedDMObjectIdentity();

            DMProperty boForRelationshipProperties = TestUtilsShared.CreateUnsavedValidDMProperty();
            boForRelationshipProperties.ObjectIdentityID = dMObjectIdentity.ObjectIdentityID;
            boForRelationshipProperties.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(2, dMObjectIdentity.Properties.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<DMObjectIdentity>().RelationshipDefCol["Properties"];
            Assert.AreEqual(DeleteParentAction.DereferenceRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMObjectIdentity.MarkForDelete();
            dMObjectIdentity.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMObjectIdentity>(dMObjectIdentity.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: DMObjectIdentity"));
            }            
            
            DMProperty relatedBO = Broker.GetBusinessObject<DMProperty>(boForRelationshipProperties.ID);
            Assert.IsNull(relatedBO.ObjectIdentityID);
        }
        // ReSharper restore RedundantNameQualifier
    }
}
