// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample DMRelationshipProperty objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsDMRelationshipProperty
    {
        /// <summary>
        /// Creates a new saved DMRelationshipProperty with a random value assigned to every property
        /// </summary>
        public static DMRelationshipProperty CreateSavedDMRelationshipProperty()
		{
		    DMRelationshipProperty dMRelationshipProperty = CreateUnsavedValidDMRelationshipProperty();
			dMRelationshipProperty.Save();
			return dMRelationshipProperty;
		}

        /// <summary>
        /// Creates a new unsaved DMRelationshipProperty with a random value assigned to every property
        /// </summary>
		public static DMRelationshipProperty CreateUnsavedValidDMRelationshipProperty()
		{
            DMRelationship relationship = TestUtilsDMRelationship.CreateUnsavedValidDMRelationship();
            DMRelationshipProperty dMRelationshipProperty = relationship.RelationshipProperties.FirstOrDefault();
			return dMRelationshipProperty;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMRelationshipProperty where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMRelationshipProperty CreateUnsavedDefaultDMRelationshipProperty()
		{
			DMRelationshipProperty dMRelationshipProperty = new DMRelationshipProperty();
			return dMRelationshipProperty;
		}

        public static DMRelationshipProperty CreateUnsavedValidDMRelationshipProperty_WNullRelationship()
        {
            DMRelationshipProperty dMRelationshipProperty = new DMRelationshipProperty();
//            dMRelationshipProperty.RelatedPropertyID = TestUtilsShared.CreateSavedDMProperty().PropertyID;
            dMRelationshipProperty.Property = TestUtilsShared.CreateSavedDMProperty();
            dMRelationshipProperty.Generated = TestUtilsShared.GetRandomBoolean();
            dMRelationshipProperty.RelatedProperty = TestUtilsShared.CreateSavedDMProperty();
            return dMRelationshipProperty;
        }
    }
    
    // Provides the part of the test class that tests DMRelationshipProperty objects
    [TestFixture]
    public partial class TestDMRelationshipProperty : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// re-implement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMRelationshipPropertyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMRelationshipProperty dMRelationshipProperty = new DMRelationshipProperty();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMRelationshipProperty.RelationshipPropertyID);
            Assert.IsInstanceOf(dMRelationshipProperty.Props["RelationshipPropertyID"].PropertyType, dMRelationshipProperty.RelationshipPropertyID);
//                        Assert.IsNull(dMRelationshipProperty.RelatedPropertyID);
                        Assert.IsNull(dMRelationshipProperty.PropertyID);
                        Assert.IsNull(dMRelationshipProperty.RelationshipID);
                        Assert.IsNotNull(dMRelationshipProperty.Generated);
            Assert.IsInstanceOf(dMRelationshipProperty.Props["Generated"].PropertyType, dMRelationshipProperty.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMRelationshipProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateUnsavedValidDMRelationshipProperty();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMRelationshipProperty.Status.IsNew);
            BusinessObjectCollection<DMRelationshipProperty> col = new BusinessObjectCollection<DMRelationshipProperty>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMRelationshipProperty.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMRelationshipProperty.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMRelationshipProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();

            //---------------Execute Test ----------------------
            DMRelationshipProperty loadedDMRelationshipProperty = Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(dMRelationshipProperty.RelationshipPropertyID, loadedDMRelationshipProperty.RelationshipPropertyID);
//            Assert.AreEqual(dMRelationshipProperty.RelatedPropertyID, loadedDMRelationshipProperty.RelatedPropertyID);
            Assert.AreEqual(dMRelationshipProperty.PropertyID, loadedDMRelationshipProperty.PropertyID);
            Assert.AreEqual(dMRelationshipProperty.RelationshipID, loadedDMRelationshipProperty.RelationshipID);
            Assert.AreEqual(dMRelationshipProperty.Generated, loadedDMRelationshipProperty.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMRelationshipProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationshipProperty.MarkForDelete();
            dMRelationshipProperty.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMRelationshipProperty", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMRelationshipProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtilsShared.CreateSavedDMProperty().PropertyID;
            dMRelationshipProperty.PropertyID = (System.Guid?) valueForPropertyID;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMRelationshipProperty.Generated = (System.Boolean) valueForGenerated;
            dMRelationshipProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMRelationshipProperty retrievedDMRelationshipProperty =
                    Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);
            
            Assert.AreEqual(valueForPropertyID, retrievedDMRelationshipProperty.PropertyID);
            Assert.AreEqual(valueForGenerated, retrievedDMRelationshipProperty.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = new DMRelationshipProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
//            object valueForRelatedPropertyID = TestUtilsShared.CreateSavedDMProperty().PropertyID;
//            dMRelationshipProperty.RelatedPropertyID = (System.Guid) valueForRelatedPropertyID;
            object valueForOwnerPropertyID = TestUtilsShared.CreateSavedDMProperty().PropertyID;
            dMRelationshipProperty.PropertyID = (System.Guid?)valueForOwnerPropertyID;
            object valueForRelationshipID = TestUtilsDMRelationship.CreateSavedDMRelationship().RelationshipID;
            dMRelationshipProperty.RelationshipID = (System.Guid?) valueForRelationshipID;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMRelationshipProperty.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
//            Assert.AreEqual(valueForRelatedPropertyID, dMRelationshipProperty.RelatedPropertyID);
            Assert.AreEqual(valueForOwnerPropertyID, dMRelationshipProperty.PropertyID);
            Assert.AreEqual(valueForRelationshipID, dMRelationshipProperty.RelationshipID);
            Assert.AreEqual(valueForGenerated, dMRelationshipProperty.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = new DMRelationshipProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtilsShared.CreateSavedDMProperty().PropertyID;
            dMRelationshipProperty.PropertyID = (System.Guid?) valueForPropertyID;
            object valueForRelationshipID = TestUtilsDMRelationship.CreateSavedDMRelationship().RelationshipID;
            dMRelationshipProperty.RelationshipID = (System.Guid?) valueForRelationshipID;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMRelationshipProperty.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPropertyID, dMRelationshipProperty.GetPropertyValue("PropertyID"));
            Assert.AreEqual(valueForRelationshipID, dMRelationshipProperty.GetPropertyValue("RelationshipID"));
            Assert.AreEqual(valueForGenerated, dMRelationshipProperty.GetPropertyValue("Generated"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = new DMRelationshipProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForPropertyID = TestUtilsShared.CreateSavedDMProperty().PropertyID;            
            dMRelationshipProperty.SetPropertyValue("PropertyID", valueForPropertyID);
            object valueForRelationshipID = TestUtilsDMRelationship.CreateSavedDMRelationship().RelationshipID;            
            dMRelationshipProperty.SetPropertyValue("RelationshipID", valueForRelationshipID);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            dMRelationshipProperty.SetPropertyValue("Generated", valueForGenerated);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForPropertyID, dMRelationshipProperty.PropertyID);
            Assert.AreEqual(valueForRelationshipID, dMRelationshipProperty.RelationshipID);
            Assert.AreEqual(valueForGenerated, dMRelationshipProperty.Generated);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationshipProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);
        }

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateUnsavedValidDMRelationshipProperty();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMRelationshipProperty.RelationshipPropertyID = null;
            dMRelationshipProperty.PropertyID = null;
            dMRelationshipProperty.Generated = null;
            
            try
            {
                dMRelationshipProperty.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Property' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Owner Property' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMRelationshipProperty>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["RelationshipPropertyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["RelationshipID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_OwnerProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();

            DMProperty boForRelationshipOwnerProperty = TestUtilsShared.CreateSavedDMProperty();
            dMRelationshipProperty.OwnerProperty = boForRelationshipOwnerProperty;
            dMRelationshipProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMProperty loadedRelatedBO = Broker.GetBusinessObject<DMProperty>(boForRelationshipOwnerProperty.ID);
            DMRelationshipProperty loadedDMRelationshipProperty = Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipOwnerProperty, loadedDMRelationshipProperty.OwnerProperty);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationshipProperty.OwnerProperty);
            Assert.AreEqual(loadedRelatedBO, dMRelationshipProperty.OwnerProperty);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_RelatedProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();

            DMProperty boForRelationshipRelatedProperty = TestUtilsShared.CreateSavedDMProperty();
            dMRelationshipProperty.RelatedProperty = boForRelationshipRelatedProperty;
            dMRelationshipProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMProperty loadedRelatedBO = Broker.GetBusinessObject<DMProperty>(boForRelationshipRelatedProperty.ID);
            DMRelationshipProperty loadedDMRelationshipProperty = Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipRelatedProperty, loadedDMRelationshipProperty.RelatedProperty);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationshipProperty.RelatedProperty);
            Assert.AreEqual(loadedRelatedBO, dMRelationshipProperty.RelatedProperty);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Relationship()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMRelationshipProperty dMRelationshipProperty = TestUtilsDMRelationshipProperty.CreateSavedDMRelationshipProperty();

            IDMRelationship boForRelationshipRelationship = dMRelationshipProperty.Relationship;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMRelationship loadedRelatedBO = Broker.GetBusinessObject<DMRelationship>(boForRelationshipRelationship.ID);
            DMRelationshipProperty loadedDMRelationshipProperty = Broker.GetBusinessObject<DMRelationshipProperty>(dMRelationshipProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipRelationship, loadedDMRelationshipProperty.Relationship);
            Assert.AreEqual(loadedRelatedBO, loadedDMRelationshipProperty.Relationship);
            Assert.AreEqual(loadedRelatedBO, dMRelationshipProperty.Relationship);
        }
        // ReSharper restore RedundantNameQualifier
    }
}
