// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample DMLookupListSimple objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public partial class TestUtilsDMSimpleLookupList
    {


        /// <summary>
        /// Creates a new unsaved DMLookupListSimple with a random value assigned to every property
        /// </summary>
		public static DMLookupListSimple CreateUnsavedValidDMSimpleLookupList()
		{
			DMLookupListSimple dMLookupListSimple = new DMLookupListSimple();
			dMLookupListSimple.Generated = TestUtilsShared.GetRandomBoolean();
			return dMLookupListSimple;
		}
	    
	    /// <summary>
        /// Creates a new unsaved DMLookupListSimple where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static DMLookupListSimple CreateUnsavedDefaultDMSimpleLookupList()
		{
			DMLookupListSimple dMLookupListSimple = new DMLookupListSimple();
			return dMLookupListSimple;
		}
    }
    
    // Provides the part of the test class that tests DMLookupListSimple objects
    [TestFixture]
    public partial class TestDMLookupListSimple : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSimpleLookupListWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupListSimple dMLookupListSimple = new DMLookupListSimple();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(dMLookupListSimple.SimpleLookupListID);
            Assert.IsInstanceOf(dMLookupListSimple.Props["SimpleLookupListID"].PropertyType, dMLookupListSimple.SimpleLookupListID);
                        Assert.IsNotNull(dMLookupListSimple.LookupListID);
            Assert.IsInstanceOf(dMLookupListSimple.Props["LookupListID"].PropertyType, dMLookupListSimple.LookupListID);
                        Assert.IsNotNull(dMLookupListSimple.Generated);
            Assert.IsInstanceOf(dMLookupListSimple.Props["Generated"].PropertyType, dMLookupListSimple.Generated);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateUnsavedValidDMSimpleLookupList();
            DMListItem dmListItem = TestUtilsDMListItem.CreateUnsavedValidDMListItem();
            dMLookupListSimple.ListItems.Add(dmListItem);
            //---------------Assert Precondition----------------
            Assert.IsTrue(dMLookupListSimple.Status.IsNew);
            BusinessObjectCollection<DMLookupListSimple> col = new BusinessObjectCollection<DMLookupListSimple>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMLookupListSimple.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMLookupListSimple.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateSavedDMSimpleLookupList();

            //---------------Execute Test ----------------------
            DMLookupListSimple loadedDMLookupListSimple = Broker.GetBusinessObject<DMLookupListSimple>(dMLookupListSimple.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMLookupListSimple.SimpleLookupListID, loadedDMLookupListSimple.SimpleLookupListID);
                        Assert.AreEqual(dMLookupListSimple.LookupListID, loadedDMLookupListSimple.LookupListID);
                        Assert.AreEqual(dMLookupListSimple.Generated, loadedDMLookupListSimple.Generated);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateSavedDMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupListSimple.MarkForDelete();
            dMLookupListSimple.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<DMLookupListSimple>(dMLookupListSimple.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMLookupListSimple", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSimpleLookupList()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateSavedDMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupListSimple.Generated = (System.Boolean) valueForGenerated;
            dMLookupListSimple.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMLookupListSimple retrievedDMLookupListSimple =
                    Broker.GetBusinessObject<DMLookupListSimple>(dMLookupListSimple.ID);
            
            Assert.AreEqual(valueForGenerated, retrievedDMLookupListSimple.Generated);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = new DMLookupListSimple();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            dMLookupListSimple.Generated = (System.Boolean) valueForGenerated;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForGenerated, dMLookupListSimple.Generated);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = new DMLookupListSimple();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.IsTrue(true, "There are no properties to set");
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = new DMLookupListSimple();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------

            //---------------Test Result -----------------------
            Assert.IsTrue(true, "There are no properties to set");
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateSavedDMSimpleLookupList();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupListSimple.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            Broker.GetBusinessObject<DMLookupListSimple>(dMLookupListSimple.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateUnsavedValidDMSimpleLookupList();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMLookupListSimple.SimpleLookupListID = null;
            dMLookupListSimple.LookupListID = null;
            dMLookupListSimple.Generated = null;
            
            try
            {
                dMLookupListSimple.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Simple Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Lookup List ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMLookupListSimple>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["SimpleLookupListID"].ReadWriteRule.ToString());
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["LookupListID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_ListItems()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateSavedDMSimpleLookupList();

            DMListItem boForRelationshipListItems = TestUtilsDMListItem.CreateUnsavedValidDMListItem();
            boForRelationshipListItems.SimpleLookupListID = dMLookupListSimple.SimpleLookupListID;
            boForRelationshipListItems.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(2, dMLookupListSimple.ListItems.Count);
            //---------------Execute Test ----------------------
            DMListItem loadedRelatedBO = Broker.GetBusinessObject<DMListItem>(boForRelationshipListItems.ID);
            DMLookupListSimple loadedDMLookupListSimple = Broker.GetBusinessObject<DMLookupListSimple>(dMLookupListSimple.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(2, loadedDMLookupListSimple.ListItems.Count);
            Assert.AreEqual(boForRelationshipListItems, loadedDMLookupListSimple.ListItems[0]);
            Assert.AreEqual(loadedRelatedBO, loadedDMLookupListSimple.ListItems[0]);
            Assert.AreEqual(loadedRelatedBO, dMLookupListSimple.ListItems[0]);
        }
        
        
       
        [Test]
        public void Test_Inheritance_SuperClassDef_Exists()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ISuperClassDef superClassDef = ClassDef.Get<DMLookupListSimple>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.IsNotNull(superClassDef);
        }

        [Test]  
        public void Test_Inheritance_SuperClassDef_PropertiesCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SuperClassDef superClassDef = (SuperClassDef) ClassDef.Get<DMLookupListSimple>().SuperClassDef;
            //---------------Test Result -----------------------
            Assert.AreEqual("DMLookupList", superClassDef.ClassName);
            Assert.AreEqual("FireStarterModeller.BO", superClassDef.AssemblyName);
            Assert.IsNull(superClassDef.ID);
        }
		
        [Test]
        public void Test_Inheritance_SuperClassDef_RelatedClassIsCorrect()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            IClassDef classDef = ClassDef.Get<DMLookupListSimple>();
            ISuperClassDef superClassDef = classDef.SuperClassDef;
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            IClassDef relatedClassDef = ClassDef.ClassDefs[superClassDef.AssemblyName, superClassDef.ClassName];
            //---------------Test Result -----------------------
            Assert.IsNotNull(relatedClassDef);
            PropDef relatedPrimaryKeyDef = (PropDef) relatedClassDef.PrimaryKeyDef[0];
            Assert.IsNotNull(relatedPrimaryKeyDef);
            PropDef propDef = (PropDef) classDef.PropDefColIncludingInheritance[relatedPrimaryKeyDef.PropertyName];
            Assert.IsNotNull(propDef, "Where no child ID match has been specified, the child must have a property with the same name and type as the parent ID");
            Assert.AreEqual(propDef.PropertyType, relatedPrimaryKeyDef.PropertyType);
        }
        
		
        [Test]
        public void Test_Inheritance_CodeClass_InheritsCorrectly()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMLookupListSimple dMLookupListSimple = TestUtilsDMSimpleLookupList.CreateUnsavedValidDMSimpleLookupList();
            //---------------Test Result -----------------------
            Assert.IsInstanceOf(typeof(DMLookupList), dMLookupListSimple);
        }        
    }
    // ReSharper restore RedundantNameQualifier
}
