// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests DMSortProperty objects
    [TestFixture]
    public partial class TestDMSortProperty
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateDMSortPropertyWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            DMSortProperty dMSortProperty = new DMSortProperty();

            //---------------Test Result -----------------------
            Assert.IsNotNull(dMSortProperty.DMSortPropertyID);
            Assert.IsInstanceOf(dMSortProperty.Props["DMSortPropertyID"].PropertyType, dMSortProperty.DMSortPropertyID);
            Assert.IsNull(dMSortProperty.DMSortOrderID);
            Assert.IsNull(dMSortProperty.PropertyName);
            Assert.AreEqual("ASC", dMSortProperty.SortDirection);
            Assert.AreEqual(0,dMSortProperty.SortPosition);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveDMSortProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateUnsavedValidDMSortProperty();

            //---------------Assert Precondition----------------
            Assert.IsTrue(dMSortProperty.Status.IsNew);
            BusinessObjectCollection<DMSortProperty> col = new BusinessObjectCollection<DMSortProperty>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            dMSortProperty.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(dMSortProperty.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadDMSortProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateSavedDMSortProperty();

            //---------------Execute Test ----------------------
            DMSortProperty loadedDMSortProperty = Broker.GetBusinessObject<DMSortProperty>(dMSortProperty.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(dMSortProperty.DMSortPropertyID, loadedDMSortProperty.DMSortPropertyID);
                        Assert.AreEqual(dMSortProperty.DMSortOrderID, loadedDMSortProperty.DMSortOrderID);
                        Assert.AreEqual(dMSortProperty.PropertyName, loadedDMSortProperty.PropertyName);
                        Assert.AreEqual(dMSortProperty.SortDirection, loadedDMSortProperty.SortDirection);
                        Assert.AreEqual(dMSortProperty.SortPosition, loadedDMSortProperty.SortPosition);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteDMSortProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateSavedDMSortProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortProperty.MarkForDelete();
            dMSortProperty.Save();
            //---------------Test Result -----------------------
            try
            {
                DMSortProperty retrievedDMSortProperty = Broker.GetBusinessObject<DMSortProperty>(dMSortProperty.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: DMSortProperty", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateDMSortProperty()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateSavedDMSortProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDMSortOrderID = TestUtilsDMSortOrder.CreateSavedDMSortOrder().DMSortOrderID;
            dMSortProperty.DMSortOrderID = (System.Guid) valueForDMSortOrderID;
            object valueForPropertyName = TestUtilsShared.GetRandomString();
            dMSortProperty.PropertyName = (System.String) valueForPropertyName;
            object valueForSortDirection = "DESC";
            dMSortProperty.SortDirection = (string) valueForSortDirection;
            object valueForSortPosition = TestUtilsShared.GetRandomInt();
            dMSortProperty.SortPosition = (System.Int32) valueForSortPosition;
            dMSortProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMSortProperty retrievedDMSortProperty =
                    Broker.GetBusinessObject<DMSortProperty>(dMSortProperty.ID);
            
            Assert.AreEqual(valueForDMSortOrderID, retrievedDMSortProperty.DMSortOrderID);
            Assert.AreEqual(valueForPropertyName, retrievedDMSortProperty.PropertyName);
            Assert.AreEqual(valueForSortDirection, retrievedDMSortProperty.SortDirection);
            Assert.AreEqual(valueForSortPosition, retrievedDMSortProperty.SortPosition);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = new DMSortProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDMSortOrderID = TestUtilsDMSortOrder.CreateSavedDMSortOrder().DMSortOrderID;
            dMSortProperty.DMSortOrderID = (System.Guid) valueForDMSortOrderID;
            object valueForPropertyName = TestUtilsShared.GetRandomString();
            dMSortProperty.PropertyName = (System.String) valueForPropertyName;
            object valueForSortDirection = "DESC";
            dMSortProperty.SortDirection = (string) valueForSortDirection;
            object valueForSortPosition = TestUtilsShared.GetRandomInt();
            dMSortProperty.SortPosition = (System.Int32) valueForSortPosition;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDMSortOrderID, dMSortProperty.DMSortOrderID);
            Assert.AreEqual(valueForPropertyName, dMSortProperty.PropertyName);
            Assert.AreEqual(valueForSortDirection, dMSortProperty.SortDirection);
            Assert.AreEqual(valueForSortPosition, dMSortProperty.SortPosition);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = new DMSortProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDMSortOrderID = TestUtilsDMSortOrder.CreateSavedDMSortOrder().DMSortOrderID;
            dMSortProperty.DMSortOrderID = (System.Guid) valueForDMSortOrderID;
            object valueForPropertyName = TestUtilsShared.GetRandomString();
            dMSortProperty.PropertyName = (System.String) valueForPropertyName;
            object valueForSortDirection = "ASC";
            dMSortProperty.SortDirection = (string) valueForSortDirection;
            object valueForSortPosition = TestUtilsShared.GetRandomInt();
            dMSortProperty.SortPosition = (System.Int32) valueForSortPosition;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDMSortOrderID, dMSortProperty.GetPropertyValue("DMSortOrderID"));
            Assert.AreEqual(valueForPropertyName, dMSortProperty.GetPropertyValue("PropertyName"));
            Assert.AreEqual(valueForSortDirection, dMSortProperty.GetPropertyValue("SortDirection"));
            Assert.AreEqual(valueForSortPosition, dMSortProperty.GetPropertyValue("SortPosition"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = new DMSortProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDMSortOrderID = TestUtilsDMSortOrder.CreateSavedDMSortOrder().DMSortOrderID;            
            dMSortProperty.SetPropertyValue("DMSortOrderID", valueForDMSortOrderID);
            object valueForPropertyName = TestUtilsShared.GetRandomString();            
            dMSortProperty.SetPropertyValue("PropertyName", valueForPropertyName);
            object valueForSortDirection = "DESC";         
            dMSortProperty.SetPropertyValue("SortDirection", valueForSortDirection);
            object valueForSortPosition = TestUtilsShared.GetRandomInt();            
            dMSortProperty.SetPropertyValue("SortPosition", valueForSortPosition);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDMSortOrderID, dMSortProperty.DMSortOrderID);
            Assert.AreEqual(valueForPropertyName, dMSortProperty.PropertyName);
            Assert.AreEqual(valueForSortDirection, dMSortProperty.SortDirection);
            Assert.AreEqual(valueForSortPosition, dMSortProperty.SortPosition);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateSavedDMSortProperty();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortProperty.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            DMSortProperty retrievedDMSortProperty =
                    Broker.GetBusinessObject<DMSortProperty>(dMSortProperty.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateUnsavedValidDMSortProperty();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            dMSortProperty.DMSortPropertyID = null;
            dMSortProperty.DMSortOrderID = null;
            dMSortProperty.PropertyName = null;
            dMSortProperty.SortDirection = null;
            dMSortProperty.SortPosition = null;
            
            try
            {
                dMSortProperty.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains(".DM Sort Property ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains(".DM Sort Order ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains(".Property Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains(".Sort Direction' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains(".Sort Position' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<DMSortProperty>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DMSortPropertyID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["DMSortOrderID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["PropertyName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SortDirection"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["SortPosition"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_DMSortOrder()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateSavedDMSortProperty();

            DMSortOrder boForRelationshipDMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();
            dMSortProperty.DMSortOrder = boForRelationshipDMSortOrder;
            dMSortProperty.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMSortOrder loadedRelatedBO = Broker.GetBusinessObject<DMSortOrder>(boForRelationshipDMSortOrder.ID);
            DMSortProperty loadedDMSortProperty = Broker.GetBusinessObject<DMSortProperty>(dMSortProperty.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipDMSortOrder, loadedDMSortProperty.DMSortOrder);
            Assert.AreEqual(loadedRelatedBO, loadedDMSortProperty.DMSortOrder);
            Assert.AreEqual(loadedRelatedBO, dMSortProperty.DMSortOrder);
        }
        
        
        
        
        
        
        
        [Test]  // Checks that deleting this instance has no effect in the related class
        public void Test_SingleRelationshipDeletion_DoNothing_DMSortOrder()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            DMSortProperty dMSortProperty = TestUtilsDMSortProperty.CreateSavedDMSortProperty();

            DMSortOrder boForRelationshipDMSortOrder = TestUtilsDMSortOrder.CreateSavedDMSortOrder();
            dMSortProperty.DMSortOrder = boForRelationshipDMSortOrder;
            dMSortProperty.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<DMSortProperty>().RelationshipDefCol["DMSortOrder"];
            Assert.AreEqual(DeleteParentAction.DoNothing, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            dMSortProperty.MarkForDelete();
            dMSortProperty.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<DMSortProperty>(dMSortProperty.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("There are no records in the database for the Class: DMSortProperty", ex.Message);
            }            
            
            DMSortOrder relatedBO = Broker.GetBusinessObject<DMSortOrder>(boForRelationshipDMSortOrder.ID);
            Assert.AreEqual(relatedBO,boForRelationshipDMSortOrder);
            
        }
       
    }
}
