// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample ModelModification objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public partial class TestUtilsModelModification
    {
        /// <summary>
        /// Creates a new saved ModelModification with a random value assigned to every property
        /// </summary>
        public static ModelModification CreateSavedModelModification()
		{
		    ModelModification modelModification = CreateUnsavedValidModelModification();
			modelModification.Save();
			return modelModification;
		}

        /// <summary>
        /// Creates a new unsaved ModelModification with a random value assigned to every property
        /// </summary>
		public static ModelModification CreateUnsavedValidModelModification()
		{
			ModelModification modelModification = new ModelModification();
			modelModification.Description = TestUtilsShared.GetRandomString();
			modelModification.ReverseEngineeringID = TestUtilsReverseEngineering.CreateSavedReverseEngineering().ReverseEngineeringID;
			modelModification.Approved = TestUtilsShared.GetRandomBoolean();
			return modelModification;
		}
	    
	    /// <summary>
        /// Creates a new unsaved ModelModification where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static ModelModification CreateUnsavedDefaultModelModification()
		{
			ModelModification modelModification = new ModelModification();
			return modelModification;
		}
    }
    
    // Provides the part of the test class that tests ModelModification objects
    [TestFixture]
    public partial class TestModelModification : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateModelModificationWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            ModelModification modelModification = new ModelModification();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(modelModification.ModelModificationID);
            Assert.IsInstanceOf(modelModification.Props["ModelModificationID"].PropertyType, modelModification.ModelModificationID);
                        Assert.IsNull(modelModification.Description);
                        Assert.IsNull(modelModification.ReverseEngineeringID);
                        Assert.IsNotNull(modelModification.Approved);
            Assert.IsInstanceOf(modelModification.Props["Approved"].PropertyType, modelModification.Approved);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveModelModification()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = TestUtilsModelModification.CreateUnsavedValidModelModification();

            //---------------Assert Precondition----------------
            Assert.IsTrue(modelModification.Status.IsNew);
            BusinessObjectCollection<ModelModification> col = new BusinessObjectCollection<ModelModification>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            modelModification.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(modelModification.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadModelModification()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = TestUtilsModelModification.CreateSavedModelModification();

            //---------------Execute Test ----------------------
            ModelModification loadedModelModification = Broker.GetBusinessObject<ModelModification>(modelModification.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(modelModification.ModelModificationID, loadedModelModification.ModelModificationID);
                        Assert.AreEqual(modelModification.Description, loadedModelModification.Description);
                        Assert.AreEqual(modelModification.ReverseEngineeringID, loadedModelModification.ReverseEngineeringID);
                        Assert.AreEqual(modelModification.Approved, loadedModelModification.Approved);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteModelModification()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = TestUtilsModelModification.CreateSavedModelModification();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            modelModification.MarkForDelete();
            modelModification.Save();
            //---------------Test Result -----------------------
            try
            {
                ModelModification retrievedModelModification = Broker.GetBusinessObject<ModelModification>(modelModification.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: ModelModification", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateModelModification()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = TestUtilsModelModification.CreateSavedModelModification();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDescription = TestUtilsShared.GetRandomString();
            modelModification.Description = (System.String) valueForDescription;
            object valueForReverseEngineeringID = TestUtilsReverseEngineering.CreateSavedReverseEngineering().ReverseEngineeringID;
            modelModification.ReverseEngineeringID = (System.Guid) valueForReverseEngineeringID;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            modelModification.Approved = (System.Boolean) valueForApproved;
            modelModification.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ModelModification retrievedModelModification =
                    Broker.GetBusinessObject<ModelModification>(modelModification.ID);
            
            Assert.AreEqual(valueForDescription, retrievedModelModification.Description);
            Assert.AreEqual(valueForReverseEngineeringID, retrievedModelModification.ReverseEngineeringID);
            Assert.AreEqual(valueForApproved, retrievedModelModification.Approved);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = new ModelModification();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDescription = TestUtilsShared.GetRandomString();
            modelModification.Description = (System.String) valueForDescription;
            object valueForReverseEngineeringID = TestUtilsReverseEngineering.CreateSavedReverseEngineering().ReverseEngineeringID;
            modelModification.ReverseEngineeringID = (System.Guid) valueForReverseEngineeringID;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            modelModification.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDescription, modelModification.Description);
            Assert.AreEqual(valueForReverseEngineeringID, modelModification.ReverseEngineeringID);
            Assert.AreEqual(valueForApproved, modelModification.Approved);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = new ModelModification();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDescription = TestUtilsShared.GetRandomString();
            modelModification.Description = (System.String) valueForDescription;
            object valueForReverseEngineeringID = TestUtilsReverseEngineering.CreateSavedReverseEngineering().ReverseEngineeringID;
            modelModification.ReverseEngineeringID = (System.Guid) valueForReverseEngineeringID;
            object valueForApproved = TestUtilsShared.GetRandomBoolean();
            modelModification.Approved = (System.Boolean) valueForApproved;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDescription, modelModification.GetPropertyValue("Description"));
            Assert.AreEqual(valueForReverseEngineeringID, modelModification.GetPropertyValue("ReverseEngineeringID"));
            Assert.AreEqual(valueForApproved, modelModification.GetPropertyValue("Approved"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = new ModelModification();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForDescription = TestUtilsShared.GetRandomString();            
            modelModification.SetPropertyValue("Description", valueForDescription);
            object valueForReverseEngineeringID = TestUtilsReverseEngineering.CreateSavedReverseEngineering().ReverseEngineeringID;            
            modelModification.SetPropertyValue("ReverseEngineeringID", valueForReverseEngineeringID);
            object valueForApproved = TestUtilsShared.GetRandomBoolean();            
            modelModification.SetPropertyValue("Approved", valueForApproved);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForDescription, modelModification.Description);
            Assert.AreEqual(valueForReverseEngineeringID, modelModification.ReverseEngineeringID);
            Assert.AreEqual(valueForApproved, modelModification.Approved);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ModelModification modelModification = TestUtilsModelModification.CreateSavedModelModification();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            modelModification.Description = null;
            modelModification.ReverseEngineeringID = null;
            modelModification.Approved = null;
            modelModification.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            ModelModification retrievedModelModification =
                    Broker.GetBusinessObject<ModelModification>(modelModification.ID);
            
            Assert.IsNull(retrievedModelModification.Description);
            Assert.IsNull(retrievedModelModification.ReverseEngineeringID);
            Assert.IsNull(retrievedModelModification.Approved);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ModelModification modelModification = TestUtilsModelModification.CreateUnsavedValidModelModification();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            modelModification.ModelModificationID = null;
            
            try
            {
                modelModification.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Model Modification ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<ModelModification>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["ModelModificationID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Description"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ReverseEngineeringID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Approved"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_ReverseEngineering()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            ModelModification modelModification = TestUtilsModelModification.CreateSavedModelModification();

            FireStarterModeller.BO.ReverseEngineering boForRelationshipReverseEngineering = TestUtilsReverseEngineering.CreateSavedReverseEngineering();
            modelModification.ReverseEngineering = boForRelationshipReverseEngineering;
            modelModification.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            FireStarterModeller.BO.ReverseEngineering loadedRelatedBO = Broker.GetBusinessObject<FireStarterModeller.BO.ReverseEngineering>(boForRelationshipReverseEngineering.ID);
            ModelModification loadedModelModification = Broker.GetBusinessObject<ModelModification>(modelModification.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipReverseEngineering, loadedModelModification.ReverseEngineering);
            Assert.AreEqual(loadedRelatedBO, loadedModelModification.ReverseEngineering);
            Assert.AreEqual(loadedRelatedBO, modelModification.ReverseEngineering);
        }
        // ReSharper restore RedundantNameQualifier       
    }
}
