// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides the part of the test class that tests SolutionType objects
    [TestFixture]
    public partial class TestSolutionType : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateSolutionTypeWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            SolutionType solutionType = new SolutionType();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(solutionType.SolutionTypeID);
            Assert.IsInstanceOf(solutionType.Props["SolutionTypeID"].PropertyType, solutionType.SolutionTypeID);
                        Assert.IsNull(solutionType.Name);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveSolutionType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = TestUtilsSolutionType.CreateUnsavedValidSolutionType();

            //---------------Assert Precondition----------------
            Assert.IsTrue(solutionType.Status.IsNew);
            BusinessObjectCollection<SolutionType> col = new BusinessObjectCollection<SolutionType>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            solutionType.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(solutionType.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadSolutionType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = TestUtilsSolutionType.CreateSavedSolutionType();

            //---------------Execute Test ----------------------
            SolutionType loadedSolutionType = Broker.GetBusinessObject<SolutionType>(solutionType.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(solutionType.SolutionTypeID, loadedSolutionType.SolutionTypeID);
                        Assert.AreEqual(solutionType.Name, loadedSolutionType.Name);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteSolutionType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = TestUtilsSolutionType.CreateSavedSolutionType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            solutionType.MarkForDelete();
            solutionType.Save();
            //---------------Test Result -----------------------
            try
            {
                SolutionType retrievedSolutionType = Broker.GetBusinessObject<SolutionType>(solutionType.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: SolutionType", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateSolutionType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = TestUtilsSolutionType.CreateSavedSolutionType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            solutionType.Name = (System.String) valueForName;
            solutionType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            SolutionType retrievedSolutionType =
                    Broker.GetBusinessObject<SolutionType>(solutionType.ID);
            
            Assert.AreEqual(valueForName, retrievedSolutionType.Name);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = new SolutionType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            solutionType.Name = (System.String) valueForName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, solutionType.Name);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = new SolutionType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            solutionType.Name = (System.String) valueForName;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, solutionType.GetPropertyValue("Name"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = new SolutionType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();            
            solutionType.SetPropertyValue("Name", valueForName);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, solutionType.Name);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = TestUtilsSolutionType.CreateSavedSolutionType();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            solutionType.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            SolutionType retrievedSolutionType =
                    Broker.GetBusinessObject<SolutionType>(solutionType.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            SolutionType solutionType = TestUtilsSolutionType.CreateUnsavedValidSolutionType();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            solutionType.SolutionTypeID = null;
            solutionType.Name = null;
            
            try
            {
                solutionType.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("Solution Type ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Name' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<SolutionType>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["SolutionTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_SolutionTypeProjects()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            SolutionType solutionType = TestUtilsSolutionType.CreateSavedSolutionType();

            SolutionTypeProject boForRelationshipSolutionTypeProjects = TestUtilsSolutionTypeProject.CreateUnsavedValidSolutionTypeProject();
            boForRelationshipSolutionTypeProjects.SolutionTypeID = solutionType.SolutionTypeID;
            boForRelationshipSolutionTypeProjects.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, solutionType.SolutionTypeProjects.Count);
            //---------------Execute Test ----------------------
            SolutionTypeProject loadedRelatedBO = Broker.GetBusinessObject<SolutionTypeProject>(boForRelationshipSolutionTypeProjects.ID);
            SolutionType loadedSolutionType = Broker.GetBusinessObject<SolutionType>(solutionType.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedSolutionType.SolutionTypeProjects.Count);
            Assert.AreEqual(boForRelationshipSolutionTypeProjects, loadedSolutionType.SolutionTypeProjects[0]);
            Assert.AreEqual(loadedRelatedBO, loadedSolutionType.SolutionTypeProjects[0]);
            Assert.AreEqual(loadedRelatedBO, solutionType.SolutionTypeProjects[0]);
        }
        
        [Test]  // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_SolutionTypeProjects()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            SolutionType solutionType = TestUtilsSolutionType.CreateSavedSolutionType();

            SolutionTypeProject boForRelationshipSolutionTypeProjects = TestUtilsSolutionTypeProject.CreateUnsavedValidSolutionTypeProject();
            boForRelationshipSolutionTypeProjects.SolutionTypeID = solutionType.SolutionTypeID;
            boForRelationshipSolutionTypeProjects.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, solutionType.SolutionTypeProjects.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<SolutionType>().RelationshipDefCol["SolutionTypeProjects"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                solutionType.MarkForDelete();
                solutionType.Save();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
        }
        
        
        
        
        
       
    }
}
