// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIGridColumnInfo objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsUIGridColumnInfo
    {
        private static int OrdinalPosition = 1;
        /// <summary>
        /// Creates a new saved UIGridColumnInfo with a random value assigned to every property
        /// </summary>
        public static UIGridColumnInfo CreateSavedUIColumn()
		{
            UIGridColumnInfo uIGridColumn = CreateUnsavedValidUIColumn();
			uIGridColumn.Save();
			return uIGridColumn;
		}

        /// <summary>
        /// Creates a new unsaved UIGridColumnInfo with a random value assigned to every property
        /// </summary>
		public static UIGridColumnInfo CreateUnsavedValidUIColumn()
		{
            UIGridColumnInfo uIGridColumn = CreateUnsavedValidUIColumn_WNullGrid();
			uIGridColumn.UIGridID = TestUtilsShared.CreateSavedUIGridInfo().UIGridID;
            uIGridColumn.OrdinalPosition = ++OrdinalPosition;
			return uIGridColumn;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIGridColumnInfo where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIGridColumnInfo CreateUnsavedDefaultUIColumn()
		{
			UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();
			return uIGridColumn;
		}

        public static UIGridColumnInfo CreateUnsavedValidUIColumn_WNullGrid()
        {
            UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();
            uIGridColumn.Heading = TestUtilsShared.GetRandomString();
            uIGridColumn.PropertyName = TestUtilsDMProperty.CreateSavedDMProperty().PropertyName;
//            uIGridColumn.PropertyName = TestUtilsShared.GetRandomString();
            uIGridColumn.UIGridColumnControlTypeID = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIGridColumn.Editable = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Width = TestUtilsShared.GetRandomInt();
            uIGridColumn.Alignment = TestUtilsShared.GetRandomString();
            uIGridColumn.Generated = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.OrdinalPosition = ++OrdinalPosition;
            return uIGridColumn;
        }
        public static UIGridColumnInfo CreateUnsavedValidUIColumn_WNullGrid_NullProperty()
        {
            UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();
            uIGridColumn.Heading = TestUtilsShared.GetRandomString();
//            uIGridColumn.Property = TestUtilsDMProperty.CreateSavedDMProperty();
//            uIGridColumn.PropertyName = TestUtilsShared.GetRandomString();
            uIGridColumn.UIGridColumnControlTypeID = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIGridColumn.Editable = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Width = TestUtilsShared.GetRandomInt();
            uIGridColumn.Alignment = TestUtilsShared.GetRandomString();
            uIGridColumn.Generated = TestUtilsShared.GetRandomBoolean();
            return uIGridColumn;
        }
    }
    
    // Provides the part of the test class that tests UIGridColumnInfo objects
    [TestFixture]
    public partial class TestUIGridColumnInfo : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIColumnWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIGridColumn.UIGridColumnID);
            Assert.IsInstanceOf(uIGridColumn.Props["UIGridColumnID"].PropertyType, uIGridColumn.UIGridColumnID);
                        Assert.IsNull(uIGridColumn.Heading);
                        Assert.IsNull(uIGridColumn.PropertyName);
                        Assert.IsNull(uIGridColumn.UIGridColumnControlTypeID);
                        Assert.IsNotNull(uIGridColumn.Editable);
            Assert.IsInstanceOf(uIGridColumn.Props["Editable"].PropertyType, uIGridColumn.Editable);
                        Assert.IsNotNull(uIGridColumn.Width);
            Assert.IsInstanceOf(uIGridColumn.Props["Width"].PropertyType, uIGridColumn.Width);
                        Assert.IsNotNull(uIGridColumn.Alignment);
            Assert.IsInstanceOf(uIGridColumn.Props["Alignment"].PropertyType, uIGridColumn.Alignment);
                        Assert.IsNotNull(uIGridColumn.Generated);
            Assert.IsInstanceOf(uIGridColumn.Props["Generated"].PropertyType, uIGridColumn.Generated);
                        Assert.IsNull(uIGridColumn.UIGridID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateUnsavedValidUIColumn();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIGridColumn.Status.IsNew);
            BusinessObjectCollection<UIGridColumnInfo> col = new BusinessObjectCollection<UIGridColumnInfo>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIGridColumn.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIGridColumn.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();

            //---------------Execute Test ----------------------
            UIGridColumnInfo loadedUIGridColumn = Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIGridColumn.UIGridColumnID, loadedUIGridColumn.UIGridColumnID);
                        Assert.AreEqual(uIGridColumn.Heading, loadedUIGridColumn.Heading);
                        Assert.AreEqual(uIGridColumn.PropertyName, loadedUIGridColumn.PropertyName);
                        Assert.AreEqual(uIGridColumn.UIGridColumnControlTypeID, loadedUIGridColumn.UIGridColumnControlTypeID);
                        Assert.AreEqual(uIGridColumn.Editable, loadedUIGridColumn.Editable);
                        Assert.AreEqual(uIGridColumn.Width, loadedUIGridColumn.Width);
                        Assert.AreEqual(uIGridColumn.Alignment, loadedUIGridColumn.Alignment);
                        Assert.AreEqual(uIGridColumn.Generated, loadedUIGridColumn.Generated);
                        Assert.AreEqual(uIGridColumn.UIGridID, loadedUIGridColumn.UIGridID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridColumn.MarkForDelete();
            uIGridColumn.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIGridColumnInfo", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtilsShared.GetRandomString();
            uIGridColumn.Heading = (System.String) valueForHeading;
//            object valueForProperty = TestUtilsShared.GetRandomString();
//            uIGridColumn.PropertyName = (System.String) valueForProperty;
            object valueForUIGridColumnControlTypeID = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIGridColumn.UIGridColumnControlTypeID = (System.Guid) valueForUIGridColumnControlTypeID;
            object valueForEditable = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Editable = (System.Boolean) valueForEditable;
            object valueForWidth = TestUtilsShared.GetRandomInt();
            uIGridColumn.Width = (System.Int32) valueForWidth;
            object valueForAlignment = TestUtilsShared.GetRandomString();
            uIGridColumn.Alignment = (System.String) valueForAlignment;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Generated = (System.Boolean) valueForGenerated;
            object valueForUIGridID = TestUtilsShared.CreateSavedUIGridInfo().UIGridID;
            uIGridColumn.UIGridID = (System.Guid) valueForUIGridID;
            uIGridColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIGridColumnInfo retrievedUIGridColumn =
                    Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
            
            Assert.AreEqual(valueForHeading, retrievedUIGridColumn.Heading);
//            Assert.AreEqual(valueForProperty, retrievedUIGridColumn.PropertyName);
            Assert.AreEqual(valueForUIGridColumnControlTypeID, retrievedUIGridColumn.UIGridColumnControlTypeID);
            Assert.AreEqual(valueForEditable, retrievedUIGridColumn.Editable);
            Assert.AreEqual(valueForWidth, retrievedUIGridColumn.Width);
            Assert.AreEqual(valueForAlignment, retrievedUIGridColumn.Alignment);
            Assert.AreEqual(valueForGenerated, retrievedUIGridColumn.Generated);
            Assert.AreEqual(valueForUIGridID, retrievedUIGridColumn.UIGridID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtilsShared.GetRandomString();
            uIGridColumn.Heading = (System.String) valueForHeading;
//            object valueForProperty = TestUtilsShared.GetRandomString();
//            uIGridColumn.PropertyName = (System.String) valueForProperty;
            object valueForUIGridColumnControlTypeID = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIGridColumn.UIGridColumnControlTypeID = (System.Guid) valueForUIGridColumnControlTypeID;
            object valueForEditable = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Editable = (System.Boolean) valueForEditable;
            object valueForWidth = TestUtilsShared.GetRandomInt();
            uIGridColumn.Width = (System.Int32) valueForWidth;
            object valueForAlignment = TestUtilsShared.GetRandomString();
            uIGridColumn.Alignment = (System.String) valueForAlignment;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Generated = (System.Boolean) valueForGenerated;
            object valueForUIGridID = TestUtilsShared.CreateSavedUIGridInfo().UIGridID;
            uIGridColumn.UIGridID = (System.Guid) valueForUIGridID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForHeading, uIGridColumn.Heading);
//            Assert.AreEqual(valueForProperty, uIGridColumn.PropertyName);
            Assert.AreEqual(valueForUIGridColumnControlTypeID, uIGridColumn.UIGridColumnControlTypeID);
            Assert.AreEqual(valueForEditable, uIGridColumn.Editable);
            Assert.AreEqual(valueForWidth, uIGridColumn.Width);
            Assert.AreEqual(valueForAlignment, uIGridColumn.Alignment);
            Assert.AreEqual(valueForGenerated, uIGridColumn.Generated);
            Assert.AreEqual(valueForUIGridID, uIGridColumn.UIGridID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtilsShared.GetRandomString();
            uIGridColumn.Heading = (System.String) valueForHeading;
//            object valueForProperty = TestUtilsShared.GetRandomString();
//            uIGridColumn.PropertyName = (System.String) valueForProperty;
            object valueForUIGridColumnControlTypeID = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;
            uIGridColumn.UIGridColumnControlTypeID = (System.Guid) valueForUIGridColumnControlTypeID;
            object valueForEditable = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Editable = (System.Boolean) valueForEditable;
            object valueForWidth = TestUtilsShared.GetRandomInt();
            uIGridColumn.Width = (System.Int32) valueForWidth;
            object valueForAlignment = TestUtilsShared.GetRandomString();
            uIGridColumn.Alignment = (System.String) valueForAlignment;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIGridColumn.Generated = (System.Boolean) valueForGenerated;
            object valueForUIGridID = TestUtilsShared.CreateSavedUIGridInfo().UIGridID;
            uIGridColumn.UIGridID = (System.Guid) valueForUIGridID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForHeading, uIGridColumn.GetPropertyValue("Heading"));
//            Assert.AreEqual(valueForProperty, uIGridColumn.GetPropertyValue("PropertyName"));
            Assert.AreEqual(valueForUIGridColumnControlTypeID, uIGridColumn.GetPropertyValue("UIGridColumnControlTypeID"));
            Assert.AreEqual(valueForEditable, uIGridColumn.GetPropertyValue("Editable"));
            Assert.AreEqual(valueForWidth, uIGridColumn.GetPropertyValue("Width"));
            Assert.AreEqual(valueForAlignment, uIGridColumn.GetPropertyValue("Alignment"));
            Assert.AreEqual(valueForGenerated, uIGridColumn.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIGridID, uIGridColumn.GetPropertyValue("UIGridID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = new UIGridColumnInfo();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForHeading = TestUtilsShared.GetRandomString();            
            uIGridColumn.SetPropertyValue("Heading", valueForHeading);
//            object valueForProperty = TestUtilsShared.GetRandomString();            
//            uIGridColumn.SetPropertyValue("PropertyName", valueForProperty);
            object valueForUIGridColumnControlTypeID = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType().UIGridColumnControlTypeID;            
            uIGridColumn.SetPropertyValue("UIGridColumnControlTypeID", valueForUIGridColumnControlTypeID);
            object valueForEditable = TestUtilsShared.GetRandomBoolean();            
            uIGridColumn.SetPropertyValue("Editable", valueForEditable);
            object valueForWidth = (decimal)TestUtilsShared.GetRandomInt();            
            uIGridColumn.SetPropertyValue("Width", valueForWidth);
            object valueForAlignment = TestUtilsShared.GetRandomString();            
            uIGridColumn.SetPropertyValue("Alignment", valueForAlignment);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIGridColumn.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIGridID = TestUtilsShared.CreateSavedUIGridInfo().UIGridID;            
            uIGridColumn.SetPropertyValue("UIGridID", valueForUIGridID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForHeading, uIGridColumn.Heading);
//            Assert.AreEqual(valueForProperty, uIGridColumn.PropertyName);
            Assert.AreEqual(valueForUIGridColumnControlTypeID, uIGridColumn.UIGridColumnControlTypeID);
            Assert.AreEqual(valueForEditable, uIGridColumn.Editable);
            Assert.AreEqual(valueForWidth, uIGridColumn.Width);
            Assert.AreEqual(valueForAlignment, uIGridColumn.Alignment);
            Assert.AreEqual(valueForGenerated, uIGridColumn.Generated);
            Assert.AreEqual(valueForUIGridID, uIGridColumn.UIGridID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridColumn.Editable = null;
            uIGridColumn.Width = null;
            uIGridColumn.Alignment = null;
            uIGridColumn.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIGridColumnInfo retrievedUIGridColumn =
                    Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
            
            Assert.IsNull(retrievedUIGridColumn.Editable);
            Assert.IsNull(retrievedUIGridColumn.Width);
            Assert.IsNull(retrievedUIGridColumn.Alignment);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateUnsavedValidUIColumn();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIGridColumn.UIGridColumnID = null;
            uIGridColumn.Heading = null;
//            uIGridColumn.PropPropertyName = null;
            uIGridColumn.UIGridColumnControlTypeID = null;
            uIGridColumn.Generated = null;
            uIGridColumn.UIGridID = null;
            
            try
            {
                uIGridColumn.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Grid Column ID' is a compulsory field and has no value", ex.Message);
//                StringAssert.Contains("Heading' is a compulsory field and has no value", ex.Message);
//                StringAssert.Contains("Property Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Grid Column Type' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("UI Grid ID' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIGridColumnInfo>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIGridColumnID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Heading"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridColumnControlTypeID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Editable"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Width"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Alignment"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIGridID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGrid()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();

            UIGridInfo boForRelationshipUIGrid = uIGridColumn.UIGrid;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIGridInfo loadedRelatedBO = Broker.GetBusinessObject<UIGridInfo>(boForRelationshipUIGrid.ID);
            UIGridColumnInfo loadedUIGridColumn = Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGrid, loadedUIGridColumn.UIGrid);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridColumn.UIGrid);
            Assert.AreEqual(loadedRelatedBO, uIGridColumn.UIGrid);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGridColumnControlType()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();

            UIGridColumnControlType boForRelationshipUIGridColumnControlType = TestUtilsUIGridColumnControlType.CreateSavedUIGridColumnControlType();
            uIGridColumn.UIGridColumnControlType = boForRelationshipUIGridColumnControlType;
            uIGridColumn.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIGridColumnControlType loadedRelatedBO = Broker.GetBusinessObject<UIGridColumnControlType>(boForRelationshipUIGridColumnControlType.ID);
            UIGridColumnInfo loadedUIGridColumn = Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridColumnControlType, loadedUIGridColumn.UIGridColumnControlType);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridColumn.UIGridColumnControlType);
            Assert.AreEqual(loadedRelatedBO, uIGridColumn.UIGridColumnControlType);
        }
        
        [Test]  // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();

            UIParameter boForRelationshipUIParameters = TestUtilsUIParameter.CreateUnsavedValidUIParameter();
            boForRelationshipUIParameters.UIColumnID = uIGridColumn.UIGridColumnID;
            boForRelationshipUIParameters.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridColumn.UIParameters.Count);
            //---------------Execute Test ----------------------
            UIParameter loadedRelatedBO = Broker.GetBusinessObject<UIParameter>(boForRelationshipUIParameters.ID);
            UIGridColumnInfo loadedUIGridColumn = Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUIGridColumn.UIParameters.Count);
            Assert.AreEqual(boForRelationshipUIParameters, loadedUIGridColumn.UIParameters[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUIGridColumn.UIParameters[0]);
            Assert.AreEqual(loadedRelatedBO, uIGridColumn.UIParameters[0]);
        }
        
        
        [Test, Ignore("TODO Eric 2009-02-23 This is the one that's causing a crash")]  // Checks that deleting a parent deletes the child
        public void Test_MultipleRelationshipDeletion_DeleteRelated_UIParameters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIGridColumnInfo uIGridColumn = TestUtilsUIGridColumnInfo.CreateSavedUIColumn();

            UIParameter boForRelationshipUIParameters = TestUtilsUIParameter.CreateUnsavedValidUIParameter();
            boForRelationshipUIParameters.UIColumnID = uIGridColumn.UIGridColumnID;
            boForRelationshipUIParameters.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uIGridColumn.UIParameters.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UIGridColumnInfo>().RelationshipDefCol["UIParameters"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIGridColumn.MarkForDelete();
            uIGridColumn.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIGridColumnInfo>(uIGridColumn.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridColumnInfo"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIParameter>(boForRelationshipUIParameters.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIParameter"));
            }
        }
        // ReSharper restore RedundantNameQualifier       
    }
}
