// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIParameter objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsUIParameter
    {
        /// <summary>
        /// Creates a new saved UIParameter with a random value assigned to every property
        /// </summary>
        public static UIParameter CreateSavedUIParameter()
		{
		    UIParameter uIParameter = CreateUnsavedValidUIParameter();
			uIParameter.Save();
			return uIParameter;
		}

        /// <summary>
        /// Creates a new unsaved UIParameter with a random value assigned to every property
        /// </summary>
		public static UIParameter CreateUnsavedValidUIParameter()
		{
			UIParameter uIParameter = new UIParameter();
			uIParameter.Name = TestUtilsShared.GetRandomString();
			uIParameter.Value = TestUtilsShared.GetRandomString();
			uIParameter.Generated = TestUtilsShared.GetRandomBoolean();
			uIParameter.UIFieldID = TestUtilsUIField.CreateSavedUIField().UIFieldID;
			uIParameter.UIColumnID = TestUtilsUIGridColumnInfo.CreateSavedUIColumn().UIGridColumnID;
			return uIParameter;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIParameter where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIParameter CreateUnsavedDefaultUIParameter()
		{
			UIParameter uIParameter = new UIParameter();
			return uIParameter;
		}
    }
    
    // Provides the part of the test class that tests UIParameter objects
    [TestFixture]
    public partial class TestUIParameter : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIParameterWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIParameter uIParameter = new UIParameter();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIParameter.UIParameterID);
            Assert.IsInstanceOf(uIParameter.Props["UIParameterID"].PropertyType, uIParameter.UIParameterID);
                        Assert.IsNull(uIParameter.Name);
                        Assert.IsNull(uIParameter.Value);
                        Assert.IsNotNull(uIParameter.Generated);
            Assert.IsInstanceOf(uIParameter.Props["Generated"].PropertyType, uIParameter.Generated);
                        Assert.IsNull(uIParameter.UIFieldID);
                        Assert.IsNull(uIParameter.UIColumnID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = TestUtilsUIParameter.CreateUnsavedValidUIParameter();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIParameter.Status.IsNew);
            BusinessObjectCollection<UIParameter> col = new BusinessObjectCollection<UIParameter>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIParameter.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIParameter.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = TestUtilsUIParameter.CreateSavedUIParameter();

            //---------------Execute Test ----------------------
            UIParameter loadedUIParameter = Broker.GetBusinessObject<UIParameter>(uIParameter.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIParameter.UIParameterID, loadedUIParameter.UIParameterID);
                        Assert.AreEqual(uIParameter.Name, loadedUIParameter.Name);
                        Assert.AreEqual(uIParameter.Value, loadedUIParameter.Value);
                        Assert.AreEqual(uIParameter.Generated, loadedUIParameter.Generated);
                        Assert.AreEqual(uIParameter.UIFieldID, loadedUIParameter.UIFieldID);
                        Assert.AreEqual(uIParameter.UIColumnID, loadedUIParameter.UIColumnID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = TestUtilsUIParameter.CreateSavedUIParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIParameter.MarkForDelete();
            uIParameter.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIParameter>(uIParameter.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIParameter", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIParameter()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = TestUtilsUIParameter.CreateSavedUIParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            uIParameter.Name = (System.String) valueForName;
            object valueForValue = TestUtilsShared.GetRandomString();
            uIParameter.Value = (System.String) valueForValue;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIParameter.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFieldID = TestUtilsUIField.CreateSavedUIField().UIFieldID;
            uIParameter.UIFieldID = (System.Guid) valueForUIFieldID;
            object valueForUIColumnID = TestUtilsUIGridColumnInfo.CreateSavedUIColumn().UIGridColumnID;
            uIParameter.UIColumnID = (System.Guid) valueForUIColumnID;
            uIParameter.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIParameter retrievedUIParameter =
                    Broker.GetBusinessObject<UIParameter>(uIParameter.ID);
            
            Assert.AreEqual(valueForName, retrievedUIParameter.Name);
            Assert.AreEqual(valueForValue, retrievedUIParameter.Value);
            Assert.AreEqual(valueForGenerated, retrievedUIParameter.Generated);
            Assert.AreEqual(valueForUIFieldID, retrievedUIParameter.UIFieldID);
            Assert.AreEqual(valueForUIColumnID, retrievedUIParameter.UIColumnID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = new UIParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            uIParameter.Name = (System.String) valueForName;
            object valueForValue = TestUtilsShared.GetRandomString();
            uIParameter.Value = (System.String) valueForValue;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIParameter.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFieldID = TestUtilsUIField.CreateSavedUIField().UIFieldID;
            uIParameter.UIFieldID = (System.Guid) valueForUIFieldID;
            object valueForUIColumnID = TestUtilsUIGridColumnInfo.CreateSavedUIColumn().UIGridColumnID;
            uIParameter.UIColumnID = (System.Guid) valueForUIColumnID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uIParameter.Name);
            Assert.AreEqual(valueForValue, uIParameter.Value);
            Assert.AreEqual(valueForGenerated, uIParameter.Generated);
            Assert.AreEqual(valueForUIFieldID, uIParameter.UIFieldID);
            Assert.AreEqual(valueForUIColumnID, uIParameter.UIColumnID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = new UIParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            uIParameter.Name = (System.String) valueForName;
            object valueForValue = TestUtilsShared.GetRandomString();
            uIParameter.Value = (System.String) valueForValue;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIParameter.Generated = (System.Boolean) valueForGenerated;
            object valueForUIFieldID = TestUtilsUIField.CreateSavedUIField().UIFieldID;
            uIParameter.UIFieldID = (System.Guid) valueForUIFieldID;
            object valueForUIColumnID = TestUtilsUIGridColumnInfo.CreateSavedUIColumn().UIGridColumnID;
            uIParameter.UIColumnID = (System.Guid) valueForUIColumnID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uIParameter.GetPropertyValue("Name"));
            Assert.AreEqual(valueForValue, uIParameter.GetPropertyValue("Value"));
            Assert.AreEqual(valueForGenerated, uIParameter.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForUIFieldID, uIParameter.GetPropertyValue("UIFieldID"));
            Assert.AreEqual(valueForUIColumnID, uIParameter.GetPropertyValue("UIColumnID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = new UIParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();            
            uIParameter.SetPropertyValue("Name", valueForName);
            object valueForValue = TestUtilsShared.GetRandomString();            
            uIParameter.SetPropertyValue("Value", valueForValue);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIParameter.SetPropertyValue("Generated", valueForGenerated);
            object valueForUIFieldID = TestUtilsUIField.CreateSavedUIField().UIFieldID;            
            uIParameter.SetPropertyValue("UIFieldID", valueForUIFieldID);
            object valueForUIColumnID = TestUtilsUIGridColumnInfo.CreateSavedUIColumn().UIGridColumnID;
            uIParameter.SetPropertyValue("UIColumnID", valueForUIColumnID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uIParameter.Name);
            Assert.AreEqual(valueForValue, uIParameter.Value);
            Assert.AreEqual(valueForGenerated, uIParameter.Generated);
            Assert.AreEqual(valueForUIFieldID, uIParameter.UIFieldID);
            Assert.AreEqual(valueForUIColumnID, uIParameter.UIColumnID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIParameter uIParameter = TestUtilsUIParameter.CreateSavedUIParameter();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIParameter.UIFieldID = null;
            uIParameter.UIColumnID = null;
            uIParameter.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIParameter retrievedUIParameter =
                    Broker.GetBusinessObject<UIParameter>(uIParameter.ID);
            
            Assert.IsNull(retrievedUIParameter.UIFieldID);
            Assert.IsNull(retrievedUIParameter.UIColumnID);
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIParameter uIParameter = TestUtilsUIParameter.CreateUnsavedValidUIParameter();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIParameter.UIParameterID = null;
            uIParameter.Name = null;
            uIParameter.Value = null;
            uIParameter.Generated = null;
            
            try
            {
                uIParameter.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Parameter ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Value' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIParameter>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
            Assert.AreEqual("WriteNew", classDef.PropDefColIncludingInheritance["UIParameterID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Name"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Value"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIFieldID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["UIColumnID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIColumn()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIParameter uIParameter = TestUtilsUIParameter.CreateSavedUIParameter();

            UIGridColumnInfo boForRelationshipUIGridColumn = uIParameter.UIGridColumnInfo;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIGridColumnInfo loadedRelatedBO = Broker.GetBusinessObject<UIGridColumnInfo>(boForRelationshipUIGridColumn.ID);
            UIParameter loadedUIParameter = Broker.GetBusinessObject<UIParameter>(uIParameter.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridColumn, loadedUIParameter.UIGridColumnInfo);
            Assert.AreEqual(loadedRelatedBO, loadedUIParameter.UIGridColumnInfo);
            Assert.AreEqual(loadedRelatedBO, uIParameter.UIGridColumnInfo);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIField()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIParameter uIParameter = TestUtilsUIParameter.CreateSavedUIParameter();

            UIField boForRelationshipUIField = uIParameter.UIField;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIField loadedRelatedBO = Broker.GetBusinessObject<UIField>(boForRelationshipUIField.ID);
            UIParameter loadedUIParameter = Broker.GetBusinessObject<UIParameter>(uIParameter.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIField, loadedUIParameter.UIField);
            Assert.AreEqual(loadedRelatedBO, loadedUIParameter.UIField);
            Assert.AreEqual(loadedRelatedBO, uIParameter.UIField);
        }
        // ReSharper restore RedundantNameQualifier
    }
}
