// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;
using Habanero.Base;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // Provides a part of the TestUtilsBase class that creates sample UITypeDefinition objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.

    // Provides the part of the test class that tests UITypeDefinition objects
    [TestFixture]
    public partial class TestUITypeDefinition
    {
        [TestFixtureSetUp]
        public void SetupFixture()
        {
            TestUtilsDomain.SetupFixture();
        }

        [SetUp]
        public virtual void SetupTest()
        {
            //-------------------------------------------------------------------------------------
            // You can choose here whether to run against a database or whether to use an in-memory
            // database for all the tests, which runs quickly. It doesn't however check that
            // your database has the correct structure, which is partly the purpose of these tests.
            // The generated tests do already use an in-memory database where possible.
            // In your custom tests, you can set them to use an in-memory database by copying the
            // line to the first line of your test.
            //-------------------------------------------------------------------------------------
            //BORegistry.DataAccessor = new DataAccessorDB();
            TestUtilsDomain.SetupTest();
        }

        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore
                    ("The developer has chosen to ignore this test: " + methodName + ", Reason: "
                     + _ignoreList[methodName]);
            }
        }

        [Test] // Ensures that the defaults have not been tampered
        public void Test_CreateUITypeDefinitionWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();

            //---------------Test Result -----------------------
            Assert.IsNotNull(uITypeDefinition.UITypeDefinitionID);
            Assert.IsInstanceOf
                (uITypeDefinition.Props["UITypeDefinitionID"].PropertyType, uITypeDefinition.UITypeDefinitionID);
            Assert.IsNull(uITypeDefinition.AssemblyName);
            Assert.IsNull(uITypeDefinition.TypeName);
            Assert.IsNull(uITypeDefinition.SolutionID);
            Assert.IsNull(uITypeDefinition.TypeDescriminator);
        }

        [Test] // Ensures that a class can be successfully saved
        public void Test_SaveUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateUnsavedValidUITypeDefinition();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uITypeDefinition.Status.IsNew);
            BusinessObjectCollection<UITypeDefinition> col = new BusinessObjectCollection<UITypeDefinition>();
            col.LoadAll();
            Assert.AreEqual(5, col.Count);

            //---------------Execute Test ----------------------
            uITypeDefinition.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uITypeDefinition.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(6, col.Count);
        }

        [Test] // Ensures that a saved class can be loaded
        public void Test_LoadUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();

            //---------------Execute Test ----------------------
            UITypeDefinition loadedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);

            //---------------Test Result -----------------------
            Assert.AreEqual(uITypeDefinition.UITypeDefinitionID, loadedUITypeDefinition.UITypeDefinitionID);
            Assert.AreEqual(uITypeDefinition.AssemblyName, loadedUITypeDefinition.AssemblyName);
            Assert.AreEqual(uITypeDefinition.TypeName, loadedUITypeDefinition.TypeName);
            Assert.AreEqual(uITypeDefinition.SolutionID, loadedUITypeDefinition.SolutionID);
            Assert.AreEqual(uITypeDefinition.TypeDescriminator, loadedUITypeDefinition.TypeDescriminator);
        }

        [Test] // Ensures that a class can be deleted
        public void Test_DeleteUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITypeDefinition.MarkForDelete();
            uITypeDefinition.Save();
            //---------------Test Result -----------------------
            try
            {
                UITypeDefinition retrievedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>
                    (uITypeDefinition.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains
                    ("A Error has occured since the object you are trying to refresh has been deleted by another user",
                     ex.Message);
                StringAssert.Contains
                    ("There are no records in the database for the Class: UITypeDefinition", ex.Message);
            }
        }

        [Test] // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUITypeDefinition()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uITypeDefinition.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uITypeDefinition.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SolutionID = (System.Guid) valueForSolutionID;
            object valueForTypeDescriminator = TestUtilsShared.GetRandomString();
            uITypeDefinition.TypeDescriminator = (System.String) valueForTypeDescriminator;
            uITypeDefinition.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UITypeDefinition retrievedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);

            Assert.AreEqual(valueForAssemblyName, retrievedUITypeDefinition.AssemblyName);
            Assert.AreEqual(valueForTypeName, retrievedUITypeDefinition.TypeName);
            Assert.AreEqual(valueForSolutionID, retrievedUITypeDefinition.SolutionID);
            Assert.AreEqual(valueForTypeDescriminator, retrievedUITypeDefinition.TypeDescriminator);
        }

        [Test] // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uITypeDefinition.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uITypeDefinition.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SolutionID = (System.Guid) valueForSolutionID;
            object valueForTypeDescriminator = TestUtilsShared.GetRandomString();
            uITypeDefinition.TypeDescriminator = (System.String) valueForTypeDescriminator;

            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uITypeDefinition.AssemblyName);
            Assert.AreEqual(valueForTypeName, uITypeDefinition.TypeName);
            Assert.AreEqual(valueForSolutionID, uITypeDefinition.SolutionID);
            Assert.AreEqual(valueForTypeDescriminator, uITypeDefinition.TypeDescriminator);
        }

        [Test] // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uITypeDefinition.AssemblyName = (System.String) valueForAssemblyName;
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uITypeDefinition.TypeName = (System.String) valueForTypeName;
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SolutionID = (System.Guid) valueForSolutionID;
            object valueForTypeDescriminator = TestUtilsShared.GetRandomString();
            uITypeDefinition.TypeDescriminator = (System.String) valueForTypeDescriminator;

            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uITypeDefinition.GetPropertyValue("AssemblyName"));
            Assert.AreEqual(valueForTypeName, uITypeDefinition.GetPropertyValue("TypeName"));
            Assert.AreEqual(valueForSolutionID, uITypeDefinition.GetPropertyValue("SolutionID"));
            Assert.AreEqual(valueForTypeDescriminator, uITypeDefinition.GetPropertyValue("TypeDescriminator"));
        }

        [Test] // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = new UITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForAssemblyName = TestUtilsShared.GetRandomString();
            uITypeDefinition.SetPropertyValue("AssemblyName", valueForAssemblyName);
            object valueForTypeName = TestUtilsShared.GetRandomString();
            uITypeDefinition.SetPropertyValue("TypeName", valueForTypeName);
            object valueForSolutionID = TestUtilsShared.CreateSavedDMSolution().SolutionID;
            uITypeDefinition.SetPropertyValue("SolutionID", valueForSolutionID);
            object valueForTypeDescriminator = TestUtilsShared.GetRandomString();
            uITypeDefinition.SetPropertyValue("TypeDescriminator", valueForTypeDescriminator);

            //---------------Test Result -----------------------
            Assert.AreEqual(valueForAssemblyName, uITypeDefinition.AssemblyName);
            Assert.AreEqual(valueForTypeName, uITypeDefinition.TypeName);
            Assert.AreEqual(valueForSolutionID, uITypeDefinition.SolutionID);
            Assert.AreEqual(valueForTypeDescriminator, uITypeDefinition.TypeDescriminator);
        }

        [Test] // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITypeDefinition.TypeDescriminator = null;
            uITypeDefinition.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UITypeDefinition retrievedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);

            Assert.IsNull(retrievedUITypeDefinition.TypeDescriminator);
        }


        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateUnsavedValidUITypeDefinition();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uITypeDefinition.UITypeDefinitionID = null;
            uITypeDefinition.AssemblyName = null;
            uITypeDefinition.TypeName = null;
            uITypeDefinition.SolutionID = null;

            try
            {
                uITypeDefinition.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
                //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI Type Definition ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Assembly Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Type Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Solution' is a compulsory field and has no value", ex.Message);
            }
        }

        [Test] // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UITypeDefinition>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------

            //---------------Test Result -----------------------
            Assert.AreEqual
                ("WriteNew", classDef.PropDefColIncludingInheritance["UITypeDefinitionID"].ReadWriteRule.ToString());
            Assert.AreEqual
                ("ReadWrite", classDef.PropDefColIncludingInheritance["AssemblyName"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite", classDef.PropDefColIncludingInheritance["TypeName"].ReadWriteRule.ToString());
            Assert.AreEqual("ReadWrite", classDef.PropDefColIncludingInheritance["SolutionID"].ReadWriteRule.ToString());
            Assert.AreEqual
                ("ReadWrite", classDef.PropDefColIncludingInheritance["TypeDescriminator"].ReadWriteRule.ToString());
        }


        [Test] // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }


        [Test] // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Solution()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();

            DMSolution boForRelationshipSolution = TestUtilsShared.CreateSavedDMSolution();
            uITypeDefinition.Solution = boForRelationshipSolution;
            uITypeDefinition.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMSolution loadedRelatedBO =
                Broker.GetBusinessObject<DMSolution>(boForRelationshipSolution.ID);
            UITypeDefinition loadedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipSolution, loadedUITypeDefinition.Solution);
            Assert.AreEqual(loadedRelatedBO, loadedUITypeDefinition.Solution);
            Assert.AreEqual(loadedRelatedBO, uITypeDefinition.Solution);
        }

        [Test] // Checks that a related collection loads correctly (no tampering with class defs)
        public void Test_LoadThroughMultipleRelationship_UIGridFilterProps()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();

            UIGridFilterProp boForRelationshipUIGridFilterProps =
                TestUtilsUIGridFilterProp.CreateUnsavedValidUIGridFilterProp();
            boForRelationshipUIGridFilterProps.FilterControlTypeID = uITypeDefinition.UITypeDefinitionID;
            boForRelationshipUIGridFilterProps.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uITypeDefinition.UIGridFilterProps.Count);
            //---------------Execute Test ----------------------
            UIGridFilterProp loadedRelatedBO =
                Broker.GetBusinessObject<UIGridFilterProp>(boForRelationshipUIGridFilterProps.ID);
            UITypeDefinition loadedUITypeDefinition = Broker.GetBusinessObject<UITypeDefinition>(uITypeDefinition.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(1, loadedUITypeDefinition.UIGridFilterProps.Count);
            Assert.AreEqual(boForRelationshipUIGridFilterProps, loadedUITypeDefinition.UIGridFilterProps[0]);
            Assert.AreEqual(loadedRelatedBO, loadedUITypeDefinition.UIGridFilterProps[0]);
            Assert.AreEqual(loadedRelatedBO, uITypeDefinition.UIGridFilterProps[0]);
        }

        [Test] // Checks that deletion is prevented when a child exists
        public void Test_MultipleRelationshipDeletion_PreventDelete_UIGridFilterProps()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UITypeDefinition uITypeDefinition = TestUtilsUITypeDefinition.CreateSavedUITypeDefinition();

            UIGridFilterProp boForRelationshipUIGridFilterProps =
                TestUtilsUIGridFilterProp.CreateUnsavedValidUIGridFilterProp();
            boForRelationshipUIGridFilterProps.FilterControlTypeID = uITypeDefinition.UITypeDefinitionID;
            boForRelationshipUIGridFilterProps.Save();

            //---------------Assert Preconditions---------------
            Assert.AreEqual(1, uITypeDefinition.UIGridFilterProps.Count);
            IRelationshipDef relationshipDef = ClassDef.Get<UITypeDefinition>().RelationshipDefCol["UIGridFilterProps"];
            Assert.AreEqual(DeleteParentAction.Prevent, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            BusObjDeleteException expectedException = null;
            try
            {
                uITypeDefinition.MarkForDelete();
                uITypeDefinition.Save();
            }
            catch (BusObjDeleteException ex)
            {
                expectedException = ex;
            }
            //---------------Test Result -----------------------
            Assert.IsNotNull(expectedException, "Should have thrown exception due to deletion prevention");
            Assert.IsTrue
                (expectedException.Message.Contains
                     ("since it is related to 1 Business Objects via the UIGridFilterProps relationship"));
        }
    }
}