// ------------------------------------------------------------------------------
// This partial class was auto-generated for use with the Habanero Architecture.
// NB Custom code should be placed in the provided stub class.
// Please do not modify this class directly!
//
// If tests are failing due to a unique condition in your application, use the
// ignore feature in the stub class SetupTestFixture() method.  Reimplement the
// test in the stub class.
// ------------------------------------------------------------------------------

using System;
using System.Collections.Generic;
using System.Diagnostics;
using Firestarter.Test.Base;
using FireStarterModeller.BO;

using Habanero.Base;
using Habanero.Base.Exceptions;
using Habanero.BO;
using Habanero.BO.ClassDefinition;
using NUnit.Framework;

namespace FireStarterModeller.Test.BO
{
    // ReSharper disable RedundantNameQualifier
    // Provides a part of the TestUtilsBase class that creates sample UIView objects.
    // If these methods create invalid data, then implement custom overrides in the
    // TestUtils class.
    public class TestUtilsUIView
    {
        /// <summary>
        /// Creates a new saved UIView with a random value assigned to every property
        /// </summary>
        public static UIView CreateSavedUIView()
		{
		    UIView uIView = CreateUnsavedValidUIView();
			uIView.Save();
			return uIView;
		}

        /// <summary>
        /// Creates a new unsaved UIView with a random value assigned to every property
        /// </summary>
		public static UIView CreateUnsavedValidUIView()
		{
			UIView uIView = new UIView();
			uIView.ViewName = TestUtilsShared.GetRandomString();
			uIView.Generated = TestUtilsShared.GetRandomBoolean();
			uIView.ClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
			return uIView;
		}
	    
	    /// <summary>
        /// Creates a new unsaved UIView where all properties are null, except ID properties
        /// and those with default values.  If there are compulsory properties without
        /// defaults, saving the object will throw an exception.
        /// </summary>
		public static UIView CreateUnsavedDefaultUIView()
		{
			UIView uIView = new UIView();
			return uIView;
		}
    }
    
    // Provides the part of the test class that tests UIView objects
    [TestFixture]
    public partial class TestUIView : TestBase
    {
        private readonly Dictionary<string, string> _ignoreList = new Dictionary<string, string>();

        /// <summary>
        /// Checks if the developer has put this test on the ignore list.
        /// If your application has a unique condition that is causing a
        /// generated test to fail, you would lose test repairs when this
        /// class is regenerated.
        /// Simply add the test name to the ignore list in the TestFixtureSetup
        /// of the once-off-generated part of this test class, and then
        /// reimplement the test in that class.
        /// </summary>
        private void CheckIfTestShouldBeIgnored()
        {
            string methodName = new StackTrace().GetFrame(1).GetMethod().Name;
            if (_ignoreList.ContainsKey(methodName))
            {
                Assert.Ignore("The developer has chosen to ignore this test: " + methodName +
                    ", Reason: " + _ignoreList[methodName]);
            }
        }
        
        [Test]  // Ensures that the defaults have not been tampered
        public void Test_CreateUIViewWithDefaults()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            UIView uIView = new UIView();

            //---------------Test Result -----------------------
                        Assert.IsNotNull(uIView.UIViewID);
            Assert.IsInstanceOf(uIView.Props["UIViewID"].PropertyType, uIView.UIViewID);
                        Assert.IsNotNull(uIView.ViewName);
            Assert.IsInstanceOf(uIView.Props["ViewName"].PropertyType, uIView.ViewName);
                        Assert.IsNotNull(uIView.Generated);
            Assert.IsInstanceOf(uIView.Props["Generated"].PropertyType, uIView.Generated);
                        Assert.IsNull(uIView.ClassID);
        }

        [Test]  // Ensures that a class can be successfully saved
        public void Test_SaveUIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateUnsavedValidUIView();

            //---------------Assert Precondition----------------
            Assert.IsTrue(uIView.Status.IsNew);
            BusinessObjectCollection<UIView> col = new BusinessObjectCollection<UIView>();
            col.LoadAll();
            Assert.AreEqual(0, col.Count);

            //---------------Execute Test ----------------------
            uIView.Save();

            //---------------Test Result -----------------------
            Assert.IsFalse(uIView.Status.IsNew);
            col.LoadAll();
            Assert.AreEqual(1, col.Count);
	    
        }
        
        [Test]  // Ensures that a saved class can be loaded
        public void Test_LoadUIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateSavedUIView();

            //---------------Execute Test ----------------------
            UIView loadedUIView = Broker.GetBusinessObject<UIView>(uIView.ID);

            //---------------Test Result -----------------------
                        Assert.AreEqual(uIView.UIViewID, loadedUIView.UIViewID);
                        Assert.AreEqual(uIView.ViewName, loadedUIView.ViewName);
                        Assert.AreEqual(uIView.Generated, loadedUIView.Generated);
                        Assert.AreEqual(uIView.ClassID, loadedUIView.ClassID);
        }
        
        [Test]  // Ensures that a class can be deleted
        public void Test_DeleteUIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateSavedUIView();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIView.MarkForDelete();
            uIView.Save();
            //---------------Test Result -----------------------
            try
            {
                Broker.GetBusinessObject<UIView>(uIView.ID);
                Assert.Fail("expected Err");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                StringAssert.Contains("A Error has occured since the object you are trying to refresh has been deleted by another user", ex.Message);
                StringAssert.Contains("There are no records in the database for the Class: UIView", ex.Message);
            }
        }

        [Test]  // Ensures that updates to property values are stored and can be retrieved
        public void Test_UpdateUIView()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateSavedUIView();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            uIView.ViewName = (System.String) valueForName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIView.Generated = (System.Boolean) valueForGenerated;
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            uIView.ClassID = (System.Guid) valueForClassID;
            uIView.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            UIView retrievedUIView =
                    Broker.GetBusinessObject<UIView>(uIView.ID);
            
            Assert.AreEqual(valueForName, retrievedUIView.ViewName);
            Assert.AreEqual(valueForGenerated, retrievedUIView.Generated);
            Assert.AreEqual(valueForClassID, retrievedUIView.ClassID);
        }
        
        [Test]  // Ensures that gets and sets in the code refer to the same property
        public void Test_PropertyGetters()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = new UIView();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            uIView.ViewName = (System.String) valueForName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIView.Generated = (System.Boolean) valueForGenerated;
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            uIView.ClassID = (System.Guid) valueForClassID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uIView.ViewName);
            Assert.AreEqual(valueForGenerated, uIView.Generated);
            Assert.AreEqual(valueForClassID, uIView.ClassID);
        }
        
        [Test]  // Ensures that property getters in the code point to the correct property
        public void Test_PropertyGettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = new UIView();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();
            uIView.ViewName = (System.String) valueForName;
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();
            uIView.Generated = (System.Boolean) valueForGenerated;
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            uIView.ClassID = (System.Guid) valueForClassID;
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uIView.GetPropertyValue("ViewName"));
            Assert.AreEqual(valueForGenerated, uIView.GetPropertyValue("Generated"));
            Assert.AreEqual(valueForClassID, uIView.GetPropertyValue("ClassID"));
        }
        
        [Test]  // Ensures that property setters in the code point to the correct property
        public void Test_PropertySettersUseCorrectPropertyNames()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = new UIView();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            object valueForName = TestUtilsShared.GetRandomString();            
            uIView.SetPropertyValue("ViewName", valueForName);
            object valueForGenerated = TestUtilsShared.GetRandomBoolean();            
            uIView.SetPropertyValue("Generated", valueForGenerated);
            object valueForClassID = TestUtilsShared.CreateSavedDMClass().ClassID;            
            uIView.SetPropertyValue("ClassID", valueForClassID);
            
            //---------------Test Result -----------------------
            Assert.AreEqual(valueForName, uIView.ViewName);
            Assert.AreEqual(valueForGenerated, uIView.Generated);
            Assert.AreEqual(valueForClassID, uIView.ClassID);
        }
        
        [Test]  // Makes sure there are no non-null rules in the database that don't have corresponding compulsory rules
        public void Test_SetPropertyValue_Null()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateSavedUIView();
            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIView.Save();

            //---------------Test Result -----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            Broker.GetBusinessObject<UIView>(uIView.ID);
            
        }
        

        [Test]
        public void Test_NotSettingCompulsoryPropertiesThrowsException()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIView uIView = TestUtilsUIView.CreateUnsavedValidUIView();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIView.UIViewID = null;
            uIView.ViewName = null;
            uIView.Generated = null;
            uIView.ClassID = TestUtilsShared.CreateSavedDMClass().ClassID;
            
            try
            {
                uIView.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("UI View ID' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("View Name' is a compulsory field and has no value", ex.Message);
                StringAssert.Contains("Generated' is a compulsory field and has no value", ex.Message);
                //StringAssert.Contains("Business Object Info' is a compulsory field and has no value", ex.Message);
            }
        }

        [Test]
        public void Test_NotSettingClassThrowsException_Rule()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIView uIView = TestUtilsUIView.CreateUnsavedValidUIView();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            uIView.UIViewID = null;
            uIView.ViewName = null;
            uIView.Generated = null;
            uIView.ClassID = null;
            
            try
            {
                uIView.Save();
                Assert.Fail("Should throw an exception when compulsory properties are null");
            }
            //---------------Test Result -----------------------
            catch (BusObjectInAnInvalidStateException ex)
            {
                StringAssert.Contains("'UIView.UI View ID' is a compulsory field and has no value.", ex.Message);
                StringAssert.Contains("'UIView.View Name' is a compulsory field and has no value.", ex.Message);
                StringAssert.Contains("'UIView.Generated' is a compulsory field and has no value.", ex.Message);
                StringAssert.Contains("'UIView.Business Object Info' is a compulsory field and has no value.", ex.Message);
            }
        }
        
        [Test]  // Checks that the read-write rules have not been changed in the class defs
        public void Test_ReadWriteRules()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            ClassDef classDef = ClassDef.Get<UIView>();

            //---------------Assert Precondition----------------

            //---------------Execute Test ----------------------
            
            //---------------Test Result -----------------------
			Assert.AreEqual("WriteNew",classDef.PropDefColIncludingInheritance["UIViewID"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ViewName"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["Generated"].ReadWriteRule.ToString());
			Assert.AreEqual("ReadWrite",classDef.PropDefColIncludingInheritance["ClassID"].ReadWriteRule.ToString());
        }
        
        
        
        
        [Test]  // Checks that classes using primary keys that are not an ID cannot have duplicate primary key values
        public void Test_NonIDPrimaryKey_ChecksForUniqueness()
        {
            CheckIfTestShouldBeIgnored();
            // Test does not apply to this class since the primary key is an ID
        }
        
        
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_Class()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIView uIView = TestUtilsUIView.CreateSavedUIView();

            DMClass boForRelationshipClass = uIView.Class;

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            DMClass loadedRelatedBO = Broker.GetBusinessObject<DMClass>(boForRelationshipClass.ID);
            UIView loadedUIView = Broker.GetBusinessObject<UIView>(uIView.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipClass, loadedUIView.Class);
            Assert.AreEqual(loadedRelatedBO, loadedUIView.Class);
            Assert.AreEqual(loadedRelatedBO, uIView.Class);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIView uIView = TestUtilsUIView.CreateSavedUIView();

            UIFormInfo boForRelationshipUIFormInfo = TestUtilsUIFormInfo.CreateUnsavedValidUIFormInfo_WNoUIView();
            uIView.UIFormInfo = boForRelationshipUIFormInfo;
            uIView.Save();
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIFormInfo loadedRelatedBO = Broker.GetBusinessObject<UIFormInfo>(boForRelationshipUIFormInfo.ID);
            UIView loadedUIView = Broker.GetBusinessObject<UIView>(uIView.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIFormInfo, loadedUIView.UIFormInfo);
            Assert.AreEqual(loadedRelatedBO, loadedUIView.UIFormInfo);
            Assert.AreEqual(loadedRelatedBO, uIView.UIFormInfo);
        }
        [Test]  // Checks that BOs in a single relationship load correctly (no tampering with class defs)
        public void Test_LoadThroughSingleRelationship_UIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            BORegistry.DataAccessor = new DataAccessorInMemory();
            UIView uIView = TestUtilsUIView.CreateSavedUIView();

            UIGridInfo boForRelationshipUIGridInfo = TestUtilsUIGridInfo.CreateUnsavedValidUIGridInfo_WNoUIView();
            uIView.UIGridInfo = boForRelationshipUIGridInfo;
            uIView.Save();

            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();
            //---------------Execute Test ----------------------
            UIGridInfo loadedRelatedBO = Broker.GetBusinessObject<UIGridInfo>(boForRelationshipUIGridInfo.ID);
            UIView loadedUIView = Broker.GetBusinessObject<UIView>(uIView.ID);
            //---------------Test Result -----------------------
            Assert.AreEqual(boForRelationshipUIGridInfo, loadedUIView.UIGridInfo);
            Assert.AreEqual(loadedRelatedBO, loadedUIView.UIGridInfo);
            Assert.AreEqual(loadedRelatedBO, uIView.UIGridInfo);
        }
        
        
        
        
        
        
        
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_SingleRelationshipDeletion_DeleteRelated_UIFormInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateSavedUIView();

            UIFormInfo boForRelationshipUIFormInfo = TestUtilsUIFormInfo.CreateUnsavedValidUIFormInfo_WNoUIView();
            uIView.UIFormInfo = boForRelationshipUIFormInfo;
            uIView.Save();

            //---------------Assert Preconditions---------------W
            IRelationshipDef relationshipDef = ClassDef.Get<UIView>().RelationshipDefCol["UIFormInfo"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIView.MarkForDelete();
            uIView.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIView>(uIView.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIView"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIFormInfo>(boForRelationshipUIFormInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIFormInfo"));
            }
            
        }
        [Test]  // Checks that deleting a parent deletes the child
        public void Test_SingleRelationshipDeletion_DeleteRelated_UIGridInfo()
        {
            CheckIfTestShouldBeIgnored();
            //---------------Set up test pack-------------------
            UIView uIView = TestUtilsUIView.CreateSavedUIView();

            UIGridInfo boForRelationshipUIGridInfo =
                TestUtilsUIGridInfo.CreateUnsavedValidUIGridInfo_WNoUIView();
            uIView.UIGridInfo = boForRelationshipUIGridInfo;
            uIView.Save();

            //---------------Assert Preconditions---------------
            IRelationshipDef relationshipDef = ClassDef.Get<UIView>().RelationshipDefCol["UIGridInfo"];
            Assert.AreEqual(DeleteParentAction.DeleteRelated, relationshipDef.DeleteParentAction);
            //---------------Execute Test ----------------------
            uIView.MarkForDelete();
            uIView.Save();
            //---------------Execute Test ----------------------
            BusinessObjectManager.Instance.ClearLoadedObjects();
            GC.Collect();
            TestUtilsDomain.WaitForGC();

            try
            {
                Broker.GetBusinessObject<UIView>(uIView.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIView"));
            }            
            
            try
            {
                Broker.GetBusinessObject<UIGridInfo>(boForRelationshipUIGridInfo.ID);
                Assert.Fail("BO should no longer exist and exception should be thrown");
            }
            catch (BusObjDeleteConcurrencyControlException ex)
            {
                Assert.IsTrue(ex.Message.Contains("There are no records in the database for the Class: UIGridInfo"));
            }
        }
        // ReSharper restore RedundantNameQualifier
    }
}
